/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !shift_count_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_V1QImode:
      return pattern12 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern12 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern12 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern12 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern12 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern12 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern12 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern12 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern12 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (!register_operand (x2, E_V1SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1SImode)
        return -1;
      return 9;

    case E_V2SImode:
      if (!register_operand (x2, E_V2SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2SImode)
        return -1;
      return 10;

    case E_V4SImode:
      if (!register_operand (x2, E_V4SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4SImode)
        return -1;
      return 11;

    case E_V1DImode:
      if (!register_operand (x2, E_V1DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1DImode)
        return -1;
      return 12;

    case E_V2DImode:
      if (!register_operand (x2, E_V2DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2DImode)
        return -1;
      return 13;

    case E_V1TImode:
      if (!register_operand (x2, E_V1TImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1TImode)
        return -1;
      return 14;

    case E_TImode:
      if (!register_operand (x2, E_TImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TImode)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern31 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern30 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern30 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCRAWmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCRAWmode)
    return -1;
  return 0;
}

int
pattern37 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 0)
    return -1;
  return 0;
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 33
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern44 (rtx x1, int i1, int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i3
      || XVECLEN (x2, 0) != i2
      || XINT (x2, 1) != i1)
    return -1;
  return 0;
}

int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x1) != E_TImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern59 (rtx x1, int *pnum_clobbers, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern65 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern0 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern0 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern0 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern0 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern0 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern0 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern0 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern0 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern0 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern0 (x1, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern0 (x1, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern0 (x1, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern0 (x1, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern0 (x1, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1SFmode:
      if (pattern0 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 14;

    case E_V2SFmode:
      if (pattern0 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 15;

    case E_V4SFmode:
      if (pattern0 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 16;

    case E_V1DFmode:
      if (pattern0 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 17;

    case E_V2DFmode:
      if (pattern0 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 18;

    case E_V1TFmode:
      if (pattern0 (x1, 
E_V1TFmode) != 0)
        return -1;
      return 19;

    case E_V1TImode:
      if (pattern0 (x1, 
E_V1TImode) != 0)
        return -1;
      return 20;

    case E_TImode:
      if (pattern0 (x1, 
E_TImode) != 0)
        return -1;
      return 21;

    case E_DImode:
      if (pnum_clobbers == NULL
          || pattern64 (x1, 
E_DImode) != 0)
        return -1;
      return 22;

    case E_HImode:
      if (pnum_clobbers == NULL
          || pattern64 (x1, 
E_HImode) != 0)
        return -1;
      return 23;

    case E_QImode:
      if (pnum_clobbers == NULL
          || pattern64 (x1, 
E_QImode) != 0)
        return -1;
      return 24;

    default:
      return -1;
    }
}

int
pattern104 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern109 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern115 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern115 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern121 (x5, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern121 (x5, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_HImode:
      if (pattern121 (x5, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_QImode:
      if (pattern121 (x5, 
E_QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern130 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern136 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern142 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern148 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != ASHIFT
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != SUBREG
      || maybe_ne (SUBREG_BYTE (x7), 0)
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x6, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x9 = XEXP (x5, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x10 = XEXP (x3, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x11) != SET)
    return -1;
  x12 = XEXP (x11, 1);
  if (GET_CODE (x12) != i1
      || GET_MODE (x12) != E_DImode)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != SIGN_EXTEND
      || GET_MODE (x13) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  x14 = XEXP (x7, 0);
  operands[1] = x14;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x15 = XEXP (x11, 0);
  operands[0] = x15;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x16 = XEXP (x13, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  return 0;
}

int
pattern161 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern171 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) != PC)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  return pattern170 (); /* [-1, 1] */
}

int
pattern175 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !memory_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern185 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 4;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern200 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern208 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern219 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern227 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern237 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern241 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern247 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern256 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !const0_operand (operands[3], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern264 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern273 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern278 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern288 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || pattern285 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern295 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pattern25 (x1, 
E_CCRAWmode) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 1244 "../../gcc-15.1.1-20250425/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 347; /* *vec_test_maskv16qi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 1244 "../../gcc-15.1.1-20250425/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 348; /* *vec_test_maskv8hi */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 1244 "../../gcc-15.1.1-20250425/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 349; /* *vec_test_maskv4si */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 1244 "../../gcc-15.1.1-20250425/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 350; /* *vec_test_maskv2di */

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !register_operand (operands[1], E_V1TImode)
          || !
#line 1244 "../../gcc-15.1.1-20250425/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 351; /* *vec_test_maskv1ti */

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode)
          || !
#line 1244 "../../gcc-15.1.1-20250425/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 352; /* *vec_test_maskti */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 1244 "../../gcc-15.1.1-20250425/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 353; /* *vec_test_maskv2df */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 1244 "../../gcc-15.1.1-20250425/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 34 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 354; /* *vec_test_maskv4sf */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || !register_operand (operands[1], E_V1TImode)
          || !(
#line 1244 "../../gcc-15.1.1-20250425/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 34 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 355; /* *vec_test_maskv1tf */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !register_operand (operands[1], E_TImode)
          || !(
#line 1244 "../../gcc-15.1.1-20250425/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 356; /* *vec_test_masktf */

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern24 (x1))
    {
    case 0:
      if (!
#line 1590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1097; /* *vec_slbv16qi */

    case 1:
      if (!
#line 1590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1098; /* *vec_slbv8hi */

    case 2:
      if (!
#line 1590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1099; /* *vec_slbv4si */

    case 3:
      if (!
#line 1590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1100; /* *vec_slbv2di */

    case 4:
      if (!
#line 1590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1101; /* *vec_slbv1ti */

    case 5:
      if (!
#line 1590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1102; /* *vec_slbti */

    case 6:
      if (!
#line 1590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1103; /* *vec_slbv4sf */

    case 7:
      if (!
#line 1590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1104; /* *vec_slbv2df */

    case 8:
      if (!
#line 1590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1105; /* *vec_slbv1tf */

    case 9:
      if (!
#line 1590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1106; /* *vec_slbtf */

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case ZERO_EXTEND:
      if (pattern165 (x1, 
E_V4SImode, 
E_DImode, 
E_SImode) != 0)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_SImode:
          if (GET_MODE (x5) != E_SImode
              || !register_operand (operands[0], E_V4SImode)
              || !
#line 450 "../../gcc-15.1.1-20250425/gcc/config/s390/vx-builtins.md"
(TARGET_VX && TARGET_64BIT && UINTVAL (operands[3]) < 4))
            return -1;
          return 38; /* vec_scatter_elementv4si_DI */

        case E_SFmode:
          if (GET_MODE (x5) != E_SFmode
              || !register_operand (operands[0], E_V4SFmode)
              || !
#line 450 "../../gcc-15.1.1-20250425/gcc/config/s390/vx-builtins.md"
(TARGET_VX && TARGET_64BIT && UINTVAL (operands[3]) < 4))
            return -1;
          return 39; /* vec_scatter_elementv4sf_DI */

        default:
          return -1;
        }

    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x7), 4)
          || pattern165 (x1, 
E_V2DImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_DImode:
          if (GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_V2DImode)
              || !
#line 466 "../../gcc-15.1.1-20250425/gcc/config/s390/vx-builtins.md"
(TARGET_VX && !TARGET_64BIT && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 40; /* vec_scatter_elementv2di_SI */

        case E_DFmode:
          if (GET_MODE (x5) != E_DFmode
              || !register_operand (operands[0], E_V2DFmode)
              || !
#line 466 "../../gcc-15.1.1-20250425/gcc/config/s390/vx-builtins.md"
(TARGET_VX && !TARGET_64BIT && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 41; /* vec_scatter_elementv2df_SI */

        default:
          return -1;
        }

    case VEC_SELECT:
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      x10 = XVECEXP (x8, 0, 0);
      operands[3] = x10;
      if (!const_mask_operand (operands[3], E_QImode)
          || !address_operand (operands[2], E_DImode))
        return -1;
      x11 = XEXP (x5, 1);
      x12 = XVECEXP (x11, 0, 0);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_SImode:
          if (pattern267 (x1, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 482 "../../gcc-15.1.1-20250425/gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 42; /* vec_scatter_elementv4si_SI */

        case E_DImode:
          if (pattern267 (x1, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 482 "../../gcc-15.1.1-20250425/gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 43; /* vec_scatter_elementv2di_DI */

        case E_DFmode:
          if (pattern268 (x1, 
E_V2DFmode, 
E_DFmode, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 482 "../../gcc-15.1.1-20250425/gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 44; /* vec_scatter_elementv2df_DI */

        case E_SFmode:
          if (pattern268 (x1, 
E_V4SFmode, 
E_SFmode, 
E_V4SImode, 
E_SImode) != 0
              || !(
#line 482 "../../gcc-15.1.1-20250425/gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 23 "../../gcc-15.1.1-20250425/gcc/config/s390/vx-builtins.md"
(TARGET_VXE)))
            return -1;
          return 45; /* vec_scatter_elementv4sf_SI */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 6135 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2193; /* *adddi3_zero_cconly */

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (nonimmediate_operand (operands[1], E_DImode)
              && general_operand (operands[2], E_DImode))
            {
              x5 = XEXP (x2, 1);
              if (rtx_equal_p (x5, operands[1])
                  && (
#line 6261 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                {
                  *pnum_clobbers = 1;
                  return 2201; /* *adddi3_carry1_cconly */
                }
              if (rtx_equal_p (x5, operands[2])
                  && (
#line 6301 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                {
                  *pnum_clobbers = 1;
                  return 2205; /* *adddi3_carry2_cconly */
                }
            }
          break;

        case E_SImode:
          if (nonimmediate_operand (operands[1], E_SImode)
              && general_operand (operands[2], E_SImode))
            {
              x5 = XEXP (x2, 1);
              if (rtx_equal_p (x5, operands[1])
                  && 
#line 6261 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                {
                  *pnum_clobbers = 1;
                  return 2202; /* *addsi3_carry1_cconly */
                }
              if (rtx_equal_p (x5, operands[2])
                  && 
#line 6301 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                {
                  *pnum_clobbers = 1;
                  return 2206; /* *addsi3_carry2_cconly */
                }
            }
          break;

        case E_TFmode:
          if (nonimmediate_operand (operands[1], E_TFmode)
              && general_operand (operands[2], E_TFmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_TFmode)
                  && (
#line 6522 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_VXE)))
                {
                  *pnum_clobbers = 1;
                  return 2232; /* *addtf3_cconly */
                }
            }
          break;

        case E_FPRX2mode:
          if (nonimmediate_operand (operands[1], E_FPRX2mode)
              && general_operand (operands[2], E_FPRX2mode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_FPRX2mode)
                  && (
#line 6522 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VXE)))
                {
                  *pnum_clobbers = 1;
                  return 2233; /* *addfprx23_cconly */
                }
            }
          break;

        case E_DFmode:
          if (nonimmediate_operand (operands[1], E_DFmode)
              && general_operand (operands[2], E_DFmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_DFmode)
                  && 
#line 6522 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                {
                  *pnum_clobbers = 1;
                  return 2234; /* *adddf3_cconly */
                }
            }
          break;

        case E_SFmode:
          if (nonimmediate_operand (operands[1], E_SFmode)
              && general_operand (operands[2], E_SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_SFmode)
                  && 
#line 6522 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                {
                  *pnum_clobbers = 1;
                  return 2235; /* *addsf3_cconly */
                }
            }
          break;

        case E_TDmode:
          if (nonimmediate_operand (operands[1], E_TDmode)
              && general_operand (operands[2], E_TDmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_TDmode)
                  && (
#line 6522 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                {
                  *pnum_clobbers = 1;
                  return 2236; /* *addtd3_cconly */
                }
            }
          break;

        case E_DDmode:
          if (nonimmediate_operand (operands[1], E_DDmode)
              && general_operand (operands[2], E_DDmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_DDmode)
                  && (
#line 6522 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                {
                  *pnum_clobbers = 1;
                  return 2237; /* *adddd3_cconly */
                }
            }
          break;

        default:
          break;
        }
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern155 (x3))
        {
        case 0:
          if (!(
#line 6341 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2209; /* *adddi3_cconly */

        case 1:
          if (!
#line 6341 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2210; /* *addsi3_cconly */

        default:
          return -1;
        }

    case PLUS:
      x6 = XEXP (x4, 0);
      operands[3] = x6;
      x8 = XEXP (x4, 1);
      operands[1] = x8;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (pattern187 (x4, 
E_DImode) != 0)
            return -1;
          x5 = XEXP (x2, 1);
          if (rtx_equal_p (x5, operands[1])
              && (
#line 7037 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 2282; /* *adddi3_alc_carry1_cconly */
            }
          if (!rtx_equal_p (x5, operands[2])
              || !(
#line 7071 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2286; /* *adddi3_alc_carry2_cconly */

        case E_SImode:
          if (pattern187 (x4, 
E_SImode) != 0)
            return -1;
          x5 = XEXP (x2, 1);
          if (rtx_equal_p (x5, operands[1])
              && 
#line 7037 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
            {
              *pnum_clobbers = 1;
              return 2283; /* *addsi3_alc_carry1_cconly */
            }
          if (!rtx_equal_p (x5, operands[2])
              || !
#line 7071 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
            return -1;
          *pnum_clobbers = 1;
          return 2287; /* *addsi3_alc_carry2_cconly */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[4] = x5;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 2);
  operands[2] = x7;
  x8 = XEXP (x4, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      return recog_29 (x1, insn, pnum_clobbers);

    case NOT:
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern207 (x3, 
E_V1QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1QImode)
              && 
#line 2566 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1435; /* *vec_sel0v1qi */
          if (!all_ones_operand (operands[4], E_V1QImode)
              || !
#line 2590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1473; /* *vec_sel1v1qi */

        case E_V2QImode:
          if (pattern207 (x3, 
E_V2QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2QImode)
              && 
#line 2566 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1436; /* *vec_sel0v2qi */
          if (!all_ones_operand (operands[4], E_V2QImode)
              || !
#line 2590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1474; /* *vec_sel1v2qi */

        case E_V4QImode:
          if (pattern207 (x3, 
E_V4QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4QImode)
              && 
#line 2566 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1437; /* *vec_sel0v4qi */
          if (!all_ones_operand (operands[4], E_V4QImode)
              || !
#line 2590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1475; /* *vec_sel1v4qi */

        case E_V8QImode:
          if (pattern207 (x3, 
E_V8QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V8QImode)
              && 
#line 2566 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1438; /* *vec_sel0v8qi */
          if (!all_ones_operand (operands[4], E_V8QImode)
              || !
#line 2590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1476; /* *vec_sel1v8qi */

        case E_V16QImode:
          if (pattern207 (x3, 
E_V16QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V16QImode)
              && 
#line 2566 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1439; /* *vec_sel0v16qi */
          if (!all_ones_operand (operands[4], E_V16QImode)
              || !
#line 2590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1477; /* *vec_sel1v16qi */

        case E_V1HImode:
          if (pattern207 (x3, 
E_V1HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1HImode)
              && 
#line 2566 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1440; /* *vec_sel0v1hi */
          if (!all_ones_operand (operands[4], E_V1HImode)
              || !
#line 2590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1478; /* *vec_sel1v1hi */

        case E_V2HImode:
          if (pattern207 (x3, 
E_V2HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2HImode)
              && 
#line 2566 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1441; /* *vec_sel0v2hi */
          if (!all_ones_operand (operands[4], E_V2HImode)
              || !
#line 2590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1479; /* *vec_sel1v2hi */

        case E_V4HImode:
          if (pattern207 (x3, 
E_V4HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4HImode)
              && 
#line 2566 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1442; /* *vec_sel0v4hi */
          if (!all_ones_operand (operands[4], E_V4HImode)
              || !
#line 2590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1480; /* *vec_sel1v4hi */

        case E_V8HImode:
          if (pattern207 (x3, 
E_V8HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V8HImode)
              && 
#line 2566 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1443; /* *vec_sel0v8hi */
          if (!all_ones_operand (operands[4], E_V8HImode)
              || !
#line 2590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1481; /* *vec_sel1v8hi */

        case E_V1SImode:
          if (pattern207 (x3, 
E_V1SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1SImode)
              && 
#line 2566 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1444; /* *vec_sel0v1si */
          if (!all_ones_operand (operands[4], E_V1SImode)
              || !
#line 2590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1482; /* *vec_sel1v1si */

        case E_V2SImode:
          if (pattern207 (x3, 
E_V2SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2SImode)
              && 
#line 2566 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1445; /* *vec_sel0v2si */
          if (!all_ones_operand (operands[4], E_V2SImode)
              || !
#line 2590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1483; /* *vec_sel1v2si */

        case E_V4SImode:
          if (pattern207 (x3, 
E_V4SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4SImode)
              && 
#line 2566 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1446; /* *vec_sel0v4si */
          if (!all_ones_operand (operands[4], E_V4SImode)
              || !
#line 2590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1484; /* *vec_sel1v4si */

        case E_V1DImode:
          if (pattern207 (x3, 
E_V1DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1DImode)
              && 
#line 2566 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1447; /* *vec_sel0v1di */
          if (!all_ones_operand (operands[4], E_V1DImode)
              || !
#line 2590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1485; /* *vec_sel1v1di */

        case E_V2DImode:
          if (pattern207 (x3, 
E_V2DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2DImode)
              && 
#line 2566 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1448; /* *vec_sel0v2di */
          if (!all_ones_operand (operands[4], E_V2DImode)
              || !
#line 2590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1486; /* *vec_sel1v2di */

        case E_V1SFmode:
          if (pattern208 (x3, 
E_V1SFmode, 
E_V1SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1SImode)
              && 
#line 2566 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1449; /* *vec_sel0v1sf */
          if (!all_ones_operand (operands[4], E_V1SImode)
              || !
#line 2590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1487; /* *vec_sel1v1sf */

        case E_V2SFmode:
          if (pattern208 (x3, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2SImode)
              && 
#line 2566 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1450; /* *vec_sel0v2sf */
          if (!all_ones_operand (operands[4], E_V2SImode)
              || !
#line 2590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1488; /* *vec_sel1v2sf */

        case E_V4SFmode:
          if (pattern208 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4SImode)
              && 
#line 2566 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1451; /* *vec_sel0v4sf */
          if (!all_ones_operand (operands[4], E_V4SImode)
              || !
#line 2590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1489; /* *vec_sel1v4sf */

        case E_V1DFmode:
          if (pattern208 (x3, 
E_V1DFmode, 
E_V1DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1DImode)
              && 
#line 2566 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1452; /* *vec_sel0v1df */
          if (!all_ones_operand (operands[4], E_V1DImode)
              || !
#line 2590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1490; /* *vec_sel1v1df */

        case E_V2DFmode:
          if (pattern208 (x3, 
E_V2DFmode, 
E_V2DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2DImode)
              && 
#line 2566 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1453; /* *vec_sel0v2df */
          if (!all_ones_operand (operands[4], E_V2DImode)
              || !
#line 2590 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1491; /* *vec_sel1v2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  switch (GET_MODE (x2))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !nonimmediate_operand (operands[3], E_DImode))
        return -1;
      if ((
#line 4482 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (DImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 64) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return 1950; /* *insvdi_nocc */
      if (pnum_clobbers == NULL
          || !(
#line 4482 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (DImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 64) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 1951; /* *insvdi_clobbercc */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !nonimmediate_operand (operands[3], E_SImode))
        return -1;
      if (
#line 4482 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (SImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 32))
        return 1952; /* *insvsi_nocc */
      if (pnum_clobbers == NULL
          || !
#line 4482 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (SImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 32))
        return -1;
      *pnum_clobbers = 1;
      return 1953; /* *insvsi_clobbercc */

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0))
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      if (!general_operand (operands[1], E_FPRX2mode)
          || !nonimmediate_operand (operands[0], E_TFmode)
          || GET_MODE (x2) != E_TFmode
          || !
#line 678 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 645; /* fprx2_to_tf */

    case UNSPEC:
      if (XVECLEN (x4, 0) != 3
          || XINT (x4, 1) != 73
          || GET_MODE (x4) != E_V16QImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != SUBREG
          || maybe_ne (SUBREG_BYTE (x5), 0)
          || GET_MODE (x5) != E_V16QImode)
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x6) != SUBREG
          || maybe_ne (SUBREG_BYTE (x6), 0)
          || GET_MODE (x6) != E_V16QImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      x9 = XVECEXP (x4, 0, 2);
      operands[3] = x9;
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern289 (x2, 
E_V16QImode) != 0
              || !
#line 773 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 648; /* *vec_permv16qi */

        case E_V8HImode:
          if (pattern289 (x2, 
E_V8HImode) != 0
              || !
#line 773 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 649; /* *vec_permv8hi */

        case E_V4SImode:
          if (pattern289 (x2, 
E_V4SImode) != 0
              || !
#line 773 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 650; /* *vec_permv4si */

        case E_V2DImode:
          if (pattern289 (x2, 
E_V2DImode) != 0
              || !
#line 773 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 651; /* *vec_permv2di */

        case E_V2DFmode:
          if (pattern289 (x2, 
E_V2DFmode) != 0
              || !
#line 773 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 652; /* *vec_permv2df */

        case E_V1TImode:
          if (pattern289 (x2, 
E_V1TImode) != 0
              || !
#line 773 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 653; /* *vec_permv1ti */

        case E_TImode:
          if (pattern289 (x2, 
E_TImode) != 0
              || !
#line 773 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 654; /* *vec_permti */

        case E_V4SFmode:
          if (pattern289 (x2, 
E_V4SFmode) != 0
              || !(
#line 773 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 47 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 655; /* *vec_permv4sf */

        case E_V1TFmode:
          if (pattern289 (x2, 
E_V1TFmode) != 0
              || !(
#line 773 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 47 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 656; /* *vec_permv1tf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      operands[1] = x3;
      if (address_operand (operands[1], E_QImode))
        {
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) == CONST_INT
              && XWINT (x4, 0) == 2147483647L
              && register_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode)
            {
              if (
#line 2571 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return 1850; /* *la_31_and */
              if (pnum_clobbers != NULL
                  && 
#line 2585 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_64BIT))
                {
                  *pnum_clobbers = 1;
                  return 1851; /* *la_31_and_cc */
                }
            }
        }
      if (GET_CODE (x3) == SUBREG)
        {
          res = recog_51 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) == CONST_INT
          && XWINT (x4, 0) == 2147483647L)
        {
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && GET_MODE (x2) == E_SImode
                  && nonimmediate_operand (operands[1], E_SImode)
                  && 
#line 5185 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 2022; /* *llgt_sisi */
              break;

            case E_DImode:
              if (register_operand (operands[0], E_DImode)
                  && GET_MODE (x2) == E_DImode
                  && nonimmediate_operand (operands[1], E_DImode)
                  && 
#line 5196 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 2023; /* *llgt_didi */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern158 (x2))
        {
        case 0:
          if (!
#line 7957 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          *pnum_clobbers = 1;
          return 2342; /* *anddi3 */

        case 1:
          if (
#line 8086 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2353; /* *andsi3_zarch */
            }
          if (!
#line 8120 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          *pnum_clobbers = 1;
          return 2354; /* *andsi3_esa */

        default:
          return -1;
        }

    case ROTATE:
      if (pattern66 (x2, 
E_DImode) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      if (!contiguous_bitmask_operand (operands[3], E_DImode))
        return -1;
      if (
#line 4400 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZEC12))
        return 1944; /* *risbgn_di_and_rot */
      if (pnum_clobbers == NULL
          || !
#line 4400 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
        return -1;
      *pnum_clobbers = 1;
      return 1945; /* *risbg_di_and_rot */

    case LSHIFTRT:
      switch (pattern116 (x2))
        {
        case 0:
          if ((
#line 8007 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (64, -INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return 2343; /* *extzv_di_srl_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 8007 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (64, -INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2344; /* *extzv_di_srl_clobbercc */

        case 1:
          if (
#line 8007 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (32, -INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return 2345; /* *extzv_si_srl_nocc */
          if (pnum_clobbers == NULL
              || !
#line 8007 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (32, -INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return -1;
          *pnum_clobbers = 1;
          return 2346; /* *extzv_si_srl_clobbercc */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern116 (x2))
        {
        case 0:
          if ((
#line 8021 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZEC12
   && s390_extzv_shift_ok (64, INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return 2347; /* *extzv_di_sll_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 8021 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && s390_extzv_shift_ok (64, INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2348; /* *extzv_di_sll_clobbercc */

        case 1:
          if (
#line 8021 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZEC12
   && s390_extzv_shift_ok (32, INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return 2349; /* *extzv_si_sll_nocc */
          if (pnum_clobbers == NULL
              || !
#line 8021 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && s390_extzv_shift_ok (32, INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return -1;
          *pnum_clobbers = 1;
          return 2350; /* *extzv_si_sll_clobbercc */

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (GET_MODE (x2) != E_DImode
                  || GET_MODE (x3) != E_DImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_DImode)
                  && nonimmediate_operand (operands[1], E_DImode)
                  && general_operand (operands[2], E_DImode)
                  && (
#line 8229 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                {
                  *pnum_clobbers = 1;
                  return 2359; /* *andc_split_di */
                }
              if (!register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !register_operand (operands[2], E_DImode)
                  || !(
#line 8608 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2381; /* *andcdi */

            case E_SImode:
              if (GET_MODE (x2) != E_SImode
                  || GET_MODE (x3) != E_SImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_SImode)
                  && nonimmediate_operand (operands[1], E_SImode)
                  && general_operand (operands[2], E_SImode)
                  && 
#line 8229 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))))
                {
                  *pnum_clobbers = 1;
                  return 2360; /* *andc_split_si */
                }
              if (!register_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode)
                  || !
#line 8608 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              *pnum_clobbers = 1;
              return 2383; /* *andcsi */

            default:
              return -1;
            }

        case NOT:
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern130 (x2, 
E_DImode) != 0
                  || !(
#line 8648 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2393; /* *nordi */

            case E_SImode:
              if (pattern130 (x2, 
E_SImode) != 0
                  || !
#line 8648 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              *pnum_clobbers = 1;
              return 2395; /* *norsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern65 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 860; /* xorv1qi3 */
          break;

        case 1:
          if (
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 861; /* xorv2qi3 */
          break;

        case 2:
          if (
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 862; /* xorv4qi3 */
          break;

        case 3:
          if (
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 863; /* xorv8qi3 */
          break;

        case 4:
          if (
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 864; /* xorv16qi3 */
          break;

        case 5:
          if (
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 865; /* xorv1hi3 */
          break;

        case 6:
          if (
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 866; /* xorv2hi3 */
          break;

        case 7:
          if (
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 867; /* xorv4hi3 */
          break;

        case 8:
          if (
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 868; /* xorv8hi3 */
          break;

        case 9:
          if (
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 869; /* xorv1si3 */
          break;

        case 10:
          if (
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 870; /* xorv2si3 */
          break;

        case 11:
          if (
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 871; /* xorv4si3 */
          break;

        case 12:
          if (
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 872; /* xorv1di3 */
          break;

        case 13:
          if (
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 873; /* xorv2di3 */
          break;

        case 14:
          if (
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 874; /* xorv1sf3 */
          break;

        case 15:
          if (
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 875; /* xorv2sf3 */
          break;

        case 16:
          if (
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 876; /* xorv4sf3 */
          break;

        case 17:
          if (
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 877; /* xorv1df3 */
          break;

        case 18:
          if (
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 878; /* xorv2df3 */
          break;

        case 19:
          if (
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 879; /* xorv1tf3 */
          break;

        case 20:
          if (
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 880; /* xorv1ti3 */
          break;

        case 21:
          if (
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return 881; /* xorti3 */
          break;

        case 22:
          if (
#line 8788 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2402; /* *xordi3 */
            }
          break;

        case 23:
          if (
#line 8891 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2406; /* *xorhi3 */
            }
          break;

        case 24:
          if (
#line 8921 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2407; /* *xorqi3 */
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      if (GET_CODE (x4) == SUBREG
          && pattern131 (x3) == 0
          && 
#line 4788 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10))
        {
          *pnum_clobbers = 1;
          return 1997; /* *rxsbg_sidi_srl */
        }
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!general_operand (operands[2], E_SImode)
          || !
#line 8858 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
        return -1;
      *pnum_clobbers = 1;
      return 2405; /* *xorsi3 */

    case AND:
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x7;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_V1QImode:
                  if (pattern8 (x3, 
E_V1QImode) != 0
                      || !
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1579; /* *vevalv1qi_xorand */

                case E_V2QImode:
                  if (pattern8 (x3, 
E_V2QImode) != 0
                      || !
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1588; /* *vevalv2qi_xorand */

                case E_V4QImode:
                  if (pattern8 (x3, 
E_V4QImode) != 0
                      || !
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1597; /* *vevalv4qi_xorand */

                case E_V8QImode:
                  if (pattern8 (x3, 
E_V8QImode) != 0
                      || !
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1606; /* *vevalv8qi_xorand */

                case E_V16QImode:
                  if (pattern8 (x3, 
E_V16QImode) != 0
                      || !
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1615; /* *vevalv16qi_xorand */

                case E_V1HImode:
                  if (pattern8 (x3, 
E_V1HImode) != 0
                      || !
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1624; /* *vevalv1hi_xorand */

                case E_V2HImode:
                  if (pattern8 (x3, 
E_V2HImode) != 0
                      || !
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1633; /* *vevalv2hi_xorand */

                case E_V4HImode:
                  if (pattern8 (x3, 
E_V4HImode) != 0
                      || !
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1642; /* *vevalv4hi_xorand */

                case E_V8HImode:
                  if (pattern8 (x3, 
E_V8HImode) != 0
                      || !
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1651; /* *vevalv8hi_xorand */

                case E_V1SImode:
                  if (pattern8 (x3, 
E_V1SImode) != 0
                      || !
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1660; /* *vevalv1si_xorand */

                case E_V2SImode:
                  if (pattern8 (x3, 
E_V2SImode) != 0
                      || !
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1669; /* *vevalv2si_xorand */

                case E_V4SImode:
                  if (pattern8 (x3, 
E_V4SImode) != 0
                      || !
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1678; /* *vevalv4si_xorand */

                case E_V1DImode:
                  if (pattern8 (x3, 
E_V1DImode) != 0
                      || !
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1687; /* *vevalv1di_xorand */

                case E_V2DImode:
                  if (pattern8 (x3, 
E_V2DImode) != 0
                      || !
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1696; /* *vevalv2di_xorand */

                case E_V1TImode:
                  if (pattern8 (x3, 
E_V1TImode) != 0
                      || !
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1705; /* *vevalv1ti_xorand */

                case E_TImode:
                  if (pattern8 (x3, 
E_TImode) != 0
                      || !
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1714; /* *vevalti_xorand */

                default:
                  return -1;
                }

            case CONST_INT:
              if (pnum_clobbers == NULL)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern189 (x3, 
E_DImode) != 0
                      || !(
#line 4681 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1975; /* *rxsbg_di_noshift */

                case E_SImode:
                  if (pattern189 (x3, 
E_SImode) != 0
                      || !
#line 4681 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1977; /* *rxsbg_si_noshift */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ROTATE:
          if (pattern60 (x3, pnum_clobbers) != 0
              || !contiguous_bitmask_operand (operands[2], E_DImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[4] = x5;
          if (!nonimmediate_operand (operands[4], E_DImode)
              || !
#line 4696 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1979; /* *rxsbg_di_rotl */

        case LSHIFTRT:
          switch (pattern86 (x3, pnum_clobbers))
            {
            case 0:
              if (!(
#line 4711 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 1981; /* *rxsbg_di_srl_bitmask */

            case 1:
              if (!
#line 4711 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 1983; /* *rxsbg_si_srl_bitmask */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern86 (x3, pnum_clobbers))
            {
            case 0:
              if (!(
#line 4731 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 1985; /* *rxsbg_di_sll_bitmask */

            case 1:
              if (!
#line 4731 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 1987; /* *rxsbg_si_sll_bitmask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1580; /* *vevalv1qi_xorior */

        case 1:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1589; /* *vevalv2qi_xorior */

        case 2:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1598; /* *vevalv4qi_xorior */

        case 3:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1607; /* *vevalv8qi_xorior */

        case 4:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1616; /* *vevalv16qi_xorior */

        case 5:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1625; /* *vevalv1hi_xorior */

        case 6:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1634; /* *vevalv2hi_xorior */

        case 7:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1643; /* *vevalv4hi_xorior */

        case 8:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1652; /* *vevalv8hi_xorior */

        case 9:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1661; /* *vevalv1si_xorior */

        case 10:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1670; /* *vevalv2si_xorior */

        case 11:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1679; /* *vevalv4si_xorior */

        case 12:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1688; /* *vevalv1di_xorior */

        case 13:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1697; /* *vevalv2di_xorior */

        case 14:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1706; /* *vevalv1ti_xorior */

        case 15:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1715; /* *vevalti_xorior */

        default:
          return -1;
        }

    case XOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1581; /* *vevalv1qi_xorxor */

        case 1:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1590; /* *vevalv2qi_xorxor */

        case 2:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1599; /* *vevalv4qi_xorxor */

        case 3:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1608; /* *vevalv8qi_xorxor */

        case 4:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1617; /* *vevalv16qi_xorxor */

        case 5:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1626; /* *vevalv1hi_xorxor */

        case 6:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1635; /* *vevalv2hi_xorxor */

        case 7:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1644; /* *vevalv4hi_xorxor */

        case 8:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1653; /* *vevalv8hi_xorxor */

        case 9:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1662; /* *vevalv1si_xorxor */

        case 10:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1671; /* *vevalv2si_xorxor */

        case 11:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1680; /* *vevalv4si_xorxor */

        case 12:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1689; /* *vevalv1di_xorxor */

        case 13:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1698; /* *vevalv2di_xorxor */

        case 14:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1707; /* *vevalv1ti_xorxor */

        case 15:
          if (!
#line 3400 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1716; /* *vevalti_xorxor */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern31 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4749 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1989; /* *rxsbg_di_sll */

        case 1:
          if (!
#line 4749 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1991; /* *rxsbg_si_sll */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern31 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4768 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1993; /* *rxsbg_di_srl */

        case 1:
          if (!
#line 4768 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1995; /* *rxsbg_si_srl */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern213 (x2) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == E_CCL1mode)
    {
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) == E_CCL1mode)
        {
          x6 = XEXP (x5, 1);
          if (rtx_equal_p (x6, operands[1]))
            {
              x7 = XEXP (x5, 0);
              switch (GET_MODE (x7))
                {
                case E_DImode:
                  if (pattern277 (x1, 
E_DImode) == 0
                      && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2280; /* adddi3_alc_carry1_cc */
                  break;

                case E_SImode:
                  if (pattern277 (x1, 
E_SImode) == 0)
                    return 2281; /* addsi3_alc_carry1_cc */
                  break;

                default:
                  break;
                }
            }
        }
    }
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XEXP (x5, 0);
  switch (GET_MODE (x7))
    {
    case E_DImode:
      if (pattern277 (x1, 
E_DImode) != 0
          || !(
#line 7056 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 2284; /* *adddi3_alc_carry2_cc */

    case E_SImode:
      if (pattern277 (x1, 
E_SImode) != 0
          || !
#line 7056 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
        return -1;
      return 2285; /* *addsi3_alc_carry2_cc */

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x6) != E_DImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!general_operand (operands[2], E_SImode))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x9))
            {
            case SET:
              x10 = XEXP (x9, 1);
              if (GET_CODE (x10) != MINUS
                  || GET_MODE (x10) != E_DImode)
                return -1;
              x11 = XEXP (x10, 1);
              if (GET_CODE (x11) != ZERO_EXTEND
                  || GET_MODE (x11) != E_DImode)
                return -1;
              x12 = XEXP (x9, 0);
              operands[0] = x12;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              x13 = XEXP (x10, 0);
              if (!rtx_equal_p (x13, operands[1]))
                return -1;
              x14 = XEXP (x11, 0);
              if (!rtx_equal_p (x14, operands[2])
                  || !
#line 6669 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
                return -1;
              return 2240; /* *subdi3_zero_cc */

            case CLOBBER:
              x12 = XEXP (x9, 0);
              operands[0] = x12;
              if (!scratch_operand (operands[0], E_DImode)
                  || !
#line 6682 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
                return -1;
              return 2241; /* *subdi3_zero_cconly */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x6;
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              if (!rtx_equal_p (x7, operands[1]))
                return -1;
              switch (pattern226 (x1))
                {
                case 0:
                  x15 = XEXP (x2, 0);
                  if (GET_MODE (x15) != E_CCL2mode
                      || GET_MODE (x3) != E_CCL2mode)
                    return -1;
                  switch (pattern245 (x1))
                    {
                    case 0:
                      if (!
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH))
                        return -1;
                      return 2247; /* subdi3_borrow_cc */

                    case 1:
                      return 2248; /* subsi3_borrow_cc */

                    default:
                      return -1;
                    }

                case 1:
                  if (!(
#line 6796 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 2249; /* *subdi3_borrow_cconly */

                case 2:
                  if (!
#line 6796 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)))
                    return -1;
                  return 2250; /* *subsi3_borrow_cconly */

                default:
                  return -1;
                }

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  switch (pattern226 (x1))
                    {
                    case 0:
                      switch (pattern245 (x1))
                        {
                        case 0:
                          if ((
#line 6814 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                            return 2251; /* *subdi3_cc */
                          break;

                        case 1:
                          if (
#line 6814 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                            return 2252; /* *subsi3_cc */
                          break;

                        default:
                          break;
                        }
                      break;

                    case 1:
                      if ((
#line 6848 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return 2255; /* *subdi3_cconly */
                      break;

                    case 2:
                      if (
#line 6848 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                        return 2256; /* *subsi3_cconly */
                      break;

                    default:
                      break;
                    }
                }
              operands[3] = x7;
              x9 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x9))
                {
                case SET:
                  x10 = XEXP (x9, 1);
                  if (GET_CODE (x10) != MINUS)
                    return -1;
                  x12 = XEXP (x9, 0);
                  operands[0] = x12;
                  x13 = XEXP (x10, 0);
                  if (!rtx_equal_p (x13, operands[1]))
                    return -1;
                  x11 = XEXP (x10, 1);
                  if (!rtx_equal_p (x11, operands[2]))
                    return -1;
                  switch (GET_MODE (x4))
                    {
                    case E_TFmode:
                      if (pattern276 (x10, 
E_TFmode) != 0
                          || !(
#line 6951 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_VXE)))
                        return -1;
                      return 2268; /* *subtf3_cc */

                    case E_FPRX2mode:
                      if (pattern276 (x10, 
E_FPRX2mode) != 0
                          || !(
#line 6951 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VXE)))
                        return -1;
                      return 2269; /* *subfprx23_cc */

                    case E_DFmode:
                      if (pattern276 (x10, 
E_DFmode) != 0
                          || !
#line 6951 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 2270; /* *subdf3_cc */

                    case E_SFmode:
                      if (pattern276 (x10, 
E_SFmode) != 0
                          || !
#line 6951 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 2271; /* *subsf3_cc */

                    case E_TDmode:
                      if (pattern276 (x10, 
E_TDmode) != 0
                          || !(
#line 6951 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 2272; /* *subtd3_cc */

                    case E_DDmode:
                      if (pattern276 (x10, 
E_DDmode) != 0
                          || !(
#line 6951 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 2273; /* *subdd3_cc */

                    default:
                      return -1;
                    }

                case CLOBBER:
                  x12 = XEXP (x9, 0);
                  operands[0] = x12;
                  switch (GET_MODE (x4))
                    {
                    case E_TFmode:
                      if (pattern256 (
E_TFmode) != 0
                          || !(
#line 6967 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_VXE)))
                        return -1;
                      return 2274; /* *subtf3_cconly */

                    case E_FPRX2mode:
                      if (pattern256 (
E_FPRX2mode) != 0
                          || !(
#line 6967 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VXE)))
                        return -1;
                      return 2275; /* *subfprx23_cconly */

                    case E_DFmode:
                      if (pattern256 (
E_DFmode) != 0
                          || !
#line 6967 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 2276; /* *subdf3_cconly */

                    case E_SFmode:
                      if (pattern256 (
E_SFmode) != 0
                          || !
#line 6967 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 2277; /* *subsf3_cconly */

                    case E_TDmode:
                      if (pattern256 (
E_TDmode) != 0
                          || !(
#line 6967 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 2278; /* *subtd3_cconly */

                    case E_DDmode:
                      if (pattern256 (
E_DDmode) != 0
                          || !(
#line 6967 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 2279; /* *subdd3_cconly */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern144 (x1, 
MINUS))
        {
        case 0:
          if (pattern286 (x1, 
E_DImode, 
E_TImode) != 0
              || !(
#line 6909 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2260; /* *subvdi3_ccoverflow */

        case 1:
          if (pattern286 (x1, 
E_SImode, 
E_DImode) != 0
              || !
#line 6909 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)))
            return -1;
          return 2261; /* *subvsi3_ccoverflow */

        default:
          return -1;
        }

    case MINUS:
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != MINUS)
        return -1;
      x13 = XEXP (x10, 0);
      if (GET_CODE (x13) != MINUS)
        return -1;
      x16 = XEXP (x5, 0);
      operands[1] = x16;
      x17 = XEXP (x5, 1);
      operands[2] = x17;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x12 = XEXP (x9, 0);
      operands[0] = x12;
      x18 = XEXP (x13, 0);
      if (!rtx_equal_p (x18, operands[1]))
        return -1;
      x19 = XEXP (x13, 1);
      if (!rtx_equal_p (x19, operands[2]))
        return -1;
      x11 = XEXP (x10, 1);
      if (!rtx_equal_p (x11, operands[3]))
        return -1;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          if (XWINT (x7, 0) != 0L)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern287 (x1, 
E_DImode) != 0
                  || !(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2292; /* *subdi3_slb_cc */

            case E_SImode:
              if (pattern287 (x1, 
E_SImode) != 0
                  || !
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                return -1;
              return 2293; /* *subsi3_slb_cc */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          x15 = XEXP (x2, 0);
          if (GET_MODE (x15) != E_CCL2mode
              || GET_MODE (x3) != E_CCL2mode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern287 (x1, 
E_DImode) != 0
                  || !
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2296; /* subdi3_slb_borrow1_cc */

            case E_SImode:
              if (pattern287 (x1, 
E_SImode) != 0)
                return -1;
              return 2297; /* subsi3_slb_borrow1_cc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case BSWAP:
      return recog_104 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_102 (x1, insn, pnum_clobbers);

    case COMPARE:
      return recog_101 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      switch (pattern36 (x1))
        {
        case 0:
          if (!
#line 1007 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 678; /* *eltswapv16qi */

        case 1:
          if (!
#line 1077 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 680; /* eltswapv4si */

        case 2:
          if (!
#line 1077 "../../gcc-15.1.1-20250425/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 681; /* eltswapv4sf */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      res = recog_88 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern70 (x1))
        {
        case 0:
          if (!(
#line 5890 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2142; /* *trunctftd2 */

        case 1:
          if (!(
#line 5890 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2143; /* *truncfprx2td2 */

        case 2:
          if (!
#line 5890 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2144; /* *truncdftd2 */

        case 3:
          if (!
#line 5890 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2145; /* *truncsftd2 */

        case 4:
          if (!(
#line 5890 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2146; /* *trunctfdd2 */

        case 5:
          if (!(
#line 5890 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2147; /* *truncfprx2dd2 */

        case 6:
          if (!
#line 5890 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2148; /* *truncdfdd2 */

        case 7:
          if (!
#line 5890 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2149; /* *truncsfdd2 */

        case 8:
          if (!(
#line 5890 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2150; /* *trunctfsd2 */

        case 9:
          if (!(
#line 5890 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2151; /* *truncfprx2sd2 */

        case 10:
          if (!
#line 5890 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2152; /* *truncdfsd2 */

        case 11:
          if (!
#line 5890 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2153; /* *truncsfsd2 */

        case 12:
          if (!(
#line 5899 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2154; /* *trunctdtf2 */

        case 13:
          if (!(
#line 5899 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2158; /* *truncddtf2 */

        case 14:
          if (!(
#line 5899 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2162; /* *truncsdtf2 */

        case 15:
          if (!(
#line 5899 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2155; /* *trunctdfprx22 */

        case 16:
          if (!(
#line 5899 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2159; /* *truncddfprx22 */

        case 17:
          if (!(
#line 5899 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2163; /* *truncsdfprx22 */

        case 18:
          if (!
#line 5899 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2156; /* *trunctddf2 */

        case 19:
          if (!
#line 5899 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2160; /* *truncdddf2 */

        case 20:
          if (!
#line 5899 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2164; /* *truncsddf2 */

        case 21:
          if (!
#line 5899 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2157; /* *trunctdsf2 */

        case 22:
          if (!
#line 5899 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2161; /* *truncddsf2 */

        case 23:
          if (!
#line 5899 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2165; /* *truncsdsf2 */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
          res = recog_91 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (!s390_unsigned_integer_comparison (x5, E_VOIDmode))
        return -1;
      operands[0] = x5;
      switch (pattern118 (x1))
        {
        case 0:
          if (!(
#line 1668 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1803; /* *cmp_and_br_unsigned_di */

        case 1:
          if (!
#line 1668 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          return 1804; /* *cmp_and_br_unsigned_si */

        case 2:
          if (!(
#line 1726 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1807; /* *icmp_and_br_unsigned_di */

        case 3:
          if (!
#line 1726 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          return 1808; /* *icmp_and_br_unsigned_si */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      return recog_105 (x1, insn, pnum_clobbers);

    case ZERO_EXTRACT:
      x6 = XEXP (x3, 2);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[3] = x6;
      if (const_int_operand (operands[3], E_VOIDmode))
        {
          res = recog_100 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XWINT (x6, 0) != 0L)
        return -1;
      switch (pattern72 (x1))
        {
        case 0:
          if (!(
#line 4411 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_Z10) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1946; /* *pre_z10_extzvdi */

        case 1:
          if (!
#line 4411 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_Z10))
            return -1;
          return 1947; /* *pre_z10_extzvsi */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT
          || GET_MODE (x4) != E_DImode
          || pattern90 (x1) != 0
          || !register_operand (operands[0], E_DImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[1] = x7;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 2);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[3] = x5;
      if (!register_operand (operands[3], E_DImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[4] = x9;
      if (!nonzero_shift_count_operand (operands[4], E_DImode)
          || !
#line 4330 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && 64 - UINTVAL (operands[4]) >= UINTVAL (operands[1])))
        return -1;
      return 1925; /* *extzvdi_clobbercc_lshiftrt */

    case IOR:
      return recog_103 (x1, insn, pnum_clobbers);

    case NE:
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern38 (x1) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTRACT:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x10 = XEXP (x5, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x11 = XEXP (x5, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x12 = XEXP (x5, 2);
          operands[2] = x12;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || !
#line 4363 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (1, INTVAL (operands[2]), 64)))
            return -1;
          return 1931; /* *extract1bitdi_clobbercc */

        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_CCZ1mode)
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          return 2302; /* sne */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      x6 = XEXP (x3, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 1948; /* *pre_z10_extvdi */

        case 1:
          return 1949; /* *pre_z10_extvsi */

        default:
          return -1;
        }

    case XOR:
      return recog_107 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      x13 = XVECEXP (x1, 0, 1);
      if (pattern37 (x13, pnum_clobbers) != 0)
        return -1;
      switch (pattern150 (x1))
        {
        case 0:
          if (
#line 5517 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            {
              *pnum_clobbers = 1;
              return 2038; /* *fixuns_truncdfdi2_z13 */
            }
          if (!(
#line 5532 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DFmode != DFmode)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2044; /* *fixuns_truncdfdi2_z196 */

        case 1:
          if (!(
#line 5532 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TFmode != DFmode)) && (((
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 751 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_VXE)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2040; /* *fixuns_trunctfdi2_z196 */

        case 2:
          if (!(
#line 5532 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || FPRX2mode != DFmode)) && (((
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 751 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VXE)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2042; /* *fixuns_truncfprx2di2_z196 */

        case 3:
          if (!(
#line 5532 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || SFmode != DFmode)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2046; /* *fixuns_truncsfdi2_z196 */

        case 4:
          if (!(
#line 5532 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TDmode != DFmode)) && (((
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 752 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2048; /* *fixuns_trunctddi2_z196 */

        case 5:
          if (!(
#line 5532 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DDmode != DFmode)) && (((
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 752 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2050; /* *fixuns_truncdddi2_z196 */

        case 6:
          if (!(
#line 5517 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 767 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return -1;
          *pnum_clobbers = 1;
          return 2039; /* *fixuns_truncsfsi2_z13 */

        case 7:
          if (!
#line 5532 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || SFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2047; /* *fixuns_truncsfsi2_z196 */

        case 8:
          if (!(
#line 5532 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TFmode != DFmode)) && 
#line 751 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2041; /* *fixuns_trunctfsi2_z196 */

        case 9:
          if (!(
#line 5532 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || FPRX2mode != DFmode)) && 
#line 751 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2043; /* *fixuns_truncfprx2si2_z196 */

        case 10:
          if (!
#line 5532 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2045; /* *fixuns_truncdfsi2_z196 */

        case 11:
          if (!(
#line 5532 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TDmode != DFmode)) && 
#line 752 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          *pnum_clobbers = 1;
          return 2049; /* *fixuns_trunctdsi2_z196 */

        case 12:
          if (!(
#line 5532 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DDmode != DFmode)) && 
#line 752 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          *pnum_clobbers = 1;
          return 2051; /* *fixuns_truncddsi2_z196 */

        default:
          return -1;
        }

    case FIX:
      x13 = XVECEXP (x1, 0, 1);
      if (pattern37 (x13, pnum_clobbers) != 0)
        return -1;
      switch (pattern151 (x1))
        {
        case 0:
          if (
#line 5555 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            {
              *pnum_clobbers = 1;
              return 2052; /* *fix_truncdfdi2_bfp_z13 */
            }
          if (!(
#line 5568 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DFmode != DFmode)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2058; /* *fix_truncdfdi2_bfp */

        case 1:
          if (!(
#line 5568 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TFmode != DFmode)) && (((
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_VXE)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2054; /* *fix_trunctfdi2_bfp */

        case 2:
          if (!(
#line 5568 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || FPRX2mode != DFmode)) && (((
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VXE)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2056; /* *fix_truncfprx2di2_bfp */

        case 3:
          if (!(
#line 5568 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || SFmode != DFmode)) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2060; /* *fix_truncsfdi2_bfp */

        case 4:
          if (!
#line 5602 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 1;
          return 2062; /* fix_trunctddi2_dfp */

        case 5:
          if (!
#line 5602 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 1;
          return 2063; /* fix_truncdddi2_dfp */

        case 6:
          if ((
#line 5555 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 767 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VXE2)))
            {
              *pnum_clobbers = 1;
              return 2053; /* *fix_truncsfsi2_bfp_z13 */
            }
          if (!
#line 5568 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || SFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2061; /* *fix_truncsfsi2_bfp */

        case 7:
          if (!(
#line 5568 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TFmode != DFmode)) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2055; /* *fix_trunctfsi2_bfp */

        case 8:
          if (!(
#line 5568 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || FPRX2mode != DFmode)) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2057; /* *fix_truncfprx2si2_bfp */

        case 9:
          if (!
#line 5568 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2059; /* *fix_truncdfsi2_bfp */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern70 (x1))
        {
        case 0:
          if (!(
#line 5964 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2166; /* *extendtftd2 */

        case 1:
          if (!(
#line 5964 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2167; /* *extendfprx2td2 */

        case 2:
          if (!
#line 5964 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2168; /* *extenddftd2 */

        case 3:
          if (!
#line 5964 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2169; /* *extendsftd2 */

        case 4:
          if (!(
#line 5964 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2170; /* *extendtfdd2 */

        case 5:
          if (!(
#line 5964 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2171; /* *extendfprx2dd2 */

        case 6:
          if (!
#line 5964 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2172; /* *extenddfdd2 */

        case 7:
          if (!
#line 5964 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2173; /* *extendsfdd2 */

        case 8:
          if (!(
#line 5964 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2174; /* *extendtfsd2 */

        case 9:
          if (!(
#line 5964 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2175; /* *extendfprx2sd2 */

        case 10:
          if (!
#line 5964 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2176; /* *extenddfsd2 */

        case 11:
          if (!
#line 5964 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2177; /* *extendsfsd2 */

        case 12:
          if (!(
#line 5972 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2178; /* *extendtdtf2 */

        case 13:
          if (!(
#line 5972 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2182; /* *extendddtf2 */

        case 14:
          if (!(
#line 5972 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2186; /* *extendsdtf2 */

        case 15:
          if (!(
#line 5972 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2179; /* *extendtdfprx22 */

        case 16:
          if (!(
#line 5972 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2183; /* *extendddfprx22 */

        case 17:
          if (!(
#line 5972 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2187; /* *extendsdfprx22 */

        case 18:
          if (!
#line 5972 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2180; /* *extendtddf2 */

        case 19:
          if (!
#line 5972 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2184; /* *extenddddf2 */

        case 20:
          if (!
#line 5972 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2188; /* *extendsddf2 */

        case 21:
          if (!
#line 5972 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2181; /* *extendtdsf2 */

        case 22:
          if (!
#line 5972 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2185; /* *extendddsf2 */

        case 23:
          if (!
#line 5972 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2189; /* *extendsdsf2 */

        default:
          return -1;
        }

    case NOT:
      if (pattern38 (x1) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          switch (pattern193 (x3))
            {
            case 0:
              if (!(
#line 8657 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2397; /* *notdi */

            case 1:
              if (!
#line 8657 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2398; /* *notsi */

            default:
              return -1;
            }

        case XOR:
          x11 = XEXP (x5, 0);
          operands[1] = x11;
          x10 = XEXP (x5, 1);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern227 (x3, 
E_DImode) != 0
                  || !(
#line 9062 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2414; /* *nxordi */

            case E_SImode:
              if (pattern227 (x3, 
E_SImode) != 0
                  || !
#line 9062 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2415; /* *nxorsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      return recog_106 (x1, insn, pnum_clobbers);

    case ABS:
      if (pattern38 (x1) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          if (pattern178 (x3) != 0
              || !
#line 9300 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2444; /* *absdi2_sign */

        case REG:
        case SUBREG:
          switch (pattern179 (x3))
            {
            case 0:
              if (!
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2449; /* absdi2 */

            case 1:
              return 2450; /* abssi2 */

            case 2:
              if (!(
#line 9388 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2465; /* *abstf2 */

            case 3:
              if (!(
#line 9388 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2466; /* *absfprx22 */

            case 4:
              if (!
#line 9388 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2467; /* *absdf2 */

            case 5:
              if (!
#line 9388 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2468; /* *abssf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x13 = XVECEXP (x1, 0, 1);
      if (pattern39 (x13) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      if (!shift_count_operand (operands[2], E_QImode))
        return -1;
      switch (pattern193 (x3))
        {
        case 0:
          if (
#line 9730 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2510; /* *ashrdi3_31 */
          if (!
#line 771 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2513; /* *ashrdi3 */

        case 1:
          return 2516; /* *ashrsi3 */

        default:
          return -1;
        }

    case CALL:
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_QImode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x11 = XEXP (x5, 0);
      operands[1] = x11;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x14 = XEXP (x13, 0);
      operands[3] = x14;
      if (!register_operand (operands[3], E_VOIDmode))
        return -1;
      if (bras_sym_operand (operands[1], E_VOIDmode))
        {
          if (const_int_operand (operands[2], E_SImode)
              && 
#line 10971 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)
   && TARGET_SMALL_EXEC
   && GET_MODE (operands[3]) == Pmode))
            return 2574; /* *bras_r */
          if (const_int_operand (operands[2], E_VOIDmode)
              && 
#line 10984 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)

   && GET_MODE (operands[3]) == Pmode))
            return 2575; /* *brasl_r */
        }
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      if (address_operand (operands[1], E_VOIDmode)
          && 
#line 10998 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode))
        return 2576; /* *basr_r */
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      if (
#line 11022 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode))
        return 2577; /* *basr_r_via_thunk_z10 */
      if (pnum_clobbers == NULL)
        return -1;
      if ((
#line 11045 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 778 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 2578; /* *basr_r_via_thunk */
        }
      if (!(
#line 11045 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 778 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 2579; /* *basr_r_via_thunk */

    case POPCOUNT:
      if (pattern40 (x1) != 0
          || !
#line 12106 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_Z15))
        return -1;
      return 2636; /* *popcountdi_z15 */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 16
          || GET_MODE (x3) != E_CCRAWmode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 33
          || GET_MODE (x4) != E_CCRAWmode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != SET)
        return -1;
      x15 = XEXP (x13, 1);
      if (pattern152 (x15, 
E_BLKmode, 
17, 
UNSPEC_VOLATILE, 
1) != 0)
        return -1;
      x16 = XVECEXP (x3, 0, 0);
      operands[0] = x16;
      if (!const_int_operand (operands[0], E_VOIDmode))
        return -1;
      x14 = XEXP (x13, 0);
      operands[1] = x14;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x17 = XVECEXP (x15, 0, 0);
      if (!rtx_equal_p (x17, operands[0]))
        return -1;
      if (pnum_clobbers != NULL)
        {
          if (
#line 12380 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_VX && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
            {
              *pnum_clobbers = 32;
              return 2648; /* tbegin_1_z13 */
            }
          if (
#line 12408 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
            {
              *pnum_clobbers = 16;
              return 2649; /* tbegin_1 */
            }
        }
      if (!
#line 12419 "../../gcc-15.1.1-20250425/gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
        return -1;
      return 2650; /* tbegin_nofloat_1 */

    default:
      return -1;
    }
}
