/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[1], E_HFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM8DImode)
      || GET_MODE (x1) != E_RVVM8DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8DFmode:
      if (!register_operand (operands[1], E_RVVM8DFmode))
        return -1;
      return 0;

    case E_RVVM4SFmode:
      if (!register_operand (operands[1], E_RVVM4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1DImode)
      || GET_MODE (x1) != E_RVVM1DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM1DFmode:
      if (!register_operand (operands[1], E_RVVM1DFmode))
        return -1;
      return 0;

    case E_RVVMF2SFmode:
      if (!register_operand (operands[1], E_RVVMF2SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V64HImode)
      || GET_MODE (x1) != E_V64HImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V64HFmode:
      if (!register_operand (operands[1], E_V64HFmode))
        return -1;
      return 0;

    case E_V64SFmode:
      if (!register_operand (operands[1], E_V64SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 0;

    case E_V4HFmode:
      if (!register_operand (operands[1], E_V4HFmode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512SImode)
      || GET_MODE (x1) != E_V512SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512SFmode:
      if (!register_operand (operands[1], E_V512SFmode))
        return -1;
      return 0;

    case E_V512HFmode:
      if (!register_operand (operands[1], E_V512HFmode))
        return -1;
      return 1;

    case E_V512DFmode:
      if (!register_operand (operands[1], E_V512DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern51 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512DImode)
      || GET_MODE (x1) != E_V512DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512DFmode:
      if (!register_operand (operands[1], E_V512DFmode))
        return -1;
      return 0;

    case E_V512SFmode:
      if (!register_operand (operands[1], E_V512SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVMF4HFmode)
      || GET_MODE (x1) != E_RVVMF4HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVMF4HImode:
      if (!register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 0;

    case E_RVVMF8QImode:
      if (!register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 1;

    case E_RVVMF2SImode:
      if (!register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern64 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM8DFmode)
      || GET_MODE (x1) != E_RVVM8DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8DImode:
      if (!register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 0;

    case E_RVVM4SImode:
      if (!register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM2DFmode)
      || GET_MODE (x1) != E_RVVM2DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM2DImode:
      if (!register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 0;

    case E_RVVM1SImode:
      if (!register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16HFmode)
      || GET_MODE (x1) != E_V16HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V1024HFmode)
      || GET_MODE (x1) != E_V1024HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V1024HImode:
      if (!register_operand (operands[1], E_V1024HImode))
        return -1;
      return 0;

    case E_V1024QImode:
      if (!register_operand (operands[1], E_V1024QImode))
        return -1;
      return 1;

    case E_V1024SImode:
      if (!register_operand (operands[1], E_V1024SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V32SFmode)
      || GET_MODE (x1) != E_V32SFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32SImode:
      if (!register_operand (operands[1], E_V32SImode))
        return -1;
      return 0;

    case E_V32HImode:
      if (!register_operand (operands[1], E_V32HImode))
        return -1;
      return 1;

    case E_V32DImode:
      if (!register_operand (operands[1], E_V32DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DFmode)
      || GET_MODE (x1) != E_V2DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      return 0;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V256DFmode)
      || GET_MODE (x1) != E_V256DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V256DImode:
      if (!register_operand (operands[1], E_V256DImode))
        return -1;
      return 0;

    case E_V256SImode:
      if (!register_operand (operands[1], E_V256SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern106 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  return pattern105 (x2); /* [-1, 2] */
}

int
pattern108 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[2], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !vector_mask_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (pattern3 (x3) != 0)
        return -1;
      return 1;

    case E_RVVM8QImode:
      if (pattern0 (x3, 
E_RVVM8QImode) != 0)
        return -1;
      return 2;

    case E_RVVM4QImode:
      if (pattern0 (x3, 
E_RVVM4QImode) != 0)
        return -1;
      return 3;

    case E_RVVM2QImode:
      if (pattern0 (x3, 
E_RVVM2QImode) != 0)
        return -1;
      return 4;

    case E_RVVM1QImode:
      if (pattern0 (x3, 
E_RVVM1QImode) != 0)
        return -1;
      return 5;

    case E_RVVM8HImode:
      if (pattern0 (x3, 
E_RVVM8HImode) != 0)
        return -1;
      return 6;

    case E_RVVM4HImode:
      if (pattern0 (x3, 
E_RVVM4HImode) != 0)
        return -1;
      return 7;

    case E_RVVM2HImode:
      if (pattern0 (x3, 
E_RVVM2HImode) != 0)
        return -1;
      return 8;

    case E_RVVM1HImode:
      if (pattern0 (x3, 
E_RVVM1HImode) != 0)
        return -1;
      return 9;

    case E_RVVM8SImode:
      if (pattern0 (x3, 
E_RVVM8SImode) != 0)
        return -1;
      return 10;

    case E_RVVM4SImode:
      if (pattern0 (x3, 
E_RVVM4SImode) != 0)
        return -1;
      return 11;

    case E_RVVM2SImode:
      if (pattern0 (x3, 
E_RVVM2SImode) != 0)
        return -1;
      return 12;

    case E_RVVM1SImode:
      if (pattern0 (x3, 
E_RVVM1SImode) != 0)
        return -1;
      return 13;

    case E_RVVM8DImode:
      if (pattern0 (x3, 
E_RVVM8DImode) != 0)
        return -1;
      return 14;

    case E_RVVM4DImode:
      if (pattern0 (x3, 
E_RVVM4DImode) != 0)
        return -1;
      return 15;

    case E_RVVM2DImode:
      if (pattern0 (x3, 
E_RVVM2DImode) != 0)
        return -1;
      return 16;

    case E_RVVM1DImode:
      if (pattern0 (x3, 
E_RVVM1DImode) != 0)
        return -1;
      return 17;

    case E_RVVMF2QImode:
      if (pattern0 (x3, 
E_RVVMF2QImode) != 0)
        return -1;
      return 18;

    case E_RVVMF4QImode:
      if (pattern0 (x3, 
E_RVVMF4QImode) != 0)
        return -1;
      return 19;

    case E_RVVMF8QImode:
      if (pattern0 (x3, 
E_RVVMF8QImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2HImode:
      if (pattern0 (x3, 
E_RVVMF2HImode) != 0)
        return -1;
      return 21;

    case E_RVVMF4HImode:
      if (pattern0 (x3, 
E_RVVMF4HImode) != 0)
        return -1;
      return 22;

    case E_RVVMF2SImode:
      if (pattern0 (x3, 
E_RVVMF2SImode) != 0)
        return -1;
      return 23;

    case E_V1QImode:
      if (pattern0 (x3, 
E_V1QImode) != 0)
        return -1;
      return 24;

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 25;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 26;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 27;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 28;

    case E_V32QImode:
      if (pattern0 (x3, 
E_V32QImode) != 0)
        return -1;
      return 29;

    case E_V64QImode:
      if (pattern0 (x3, 
E_V64QImode) != 0)
        return -1;
      return 30;

    case E_V128QImode:
      if (pattern0 (x3, 
E_V128QImode) != 0)
        return -1;
      return 31;

    case E_V256QImode:
      if (pattern0 (x3, 
E_V256QImode) != 0)
        return -1;
      return 32;

    case E_V512QImode:
      if (pattern0 (x3, 
E_V512QImode) != 0)
        return -1;
      return 33;

    case E_V1024QImode:
      if (pattern0 (x3, 
E_V1024QImode) != 0)
        return -1;
      return 34;

    case E_V2048QImode:
      if (pattern0 (x3, 
E_V2048QImode) != 0)
        return -1;
      return 35;

    case E_V4096QImode:
      if (pattern0 (x3, 
E_V4096QImode) != 0)
        return -1;
      return 36;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 37;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 38;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 39;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 40;

    case E_V16HImode:
      if (pattern0 (x3, 
E_V16HImode) != 0)
        return -1;
      return 41;

    case E_V32HImode:
      if (pattern0 (x3, 
E_V32HImode) != 0)
        return -1;
      return 42;

    case E_V64HImode:
      if (pattern0 (x3, 
E_V64HImode) != 0)
        return -1;
      return 43;

    case E_V128HImode:
      if (pattern0 (x3, 
E_V128HImode) != 0)
        return -1;
      return 44;

    case E_V256HImode:
      if (pattern0 (x3, 
E_V256HImode) != 0)
        return -1;
      return 45;

    case E_V512HImode:
      if (pattern0 (x3, 
E_V512HImode) != 0)
        return -1;
      return 46;

    case E_V1024HImode:
      if (pattern0 (x3, 
E_V1024HImode) != 0)
        return -1;
      return 47;

    case E_V2048HImode:
      if (pattern0 (x3, 
E_V2048HImode) != 0)
        return -1;
      return 48;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 49;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 50;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 51;

    case E_V8SImode:
      if (pattern0 (x3, 
E_V8SImode) != 0)
        return -1;
      return 52;

    case E_V16SImode:
      if (pattern0 (x3, 
E_V16SImode) != 0)
        return -1;
      return 53;

    case E_V32SImode:
      if (pattern0 (x3, 
E_V32SImode) != 0)
        return -1;
      return 54;

    case E_V64SImode:
      if (pattern0 (x3, 
E_V64SImode) != 0)
        return -1;
      return 55;

    case E_V128SImode:
      if (pattern0 (x3, 
E_V128SImode) != 0)
        return -1;
      return 56;

    case E_V256SImode:
      if (pattern0 (x3, 
E_V256SImode) != 0)
        return -1;
      return 57;

    case E_V512SImode:
      if (pattern0 (x3, 
E_V512SImode) != 0)
        return -1;
      return 58;

    case E_V1024SImode:
      if (pattern0 (x3, 
E_V1024SImode) != 0)
        return -1;
      return 59;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 60;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 61;

    case E_V4DImode:
      if (pattern0 (x3, 
E_V4DImode) != 0)
        return -1;
      return 62;

    case E_V8DImode:
      if (pattern0 (x3, 
E_V8DImode) != 0)
        return -1;
      return 63;

    case E_V16DImode:
      if (pattern0 (x3, 
E_V16DImode) != 0)
        return -1;
      return 64;

    case E_V32DImode:
      if (pattern0 (x3, 
E_V32DImode) != 0)
        return -1;
      return 65;

    case E_V64DImode:
      if (pattern0 (x3, 
E_V64DImode) != 0)
        return -1;
      return 66;

    case E_V128DImode:
      if (pattern0 (x3, 
E_V128DImode) != 0)
        return -1;
      return 67;

    case E_V256DImode:
      if (pattern0 (x3, 
E_V256DImode) != 0)
        return -1;
      return 68;

    case E_V512DImode:
      if (pattern0 (x3, 
E_V512DImode) != 0)
        return -1;
      return 69;

    default:
      return -1;
    }
}

int
pattern128 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SFmode:
      return pattern128 (x1, 
E_RVVM4HFmode, 
E_RVVM8SFmode); /* [-1, 0] */

    case E_RVVM4SFmode:
      if (pattern128 (x1, 
E_RVVM2HFmode, 
E_RVVM4SFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2SFmode:
      if (pattern128 (x1, 
E_RVVM1HFmode, 
E_RVVM2SFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1SFmode:
      if (pattern128 (x1, 
E_RVVMF2HFmode, 
E_RVVM1SFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2SFmode:
      if (pattern128 (x1, 
E_RVVMF4HFmode, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 4;

    case E_RVVM8DFmode:
      if (pattern128 (x1, 
E_RVVM4SFmode, 
E_RVVM8DFmode) != 0)
        return -1;
      return 5;

    case E_RVVM4DFmode:
      if (pattern128 (x1, 
E_RVVM2SFmode, 
E_RVVM4DFmode) != 0)
        return -1;
      return 6;

    case E_RVVM2DFmode:
      if (pattern128 (x1, 
E_RVVM1SFmode, 
E_RVVM2DFmode) != 0)
        return -1;
      return 7;

    case E_RVVM1DFmode:
      if (pattern128 (x1, 
E_RVVMF2SFmode, 
E_RVVM1DFmode) != 0)
        return -1;
      return 8;

    case E_V1SFmode:
      if (pattern128 (x1, 
E_V1HFmode, 
E_V1SFmode) != 0)
        return -1;
      return 9;

    case E_V2SFmode:
      if (pattern128 (x1, 
E_V2HFmode, 
E_V2SFmode) != 0)
        return -1;
      return 10;

    case E_V4SFmode:
      if (pattern128 (x1, 
E_V4HFmode, 
E_V4SFmode) != 0)
        return -1;
      return 11;

    case E_V8SFmode:
      if (pattern128 (x1, 
E_V8HFmode, 
E_V8SFmode) != 0)
        return -1;
      return 12;

    case E_V16SFmode:
      if (pattern128 (x1, 
E_V16HFmode, 
E_V16SFmode) != 0)
        return -1;
      return 13;

    case E_V32SFmode:
      if (pattern128 (x1, 
E_V32HFmode, 
E_V32SFmode) != 0)
        return -1;
      return 14;

    case E_V64SFmode:
      if (pattern128 (x1, 
E_V64HFmode, 
E_V64SFmode) != 0)
        return -1;
      return 15;

    case E_V128SFmode:
      if (pattern128 (x1, 
E_V128HFmode, 
E_V128SFmode) != 0)
        return -1;
      return 16;

    case E_V256SFmode:
      if (pattern128 (x1, 
E_V256HFmode, 
E_V256SFmode) != 0)
        return -1;
      return 17;

    case E_V512SFmode:
      if (pattern128 (x1, 
E_V512HFmode, 
E_V512SFmode) != 0)
        return -1;
      return 18;

    case E_V1024SFmode:
      if (pattern128 (x1, 
E_V1024HFmode, 
E_V1024SFmode) != 0)
        return -1;
      return 19;

    case E_V1DFmode:
      if (pattern128 (x1, 
E_V1SFmode, 
E_V1DFmode) != 0)
        return -1;
      return 20;

    case E_V2DFmode:
      if (pattern128 (x1, 
E_V2SFmode, 
E_V2DFmode) != 0)
        return -1;
      return 21;

    case E_V4DFmode:
      if (pattern128 (x1, 
E_V4SFmode, 
E_V4DFmode) != 0)
        return -1;
      return 22;

    case E_V8DFmode:
      if (pattern128 (x1, 
E_V8SFmode, 
E_V8DFmode) != 0)
        return -1;
      return 23;

    case E_V16DFmode:
      if (pattern128 (x1, 
E_V16SFmode, 
E_V16DFmode) != 0)
        return -1;
      return 24;

    case E_V32DFmode:
      if (pattern128 (x1, 
E_V32SFmode, 
E_V32DFmode) != 0)
        return -1;
      return 25;

    case E_V64DFmode:
      if (pattern128 (x1, 
E_V64SFmode, 
E_V64DFmode) != 0)
        return -1;
      return 26;

    case E_V128DFmode:
      if (pattern128 (x1, 
E_V128SFmode, 
E_V128DFmode) != 0)
        return -1;
      return 27;

    case E_V256DFmode:
      if (pattern128 (x1, 
E_V256SFmode, 
E_V256DFmode) != 0)
        return -1;
      return 28;

    case E_V512DFmode:
      if (pattern128 (x1, 
E_V512SFmode, 
E_V512DFmode) != 0)
        return -1;
      return 29;

    default:
      return -1;
    }
}

int
pattern142 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      x5 = XEXP (x1, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          return pattern136 (x1, 
E_RVVM8HFmode); /* [-1, 0] */

        case E_RVVM4HFmode:
          if (pattern136 (x1, 
E_RVVM4HFmode) != 0)
            return -1;
          return 1;

        case E_RVVM2HFmode:
          if (pattern136 (x1, 
E_RVVM2HFmode) != 0)
            return -1;
          return 2;

        case E_RVVM1HFmode:
          if (pattern136 (x1, 
E_RVVM1HFmode) != 0)
            return -1;
          return 3;

        case E_RVVMF2HFmode:
          if (pattern136 (x1, 
E_RVVMF2HFmode) != 0)
            return -1;
          return 4;

        case E_RVVMF4HFmode:
          if (pattern136 (x1, 
E_RVVMF4HFmode) != 0)
            return -1;
          return 5;

        case E_RVVM8SFmode:
          if (pattern136 (x1, 
E_RVVM8SFmode) != 0)
            return -1;
          return 6;

        case E_RVVM4SFmode:
          if (pattern136 (x1, 
E_RVVM4SFmode) != 0)
            return -1;
          return 7;

        case E_RVVM2SFmode:
          if (pattern136 (x1, 
E_RVVM2SFmode) != 0)
            return -1;
          return 8;

        case E_RVVM1SFmode:
          if (pattern136 (x1, 
E_RVVM1SFmode) != 0)
            return -1;
          return 9;

        case E_RVVMF2SFmode:
          if (pattern136 (x1, 
E_RVVMF2SFmode) != 0)
            return -1;
          return 10;

        case E_RVVM8DFmode:
          if (pattern136 (x1, 
E_RVVM8DFmode) != 0)
            return -1;
          return 11;

        case E_RVVM4DFmode:
          if (pattern136 (x1, 
E_RVVM4DFmode) != 0)
            return -1;
          return 12;

        case E_RVVM2DFmode:
          if (pattern136 (x1, 
E_RVVM2DFmode) != 0)
            return -1;
          return 13;

        case E_RVVM1DFmode:
          if (pattern136 (x1, 
E_RVVM1DFmode) != 0)
            return -1;
          return 14;

        case E_V1HFmode:
          if (pattern136 (x1, 
E_V1HFmode) != 0)
            return -1;
          return 15;

        case E_V2HFmode:
          if (pattern136 (x1, 
E_V2HFmode) != 0)
            return -1;
          return 16;

        case E_V4HFmode:
          if (pattern136 (x1, 
E_V4HFmode) != 0)
            return -1;
          return 17;

        case E_V8HFmode:
          if (pattern136 (x1, 
E_V8HFmode) != 0)
            return -1;
          return 18;

        case E_V16HFmode:
          if (pattern136 (x1, 
E_V16HFmode) != 0)
            return -1;
          return 19;

        case E_V32HFmode:
          if (pattern136 (x1, 
E_V32HFmode) != 0)
            return -1;
          return 20;

        case E_V64HFmode:
          if (pattern136 (x1, 
E_V64HFmode) != 0)
            return -1;
          return 21;

        case E_V128HFmode:
          if (pattern136 (x1, 
E_V128HFmode) != 0)
            return -1;
          return 22;

        case E_V256HFmode:
          if (pattern136 (x1, 
E_V256HFmode) != 0)
            return -1;
          return 23;

        case E_V512HFmode:
          if (pattern136 (x1, 
E_V512HFmode) != 0)
            return -1;
          return 24;

        case E_V1024HFmode:
          if (pattern136 (x1, 
E_V1024HFmode) != 0)
            return -1;
          return 25;

        case E_V2048HFmode:
          if (pattern136 (x1, 
E_V2048HFmode) != 0)
            return -1;
          return 26;

        case E_V1SFmode:
          if (pattern136 (x1, 
E_V1SFmode) != 0)
            return -1;
          return 27;

        case E_V2SFmode:
          if (pattern136 (x1, 
E_V2SFmode) != 0)
            return -1;
          return 28;

        case E_V4SFmode:
          if (pattern136 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 29;

        case E_V8SFmode:
          if (pattern136 (x1, 
E_V8SFmode) != 0)
            return -1;
          return 30;

        case E_V16SFmode:
          if (pattern136 (x1, 
E_V16SFmode) != 0)
            return -1;
          return 31;

        case E_V32SFmode:
          if (pattern136 (x1, 
E_V32SFmode) != 0)
            return -1;
          return 32;

        case E_V64SFmode:
          if (pattern136 (x1, 
E_V64SFmode) != 0)
            return -1;
          return 33;

        case E_V128SFmode:
          if (pattern136 (x1, 
E_V128SFmode) != 0)
            return -1;
          return 34;

        case E_V256SFmode:
          if (pattern136 (x1, 
E_V256SFmode) != 0)
            return -1;
          return 35;

        case E_V512SFmode:
          if (pattern136 (x1, 
E_V512SFmode) != 0)
            return -1;
          return 36;

        case E_V1024SFmode:
          if (pattern136 (x1, 
E_V1024SFmode) != 0)
            return -1;
          return 37;

        case E_V1DFmode:
          if (pattern136 (x1, 
E_V1DFmode) != 0)
            return -1;
          return 38;

        case E_V2DFmode:
          if (pattern136 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 39;

        case E_V4DFmode:
          if (pattern136 (x1, 
E_V4DFmode) != 0)
            return -1;
          return 40;

        case E_V8DFmode:
          if (pattern136 (x1, 
E_V8DFmode) != 0)
            return -1;
          return 41;

        case E_V16DFmode:
          if (pattern136 (x1, 
E_V16DFmode) != 0)
            return -1;
          return 42;

        case E_V32DFmode:
          if (pattern136 (x1, 
E_V32DFmode) != 0)
            return -1;
          return 43;

        case E_V64DFmode:
          if (pattern136 (x1, 
E_V64DFmode) != 0)
            return -1;
          return 44;

        case E_V128DFmode:
          if (pattern136 (x1, 
E_V128DFmode) != 0)
            return -1;
          return 45;

        case E_V256DFmode:
          if (pattern136 (x1, 
E_V256DFmode) != 0)
            return -1;
          return 46;

        case E_V512DFmode:
          if (pattern136 (x1, 
E_V512DFmode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      res = pattern139 (x1);
      if (res >= 0)
        return res + 48; /* [48, 107] */
      return -1;

    case NEG:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != FLOAT_EXTEND)
        return -1;
      x5 = XEXP (x1, 1);
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case FLOAT_EXTEND:
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          x8 = XEXP (x4, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern140 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode) != 0)
                return -1;
              return 108;

            case E_RVVM4SFmode:
              if (pattern140 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode) != 0)
                return -1;
              return 109;

            case E_RVVM2SFmode:
              if (pattern140 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode) != 0)
                return -1;
              return 110;

            case E_RVVM1SFmode:
              if (pattern140 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode) != 0)
                return -1;
              return 111;

            case E_RVVMF2SFmode:
              if (pattern140 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode) != 0)
                return -1;
              return 112;

            case E_RVVM8DFmode:
              if (pattern140 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode) != 0)
                return -1;
              return 113;

            case E_RVVM4DFmode:
              if (pattern140 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode) != 0)
                return -1;
              return 114;

            case E_RVVM2DFmode:
              if (pattern140 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode) != 0)
                return -1;
              return 115;

            case E_RVVM1DFmode:
              if (pattern140 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode) != 0)
                return -1;
              return 116;

            case E_V1SFmode:
              if (pattern140 (x1, 
E_V1SFmode, 
E_V1HFmode) != 0)
                return -1;
              return 117;

            case E_V2SFmode:
              if (pattern140 (x1, 
E_V2SFmode, 
E_V2HFmode) != 0)
                return -1;
              return 118;

            case E_V4SFmode:
              if (pattern140 (x1, 
E_V4SFmode, 
E_V4HFmode) != 0)
                return -1;
              return 119;

            case E_V8SFmode:
              if (pattern140 (x1, 
E_V8SFmode, 
E_V8HFmode) != 0)
                return -1;
              return 120;

            case E_V16SFmode:
              if (pattern140 (x1, 
E_V16SFmode, 
E_V16HFmode) != 0)
                return -1;
              return 121;

            case E_V32SFmode:
              if (pattern140 (x1, 
E_V32SFmode, 
E_V32HFmode) != 0)
                return -1;
              return 122;

            case E_V64SFmode:
              if (pattern140 (x1, 
E_V64SFmode, 
E_V64HFmode) != 0)
                return -1;
              return 123;

            case E_V128SFmode:
              if (pattern140 (x1, 
E_V128SFmode, 
E_V128HFmode) != 0)
                return -1;
              return 124;

            case E_V256SFmode:
              if (pattern140 (x1, 
E_V256SFmode, 
E_V256HFmode) != 0)
                return -1;
              return 125;

            case E_V512SFmode:
              if (pattern140 (x1, 
E_V512SFmode, 
E_V512HFmode) != 0)
                return -1;
              return 126;

            case E_V1024SFmode:
              if (pattern140 (x1, 
E_V1024SFmode, 
E_V1024HFmode) != 0)
                return -1;
              return 127;

            case E_V1DFmode:
              if (pattern140 (x1, 
E_V1DFmode, 
E_V1SFmode) != 0)
                return -1;
              return 128;

            case E_V2DFmode:
              if (pattern140 (x1, 
E_V2DFmode, 
E_V2SFmode) != 0)
                return -1;
              return 129;

            case E_V4DFmode:
              if (pattern140 (x1, 
E_V4DFmode, 
E_V4SFmode) != 0)
                return -1;
              return 130;

            case E_V8DFmode:
              if (pattern140 (x1, 
E_V8DFmode, 
E_V8SFmode) != 0)
                return -1;
              return 131;

            case E_V16DFmode:
              if (pattern140 (x1, 
E_V16DFmode, 
E_V16SFmode) != 0)
                return -1;
              return 132;

            case E_V32DFmode:
              if (pattern140 (x1, 
E_V32DFmode, 
E_V32SFmode) != 0)
                return -1;
              return 133;

            case E_V64DFmode:
              if (pattern140 (x1, 
E_V64DFmode, 
E_V64SFmode) != 0)
                return -1;
              return 134;

            case E_V128DFmode:
              if (pattern140 (x1, 
E_V128DFmode, 
E_V128SFmode) != 0)
                return -1;
              return 135;

            case E_V256DFmode:
              if (pattern140 (x1, 
E_V256DFmode, 
E_V256SFmode) != 0)
                return -1;
              return 136;

            case E_V512DFmode:
              if (pattern140 (x1, 
E_V512DFmode, 
E_V512SFmode) != 0)
                return -1;
              return 137;

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[3] = x6;
          x8 = XEXP (x4, 0);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern141 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode) != 0)
                return -1;
              return 138;

            case E_RVVM4SFmode:
              if (pattern141 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode) != 0)
                return -1;
              return 139;

            case E_RVVM2SFmode:
              if (pattern141 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode) != 0)
                return -1;
              return 140;

            case E_RVVM1SFmode:
              if (pattern141 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode) != 0)
                return -1;
              return 141;

            case E_RVVMF2SFmode:
              if (pattern141 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode) != 0)
                return -1;
              return 142;

            case E_RVVM8DFmode:
              if (pattern141 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode) != 0)
                return -1;
              return 143;

            case E_RVVM4DFmode:
              if (pattern141 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode) != 0)
                return -1;
              return 144;

            case E_RVVM2DFmode:
              if (pattern141 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode) != 0)
                return -1;
              return 145;

            case E_RVVM1DFmode:
              if (pattern141 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode) != 0)
                return -1;
              return 146;

            case E_V1SFmode:
              if (pattern141 (x1, 
E_V1SFmode, 
E_V1HFmode) != 0)
                return -1;
              return 147;

            case E_V2SFmode:
              if (pattern141 (x1, 
E_V2SFmode, 
E_V2HFmode) != 0)
                return -1;
              return 148;

            case E_V4SFmode:
              if (pattern141 (x1, 
E_V4SFmode, 
E_V4HFmode) != 0)
                return -1;
              return 149;

            case E_V8SFmode:
              if (pattern141 (x1, 
E_V8SFmode, 
E_V8HFmode) != 0)
                return -1;
              return 150;

            case E_V16SFmode:
              if (pattern141 (x1, 
E_V16SFmode, 
E_V16HFmode) != 0)
                return -1;
              return 151;

            case E_V32SFmode:
              if (pattern141 (x1, 
E_V32SFmode, 
E_V32HFmode) != 0)
                return -1;
              return 152;

            case E_V64SFmode:
              if (pattern141 (x1, 
E_V64SFmode, 
E_V64HFmode) != 0)
                return -1;
              return 153;

            case E_V128SFmode:
              if (pattern141 (x1, 
E_V128SFmode, 
E_V128HFmode) != 0)
                return -1;
              return 154;

            case E_V256SFmode:
              if (pattern141 (x1, 
E_V256SFmode, 
E_V256HFmode) != 0)
                return -1;
              return 155;

            case E_V512SFmode:
              if (pattern141 (x1, 
E_V512SFmode, 
E_V512HFmode) != 0)
                return -1;
              return 156;

            case E_V1024SFmode:
              if (pattern141 (x1, 
E_V1024SFmode, 
E_V1024HFmode) != 0)
                return -1;
              return 157;

            case E_V1DFmode:
              if (pattern141 (x1, 
E_V1DFmode, 
E_V1SFmode) != 0)
                return -1;
              return 158;

            case E_V2DFmode:
              if (pattern141 (x1, 
E_V2DFmode, 
E_V2SFmode) != 0)
                return -1;
              return 159;

            case E_V4DFmode:
              if (pattern141 (x1, 
E_V4DFmode, 
E_V4SFmode) != 0)
                return -1;
              return 160;

            case E_V8DFmode:
              if (pattern141 (x1, 
E_V8DFmode, 
E_V8SFmode) != 0)
                return -1;
              return 161;

            case E_V16DFmode:
              if (pattern141 (x1, 
E_V16DFmode, 
E_V16SFmode) != 0)
                return -1;
              return 162;

            case E_V32DFmode:
              if (pattern141 (x1, 
E_V32DFmode, 
E_V32SFmode) != 0)
                return -1;
              return 163;

            case E_V64DFmode:
              if (pattern141 (x1, 
E_V64DFmode, 
E_V64SFmode) != 0)
                return -1;
              return 164;

            case E_V128DFmode:
              if (pattern141 (x1, 
E_V128DFmode, 
E_V128SFmode) != 0)
                return -1;
              return 165;

            case E_V256DFmode:
              if (pattern141 (x1, 
E_V256DFmode, 
E_V256SFmode) != 0)
                return -1;
              return 166;

            case E_V512DFmode:
              if (pattern141 (x1, 
E_V512DFmode, 
E_V512SFmode) != 0)
                return -1;
              return 167;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern191 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 5
      || XINT (x3, 1) != 93)
    return -1;
  x4 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x3, 0, 4);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != MEM
      || GET_MODE (x6) != E_BLKmode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != SCRATCH)
    return -1;
  x8 = XVECEXP (x3, 0, 0);
  operands[0] = x8;
  x9 = XVECEXP (x3, 0, 1);
  operands[4] = x9;
  if (!vector_length_operand (operands[4], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 2);
  operands[5] = x10;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x2, 0, 1);
  operands[1] = x11;
  if (!pmode_reg_or_0_operand (operands[1], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x2, 0, 2);
  operands[2] = x12;
  x13 = XVECEXP (x2, 0, 3);
  operands[3] = x13;
  switch (GET_MODE (x3))
    {
    case E_RVVMF64BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF64BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF8QImode:
          return pattern185 (
E_RVVMF8QImode); /* [-1, 63] */

        case E_RVVMF4HImode:
          res = pattern185 (
E_RVVMF4HImode);
          if (res >= 0)
            return res + 64; /* [64, 127] */
          return -1;

        case E_RVVMF2SImode:
          res = pattern185 (
E_RVVMF2SImode);
          if (res >= 0)
            return res + 128; /* [128, 191] */
          return -1;

        case E_RVVM1DImode:
          res = pattern185 (
E_RVVM1DImode);
          if (res >= 0)
            return res + 192; /* [192, 255] */
          return -1;

        default:
          return -1;
        }

    case E_RVVMF32BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF32BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF4QImode:
          res = pattern186 (
E_RVVMF4QImode);
          if (res >= 0)
            return res + 256; /* [256, 311] */
          return -1;

        case E_RVVMF2HImode:
          res = pattern186 (
E_RVVMF2HImode);
          if (res >= 0)
            return res + 312; /* [312, 367] */
          return -1;

        case E_RVVM1SImode:
          res = pattern186 (
E_RVVM1SImode);
          if (res >= 0)
            return res + 368; /* [368, 423] */
          return -1;

        case E_RVVM2DImode:
          res = pattern186 (
E_RVVM2DImode);
          if (res >= 0)
            return res + 424; /* [424, 479] */
          return -1;

        default:
          return -1;
        }

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF16BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2QImode:
          res = pattern187 (
E_RVVMF2QImode);
          if (res >= 0)
            return res + 480; /* [480, 523] */
          return -1;

        case E_RVVM1HImode:
          res = pattern187 (
E_RVVM1HImode);
          if (res >= 0)
            return res + 524; /* [524, 567] */
          return -1;

        case E_RVVM2SImode:
          res = pattern187 (
E_RVVM2SImode);
          if (res >= 0)
            return res + 568; /* [568, 611] */
          return -1;

        case E_RVVM4DImode:
          res = pattern187 (
E_RVVM4DImode);
          if (res >= 0)
            return res + 612; /* [612, 655] */
          return -1;

        default:
          return -1;
        }

    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1QImode:
          res = pattern188 (
E_RVVM1QImode);
          if (res >= 0)
            return res + 656; /* [656, 681] */
          return -1;

        case E_RVVM2HImode:
          res = pattern188 (
E_RVVM2HImode);
          if (res >= 0)
            return res + 682; /* [682, 707] */
          return -1;

        case E_RVVM4SImode:
          res = pattern188 (
E_RVVM4SImode);
          if (res >= 0)
            return res + 708; /* [708, 733] */
          return -1;

        case E_RVVM8DImode:
          res = pattern188 (
E_RVVM8DImode);
          if (res >= 0)
            return res + 734; /* [734, 759] */
          return -1;

        default:
          return -1;
        }

    case E_RVVMF4BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2QImode:
          res = pattern189 (
E_RVVM2QImode);
          if (res >= 0)
            return res + 760; /* [760, 771] */
          return -1;

        case E_RVVM4HImode:
          res = pattern189 (
E_RVVM4HImode);
          if (res >= 0)
            return res + 772; /* [772, 783] */
          return -1;

        case E_RVVM8SImode:
          res = pattern189 (
E_RVVM8SImode);
          if (res >= 0)
            return res + 784; /* [784, 795] */
          return -1;

        default:
          return -1;
        }

    case E_RVVMF2BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF2BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4QImode:
          res = pattern190 (
E_RVVM4QImode);
          if (res >= 0)
            return res + 796; /* [796, 800] */
          return -1;

        case E_RVVM8HImode:
          res = pattern190 (
E_RVVM8HImode);
          if (res >= 0)
            return res + 801; /* [801, 805] */
          return -1;

        default:
          return -1;
        }

    case E_RVVM1BImode:
      if (!vector_mask_operand (operands[0], E_RVVM1BImode)
          || !register_operand (operands[2], E_RVVM8QImode)
          || !register_operand (operands[3], E_RVVM8QImode))
        return -1;
      return 806;

    default:
      return -1;
    }
}

int
pattern217 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern218 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern217 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern217 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern217 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern217 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2QImode:
      if (pattern217 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4QImode:
      if (pattern217 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 5;

    case E_RVVMF8QImode:
      if (pattern217 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 6;

    case E_RVVM8HImode:
      if (pattern217 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 7;

    case E_RVVM4HImode:
      if (pattern217 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM2HImode:
      if (pattern217 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM1HImode:
      if (pattern217 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVMF2HImode:
      if (pattern217 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVMF4HImode:
      if (pattern217 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 12;

    case E_RVVM8SImode:
      if (pattern217 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 13;

    case E_RVVM4SImode:
      if (pattern217 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 14;

    case E_RVVM2SImode:
      if (pattern217 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 15;

    case E_RVVM1SImode:
      if (pattern217 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF2SImode:
      if (pattern217 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 17;

    case E_RVVM8DImode:
      if (pattern217 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 18;

    case E_RVVM4DImode:
      if (pattern217 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 19;

    case E_RVVM2DImode:
      if (pattern217 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 20;

    case E_RVVM1DImode:
      if (pattern217 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_V1QImode:
      if (pattern217 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 22;

    case E_V2QImode:
      if (pattern217 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 23;

    case E_V4QImode:
      if (pattern217 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 24;

    case E_V8QImode:
      if (pattern217 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 25;

    case E_V16QImode:
      if (pattern217 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 26;

    case E_V32QImode:
      if (pattern217 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 27;

    case E_V64QImode:
      if (pattern217 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 28;

    case E_V128QImode:
      if (pattern217 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 29;

    case E_V256QImode:
      if (pattern217 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 30;

    case E_V512QImode:
      if (pattern217 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 31;

    case E_V1024QImode:
      if (pattern217 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 32;

    case E_V2048QImode:
      if (pattern217 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 33;

    case E_V4096QImode:
      if (pattern217 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 34;

    case E_V1HImode:
      if (pattern217 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 35;

    case E_V2HImode:
      if (pattern217 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 36;

    case E_V4HImode:
      if (pattern217 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 37;

    case E_V8HImode:
      if (pattern217 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 38;

    case E_V16HImode:
      if (pattern217 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 39;

    case E_V32HImode:
      if (pattern217 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 40;

    case E_V64HImode:
      if (pattern217 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 41;

    case E_V128HImode:
      if (pattern217 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 42;

    case E_V256HImode:
      if (pattern217 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 43;

    case E_V512HImode:
      if (pattern217 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 44;

    case E_V1024HImode:
      if (pattern217 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 45;

    case E_V2048HImode:
      if (pattern217 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 46;

    case E_V1SImode:
      if (pattern217 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 47;

    case E_V2SImode:
      if (pattern217 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 48;

    case E_V4SImode:
      if (pattern217 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 49;

    case E_V8SImode:
      if (pattern217 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 50;

    case E_V16SImode:
      if (pattern217 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 51;

    case E_V32SImode:
      if (pattern217 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 52;

    case E_V64SImode:
      if (pattern217 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 53;

    case E_V128SImode:
      if (pattern217 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 54;

    case E_V256SImode:
      if (pattern217 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 55;

    case E_V512SImode:
      if (pattern217 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 56;

    case E_V1024SImode:
      if (pattern217 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern217 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern217 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern217 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern217 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern217 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern217 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern217 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern217 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern217 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern217 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 67;

    default:
      return -1;
    }
}

int
pattern233 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_arith_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern237 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 5
      || XINT (x3, 1) != 91
      || GET_MODE (x3) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!const_int_operand (operands[4], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x3, 0, 4);
  operands[5] = x8;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern242 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM8SFmode:
      if (!register_operand (operands[1], E_RVVM4HFmode))
        return -1;
      return 0;

    case E_RVVM4SFmode:
      if (!register_operand (operands[1], E_RVVM2HFmode))
        return -1;
      return 1;

    case E_RVVM2SFmode:
      if (!register_operand (operands[1], E_RVVM1HFmode))
        return -1;
      return 2;

    case E_RVVM1SFmode:
      if (!register_operand (operands[1], E_RVVMF2HFmode))
        return -1;
      return 3;

    case E_RVVMF2SFmode:
      if (!register_operand (operands[1], E_RVVMF4HFmode))
        return -1;
      return 4;

    case E_V1SFmode:
      if (!register_operand (operands[1], E_V1HFmode))
        return -1;
      return 5;

    case E_V2SFmode:
      if (!register_operand (operands[1], E_V2HFmode))
        return -1;
      return 6;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4HFmode))
        return -1;
      return 7;

    case E_V8SFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 8;

    case E_V16SFmode:
      if (!register_operand (operands[1], E_V16HFmode))
        return -1;
      return 9;

    case E_V32SFmode:
      if (!register_operand (operands[1], E_V32HFmode))
        return -1;
      return 10;

    case E_V64SFmode:
      if (!register_operand (operands[1], E_V64HFmode))
        return -1;
      return 11;

    case E_V128SFmode:
      if (!register_operand (operands[1], E_V128HFmode))
        return -1;
      return 12;

    case E_V256SFmode:
      if (!register_operand (operands[1], E_V256HFmode))
        return -1;
      return 13;

    case E_V512SFmode:
      if (!register_operand (operands[1], E_V512HFmode))
        return -1;
      return 14;

    case E_V1024SFmode:
      if (!register_operand (operands[1], E_V1024HFmode))
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern243 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM8DFmode:
      if (!register_operand (operands[1], E_RVVM4SFmode))
        return -1;
      return 0;

    case E_RVVM4DFmode:
      if (!register_operand (operands[1], E_RVVM2SFmode))
        return -1;
      return 1;

    case E_RVVM2DFmode:
      if (!register_operand (operands[1], E_RVVM1SFmode))
        return -1;
      return 2;

    case E_RVVM1DFmode:
      if (!register_operand (operands[1], E_RVVMF2SFmode))
        return -1;
      return 3;

    case E_V1DFmode:
      if (!register_operand (operands[1], E_V1SFmode))
        return -1;
      return 4;

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      return 5;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 6;

    case E_V8DFmode:
      if (!register_operand (operands[1], E_V8SFmode))
        return -1;
      return 7;

    case E_V16DFmode:
      if (!register_operand (operands[1], E_V16SFmode))
        return -1;
      return 8;

    case E_V32DFmode:
      if (!register_operand (operands[1], E_V32SFmode))
        return -1;
      return 9;

    case E_V64DFmode:
      if (!register_operand (operands[1], E_V64SFmode))
        return -1;
      return 10;

    case E_V128DFmode:
      if (!register_operand (operands[1], E_V128SFmode))
        return -1;
      return 11;

    case E_V256DFmode:
      if (!register_operand (operands[1], E_V256SFmode))
        return -1;
      return 12;

    case E_V512DFmode:
      if (!register_operand (operands[1], E_V512SFmode))
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern245 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8HImode:
          if (!register_operand (operands[1], E_RVVM4QImode))
            return -1;
          return 0;

        case E_RVVM4HImode:
          if (!register_operand (operands[1], E_RVVM2QImode))
            return -1;
          return 1;

        case E_RVVM2HImode:
          if (!register_operand (operands[1], E_RVVM1QImode))
            return -1;
          return 2;

        case E_RVVM1HImode:
          if (!register_operand (operands[1], E_RVVMF2QImode))
            return -1;
          return 3;

        case E_RVVMF2HImode:
          if (!register_operand (operands[1], E_RVVMF4QImode))
            return -1;
          return 4;

        case E_RVVMF4HImode:
          if (!register_operand (operands[1], E_RVVMF8QImode))
            return -1;
          return 5;

        case E_V1HImode:
          if (!register_operand (operands[1], E_V1QImode))
            return -1;
          return 6;

        case E_V2HImode:
          if (!register_operand (operands[1], E_V2QImode))
            return -1;
          return 7;

        case E_V4HImode:
          if (!register_operand (operands[1], E_V4QImode))
            return -1;
          return 8;

        case E_V8HImode:
          if (!register_operand (operands[1], E_V8QImode))
            return -1;
          return 9;

        case E_V16HImode:
          if (!register_operand (operands[1], E_V16QImode))
            return -1;
          return 10;

        case E_V32HImode:
          if (!register_operand (operands[1], E_V32QImode))
            return -1;
          return 11;

        case E_V64HImode:
          if (!register_operand (operands[1], E_V64QImode))
            return -1;
          return 12;

        case E_V128HImode:
          if (!register_operand (operands[1], E_V128QImode))
            return -1;
          return 13;

        case E_V256HImode:
          if (!register_operand (operands[1], E_V256QImode))
            return -1;
          return 14;

        case E_V512HImode:
          if (!register_operand (operands[1], E_V512QImode))
            return -1;
          return 15;

        case E_V1024HImode:
          if (!register_operand (operands[1], E_V1024QImode))
            return -1;
          return 16;

        case E_V2048HImode:
          if (!register_operand (operands[1], E_V2048QImode))
            return -1;
          return 17;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8SImode:
          if (!register_operand (operands[1], E_RVVM4HImode))
            return -1;
          return 18;

        case E_RVVM4SImode:
          if (!register_operand (operands[1], E_RVVM2HImode))
            return -1;
          return 19;

        case E_RVVM2SImode:
          if (!register_operand (operands[1], E_RVVM1HImode))
            return -1;
          return 20;

        case E_RVVM1SImode:
          if (!register_operand (operands[1], E_RVVMF2HImode))
            return -1;
          return 21;

        case E_RVVMF2SImode:
          if (!register_operand (operands[1], E_RVVMF4HImode))
            return -1;
          return 22;

        case E_V1SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V1HImode:
              if (!register_operand (operands[1], E_V1HImode))
                return -1;
              return 23;

            case E_V1SImode:
              if (!register_operand (operands[1], E_V1SImode))
                return -1;
              return 24;

            default:
              return -1;
            }

        case E_V2SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V2HImode:
              if (!register_operand (operands[1], E_V2HImode))
                return -1;
              return 25;

            case E_V2SImode:
              if (!register_operand (operands[1], E_V2SImode))
                return -1;
              return 26;

            default:
              return -1;
            }

        case E_V4SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V4HImode:
              if (!register_operand (operands[1], E_V4HImode))
                return -1;
              return 27;

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode))
                return -1;
              return 28;

            default:
              return -1;
            }

        case E_V8SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode))
                return -1;
              return 29;

            case E_V8SImode:
              if (!register_operand (operands[1], E_V8SImode))
                return -1;
              return 30;

            default:
              return -1;
            }

        case E_V16SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V16HImode:
              if (!register_operand (operands[1], E_V16HImode))
                return -1;
              return 31;

            case E_V16SImode:
              if (!register_operand (operands[1], E_V16SImode))
                return -1;
              return 32;

            default:
              return -1;
            }

        case E_V32SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V32HImode:
              if (!register_operand (operands[1], E_V32HImode))
                return -1;
              return 33;

            case E_V32SImode:
              if (!register_operand (operands[1], E_V32SImode))
                return -1;
              return 34;

            default:
              return -1;
            }

        case E_V64SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V64HImode:
              if (!register_operand (operands[1], E_V64HImode))
                return -1;
              return 35;

            case E_V64SImode:
              if (!register_operand (operands[1], E_V64SImode))
                return -1;
              return 36;

            default:
              return -1;
            }

        case E_V128SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V128HImode:
              if (!register_operand (operands[1], E_V128HImode))
                return -1;
              return 37;

            case E_V128SImode:
              if (!register_operand (operands[1], E_V128SImode))
                return -1;
              return 38;

            default:
              return -1;
            }

        case E_V256SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V256HImode:
              if (!register_operand (operands[1], E_V256HImode))
                return -1;
              return 39;

            case E_V256SImode:
              if (!register_operand (operands[1], E_V256SImode))
                return -1;
              return 40;

            default:
              return -1;
            }

        case E_V512SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V512HImode:
              if (!register_operand (operands[1], E_V512HImode))
                return -1;
              return 41;

            case E_V512SImode:
              if (!register_operand (operands[1], E_V512SImode))
                return -1;
              return 42;

            default:
              return -1;
            }

        case E_V1024SImode:
          if (!register_operand (operands[1], E_V1024HImode))
            return -1;
          return 43;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8DImode:
          if (!register_operand (operands[1], E_RVVM4SImode))
            return -1;
          return 44;

        case E_RVVM4DImode:
          if (!register_operand (operands[1], E_RVVM2SImode))
            return -1;
          return 45;

        case E_RVVM2DImode:
          if (!register_operand (operands[1], E_RVVM1SImode))
            return -1;
          return 46;

        case E_RVVM1DImode:
          if (!register_operand (operands[1], E_RVVMF2SImode))
            return -1;
          return 47;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern252 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_0_3_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern254 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 4
      || XINT (x3, 1) != 93)
    return -1;
  x4 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 0);
  operands[4] = x7;
  if (!vector_length_operand (operands[4], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x3, 0, 1);
  operands[5] = x8;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return -1;
  x9 = XEXP (x2, 0);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[1] = x9;
      x10 = XEXP (x2, 1);
      operands[2] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM1BImode:
          return 0;

        case E_RVVMF2BImode:
          return 1;

        case E_RVVMF4BImode:
          return 2;

        case E_RVVMF8BImode:
          return 3;

        case E_RVVMF16BImode:
          return 4;

        case E_RVVMF32BImode:
          return 5;

        case E_RVVMF64BImode:
          return 6;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x10 = XEXP (x2, 1);
      operands[1] = x10;
      x11 = XEXP (x9, 0);
      switch (GET_CODE (x11))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[2] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM1BImode:
              return 7;

            case E_RVVMF2BImode:
              return 8;

            case E_RVVMF4BImode:
              return 9;

            case E_RVVMF8BImode:
              return 10;

            case E_RVVMF16BImode:
              return 11;

            case E_RVVMF32BImode:
              return 12;

            case E_RVVMF64BImode:
              return 13;

            case E_V1BImode:
              return 14;

            case E_V2BImode:
              return 15;

            case E_V4BImode:
              return 16;

            case E_V8BImode:
              return 17;

            case E_V16BImode:
              return 18;

            case E_V32BImode:
              return 19;

            case E_V64BImode:
              return 20;

            case E_V128BImode:
              return 21;

            case E_V256BImode:
              return 22;

            case E_V512BImode:
              return 23;

            case E_V1024BImode:
              return 24;

            case E_V2048BImode:
              return 25;

            case E_V4096BImode:
              return 26;

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x11) != E_DImode)
            return -1;
          x12 = XEXP (x11, 0);
          operands[2] = x12;
          if (!reg_or_0_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVMF8BImode:
              if (pattern253 (x1, 
E_RVVMF8BImode, 
E_RVVM8DImode) != 0)
                return -1;
              return 27;

            case E_RVVMF16BImode:
              if (pattern253 (x1, 
E_RVVMF16BImode, 
E_RVVM4DImode) != 0)
                return -1;
              return 28;

            case E_RVVMF32BImode:
              if (pattern253 (x1, 
E_RVVMF32BImode, 
E_RVVM2DImode) != 0)
                return -1;
              return 29;

            case E_RVVMF64BImode:
              if (pattern253 (x1, 
E_RVVMF64BImode, 
E_RVVM1DImode) != 0)
                return -1;
              return 30;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern261 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern262 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern261 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern261 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern265 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 66
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 67
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (!const_int_operand (x4, E_VOIDmode))
    return -1;
  return 0;
}

int
pattern267 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (XINT (x1, 1) != 93)
    return -1;
  x2 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 66
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 67
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern270 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[4] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND)
    return -1;
  return pattern121 (x1); /* [-1, 3] */
}

int
pattern272 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != USE)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 34
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern273 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 34
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 1
      || GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern277 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x9 = XEXP (x6, 1);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 0);
  operands[3] = x11;
  if (!scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern279 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case NOT:
      if (GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[1] = x1;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern280 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != ASHIFT
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x4, 0);
  return pattern279 (x6); /* [-1, 1] */
}

int
pattern283 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern287 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern291 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern293 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern297 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM4SImode)
      || GET_MODE (x1) != E_RVVM4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM2HImode:
      if (!register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 0;

    case E_RVVM1QImode:
      if (!register_operand (operands[1], E_RVVM1QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern302 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM4DImode)
      || GET_MODE (x1) != E_RVVM4DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM2SImode:
      if (!register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 0;

    case E_RVVM1HImode:
      if (!register_operand (operands[1], E_RVVM1HImode))
        return -1;
      return 1;

    case E_RVVMF2QImode:
      if (!register_operand (operands[1], E_RVVMF2QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern307 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      return 0;

    case E_V4QImode:
      if (!register_operand (operands[1], E_V4QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern312 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V128SImode)
      || GET_MODE (x1) != E_V128SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V128HImode:
      if (!register_operand (operands[1], E_V128HImode))
        return -1;
      return 0;

    case E_V128QImode:
      if (!register_operand (operands[1], E_V128QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern317 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!register_operand (operands[1], E_V2HImode))
        return -1;
      return 1;

    case E_V2QImode:
      if (!register_operand (operands[1], E_V2QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern322 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V64DImode)
      || GET_MODE (x1) != E_V64DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V64SImode:
      if (!register_operand (operands[1], E_V64SImode))
        return -1;
      return 0;

    case E_V64HImode:
      if (!register_operand (operands[1], E_V64HImode))
        return -1;
      return 1;

    case E_V64QImode:
      if (!register_operand (operands[1], E_V64QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern329 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 66
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 67
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern334 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern338 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern341 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case NOT:
      if (GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_SImode:
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!scratch_operand (operands[4], E_DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x1;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_SImode:
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!scratch_operand (operands[4], E_DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern347 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF2QImode:
      return pattern346 (
E_RVVMF2QImode); /* [-1, 1] */

    case E_RVVMF4QImode:
      res = pattern346 (
E_RVVMF4QImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case E_RVVMF8QImode:
      res = pattern346 (
E_RVVMF8QImode);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    case E_RVVMF2HImode:
      res = pattern346 (
E_RVVMF2HImode);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    case E_RVVMF4HImode:
      res = pattern346 (
E_RVVMF4HImode);
      if (res >= 0)
        return res + 8; /* [8, 9] */
      return -1;

    case E_RVVMF2BFmode:
      res = pattern346 (
E_RVVMF2BFmode);
      if (res >= 0)
        return res + 10; /* [10, 11] */
      return -1;

    case E_RVVMF4BFmode:
      res = pattern346 (
E_RVVMF4BFmode);
      if (res >= 0)
        return res + 12; /* [12, 13] */
      return -1;

    case E_RVVMF2HFmode:
      res = pattern346 (
E_RVVMF2HFmode);
      if (res >= 0)
        return res + 14; /* [14, 15] */
      return -1;

    case E_RVVMF4HFmode:
      res = pattern346 (
E_RVVMF4HFmode);
      if (res >= 0)
        return res + 16; /* [16, 17] */
      return -1;

    case E_RVVMF2SImode:
      res = pattern346 (
E_RVVMF2SImode);
      if (res >= 0)
        return res + 18; /* [18, 19] */
      return -1;

    case E_RVVMF2SFmode:
      res = pattern346 (
E_RVVMF2SFmode);
      if (res >= 0)
        return res + 20; /* [20, 21] */
      return -1;

    case E_RVVMF64BImode:
      res = pattern346 (
E_RVVMF64BImode);
      if (res >= 0)
        return res + 22; /* [22, 23] */
      return -1;

    case E_RVVMF32BImode:
      res = pattern346 (
E_RVVMF32BImode);
      if (res >= 0)
        return res + 24; /* [24, 25] */
      return -1;

    case E_RVVMF16BImode:
      res = pattern346 (
E_RVVMF16BImode);
      if (res >= 0)
        return res + 26; /* [26, 27] */
      return -1;

    case E_RVVMF8BImode:
      res = pattern346 (
E_RVVMF8BImode);
      if (res >= 0)
        return res + 28; /* [28, 29] */
      return -1;

    case E_RVVMF4BImode:
      res = pattern346 (
E_RVVMF4BImode);
      if (res >= 0)
        return res + 30; /* [30, 31] */
      return -1;

    case E_RVVMF2BImode:
      res = pattern346 (
E_RVVMF2BImode);
      if (res >= 0)
        return res + 32; /* [32, 33] */
      return -1;

    case E_RVVM1BImode:
      res = pattern346 (
E_RVVM1BImode);
      if (res >= 0)
        return res + 34; /* [34, 35] */
      return -1;

    case E_V32QImode:
      res = pattern346 (
E_V32QImode);
      if (res >= 0)
        return res + 36; /* [36, 37] */
      return -1;

    case E_V64QImode:
      res = pattern346 (
E_V64QImode);
      if (res >= 0)
        return res + 38; /* [38, 39] */
      return -1;

    case E_V128QImode:
      res = pattern346 (
E_V128QImode);
      if (res >= 0)
        return res + 40; /* [40, 41] */
      return -1;

    case E_V256QImode:
      res = pattern346 (
E_V256QImode);
      if (res >= 0)
        return res + 42; /* [42, 43] */
      return -1;

    case E_V512QImode:
      res = pattern346 (
E_V512QImode);
      if (res >= 0)
        return res + 44; /* [44, 45] */
      return -1;

    case E_V1024QImode:
      res = pattern346 (
E_V1024QImode);
      if (res >= 0)
        return res + 46; /* [46, 47] */
      return -1;

    case E_V2048QImode:
      res = pattern346 (
E_V2048QImode);
      if (res >= 0)
        return res + 48; /* [48, 49] */
      return -1;

    case E_V4096QImode:
      res = pattern346 (
E_V4096QImode);
      if (res >= 0)
        return res + 50; /* [50, 51] */
      return -1;

    case E_V32HImode:
      res = pattern346 (
E_V32HImode);
      if (res >= 0)
        return res + 52; /* [52, 53] */
      return -1;

    case E_V64HImode:
      res = pattern346 (
E_V64HImode);
      if (res >= 0)
        return res + 54; /* [54, 55] */
      return -1;

    case E_V128HImode:
      res = pattern346 (
E_V128HImode);
      if (res >= 0)
        return res + 56; /* [56, 57] */
      return -1;

    case E_V256HImode:
      res = pattern346 (
E_V256HImode);
      if (res >= 0)
        return res + 58; /* [58, 59] */
      return -1;

    case E_V512HImode:
      res = pattern346 (
E_V512HImode);
      if (res >= 0)
        return res + 60; /* [60, 61] */
      return -1;

    case E_V1024HImode:
      res = pattern346 (
E_V1024HImode);
      if (res >= 0)
        return res + 62; /* [62, 63] */
      return -1;

    case E_V2048HImode:
      res = pattern346 (
E_V2048HImode);
      if (res >= 0)
        return res + 64; /* [64, 65] */
      return -1;

    case E_V32SImode:
      res = pattern346 (
E_V32SImode);
      if (res >= 0)
        return res + 66; /* [66, 67] */
      return -1;

    case E_V64SImode:
      res = pattern346 (
E_V64SImode);
      if (res >= 0)
        return res + 68; /* [68, 69] */
      return -1;

    case E_V128SImode:
      res = pattern346 (
E_V128SImode);
      if (res >= 0)
        return res + 70; /* [70, 71] */
      return -1;

    case E_V256SImode:
      res = pattern346 (
E_V256SImode);
      if (res >= 0)
        return res + 72; /* [72, 73] */
      return -1;

    case E_V512SImode:
      res = pattern346 (
E_V512SImode);
      if (res >= 0)
        return res + 74; /* [74, 75] */
      return -1;

    case E_V1024SImode:
      res = pattern346 (
E_V1024SImode);
      if (res >= 0)
        return res + 76; /* [76, 77] */
      return -1;

    case E_V32DImode:
      res = pattern346 (
E_V32DImode);
      if (res >= 0)
        return res + 78; /* [78, 79] */
      return -1;

    case E_V64DImode:
      res = pattern346 (
E_V64DImode);
      if (res >= 0)
        return res + 80; /* [80, 81] */
      return -1;

    case E_V128DImode:
      res = pattern346 (
E_V128DImode);
      if (res >= 0)
        return res + 82; /* [82, 83] */
      return -1;

    case E_V256DImode:
      res = pattern346 (
E_V256DImode);
      if (res >= 0)
        return res + 84; /* [84, 85] */
      return -1;

    case E_V512DImode:
      res = pattern346 (
E_V512DImode);
      if (res >= 0)
        return res + 86; /* [86, 87] */
      return -1;

    case E_V32HFmode:
      res = pattern346 (
E_V32HFmode);
      if (res >= 0)
        return res + 88; /* [88, 89] */
      return -1;

    case E_V64HFmode:
      res = pattern346 (
E_V64HFmode);
      if (res >= 0)
        return res + 90; /* [90, 91] */
      return -1;

    case E_V128HFmode:
      res = pattern346 (
E_V128HFmode);
      if (res >= 0)
        return res + 92; /* [92, 93] */
      return -1;

    case E_V256HFmode:
      res = pattern346 (
E_V256HFmode);
      if (res >= 0)
        return res + 94; /* [94, 95] */
      return -1;

    case E_V512HFmode:
      res = pattern346 (
E_V512HFmode);
      if (res >= 0)
        return res + 96; /* [96, 97] */
      return -1;

    case E_V1024HFmode:
      res = pattern346 (
E_V1024HFmode);
      if (res >= 0)
        return res + 98; /* [98, 99] */
      return -1;

    case E_V2048HFmode:
      res = pattern346 (
E_V2048HFmode);
      if (res >= 0)
        return res + 100; /* [100, 101] */
      return -1;

    case E_V32SFmode:
      res = pattern346 (
E_V32SFmode);
      if (res >= 0)
        return res + 102; /* [102, 103] */
      return -1;

    case E_V64SFmode:
      res = pattern346 (
E_V64SFmode);
      if (res >= 0)
        return res + 104; /* [104, 105] */
      return -1;

    case E_V128SFmode:
      res = pattern346 (
E_V128SFmode);
      if (res >= 0)
        return res + 106; /* [106, 107] */
      return -1;

    case E_V256SFmode:
      res = pattern346 (
E_V256SFmode);
      if (res >= 0)
        return res + 108; /* [108, 109] */
      return -1;

    case E_V512SFmode:
      res = pattern346 (
E_V512SFmode);
      if (res >= 0)
        return res + 110; /* [110, 111] */
      return -1;

    case E_V1024SFmode:
      res = pattern346 (
E_V1024SFmode);
      if (res >= 0)
        return res + 112; /* [112, 113] */
      return -1;

    case E_V32DFmode:
      res = pattern346 (
E_V32DFmode);
      if (res >= 0)
        return res + 114; /* [114, 115] */
      return -1;

    case E_V64DFmode:
      res = pattern346 (
E_V64DFmode);
      if (res >= 0)
        return res + 116; /* [116, 117] */
      return -1;

    case E_V128DFmode:
      res = pattern346 (
E_V128DFmode);
      if (res >= 0)
        return res + 118; /* [118, 119] */
      return -1;

    case E_V256DFmode:
      res = pattern346 (
E_V256DFmode);
      if (res >= 0)
        return res + 120; /* [120, 121] */
      return -1;

    case E_V512DFmode:
      res = pattern346 (
E_V512DFmode);
      if (res >= 0)
        return res + 122; /* [122, 123] */
      return -1;

    case E_V32BImode:
      res = pattern346 (
E_V32BImode);
      if (res >= 0)
        return res + 124; /* [124, 125] */
      return -1;

    case E_V64BImode:
      res = pattern346 (
E_V64BImode);
      if (res >= 0)
        return res + 126; /* [126, 127] */
      return -1;

    case E_V128BImode:
      res = pattern346 (
E_V128BImode);
      if (res >= 0)
        return res + 128; /* [128, 129] */
      return -1;

    case E_V256BImode:
      res = pattern346 (
E_V256BImode);
      if (res >= 0)
        return res + 130; /* [130, 131] */
      return -1;

    case E_V512BImode:
      res = pattern346 (
E_V512BImode);
      if (res >= 0)
        return res + 132; /* [132, 133] */
      return -1;

    case E_V1024BImode:
      res = pattern346 (
E_V1024BImode);
      if (res >= 0)
        return res + 134; /* [134, 135] */
      return -1;

    case E_V2048BImode:
      res = pattern346 (
E_V2048BImode);
      if (res >= 0)
        return res + 136; /* [136, 137] */
      return -1;

    case E_V4096BImode:
      res = pattern346 (
E_V4096BImode);
      if (res >= 0)
        return res + 138; /* [138, 139] */
      return -1;

    default:
      return -1;
    }
}

int
pattern412 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !memory_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern416 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !memory_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern420 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != AND
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ASHIFT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return 0;
}

int
pattern426 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern431 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  if (!equality_operator (operands[1], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x5, 1);
  operands[3] = x7;
  x8 = XEXP (x4, 1);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[0] = x10;
  x11 = XVECEXP (x1, 0, 1);
  x12 = XEXP (x11, 0);
  operands[5] = x12;
  x13 = XVECEXP (x1, 0, 2);
  x14 = XEXP (x13, 0);
  operands[6] = x14;
  switch (GET_MODE (x5))
    {
    case E_SImode:
      return pattern430 (
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern430 (
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern442 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[5] = x4;
  if (!vector_length_operand (operands[5], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[6] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XEXP (x1, 2);
  operands[2] = x8;
  x9 = XEXP (x6, 1);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[4] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVMF64BImode:
          return pattern440 (x1, 
E_RVVMF64BImode); /* [-1, 0] */

        case E_RVVMF32BImode:
          if (pattern440 (x1, 
E_RVVMF32BImode) != 0)
            return -1;
          return 1;

        case E_RVVMF16BImode:
          if (pattern440 (x1, 
E_RVVMF16BImode) != 0)
            return -1;
          return 2;

        case E_RVVMF8BImode:
          if (pattern440 (x1, 
E_RVVMF8BImode) != 0)
            return -1;
          return 3;

        case E_RVVMF4BImode:
          if (pattern440 (x1, 
E_RVVMF4BImode) != 0)
            return -1;
          return 4;

        case E_RVVMF2BImode:
          if (pattern440 (x1, 
E_RVVMF2BImode) != 0)
            return -1;
          return 5;

        case E_RVVM1BImode:
          if (pattern440 (x1, 
E_RVVM1BImode) != 0)
            return -1;
          return 6;

        case E_V1BImode:
          if (pattern440 (x1, 
E_V1BImode) != 0)
            return -1;
          return 7;

        case E_V2BImode:
          if (pattern440 (x1, 
E_V2BImode) != 0)
            return -1;
          return 8;

        case E_V4BImode:
          if (pattern440 (x1, 
E_V4BImode) != 0)
            return -1;
          return 9;

        case E_V8BImode:
          if (pattern440 (x1, 
E_V8BImode) != 0)
            return -1;
          return 10;

        case E_V16BImode:
          if (pattern440 (x1, 
E_V16BImode) != 0)
            return -1;
          return 11;

        case E_V32BImode:
          if (pattern440 (x1, 
E_V32BImode) != 0)
            return -1;
          return 12;

        case E_V64BImode:
          if (pattern440 (x1, 
E_V64BImode) != 0)
            return -1;
          return 13;

        case E_V128BImode:
          if (pattern440 (x1, 
E_V128BImode) != 0)
            return -1;
          return 14;

        case E_V256BImode:
          if (pattern440 (x1, 
E_V256BImode) != 0)
            return -1;
          return 15;

        case E_V512BImode:
          if (pattern440 (x1, 
E_V512BImode) != 0)
            return -1;
          return 16;

        case E_V1024BImode:
          if (pattern440 (x1, 
E_V1024BImode) != 0)
            return -1;
          return 17;

        case E_V2048BImode:
          if (pattern440 (x1, 
E_V2048BImode) != 0)
            return -1;
          return 18;

        case E_V4096BImode:
          if (pattern440 (x1, 
E_V4096BImode) != 0)
            return -1;
          return 19;

        default:
          return -1;
        }

    case NOT:
      x10 = XEXP (x9, 0);
      operands[4] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVMF64BImode:
          if (pattern441 (x1, 
E_RVVMF64BImode) != 0)
            return -1;
          return 20;

        case E_RVVMF32BImode:
          if (pattern441 (x1, 
E_RVVMF32BImode) != 0)
            return -1;
          return 21;

        case E_RVVMF16BImode:
          if (pattern441 (x1, 
E_RVVMF16BImode) != 0)
            return -1;
          return 22;

        case E_RVVMF8BImode:
          if (pattern441 (x1, 
E_RVVMF8BImode) != 0)
            return -1;
          return 23;

        case E_RVVMF4BImode:
          if (pattern441 (x1, 
E_RVVMF4BImode) != 0)
            return -1;
          return 24;

        case E_RVVMF2BImode:
          if (pattern441 (x1, 
E_RVVMF2BImode) != 0)
            return -1;
          return 25;

        case E_RVVM1BImode:
          if (pattern441 (x1, 
E_RVVM1BImode) != 0)
            return -1;
          return 26;

        case E_V1BImode:
          if (pattern441 (x1, 
E_V1BImode) != 0)
            return -1;
          return 27;

        case E_V2BImode:
          if (pattern441 (x1, 
E_V2BImode) != 0)
            return -1;
          return 28;

        case E_V4BImode:
          if (pattern441 (x1, 
E_V4BImode) != 0)
            return -1;
          return 29;

        case E_V8BImode:
          if (pattern441 (x1, 
E_V8BImode) != 0)
            return -1;
          return 30;

        case E_V16BImode:
          if (pattern441 (x1, 
E_V16BImode) != 0)
            return -1;
          return 31;

        case E_V32BImode:
          if (pattern441 (x1, 
E_V32BImode) != 0)
            return -1;
          return 32;

        case E_V64BImode:
          if (pattern441 (x1, 
E_V64BImode) != 0)
            return -1;
          return 33;

        case E_V128BImode:
          if (pattern441 (x1, 
E_V128BImode) != 0)
            return -1;
          return 34;

        case E_V256BImode:
          if (pattern441 (x1, 
E_V256BImode) != 0)
            return -1;
          return 35;

        case E_V512BImode:
          if (pattern441 (x1, 
E_V512BImode) != 0)
            return -1;
          return 36;

        case E_V1024BImode:
          if (pattern441 (x1, 
E_V1024BImode) != 0)
            return -1;
          return 37;

        case E_V2048BImode:
          if (pattern441 (x1, 
E_V2048BImode) != 0)
            return -1;
          return 38;

        case E_V4096BImode:
          if (pattern441 (x1, 
E_V4096BImode) != 0)
            return -1;
          return 39;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern482 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern484 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1)
      || !vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern485 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF64BImode:
      return pattern484 (x1, 
E_RVVMF64BImode); /* [-1, 0] */

    case E_RVVMF32BImode:
      if (pattern484 (x1, 
E_RVVMF32BImode) != 0)
        return -1;
      return 1;

    case E_RVVMF16BImode:
      if (pattern484 (x1, 
E_RVVMF16BImode) != 0)
        return -1;
      return 2;

    case E_RVVMF8BImode:
      if (pattern484 (x1, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF4BImode:
      if (pattern484 (x1, 
E_RVVMF4BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF2BImode:
      if (pattern484 (x1, 
E_RVVMF2BImode) != 0)
        return -1;
      return 5;

    case E_RVVM1BImode:
      if (pattern484 (x1, 
E_RVVM1BImode) != 0)
        return -1;
      return 6;

    case E_V1BImode:
      if (pattern484 (x1, 
E_V1BImode) != 0)
        return -1;
      return 7;

    case E_V2BImode:
      if (pattern484 (x1, 
E_V2BImode) != 0)
        return -1;
      return 8;

    case E_V4BImode:
      if (pattern484 (x1, 
E_V4BImode) != 0)
        return -1;
      return 9;

    case E_V8BImode:
      if (pattern484 (x1, 
E_V8BImode) != 0)
        return -1;
      return 10;

    case E_V16BImode:
      if (pattern484 (x1, 
E_V16BImode) != 0)
        return -1;
      return 11;

    case E_V32BImode:
      if (pattern484 (x1, 
E_V32BImode) != 0)
        return -1;
      return 12;

    case E_V64BImode:
      if (pattern484 (x1, 
E_V64BImode) != 0)
        return -1;
      return 13;

    case E_V128BImode:
      if (pattern484 (x1, 
E_V128BImode) != 0)
        return -1;
      return 14;

    case E_V256BImode:
      if (pattern484 (x1, 
E_V256BImode) != 0)
        return -1;
      return 15;

    case E_V512BImode:
      if (pattern484 (x1, 
E_V512BImode) != 0)
        return -1;
      return 16;

    case E_V1024BImode:
      if (pattern484 (x1, 
E_V1024BImode) != 0)
        return -1;
      return 17;

    case E_V2048BImode:
      if (pattern484 (x1, 
E_V2048BImode) != 0)
        return -1;
      return 18;

    case E_V4096BImode:
      if (pattern484 (x1, 
E_V4096BImode) != 0)
        return -1;
      return 19;

    default:
      return -1;
    }
}

int
pattern493 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern495 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern497 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 2);
  operands[2] = x7;
  x8 = XEXP (x1, 1);
  x9 = XEXP (x8, 0);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[3] = x9;
      x10 = XEXP (x8, 1);
      operands[4] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          return pattern495 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

        case E_RVVM4QImode:
          if (pattern495 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2QImode:
          if (pattern495 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1QImode:
          if (pattern495 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 3;

        case E_RVVM8HImode:
          if (pattern495 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 4;

        case E_RVVM4HImode:
          if (pattern495 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 5;

        case E_RVVM2HImode:
          if (pattern495 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 6;

        case E_RVVM1HImode:
          if (pattern495 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 7;

        case E_RVVM8SImode:
          if (pattern495 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 8;

        case E_RVVM4SImode:
          if (pattern495 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 9;

        case E_RVVM2SImode:
          if (pattern495 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 10;

        case E_RVVM1SImode:
          if (pattern495 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 11;

        case E_RVVM8DImode:
          if (pattern495 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 12;

        case E_RVVM4DImode:
          if (pattern495 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 13;

        case E_RVVM2DImode:
          if (pattern495 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 14;

        case E_RVVM1DImode:
          if (pattern495 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 15;

        case E_RVVMF2QImode:
          if (pattern495 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 16;

        case E_RVVMF4QImode:
          if (pattern495 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 17;

        case E_RVVMF8QImode:
          if (pattern495 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 18;

        case E_RVVMF2HImode:
          if (pattern495 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 19;

        case E_RVVMF4HImode:
          if (pattern495 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 20;

        case E_RVVMF2SImode:
          if (pattern495 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 21;

        case E_V1QImode:
          if (pattern495 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
            return -1;
          return 22;

        case E_V2QImode:
          if (pattern495 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
            return -1;
          return 23;

        case E_V4QImode:
          if (pattern495 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
            return -1;
          return 24;

        case E_V8QImode:
          if (pattern495 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
            return -1;
          return 25;

        case E_V16QImode:
          if (pattern495 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 26;

        case E_V32QImode:
          if (pattern495 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
            return -1;
          return 27;

        case E_V64QImode:
          if (pattern495 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
            return -1;
          return 28;

        case E_V128QImode:
          if (pattern495 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
            return -1;
          return 29;

        case E_V256QImode:
          if (pattern495 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
            return -1;
          return 30;

        case E_V512QImode:
          if (pattern495 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
            return -1;
          return 31;

        case E_V1024QImode:
          if (pattern495 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
            return -1;
          return 32;

        case E_V2048QImode:
          if (pattern495 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
            return -1;
          return 33;

        case E_V4096QImode:
          if (pattern495 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
            return -1;
          return 34;

        case E_V1HImode:
          if (pattern495 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
            return -1;
          return 35;

        case E_V2HImode:
          if (pattern495 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
            return -1;
          return 36;

        case E_V4HImode:
          if (pattern495 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
            return -1;
          return 37;

        case E_V8HImode:
          if (pattern495 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 38;

        case E_V16HImode:
          if (pattern495 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
            return -1;
          return 39;

        case E_V32HImode:
          if (pattern495 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
            return -1;
          return 40;

        case E_V64HImode:
          if (pattern495 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
            return -1;
          return 41;

        case E_V128HImode:
          if (pattern495 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
            return -1;
          return 42;

        case E_V256HImode:
          if (pattern495 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
            return -1;
          return 43;

        case E_V512HImode:
          if (pattern495 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
            return -1;
          return 44;

        case E_V1024HImode:
          if (pattern495 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
            return -1;
          return 45;

        case E_V2048HImode:
          if (pattern495 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
            return -1;
          return 46;

        case E_V1SImode:
          if (pattern495 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
            return -1;
          return 47;

        case E_V2SImode:
          if (pattern495 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
            return -1;
          return 48;

        case E_V4SImode:
          if (pattern495 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 49;

        case E_V8SImode:
          if (pattern495 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
            return -1;
          return 50;

        case E_V16SImode:
          if (pattern495 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
            return -1;
          return 51;

        case E_V32SImode:
          if (pattern495 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
            return -1;
          return 52;

        case E_V64SImode:
          if (pattern495 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
            return -1;
          return 53;

        case E_V128SImode:
          if (pattern495 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
            return -1;
          return 54;

        case E_V256SImode:
          if (pattern495 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
            return -1;
          return 55;

        case E_V512SImode:
          if (pattern495 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
            return -1;
          return 56;

        case E_V1024SImode:
          if (pattern495 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
            return -1;
          return 57;

        case E_V1DImode:
          if (pattern495 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
            return -1;
          return 58;

        case E_V2DImode:
          if (pattern495 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
            return -1;
          return 59;

        case E_V4DImode:
          if (pattern495 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
            return -1;
          return 60;

        case E_V8DImode:
          if (pattern495 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
            return -1;
          return 61;

        case E_V16DImode:
          if (pattern495 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
            return -1;
          return 62;

        case E_V32DImode:
          if (pattern495 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
            return -1;
          return 63;

        case E_V64DImode:
          if (pattern495 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
            return -1;
          return 64;

        case E_V128DImode:
          if (pattern495 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
            return -1;
          return 65;

        case E_V256DImode:
          if (pattern495 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
            return -1;
          return 66;

        case E_V512DImode:
          if (pattern495 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
            return -1;
          return 67;

        case E_RVVM8HFmode:
          if (pattern495 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 68;

        case E_RVVM4HFmode:
          if (pattern495 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 69;

        case E_RVVM2HFmode:
          if (pattern495 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 70;

        case E_RVVM1HFmode:
          if (pattern495 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 71;

        case E_RVVMF2HFmode:
          if (pattern495 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 72;

        case E_RVVMF4HFmode:
          if (pattern495 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 73;

        case E_RVVM8SFmode:
          if (pattern495 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 74;

        case E_RVVM4SFmode:
          if (pattern495 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 75;

        case E_RVVM2SFmode:
          if (pattern495 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 76;

        case E_RVVM1SFmode:
          if (pattern495 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 77;

        case E_RVVMF2SFmode:
          if (pattern495 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 78;

        case E_RVVM8DFmode:
          if (pattern495 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 79;

        case E_RVVM4DFmode:
          if (pattern495 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 80;

        case E_RVVM2DFmode:
          if (pattern495 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 81;

        case E_RVVM1DFmode:
          if (pattern495 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 82;

        case E_V1HFmode:
          if (pattern495 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 83;

        case E_V2HFmode:
          if (pattern495 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 84;

        case E_V4HFmode:
          if (pattern495 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 85;

        case E_V8HFmode:
          if (pattern495 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 86;

        case E_V16HFmode:
          if (pattern495 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 87;

        case E_V32HFmode:
          if (pattern495 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 88;

        case E_V64HFmode:
          if (pattern495 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 89;

        case E_V128HFmode:
          if (pattern495 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 90;

        case E_V256HFmode:
          if (pattern495 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 91;

        case E_V512HFmode:
          if (pattern495 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 92;

        case E_V1024HFmode:
          if (pattern495 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 93;

        case E_V2048HFmode:
          if (pattern495 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 94;

        case E_V1SFmode:
          if (pattern495 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 95;

        case E_V2SFmode:
          if (pattern495 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 96;

        case E_V4SFmode:
          if (pattern495 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 97;

        case E_V8SFmode:
          if (pattern495 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 98;

        case E_V16SFmode:
          if (pattern495 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 99;

        case E_V32SFmode:
          if (pattern495 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 100;

        case E_V64SFmode:
          if (pattern495 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 101;

        case E_V128SFmode:
          if (pattern495 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 102;

        case E_V256SFmode:
          if (pattern495 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 103;

        case E_V512SFmode:
          if (pattern495 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 104;

        case E_V1024SFmode:
          if (pattern495 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 105;

        case E_V1DFmode:
          if (pattern495 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 106;

        case E_V2DFmode:
          if (pattern495 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 107;

        case E_V4DFmode:
          if (pattern495 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 108;

        case E_V8DFmode:
          if (pattern495 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 109;

        case E_V16DFmode:
          if (pattern495 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 110;

        case E_V32DFmode:
          if (pattern495 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 111;

        case E_V64DFmode:
          if (pattern495 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 112;

        case E_V128DFmode:
          if (pattern495 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 113;

        case E_V256DFmode:
          if (pattern495 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 114;

        case E_V512DFmode:
          if (pattern495 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 115;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x10 = XEXP (x8, 1);
      operands[3] = x10;
      x11 = XEXP (x9, 0);
      switch (GET_CODE (x11))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[4] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8QImode:
              if (pattern488 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode) != 0)
                return -1;
              return 116;

            case E_RVVM4QImode:
              if (pattern488 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0)
                return -1;
              return 117;

            case E_RVVM2QImode:
              if (pattern488 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0)
                return -1;
              return 118;

            case E_RVVM1QImode:
              if (pattern488 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0)
                return -1;
              return 119;

            case E_RVVMF2QImode:
              if (pattern488 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0)
                return -1;
              return 120;

            case E_RVVMF4QImode:
              if (pattern488 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0)
                return -1;
              return 121;

            case E_RVVMF8QImode:
              if (pattern488 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0)
                return -1;
              return 122;

            case E_RVVM8HImode:
              if (pattern488 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0)
                return -1;
              return 123;

            case E_RVVM4HImode:
              if (pattern488 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
                return -1;
              return 124;

            case E_RVVM2HImode:
              if (pattern488 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
                return -1;
              return 125;

            case E_RVVM1HImode:
              if (pattern488 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
                return -1;
              return 126;

            case E_RVVMF2HImode:
              if (pattern488 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
                return -1;
              return 127;

            case E_RVVMF4HImode:
              if (pattern488 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
                return -1;
              return 128;

            case E_RVVM8SImode:
              if (pattern488 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0)
                return -1;
              return 129;

            case E_RVVM4SImode:
              if (pattern488 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
                return -1;
              return 130;

            case E_RVVM2SImode:
              if (pattern488 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
                return -1;
              return 131;

            case E_RVVM1SImode:
              if (pattern488 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
                return -1;
              return 132;

            case E_RVVMF2SImode:
              if (pattern488 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
                return -1;
              return 133;

            case E_V1QImode:
              if (pattern488 (x1, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0)
                return -1;
              return 134;

            case E_V2QImode:
              if (pattern488 (x1, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0)
                return -1;
              return 135;

            case E_V4QImode:
              if (pattern488 (x1, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0)
                return -1;
              return 136;

            case E_V8QImode:
              if (pattern488 (x1, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0)
                return -1;
              return 137;

            case E_V16QImode:
              if (pattern488 (x1, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0)
                return -1;
              return 138;

            case E_V32QImode:
              if (pattern488 (x1, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0)
                return -1;
              return 139;

            case E_V64QImode:
              if (pattern488 (x1, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0)
                return -1;
              return 140;

            case E_V128QImode:
              if (pattern488 (x1, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0)
                return -1;
              return 141;

            case E_V256QImode:
              if (pattern488 (x1, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0)
                return -1;
              return 142;

            case E_V512QImode:
              if (pattern488 (x1, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0)
                return -1;
              return 143;

            case E_V1024QImode:
              if (pattern488 (x1, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0)
                return -1;
              return 144;

            case E_V2048QImode:
              if (pattern488 (x1, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0)
                return -1;
              return 145;

            case E_V4096QImode:
              if (pattern488 (x1, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0)
                return -1;
              return 146;

            case E_V1HImode:
              if (pattern488 (x1, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0)
                return -1;
              return 147;

            case E_V2HImode:
              if (pattern488 (x1, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0)
                return -1;
              return 148;

            case E_V4HImode:
              if (pattern488 (x1, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0)
                return -1;
              return 149;

            case E_V8HImode:
              if (pattern488 (x1, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0)
                return -1;
              return 150;

            case E_V16HImode:
              if (pattern488 (x1, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
                return -1;
              return 151;

            case E_V32HImode:
              if (pattern488 (x1, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
                return -1;
              return 152;

            case E_V64HImode:
              if (pattern488 (x1, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
                return -1;
              return 153;

            case E_V128HImode:
              if (pattern488 (x1, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0)
                return -1;
              return 154;

            case E_V256HImode:
              if (pattern488 (x1, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
                return -1;
              return 155;

            case E_V512HImode:
              if (pattern488 (x1, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
                return -1;
              return 156;

            case E_V1024HImode:
              if (pattern488 (x1, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0)
                return -1;
              return 157;

            case E_V2048HImode:
              if (pattern488 (x1, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0)
                return -1;
              return 158;

            case E_V1SImode:
              if (pattern488 (x1, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0)
                return -1;
              return 159;

            case E_V2SImode:
              if (pattern488 (x1, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
                return -1;
              return 160;

            case E_V4SImode:
              if (pattern488 (x1, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
                return -1;
              return 161;

            case E_V8SImode:
              if (pattern488 (x1, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0)
                return -1;
              return 162;

            case E_V16SImode:
              if (pattern488 (x1, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
                return -1;
              return 163;

            case E_V32SImode:
              if (pattern488 (x1, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0)
                return -1;
              return 164;

            case E_V64SImode:
              if (pattern488 (x1, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
                return -1;
              return 165;

            case E_V128SImode:
              if (pattern488 (x1, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
                return -1;
              return 166;

            case E_V256SImode:
              if (pattern488 (x1, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
                return -1;
              return 167;

            case E_V512SImode:
              if (pattern488 (x1, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
                return -1;
              return 168;

            case E_V1024SImode:
              if (pattern488 (x1, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0)
                return -1;
              return 169;

            case E_RVVM8DImode:
              if (pattern488 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0)
                return -1;
              return 170;

            case E_RVVM4DImode:
              if (pattern488 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0)
                return -1;
              return 171;

            case E_RVVM2DImode:
              if (pattern488 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0)
                return -1;
              return 172;

            case E_RVVM1DImode:
              if (pattern488 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0)
                return -1;
              return 173;

            case E_V1DImode:
              if (pattern488 (x1, 
E_V1DImode, 
E_V1BImode, 
E_DImode) != 0)
                return -1;
              return 174;

            case E_V2DImode:
              if (pattern488 (x1, 
E_V2DImode, 
E_V2BImode, 
E_DImode) != 0)
                return -1;
              return 175;

            case E_V4DImode:
              if (pattern488 (x1, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0)
                return -1;
              return 176;

            case E_V8DImode:
              if (pattern488 (x1, 
E_V8DImode, 
E_V8BImode, 
E_DImode) != 0)
                return -1;
              return 177;

            case E_V16DImode:
              if (pattern488 (x1, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0)
                return -1;
              return 178;

            case E_V32DImode:
              if (pattern488 (x1, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0)
                return -1;
              return 179;

            case E_V64DImode:
              if (pattern488 (x1, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0)
                return -1;
              return 180;

            case E_V128DImode:
              if (pattern488 (x1, 
E_V128DImode, 
E_V128BImode, 
E_DImode) != 0)
                return -1;
              return 181;

            case E_V256DImode:
              if (pattern488 (x1, 
E_V256DImode, 
E_V256BImode, 
E_DImode) != 0)
                return -1;
              return 182;

            case E_V512DImode:
              if (pattern488 (x1, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0)
                return -1;
              return 183;

            case E_RVVM8HFmode:
              if (pattern496 (x1, 
E_RVVM8HFmode, 
E_HFmode, 
E_RVVMF2BImode) != 0)
                return -1;
              return 184;

            case E_RVVM4HFmode:
              if (pattern496 (x1, 
E_RVVM4HFmode, 
E_HFmode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 185;

            case E_RVVM2HFmode:
              if (pattern496 (x1, 
E_RVVM2HFmode, 
E_HFmode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 186;

            case E_RVVM1HFmode:
              if (pattern496 (x1, 
E_RVVM1HFmode, 
E_HFmode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 187;

            case E_RVVMF2HFmode:
              if (pattern496 (x1, 
E_RVVMF2HFmode, 
E_HFmode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 188;

            case E_RVVMF4HFmode:
              if (pattern496 (x1, 
E_RVVMF4HFmode, 
E_HFmode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 189;

            case E_RVVM8SFmode:
              if (pattern496 (x1, 
E_RVVM8SFmode, 
E_SFmode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 190;

            case E_RVVM4SFmode:
              if (pattern496 (x1, 
E_RVVM4SFmode, 
E_SFmode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 191;

            case E_RVVM2SFmode:
              if (pattern496 (x1, 
E_RVVM2SFmode, 
E_SFmode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 192;

            case E_RVVM1SFmode:
              if (pattern496 (x1, 
E_RVVM1SFmode, 
E_SFmode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 193;

            case E_RVVMF2SFmode:
              if (pattern496 (x1, 
E_RVVMF2SFmode, 
E_SFmode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 194;

            case E_RVVM8DFmode:
              if (pattern496 (x1, 
E_RVVM8DFmode, 
E_DFmode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 195;

            case E_RVVM4DFmode:
              if (pattern496 (x1, 
E_RVVM4DFmode, 
E_DFmode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 196;

            case E_RVVM2DFmode:
              if (pattern496 (x1, 
E_RVVM2DFmode, 
E_DFmode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 197;

            case E_RVVM1DFmode:
              if (pattern496 (x1, 
E_RVVM1DFmode, 
E_DFmode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 198;

            default:
              return -1;
            }

        case SIGN_EXTEND:
          res = pattern491 (x1);
          if (res >= 0)
            return res + 199; /* [199, 212] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern563 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern565 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 1);
  x8 = XVECEXP (x7, 0, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[3] = x8;
      x9 = XVECEXP (x7, 0, 1);
      operands[4] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8DImode:
          return pattern554 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode); /* [-1, 0] */

        case E_RVVM4DImode:
          if (pattern554 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2DImode:
          if (pattern554 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1DImode:
          if (pattern554 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x9 = XVECEXP (x7, 0, 1);
      operands[3] = x9;
      x10 = XEXP (x8, 0);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[4] = x10;
          if (!reg_or_0_operand (operands[4], E_DImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8DImode:
              if (pattern556 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 4;

            case E_RVVM4DImode:
              if (pattern556 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 5;

            case E_RVVM2DImode:
              if (pattern556 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 6;

            case E_RVVM1DImode:
              if (pattern556 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 7;

            default:
              return -1;
            }

        case SIGN_EXTEND:
          res = pattern557 (x1);
          if (res >= 0)
            return res + 8; /* [8, 11] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern574 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (!register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern576 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[5] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[6] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[7] = x6;
  x7 = XVECEXP (x2, 0, 5);
  operands[8] = x7;
  x8 = XEXP (x1, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XEXP (x1, 2);
  operands[2] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern504 (x1, 
E_RVVM8HFmode, 
E_RVVM8HImode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x1) != E_RVVM4HFmode
          || GET_MODE (x2) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x8) != E_RVVM4HFmode
          || !vector_merge_operand (operands[2], E_RVVM4HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HImode:
          if (!register_operand (operands[3], E_RVVM4HImode))
            return -1;
          return 1;

        case E_RVVM8SImode:
          if (!register_operand (operands[3], E_RVVM8SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x1) != E_RVVM2HFmode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x8) != E_RVVM2HFmode
          || !vector_merge_operand (operands[2], E_RVVM2HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode))
            return -1;
          return 3;

        case E_RVVM4SImode:
          if (!register_operand (operands[3], E_RVVM4SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x1) != E_RVVM1HFmode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x8) != E_RVVM1HFmode
          || !vector_merge_operand (operands[2], E_RVVM1HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode))
            return -1;
          return 5;

        case E_RVVM2SImode:
          if (!register_operand (operands[3], E_RVVM2SImode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x1) != E_RVVMF2HFmode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x8) != E_RVVMF2HFmode
          || !vector_merge_operand (operands[2], E_RVVMF2HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode))
            return -1;
          return 7;

        case E_RVVM1SImode:
          if (!register_operand (operands[3], E_RVVM1SImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x1) != E_RVVMF4HFmode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x8) != E_RVVMF4HFmode
          || !vector_merge_operand (operands[2], E_RVVMF4HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF4HImode:
          if (!register_operand (operands[3], E_RVVMF4HImode))
            return -1;
          return 9;

        case E_RVVMF2SImode:
          if (!register_operand (operands[3], E_RVVMF2SImode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_RVVM8SFmode:
      if (pattern504 (x1, 
E_RVVM8SFmode, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x1) != E_RVVM4SFmode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x8) != E_RVVM4SFmode
          || !vector_merge_operand (operands[2], E_RVVM4SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4SImode:
          if (!register_operand (operands[3], E_RVVM4SImode))
            return -1;
          return 12;

        case E_RVVM8DImode:
          if (!register_operand (operands[3], E_RVVM8DImode))
            return -1;
          return 13;

        default:
          return -1;
        }

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x1) != E_RVVM2SFmode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x8) != E_RVVM2SFmode
          || !vector_merge_operand (operands[2], E_RVVM2SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2SImode:
          if (!register_operand (operands[3], E_RVVM2SImode))
            return -1;
          return 14;

        case E_RVVM4DImode:
          if (!register_operand (operands[3], E_RVVM4DImode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x1) != E_RVVM1SFmode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x8) != E_RVVM1SFmode
          || !vector_merge_operand (operands[2], E_RVVM1SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1SImode:
          if (!register_operand (operands[3], E_RVVM1SImode))
            return -1;
          return 16;

        case E_RVVM2DImode:
          if (!register_operand (operands[3], E_RVVM2DImode))
            return -1;
          return 17;

        default:
          return -1;
        }

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x1) != E_RVVMF2SFmode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x8) != E_RVVMF2SFmode
          || !vector_merge_operand (operands[2], E_RVVMF2SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2SImode:
          if (!register_operand (operands[3], E_RVVMF2SImode))
            return -1;
          return 18;

        case E_RVVM1DImode:
          if (!register_operand (operands[3], E_RVVM1DImode))
            return -1;
          return 19;

        default:
          return -1;
        }

    case E_RVVM8DFmode:
      if (pattern504 (x1, 
E_RVVM8DFmode, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 20;

    case E_RVVM4DFmode:
      if (pattern504 (x1, 
E_RVVM4DFmode, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 21;

    case E_RVVM2DFmode:
      if (pattern504 (x1, 
E_RVVM2DFmode, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 22;

    case E_RVVM1DFmode:
      if (pattern504 (x1, 
E_RVVM1DFmode, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 23;

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x1) != E_V1HFmode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x8) != E_V1HFmode
          || !vector_merge_operand (operands[2], E_V1HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1HImode:
          if (!register_operand (operands[3], E_V1HImode))
            return -1;
          return 24;

        case E_V1SImode:
          if (!register_operand (operands[3], E_V1SImode))
            return -1;
          return 25;

        default:
          return -1;
        }

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x1) != E_V2HFmode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x8) != E_V2HFmode
          || !vector_merge_operand (operands[2], E_V2HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2HImode:
          if (!register_operand (operands[3], E_V2HImode))
            return -1;
          return 26;

        case E_V2SImode:
          if (!register_operand (operands[3], E_V2SImode))
            return -1;
          return 27;

        default:
          return -1;
        }

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x1) != E_V4HFmode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x8) != E_V4HFmode
          || !vector_merge_operand (operands[2], E_V4HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HImode:
          if (!register_operand (operands[3], E_V4HImode))
            return -1;
          return 28;

        case E_V4SImode:
          if (!register_operand (operands[3], E_V4SImode))
            return -1;
          return 29;

        default:
          return -1;
        }

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x8) != E_V8HFmode
          || !vector_merge_operand (operands[2], E_V8HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8HImode:
          if (!register_operand (operands[3], E_V8HImode))
            return -1;
          return 30;

        case E_V8SImode:
          if (!register_operand (operands[3], E_V8SImode))
            return -1;
          return 31;

        default:
          return -1;
        }

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x1) != E_V16HFmode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x8) != E_V16HFmode
          || !vector_merge_operand (operands[2], E_V16HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16HImode:
          if (!register_operand (operands[3], E_V16HImode))
            return -1;
          return 32;

        case E_V16SImode:
          if (!register_operand (operands[3], E_V16SImode))
            return -1;
          return 33;

        default:
          return -1;
        }

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x1) != E_V32HFmode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x8) != E_V32HFmode
          || !vector_merge_operand (operands[2], E_V32HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32HImode:
          if (!register_operand (operands[3], E_V32HImode))
            return -1;
          return 34;

        case E_V32SImode:
          if (!register_operand (operands[3], E_V32SImode))
            return -1;
          return 35;

        default:
          return -1;
        }

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x1) != E_V64HFmode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x8) != E_V64HFmode
          || !vector_merge_operand (operands[2], E_V64HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64HImode:
          if (!register_operand (operands[3], E_V64HImode))
            return -1;
          return 36;

        case E_V64SImode:
          if (!register_operand (operands[3], E_V64SImode))
            return -1;
          return 37;

        default:
          return -1;
        }

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x1) != E_V128HFmode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x8) != E_V128HFmode
          || !vector_merge_operand (operands[2], E_V128HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128HImode:
          if (!register_operand (operands[3], E_V128HImode))
            return -1;
          return 38;

        case E_V128SImode:
          if (!register_operand (operands[3], E_V128SImode))
            return -1;
          return 39;

        default:
          return -1;
        }

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x1) != E_V256HFmode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x8) != E_V256HFmode
          || !vector_merge_operand (operands[2], E_V256HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256HImode:
          if (!register_operand (operands[3], E_V256HImode))
            return -1;
          return 40;

        case E_V256SImode:
          if (!register_operand (operands[3], E_V256SImode))
            return -1;
          return 41;

        default:
          return -1;
        }

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x1) != E_V512HFmode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x8) != E_V512HFmode
          || !vector_merge_operand (operands[2], E_V512HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512HImode:
          if (!register_operand (operands[3], E_V512HImode))
            return -1;
          return 42;

        case E_V512SImode:
          if (!register_operand (operands[3], E_V512SImode))
            return -1;
          return 43;

        default:
          return -1;
        }

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x1) != E_V1024HFmode
          || GET_MODE (x2) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode)
          || GET_MODE (x8) != E_V1024HFmode
          || !vector_merge_operand (operands[2], E_V1024HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1024HImode:
          if (!register_operand (operands[3], E_V1024HImode))
            return -1;
          return 44;

        case E_V1024SImode:
          if (!register_operand (operands[3], E_V1024SImode))
            return -1;
          return 45;

        default:
          return -1;
        }

    case E_V2048HFmode:
      if (pattern504 (x1, 
E_V2048HFmode, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 46;

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x1) != E_V1SFmode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x8) != E_V1SFmode
          || !vector_merge_operand (operands[2], E_V1SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1SImode:
          if (!register_operand (operands[3], E_V1SImode))
            return -1;
          return 47;

        case E_V1DImode:
          if (!register_operand (operands[3], E_V1DImode))
            return -1;
          return 48;

        default:
          return -1;
        }

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x1) != E_V2SFmode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x8) != E_V2SFmode
          || !vector_merge_operand (operands[2], E_V2SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2SImode:
          if (!register_operand (operands[3], E_V2SImode))
            return -1;
          return 49;

        case E_V2DImode:
          if (!register_operand (operands[3], E_V2DImode))
            return -1;
          return 50;

        default:
          return -1;
        }

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x8) != E_V4SFmode
          || !vector_merge_operand (operands[2], E_V4SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4SImode:
          if (!register_operand (operands[3], E_V4SImode))
            return -1;
          return 51;

        case E_V4DImode:
          if (!register_operand (operands[3], E_V4DImode))
            return -1;
          return 52;

        default:
          return -1;
        }

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x1) != E_V8SFmode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x8) != E_V8SFmode
          || !vector_merge_operand (operands[2], E_V8SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8SImode:
          if (!register_operand (operands[3], E_V8SImode))
            return -1;
          return 53;

        case E_V8DImode:
          if (!register_operand (operands[3], E_V8DImode))
            return -1;
          return 54;

        default:
          return -1;
        }

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x1) != E_V16SFmode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x8) != E_V16SFmode
          || !vector_merge_operand (operands[2], E_V16SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16SImode:
          if (!register_operand (operands[3], E_V16SImode))
            return -1;
          return 55;

        case E_V16DImode:
          if (!register_operand (operands[3], E_V16DImode))
            return -1;
          return 56;

        default:
          return -1;
        }

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x1) != E_V32SFmode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x8) != E_V32SFmode
          || !vector_merge_operand (operands[2], E_V32SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32SImode:
          if (!register_operand (operands[3], E_V32SImode))
            return -1;
          return 57;

        case E_V32DImode:
          if (!register_operand (operands[3], E_V32DImode))
            return -1;
          return 58;

        default:
          return -1;
        }

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x1) != E_V64SFmode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x8) != E_V64SFmode
          || !vector_merge_operand (operands[2], E_V64SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64SImode:
          if (!register_operand (operands[3], E_V64SImode))
            return -1;
          return 59;

        case E_V64DImode:
          if (!register_operand (operands[3], E_V64DImode))
            return -1;
          return 60;

        default:
          return -1;
        }

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x1) != E_V128SFmode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x8) != E_V128SFmode
          || !vector_merge_operand (operands[2], E_V128SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128SImode:
          if (!register_operand (operands[3], E_V128SImode))
            return -1;
          return 61;

        case E_V128DImode:
          if (!register_operand (operands[3], E_V128DImode))
            return -1;
          return 62;

        default:
          return -1;
        }

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x1) != E_V256SFmode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x8) != E_V256SFmode
          || !vector_merge_operand (operands[2], E_V256SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256SImode:
          if (!register_operand (operands[3], E_V256SImode))
            return -1;
          return 63;

        case E_V256DImode:
          if (!register_operand (operands[3], E_V256DImode))
            return -1;
          return 64;

        default:
          return -1;
        }

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x1) != E_V512SFmode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x8) != E_V512SFmode
          || !vector_merge_operand (operands[2], E_V512SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512SImode:
          if (!register_operand (operands[3], E_V512SImode))
            return -1;
          return 65;

        case E_V512DImode:
          if (!register_operand (operands[3], E_V512DImode))
            return -1;
          return 66;

        default:
          return -1;
        }

    case E_V1024SFmode:
      if (pattern504 (x1, 
E_V1024SFmode, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 67;

    case E_V1DFmode:
      if (pattern504 (x1, 
E_V1DFmode, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 68;

    case E_V2DFmode:
      if (pattern504 (x1, 
E_V2DFmode, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 69;

    case E_V4DFmode:
      if (pattern504 (x1, 
E_V4DFmode, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 70;

    case E_V8DFmode:
      if (pattern504 (x1, 
E_V8DFmode, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 71;

    case E_V16DFmode:
      if (pattern504 (x1, 
E_V16DFmode, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 72;

    case E_V32DFmode:
      if (pattern504 (x1, 
E_V32DFmode, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 73;

    case E_V64DFmode:
      if (pattern504 (x1, 
E_V64DFmode, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 74;

    case E_V128DFmode:
      if (pattern504 (x1, 
E_V128DFmode, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 75;

    case E_V256DFmode:
      if (pattern504 (x1, 
E_V256DFmode, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 76;

    case E_V512DFmode:
      if (pattern504 (x1, 
E_V512DFmode, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 77;

    default:
      return -1;
    }
}

int
pattern682 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF4BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode)
          || !register_operand (operands[3], E_RVVM8SFmode))
        return -1;
      return 0;

    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[3], E_RVVM4SFmode))
        return -1;
      return 1;

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[3], E_RVVM2SFmode))
        return -1;
      return 2;

    case E_RVVMF32BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[3], E_RVVM1SFmode))
        return -1;
      return 3;

    case E_RVVMF64BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[3], E_RVVMF2SFmode))
        return -1;
      return 4;

    case E_V1BImode:
      if (!vector_mask_operand (operands[1], E_V1BImode)
          || !register_operand (operands[3], E_V1SFmode))
        return -1;
      return 5;

    case E_V2BImode:
      if (!vector_mask_operand (operands[1], E_V2BImode)
          || !register_operand (operands[3], E_V2SFmode))
        return -1;
      return 6;

    case E_V4BImode:
      if (!vector_mask_operand (operands[1], E_V4BImode)
          || !register_operand (operands[3], E_V4SFmode))
        return -1;
      return 7;

    case E_V8BImode:
      if (!vector_mask_operand (operands[1], E_V8BImode)
          || !register_operand (operands[3], E_V8SFmode))
        return -1;
      return 8;

    case E_V16BImode:
      if (!vector_mask_operand (operands[1], E_V16BImode)
          || !register_operand (operands[3], E_V16SFmode))
        return -1;
      return 9;

    case E_V32BImode:
      if (!vector_mask_operand (operands[1], E_V32BImode)
          || !register_operand (operands[3], E_V32SFmode))
        return -1;
      return 10;

    case E_V64BImode:
      if (!vector_mask_operand (operands[1], E_V64BImode)
          || !register_operand (operands[3], E_V64SFmode))
        return -1;
      return 11;

    case E_V128BImode:
      if (!vector_mask_operand (operands[1], E_V128BImode)
          || !register_operand (operands[3], E_V128SFmode))
        return -1;
      return 12;

    case E_V256BImode:
      if (!vector_mask_operand (operands[1], E_V256BImode)
          || !register_operand (operands[3], E_V256SFmode))
        return -1;
      return 13;

    case E_V512BImode:
      if (!vector_mask_operand (operands[1], E_V512BImode)
          || !register_operand (operands[3], E_V512SFmode))
        return -1;
      return 14;

    case E_V1024BImode:
      if (!vector_mask_operand (operands[1], E_V1024BImode)
          || !register_operand (operands[3], E_V1024SFmode))
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern692 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[4], i1)
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern699 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !reg_or_0_operand (operands[3], i3)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern705 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern704 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (pattern704 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (pattern704 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (pattern704 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (pattern704 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (pattern704 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SImode:
      if (pattern704 (x1, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SImode:
      if (pattern704 (x1, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SImode:
      if (pattern704 (x1, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SImode:
      if (pattern704 (x1, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SImode:
      if (pattern704 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DImode:
      if (pattern704 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DImode:
      if (pattern704 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DImode:
      if (pattern704 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DImode:
      if (pattern704 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
        return -1;
      return 14;

    case E_V1HImode:
      if (pattern704 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0)
        return -1;
      return 15;

    case E_V2HImode:
      if (pattern704 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0)
        return -1;
      return 16;

    case E_V4HImode:
      if (pattern704 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0)
        return -1;
      return 17;

    case E_V8HImode:
      if (pattern704 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0)
        return -1;
      return 18;

    case E_V16HImode:
      if (pattern704 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0)
        return -1;
      return 19;

    case E_V32HImode:
      if (pattern704 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0)
        return -1;
      return 20;

    case E_V64HImode:
      if (pattern704 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0)
        return -1;
      return 21;

    case E_V128HImode:
      if (pattern704 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0)
        return -1;
      return 22;

    case E_V256HImode:
      if (pattern704 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0)
        return -1;
      return 23;

    case E_V512HImode:
      if (pattern704 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0)
        return -1;
      return 24;

    case E_V1024HImode:
      if (pattern704 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0)
        return -1;
      return 25;

    case E_V2048HImode:
      if (pattern704 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0)
        return -1;
      return 26;

    case E_V1SImode:
      if (pattern704 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0)
        return -1;
      return 27;

    case E_V2SImode:
      if (pattern704 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0)
        return -1;
      return 28;

    case E_V4SImode:
      if (pattern704 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0)
        return -1;
      return 29;

    case E_V8SImode:
      if (pattern704 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0)
        return -1;
      return 30;

    case E_V16SImode:
      if (pattern704 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
        return -1;
      return 31;

    case E_V32SImode:
      if (pattern704 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
        return -1;
      return 32;

    case E_V64SImode:
      if (pattern704 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
        return -1;
      return 33;

    case E_V128SImode:
      if (pattern704 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0)
        return -1;
      return 34;

    case E_V256SImode:
      if (pattern704 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
        return -1;
      return 35;

    case E_V512SImode:
      if (pattern704 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
        return -1;
      return 36;

    case E_V1024SImode:
      if (pattern704 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0)
        return -1;
      return 37;

    case E_V1DImode:
      if (pattern704 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0)
        return -1;
      return 38;

    case E_V2DImode:
      if (pattern704 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
        return -1;
      return 39;

    case E_V4DImode:
      if (pattern704 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
        return -1;
      return 40;

    case E_V8DImode:
      if (pattern704 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0)
        return -1;
      return 41;

    case E_V16DImode:
      if (pattern704 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
        return -1;
      return 42;

    case E_V32DImode:
      if (pattern704 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0)
        return -1;
      return 43;

    case E_V64DImode:
      if (pattern704 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
        return -1;
      return 44;

    case E_V128DImode:
      if (pattern704 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
        return -1;
      return 45;

    case E_V256DImode:
      if (pattern704 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
        return -1;
      return 46;

    case E_V512DImode:
      if (pattern704 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern730 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[0] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  switch (XWINT (x8, 0))
    {
    case -4L:
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 1);
      if (XWINT (x12, 0) != -8L)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -12L)
        return -1;
      return 0;

    case -8L:
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 1);
      if (XWINT (x12, 0) != -16L)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -24L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern733 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x3, 1);
  return pattern725 (x4, 
i1, 
i2, 
i4); /* [-1, 0] */
}

int
pattern735 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  return 0;
}

int
pattern736 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  switch (XWINT (x5, 0))
    {
    case -4L:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -8L)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -12L)
        return -1;
      return 0;

    case -8L:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -16L)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -24L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern739 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x17, 1);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  return 0;
}

int
pattern742 (rtx x1, machine_mode i1, int i2, int i3, int i4, int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 22:
      if (REGNO (x12) != 21
          || REGNO (x17) != 20
          || REGNO (x22) != 19)
        return -1;
      x28 = XEXP (x26, 1);
      if (GET_CODE (x28) != MEM
          || GET_MODE (x28) != i1)
        return -1;
      x29 = XEXP (x28, 0);
      if (GET_CODE (x29) != PLUS
          || GET_MODE (x29) != i1)
        return -1;
      x30 = XEXP (x29, 0);
      if (GET_CODE (x30) != REG
          || REGNO (x30) != 2
          || GET_MODE (x30) != i1)
        return -1;
      x31 = XEXP (x29, 1);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + i5]
          || REGNO (x27) != 18)
        return -1;
      x32 = XVECEXP (x1, 0, 6);
      if (GET_CODE (x32) != SET)
        return -1;
      x33 = XEXP (x32, 1);
      if (GET_CODE (x33) != MEM
          || GET_MODE (x33) != i1)
        return -1;
      x34 = XEXP (x33, 0);
      if (GET_CODE (x34) != PLUS
          || GET_MODE (x34) != i1)
        return -1;
      x35 = XEXP (x34, 0);
      if (GET_CODE (x35) != REG
          || REGNO (x35) != 2
          || GET_MODE (x35) != i1)
        return -1;
      x36 = XEXP (x34, 1);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
        return -1;
      x37 = XEXP (x32, 0);
      if (GET_CODE (x37) != REG
          || REGNO (x37) != 9
          || GET_MODE (x37) != i1)
        return -1;
      x38 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x38) != SET)
        return -1;
      x39 = XEXP (x38, 1);
      if (GET_CODE (x39) != MEM
          || GET_MODE (x39) != i1)
        return -1;
      x40 = XEXP (x39, 0);
      if (GET_CODE (x40) != PLUS
          || GET_MODE (x40) != i1)
        return -1;
      x41 = XEXP (x40, 0);
      if (GET_CODE (x41) != REG
          || REGNO (x41) != 2
          || GET_MODE (x41) != i1)
        return -1;
      x42 = XEXP (x40, 1);
      if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
        return -1;
      x43 = XEXP (x38, 0);
      if (GET_CODE (x43) != REG
          || REGNO (x43) != 8
          || GET_MODE (x43) != i1)
        return -1;
      x44 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x44) != SET)
        return -1;
      x45 = XEXP (x44, 1);
      if (GET_CODE (x45) != MEM
          || GET_MODE (x45) != i1)
        return -1;
      x46 = XEXP (x45, 0);
      if (GET_CODE (x46) != PLUS
          || GET_MODE (x46) != i1)
        return -1;
      x47 = XEXP (x46, 0);
      if (GET_CODE (x47) != REG
          || REGNO (x47) != 2
          || GET_MODE (x47) != i1)
        return -1;
      x48 = XEXP (x46, 1);
      if (x48 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
        return -1;
      x49 = XEXP (x44, 0);
      if (GET_CODE (x49) != REG
          || REGNO (x49) != 1
          || GET_MODE (x49) != i1
          || !stack_pop_up_to_s6_operand (operands[0], E_VOIDmode))
        return -1;
      return 0;

    case 20:
      if (REGNO (x12) != 19
          || REGNO (x17) != 18
          || REGNO (x22) != 9)
        return -1;
      x28 = XEXP (x26, 1);
      if (GET_CODE (x28) != MEM
          || GET_MODE (x28) != i1)
        return -1;
      x29 = XEXP (x28, 0);
      if (GET_CODE (x29) != PLUS
          || GET_MODE (x29) != i1)
        return -1;
      x30 = XEXP (x29, 0);
      if (GET_CODE (x30) != REG
          || REGNO (x30) != 2
          || GET_MODE (x30) != i1)
        return -1;
      x31 = XEXP (x29, 1);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + i5]
          || REGNO (x27) != 8)
        return -1;
      x32 = XVECEXP (x1, 0, 6);
      if (GET_CODE (x32) != SET)
        return -1;
      x33 = XEXP (x32, 1);
      if (GET_CODE (x33) != MEM
          || GET_MODE (x33) != i1)
        return -1;
      x34 = XEXP (x33, 0);
      if (GET_CODE (x34) != PLUS
          || GET_MODE (x34) != i1)
        return -1;
      x35 = XEXP (x34, 0);
      if (GET_CODE (x35) != REG
          || REGNO (x35) != 2
          || GET_MODE (x35) != i1)
        return -1;
      x36 = XEXP (x34, 1);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
        return -1;
      x37 = XEXP (x32, 0);
      if (GET_CODE (x37) != REG
          || REGNO (x37) != 1
          || GET_MODE (x37) != i1)
        return -1;
      x38 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x38) != RETURN)
        return -1;
      x44 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x44) != USE)
        return -1;
      x49 = XEXP (x44, 0);
      if (GET_CODE (x49) != REG
          || REGNO (x49) != 1
          || GET_MODE (x49) != E_SImode
          || !stack_pop_up_to_s4_operand (operands[0], E_VOIDmode))
        return -1;
      return 1;

    case 18:
      if (REGNO (x12) != 9
          || REGNO (x17) != 8
          || REGNO (x22) != 1)
        return -1;
      x28 = XEXP (x26, 1);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x27) != 10)
        return -1;
      x32 = XVECEXP (x1, 0, 6);
      if (GET_CODE (x32) != USE)
        return -1;
      x37 = XEXP (x32, 0);
      if (GET_CODE (x37) != REG
          || REGNO (x37) != 10
          || GET_MODE (x37) != i1)
        return -1;
      x38 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x38) != RETURN)
        return -1;
      x44 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x44) != USE)
        return -1;
      x49 = XEXP (x44, 0);
      if (GET_CODE (x49) != REG
          || REGNO (x49) != 1
          || GET_MODE (x49) != E_SImode
          || !stack_pop_up_to_s2_operand (operands[0], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern767 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != MEM)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  return 0;
}

int
pattern770 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  switch (XWINT (x5, 0))
    {
    case -4L:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -8L)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -12L)
        return -1;
      x14 = XVECEXP (x1, 0, 3);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (XWINT (x17, 0) != -16L)
        return -1;
      x18 = XVECEXP (x1, 0, 4);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 1);
      if (XWINT (x21, 0) != -20L)
        return -1;
      x22 = XVECEXP (x1, 0, 5);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 0);
      x25 = XEXP (x24, 1);
      if (XWINT (x25, 0) != -24L)
        return -1;
      x26 = XVECEXP (x1, 0, 6);
      x27 = XEXP (x26, 0);
      x28 = XEXP (x27, 0);
      x29 = XEXP (x28, 1);
      if (XWINT (x29, 0) != -28L)
        return -1;
      x30 = XVECEXP (x1, 0, 7);
      x31 = XEXP (x30, 0);
      x32 = XEXP (x31, 0);
      x33 = XEXP (x32, 1);
      if (XWINT (x33, 0) != -32L)
        return -1;
      x34 = XVECEXP (x1, 0, 8);
      x35 = XEXP (x34, 0);
      x36 = XEXP (x35, 0);
      x37 = XEXP (x36, 1);
      if (XWINT (x37, 0) != -36L)
        return -1;
      return 0;

    case -8L:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -16L)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -24L)
        return -1;
      x14 = XVECEXP (x1, 0, 3);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (XWINT (x17, 0) != -32L)
        return -1;
      x18 = XVECEXP (x1, 0, 4);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 1);
      if (XWINT (x21, 0) != -40L)
        return -1;
      x22 = XVECEXP (x1, 0, 5);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 0);
      x25 = XEXP (x24, 1);
      if (XWINT (x25, 0) != -48L)
        return -1;
      x26 = XVECEXP (x1, 0, 6);
      x27 = XEXP (x26, 0);
      x28 = XEXP (x27, 0);
      x29 = XEXP (x28, 1);
      if (XWINT (x29, 0) != -56L)
        return -1;
      x30 = XVECEXP (x1, 0, 7);
      x31 = XEXP (x30, 0);
      x32 = XEXP (x31, 0);
      x33 = XEXP (x32, 1);
      if (XWINT (x33, 0) != -64L)
        return -1;
      x34 = XVECEXP (x1, 0, 8);
      x35 = XEXP (x34, 0);
      x36 = XEXP (x35, 0);
      x37 = XEXP (x36, 1);
      if (XWINT (x37, 0) != -72L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern779 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + -32])
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i1
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  return pattern778 (x9); /* [-1, 0] */
}

int
pattern783 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != USE)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1
      || !stack_pop_up_to_s9_operand (operands[0], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern784 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i1)
    return -1;
  x33 = XEXP (x31, 1);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XVECEXP (x1, 0, 7);
  x37 = XEXP (x36, 0);
  if (GET_MODE (x37) != i1)
    return -1;
  x38 = XEXP (x36, 1);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XVECEXP (x1, 0, 8);
  x42 = XEXP (x41, 0);
  if (GET_MODE (x42) != i1)
    return -1;
  x43 = XEXP (x41, 1);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XVECEXP (x1, 0, 9);
  x47 = XEXP (x46, 0);
  if (GET_MODE (x47) != i1)
    return -1;
  x48 = XEXP (x46, 1);
  if (GET_MODE (x48) != i1)
    return -1;
  x49 = XEXP (x48, 0);
  if (GET_MODE (x49) != i1)
    return -1;
  x50 = XEXP (x49, 0);
  if (GET_MODE (x50) != i1)
    return -1;
  x51 = XVECEXP (x1, 0, 10);
  x52 = XEXP (x51, 0);
  if (GET_MODE (x52) != i1)
    return -1;
  x53 = XEXP (x51, 1);
  if (GET_MODE (x53) != i1)
    return -1;
  x54 = XEXP (x53, 0);
  if (GET_MODE (x54) != i1)
    return -1;
  x55 = XEXP (x54, 0);
  if (GET_MODE (x55) != i1)
    return -1;
  x56 = XVECEXP (x1, 0, 11);
  x57 = XEXP (x56, 0);
  if (GET_MODE (x57) != i1)
    return -1;
  x58 = XEXP (x56, 1);
  if (GET_MODE (x58) != i1)
    return -1;
  x59 = XEXP (x58, 0);
  if (GET_MODE (x59) != i1)
    return -1;
  x60 = XEXP (x59, 0);
  if (GET_MODE (x60) != i1)
    return -1;
  x61 = XVECEXP (x1, 0, 12);
  x62 = XEXP (x61, 0);
  if (GET_MODE (x62) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 27:
      if (REGNO (x12) != 26
          || REGNO (x17) != 25
          || REGNO (x22) != 24
          || REGNO (x27) != 23
          || REGNO (x32) != 22
          || REGNO (x37) != 21
          || REGNO (x42) != 20
          || REGNO (x47) != 19
          || REGNO (x52) != 18
          || REGNO (x57) != 9)
        return -1;
      return 0;

    case 25:
      if (REGNO (x12) != 24
          || REGNO (x17) != 23
          || REGNO (x22) != 22
          || REGNO (x27) != 21
          || REGNO (x32) != 20
          || REGNO (x37) != 19
          || REGNO (x42) != 18
          || REGNO (x47) != 9
          || REGNO (x52) != 8
          || REGNO (x57) != 1)
        return -1;
      x63 = XEXP (x61, 1);
      if (x63 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x62) != 10)
        return -1;
      x64 = XVECEXP (x1, 0, 13);
      if (pattern783 (x64, 
i1, 
10) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      return recog_5 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      x5 = XEXP (x3, 0);
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x7 = XEXP (x4, 0);
      operands[3] = x7;
      x8 = XEXP (x2, 1);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern137 (x2, 
E_RVVM8HImode, 
E_RVVM4QImode) != 0
              || !
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31406; /* *dual_widen_fmasurvvm8hi */

        case E_RVVM4HImode:
          if (pattern137 (x2, 
E_RVVM4HImode, 
E_RVVM2QImode) != 0
              || !
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31407; /* *dual_widen_fmasurvvm4hi */

        case E_RVVM2HImode:
          if (pattern137 (x2, 
E_RVVM2HImode, 
E_RVVM1QImode) != 0
              || !
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31408; /* *dual_widen_fmasurvvm2hi */

        case E_RVVM1HImode:
          if (pattern137 (x2, 
E_RVVM1HImode, 
E_RVVMF2QImode) != 0
              || !
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31409; /* *dual_widen_fmasurvvm1hi */

        case E_RVVMF2HImode:
          if (pattern137 (x2, 
E_RVVMF2HImode, 
E_RVVMF4QImode) != 0
              || !
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31410; /* *dual_widen_fmasurvvmf2hi */

        case E_RVVMF4HImode:
          if (pattern137 (x2, 
E_RVVMF4HImode, 
E_RVVMF8QImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31411; /* *dual_widen_fmasurvvmf4hi */

        case E_RVVM8SImode:
          if (pattern137 (x2, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0
              || !
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31412; /* *dual_widen_fmasurvvm8si */

        case E_RVVM4SImode:
          if (pattern137 (x2, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0
              || !
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31413; /* *dual_widen_fmasurvvm4si */

        case E_RVVM2SImode:
          if (pattern137 (x2, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0
              || !
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31414; /* *dual_widen_fmasurvvm2si */

        case E_RVVM1SImode:
          if (pattern137 (x2, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0
              || !
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31415; /* *dual_widen_fmasurvvm1si */

        case E_RVVMF2SImode:
          if (pattern137 (x2, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31416; /* *dual_widen_fmasurvvmf2si */

        case E_RVVM8DImode:
          if (pattern137 (x2, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31417; /* *dual_widen_fmasurvvm8di */

        case E_RVVM4DImode:
          if (pattern137 (x2, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31418; /* *dual_widen_fmasurvvm4di */

        case E_RVVM2DImode:
          if (pattern137 (x2, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31419; /* *dual_widen_fmasurvvm2di */

        case E_RVVM1DImode:
          if (pattern137 (x2, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31420; /* *dual_widen_fmasurvvm1di */

        case E_V1HImode:
          if (pattern137 (x2, 
E_V1HImode, 
E_V1QImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 31421; /* *dual_widen_fmasuv1hi */

        case E_V2HImode:
          if (pattern137 (x2, 
E_V2HImode, 
E_V2QImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 31422; /* *dual_widen_fmasuv2hi */

        case E_V4HImode:
          if (pattern137 (x2, 
E_V4HImode, 
E_V4QImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 31423; /* *dual_widen_fmasuv4hi */

        case E_V8HImode:
          if (pattern137 (x2, 
E_V8HImode, 
E_V8QImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 31424; /* *dual_widen_fmasuv8hi */

        case E_V16HImode:
          if (pattern137 (x2, 
E_V16HImode, 
E_V16QImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 31425; /* *dual_widen_fmasuv16hi */

        case E_V32HImode:
          if (pattern137 (x2, 
E_V32HImode, 
E_V32QImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31426; /* *dual_widen_fmasuv32hi */

        case E_V64HImode:
          if (pattern137 (x2, 
E_V64HImode, 
E_V64QImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31427; /* *dual_widen_fmasuv64hi */

        case E_V128HImode:
          if (pattern137 (x2, 
E_V128HImode, 
E_V128QImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31428; /* *dual_widen_fmasuv128hi */

        case E_V256HImode:
          if (pattern137 (x2, 
E_V256HImode, 
E_V256QImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31429; /* *dual_widen_fmasuv256hi */

        case E_V512HImode:
          if (pattern137 (x2, 
E_V512HImode, 
E_V512QImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31430; /* *dual_widen_fmasuv512hi */

        case E_V1024HImode:
          if (pattern137 (x2, 
E_V1024HImode, 
E_V1024QImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31431; /* *dual_widen_fmasuv1024hi */

        case E_V2048HImode:
          if (pattern137 (x2, 
E_V2048HImode, 
E_V2048QImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31432; /* *dual_widen_fmasuv2048hi */

        case E_V1SImode:
          if (pattern137 (x2, 
E_V1SImode, 
E_V1HImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 31433; /* *dual_widen_fmasuv1si */

        case E_V2SImode:
          if (pattern137 (x2, 
E_V2SImode, 
E_V2HImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 31434; /* *dual_widen_fmasuv2si */

        case E_V4SImode:
          if (pattern137 (x2, 
E_V4SImode, 
E_V4HImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 31435; /* *dual_widen_fmasuv4si */

        case E_V8SImode:
          if (pattern137 (x2, 
E_V8SImode, 
E_V8HImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 31436; /* *dual_widen_fmasuv8si */

        case E_V16SImode:
          if (pattern137 (x2, 
E_V16SImode, 
E_V16HImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31437; /* *dual_widen_fmasuv16si */

        case E_V32SImode:
          if (pattern137 (x2, 
E_V32SImode, 
E_V32HImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31438; /* *dual_widen_fmasuv32si */

        case E_V64SImode:
          if (pattern137 (x2, 
E_V64SImode, 
E_V64HImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31439; /* *dual_widen_fmasuv64si */

        case E_V128SImode:
          if (pattern137 (x2, 
E_V128SImode, 
E_V128HImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31440; /* *dual_widen_fmasuv128si */

        case E_V256SImode:
          if (pattern137 (x2, 
E_V256SImode, 
E_V256HImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31441; /* *dual_widen_fmasuv256si */

        case E_V512SImode:
          if (pattern137 (x2, 
E_V512SImode, 
E_V512HImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31442; /* *dual_widen_fmasuv512si */

        case E_V1024SImode:
          if (pattern137 (x2, 
E_V1024SImode, 
E_V1024HImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31443; /* *dual_widen_fmasuv1024si */

        case E_V1DImode:
          if (pattern137 (x2, 
E_V1DImode, 
E_V1SImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31444; /* *dual_widen_fmasuv1di */

        case E_V2DImode:
          if (pattern137 (x2, 
E_V2DImode, 
E_V2SImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31445; /* *dual_widen_fmasuv2di */

        case E_V4DImode:
          if (pattern137 (x2, 
E_V4DImode, 
E_V4SImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31446; /* *dual_widen_fmasuv4di */

        case E_V8DImode:
          if (pattern137 (x2, 
E_V8DImode, 
E_V8SImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31447; /* *dual_widen_fmasuv8di */

        case E_V16DImode:
          if (pattern137 (x2, 
E_V16DImode, 
E_V16SImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31448; /* *dual_widen_fmasuv16di */

        case E_V32DImode:
          if (pattern137 (x2, 
E_V32DImode, 
E_V32SImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31449; /* *dual_widen_fmasuv32di */

        case E_V64DImode:
          if (pattern137 (x2, 
E_V64DImode, 
E_V64SImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31450; /* *dual_widen_fmasuv64di */

        case E_V128DImode:
          if (pattern137 (x2, 
E_V128DImode, 
E_V128SImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31451; /* *dual_widen_fmasuv128di */

        case E_V256DImode:
          if (pattern137 (x2, 
E_V256DImode, 
E_V256SImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31452; /* *dual_widen_fmasuv256di */

        case E_V512DImode:
          if (pattern137 (x2, 
E_V512DImode, 
E_V512SImode) != 0
              || !(
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31453; /* *dual_widen_fmasuv512di */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x8 = XEXP (x2, 1);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern138 (x2, 
E_RVVM8HImode, 
E_RVVM4QImode) != 0
              || !
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31502; /* *single_widen_fmasrvvm8hi */

        case E_RVVM4HImode:
          if (pattern138 (x2, 
E_RVVM4HImode, 
E_RVVM2QImode) != 0
              || !
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31504; /* *single_widen_fmasrvvm4hi */

        case E_RVVM2HImode:
          if (pattern138 (x2, 
E_RVVM2HImode, 
E_RVVM1QImode) != 0
              || !
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31506; /* *single_widen_fmasrvvm2hi */

        case E_RVVM1HImode:
          if (pattern138 (x2, 
E_RVVM1HImode, 
E_RVVMF2QImode) != 0
              || !
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31508; /* *single_widen_fmasrvvm1hi */

        case E_RVVMF2HImode:
          if (pattern138 (x2, 
E_RVVMF2HImode, 
E_RVVMF4QImode) != 0
              || !
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31510; /* *single_widen_fmasrvvmf2hi */

        case E_RVVMF4HImode:
          if (pattern138 (x2, 
E_RVVMF4HImode, 
E_RVVMF8QImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31512; /* *single_widen_fmasrvvmf4hi */

        case E_RVVM8SImode:
          if (pattern138 (x2, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0
              || !
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31514; /* *single_widen_fmasrvvm8si */

        case E_RVVM4SImode:
          if (pattern138 (x2, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0
              || !
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31516; /* *single_widen_fmasrvvm4si */

        case E_RVVM2SImode:
          if (pattern138 (x2, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0
              || !
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31518; /* *single_widen_fmasrvvm2si */

        case E_RVVM1SImode:
          if (pattern138 (x2, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0
              || !
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31520; /* *single_widen_fmasrvvm1si */

        case E_RVVMF2SImode:
          if (pattern138 (x2, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31522; /* *single_widen_fmasrvvmf2si */

        case E_RVVM8DImode:
          if (pattern138 (x2, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31524; /* *single_widen_fmasrvvm8di */

        case E_RVVM4DImode:
          if (pattern138 (x2, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31526; /* *single_widen_fmasrvvm4di */

        case E_RVVM2DImode:
          if (pattern138 (x2, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31528; /* *single_widen_fmasrvvm2di */

        case E_RVVM1DImode:
          if (pattern138 (x2, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31530; /* *single_widen_fmasrvvm1di */

        case E_V1HImode:
          if (pattern138 (x2, 
E_V1HImode, 
E_V1QImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 31532; /* *single_widen_fmasv1hi */

        case E_V2HImode:
          if (pattern138 (x2, 
E_V2HImode, 
E_V2QImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 31534; /* *single_widen_fmasv2hi */

        case E_V4HImode:
          if (pattern138 (x2, 
E_V4HImode, 
E_V4QImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 31536; /* *single_widen_fmasv4hi */

        case E_V8HImode:
          if (pattern138 (x2, 
E_V8HImode, 
E_V8QImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 31538; /* *single_widen_fmasv8hi */

        case E_V16HImode:
          if (pattern138 (x2, 
E_V16HImode, 
E_V16QImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 31540; /* *single_widen_fmasv16hi */

        case E_V32HImode:
          if (pattern138 (x2, 
E_V32HImode, 
E_V32QImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31542; /* *single_widen_fmasv32hi */

        case E_V64HImode:
          if (pattern138 (x2, 
E_V64HImode, 
E_V64QImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31544; /* *single_widen_fmasv64hi */

        case E_V128HImode:
          if (pattern138 (x2, 
E_V128HImode, 
E_V128QImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31546; /* *single_widen_fmasv128hi */

        case E_V256HImode:
          if (pattern138 (x2, 
E_V256HImode, 
E_V256QImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31548; /* *single_widen_fmasv256hi */

        case E_V512HImode:
          if (pattern138 (x2, 
E_V512HImode, 
E_V512QImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31550; /* *single_widen_fmasv512hi */

        case E_V1024HImode:
          if (pattern138 (x2, 
E_V1024HImode, 
E_V1024QImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31552; /* *single_widen_fmasv1024hi */

        case E_V2048HImode:
          if (pattern138 (x2, 
E_V2048HImode, 
E_V2048QImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31554; /* *single_widen_fmasv2048hi */

        case E_V1SImode:
          if (pattern138 (x2, 
E_V1SImode, 
E_V1HImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 31556; /* *single_widen_fmasv1si */

        case E_V2SImode:
          if (pattern138 (x2, 
E_V2SImode, 
E_V2HImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 31558; /* *single_widen_fmasv2si */

        case E_V4SImode:
          if (pattern138 (x2, 
E_V4SImode, 
E_V4HImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 31560; /* *single_widen_fmasv4si */

        case E_V8SImode:
          if (pattern138 (x2, 
E_V8SImode, 
E_V8HImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 31562; /* *single_widen_fmasv8si */

        case E_V16SImode:
          if (pattern138 (x2, 
E_V16SImode, 
E_V16HImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31564; /* *single_widen_fmasv16si */

        case E_V32SImode:
          if (pattern138 (x2, 
E_V32SImode, 
E_V32HImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31566; /* *single_widen_fmasv32si */

        case E_V64SImode:
          if (pattern138 (x2, 
E_V64SImode, 
E_V64HImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31568; /* *single_widen_fmasv64si */

        case E_V128SImode:
          if (pattern138 (x2, 
E_V128SImode, 
E_V128HImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31570; /* *single_widen_fmasv128si */

        case E_V256SImode:
          if (pattern138 (x2, 
E_V256SImode, 
E_V256HImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31572; /* *single_widen_fmasv256si */

        case E_V512SImode:
          if (pattern138 (x2, 
E_V512SImode, 
E_V512HImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31574; /* *single_widen_fmasv512si */

        case E_V1024SImode:
          if (pattern138 (x2, 
E_V1024SImode, 
E_V1024HImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31576; /* *single_widen_fmasv1024si */

        case E_V1DImode:
          if (pattern138 (x2, 
E_V1DImode, 
E_V1SImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31578; /* *single_widen_fmasv1di */

        case E_V2DImode:
          if (pattern138 (x2, 
E_V2DImode, 
E_V2SImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31580; /* *single_widen_fmasv2di */

        case E_V4DImode:
          if (pattern138 (x2, 
E_V4DImode, 
E_V4SImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31582; /* *single_widen_fmasv4di */

        case E_V8DImode:
          if (pattern138 (x2, 
E_V8DImode, 
E_V8SImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31584; /* *single_widen_fmasv8di */

        case E_V16DImode:
          if (pattern138 (x2, 
E_V16DImode, 
E_V16SImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31586; /* *single_widen_fmasv16di */

        case E_V32DImode:
          if (pattern138 (x2, 
E_V32DImode, 
E_V32SImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31588; /* *single_widen_fmasv32di */

        case E_V64DImode:
          if (pattern138 (x2, 
E_V64DImode, 
E_V64SImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31590; /* *single_widen_fmasv64di */

        case E_V128DImode:
          if (pattern138 (x2, 
E_V128DImode, 
E_V128SImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31592; /* *single_widen_fmasv128di */

        case E_V256DImode:
          if (pattern138 (x2, 
E_V256DImode, 
E_V256SImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31594; /* *single_widen_fmasv256di */

        case E_V512DImode:
          if (pattern138 (x2, 
E_V512DImode, 
E_V512SImode) != 0
              || !(
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31596; /* *single_widen_fmasv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[2] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      return recog_17 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_19 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      switch (pattern239 (x2))
        {
        case 0:
          if (!
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30434; /* *single_widen_subsrvvm8hi */

        case 1:
          if (!
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30436; /* *single_widen_subsrvvm4hi */

        case 2:
          if (!
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30438; /* *single_widen_subsrvvm2hi */

        case 3:
          if (!
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30440; /* *single_widen_subsrvvm1hi */

        case 4:
          if (!
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30442; /* *single_widen_subsrvvmf2hi */

        case 5:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30444; /* *single_widen_subsrvvmf4hi */

        case 6:
          if (!
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30446; /* *single_widen_subsrvvm8si */

        case 7:
          if (!
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30448; /* *single_widen_subsrvvm4si */

        case 8:
          if (!
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30450; /* *single_widen_subsrvvm2si */

        case 9:
          if (!
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30452; /* *single_widen_subsrvvm1si */

        case 10:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30454; /* *single_widen_subsrvvmf2si */

        case 11:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30456; /* *single_widen_subsrvvm8di */

        case 12:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30458; /* *single_widen_subsrvvm4di */

        case 13:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30460; /* *single_widen_subsrvvm2di */

        case 14:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30462; /* *single_widen_subsrvvm1di */

        case 15:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 30464; /* *single_widen_subsv1hi */

        case 16:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 30466; /* *single_widen_subsv2hi */

        case 17:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 30468; /* *single_widen_subsv4hi */

        case 18:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 30470; /* *single_widen_subsv8hi */

        case 19:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 30472; /* *single_widen_subsv16hi */

        case 20:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30474; /* *single_widen_subsv32hi */

        case 21:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30476; /* *single_widen_subsv64hi */

        case 22:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30478; /* *single_widen_subsv128hi */

        case 23:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30480; /* *single_widen_subsv256hi */

        case 24:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30482; /* *single_widen_subsv512hi */

        case 25:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30484; /* *single_widen_subsv1024hi */

        case 26:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30486; /* *single_widen_subsv2048hi */

        case 27:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 30488; /* *single_widen_subsv1si */

        case 28:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 30490; /* *single_widen_subsv2si */

        case 29:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 30492; /* *single_widen_subsv4si */

        case 30:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 30494; /* *single_widen_subsv8si */

        case 31:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30496; /* *single_widen_subsv16si */

        case 32:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30498; /* *single_widen_subsv32si */

        case 33:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30500; /* *single_widen_subsv64si */

        case 34:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30502; /* *single_widen_subsv128si */

        case 35:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30504; /* *single_widen_subsv256si */

        case 36:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30506; /* *single_widen_subsv512si */

        case 37:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30508; /* *single_widen_subsv1024si */

        case 38:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30510; /* *single_widen_subsv1di */

        case 39:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30512; /* *single_widen_subsv2di */

        case 40:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30514; /* *single_widen_subsv4di */

        case 41:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30516; /* *single_widen_subsv8di */

        case 42:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30518; /* *single_widen_subsv16di */

        case 43:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30520; /* *single_widen_subsv32di */

        case 44:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30522; /* *single_widen_subsv64di */

        case 45:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30524; /* *single_widen_subsv128di */

        case 46:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30526; /* *single_widen_subsv256di */

        case 47:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30528; /* *single_widen_subsv512di */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern239 (x2))
        {
        case 0:
          if (!
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30435; /* *single_widen_suburvvm8hi */

        case 1:
          if (!
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30437; /* *single_widen_suburvvm4hi */

        case 2:
          if (!
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30439; /* *single_widen_suburvvm2hi */

        case 3:
          if (!
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30441; /* *single_widen_suburvvm1hi */

        case 4:
          if (!
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30443; /* *single_widen_suburvvmf2hi */

        case 5:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30445; /* *single_widen_suburvvmf4hi */

        case 6:
          if (!
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30447; /* *single_widen_suburvvm8si */

        case 7:
          if (!
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30449; /* *single_widen_suburvvm4si */

        case 8:
          if (!
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30451; /* *single_widen_suburvvm2si */

        case 9:
          if (!
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30453; /* *single_widen_suburvvm1si */

        case 10:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30455; /* *single_widen_suburvvmf2si */

        case 11:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30457; /* *single_widen_suburvvm8di */

        case 12:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30459; /* *single_widen_suburvvm4di */

        case 13:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30461; /* *single_widen_suburvvm2di */

        case 14:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30463; /* *single_widen_suburvvm1di */

        case 15:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 30465; /* *single_widen_subuv1hi */

        case 16:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 30467; /* *single_widen_subuv2hi */

        case 17:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 30469; /* *single_widen_subuv4hi */

        case 18:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 30471; /* *single_widen_subuv8hi */

        case 19:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 30473; /* *single_widen_subuv16hi */

        case 20:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30475; /* *single_widen_subuv32hi */

        case 21:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30477; /* *single_widen_subuv64hi */

        case 22:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30479; /* *single_widen_subuv128hi */

        case 23:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30481; /* *single_widen_subuv256hi */

        case 24:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30483; /* *single_widen_subuv512hi */

        case 25:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30485; /* *single_widen_subuv1024hi */

        case 26:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30487; /* *single_widen_subuv2048hi */

        case 27:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 30489; /* *single_widen_subuv1si */

        case 28:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 30491; /* *single_widen_subuv2si */

        case 29:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 30493; /* *single_widen_subuv4si */

        case 30:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 30495; /* *single_widen_subuv8si */

        case 31:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30497; /* *single_widen_subuv16si */

        case 32:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30499; /* *single_widen_subuv32si */

        case 33:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30501; /* *single_widen_subuv64si */

        case 34:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30503; /* *single_widen_subuv128si */

        case 35:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30505; /* *single_widen_subuv256si */

        case 36:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30507; /* *single_widen_subuv512si */

        case 37:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30509; /* *single_widen_subuv1024si */

        case 38:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30511; /* *single_widen_subuv1di */

        case 39:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30513; /* *single_widen_subuv2di */

        case 40:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30515; /* *single_widen_subuv4di */

        case 41:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30517; /* *single_widen_subuv8di */

        case 42:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30519; /* *single_widen_subuv16di */

        case 43:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30521; /* *single_widen_subuv32di */

        case 44:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30523; /* *single_widen_subuv64di */

        case 45:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30525; /* *single_widen_subuv128di */

        case 46:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30527; /* *single_widen_subuv256di */

        case 47:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30529; /* *single_widen_subuv512di */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      switch (pattern240 (x2))
        {
        case 0:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31034; /* *single_widen_subrvvm8sf */

        case 1:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31035; /* *single_widen_subrvvm4sf */

        case 2:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31036; /* *single_widen_subrvvm2sf */

        case 3:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31037; /* *single_widen_subrvvm1sf */

        case 4:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31038; /* *single_widen_subrvvmf2sf */

        case 5:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31039; /* *single_widen_subrvvm8df */

        case 6:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31040; /* *single_widen_subrvvm4df */

        case 7:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31041; /* *single_widen_subrvvm2df */

        case 8:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31042; /* *single_widen_subrvvm1df */

        case 9:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31043; /* *single_widen_subv1sf */

        case 10:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31044; /* *single_widen_subv2sf */

        case 11:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31045; /* *single_widen_subv4sf */

        case 12:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31046; /* *single_widen_subv8sf */

        case 13:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31047; /* *single_widen_subv16sf */

        case 14:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31048; /* *single_widen_subv32sf */

        case 15:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31049; /* *single_widen_subv64sf */

        case 16:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31050; /* *single_widen_subv128sf */

        case 17:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31051; /* *single_widen_subv256sf */

        case 18:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31052; /* *single_widen_subv512sf */

        case 19:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31053; /* *single_widen_subv1024sf */

        case 20:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31054; /* *single_widen_subv1df */

        case 21:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31055; /* *single_widen_subv2df */

        case 22:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31056; /* *single_widen_subv4df */

        case 23:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31057; /* *single_widen_subv8df */

        case 24:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31058; /* *single_widen_subv16df */

        case 25:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31059; /* *single_widen_subv32df */

        case 26:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31060; /* *single_widen_subv64df */

        case 27:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31061; /* *single_widen_subv128df */

        case 28:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31062; /* *single_widen_subv256df */

        case 29:
          if (!(
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31063; /* *single_widen_subv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (XWINT (x5, 0) != 0L)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      switch (pattern444 (x2))
        {
        case 0:
          if (!
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19949; /* *pred_extract_firstrvvm8qi */

        case 1:
          if (!
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19950; /* *pred_extract_firstrvvm4qi */

        case 2:
          if (!
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19951; /* *pred_extract_firstrvvm2qi */

        case 3:
          if (!
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19952; /* *pred_extract_firstrvvm1qi */

        case 4:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 19965; /* *pred_extract_firstrvvmf2qi */

        case 5:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 19966; /* *pred_extract_firstrvvmf4qi */

        case 6:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 19967; /* *pred_extract_firstrvvmf8qi */

        case 7:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 19971; /* *pred_extract_firstv1qi */

        case 8:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 19972; /* *pred_extract_firstv2qi */

        case 9:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 19973; /* *pred_extract_firstv4qi */

        case 10:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 19974; /* *pred_extract_firstv8qi */

        case 11:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 19975; /* *pred_extract_firstv16qi */

        case 12:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 19976; /* *pred_extract_firstv32qi */

        case 13:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19977; /* *pred_extract_firstv64qi */

        case 14:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19978; /* *pred_extract_firstv128qi */

        case 15:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19979; /* *pred_extract_firstv256qi */

        case 16:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19980; /* *pred_extract_firstv512qi */

        case 17:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19981; /* *pred_extract_firstv1024qi */

        case 18:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19982; /* *pred_extract_firstv2048qi */

        case 19:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19983; /* *pred_extract_firstv4096qi */

        default:
          return -1;
        }

    case E_HImode:
      switch (pattern445 (x2))
        {
        case 0:
          if (!
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19953; /* *pred_extract_firstrvvm8hi */

        case 1:
          if (!
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19954; /* *pred_extract_firstrvvm4hi */

        case 2:
          if (!
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19955; /* *pred_extract_firstrvvm2hi */

        case 3:
          if (!
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19956; /* *pred_extract_firstrvvm1hi */

        case 4:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 19968; /* *pred_extract_firstrvvmf2hi */

        case 5:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 19969; /* *pred_extract_firstrvvmf4hi */

        case 6:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 19984; /* *pred_extract_firstv1hi */

        case 7:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 19985; /* *pred_extract_firstv2hi */

        case 8:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 19986; /* *pred_extract_firstv4hi */

        case 9:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 19987; /* *pred_extract_firstv8hi */

        case 10:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 19988; /* *pred_extract_firstv16hi */

        case 11:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19989; /* *pred_extract_firstv32hi */

        case 12:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19990; /* *pred_extract_firstv64hi */

        case 13:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19991; /* *pred_extract_firstv128hi */

        case 14:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19992; /* *pred_extract_firstv256hi */

        case 15:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19993; /* *pred_extract_firstv512hi */

        case 16:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19994; /* *pred_extract_firstv1024hi */

        case 17:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19995; /* *pred_extract_firstv2048hi */

        default:
          return -1;
        }

    case E_SImode:
      switch (pattern446 (x2))
        {
        case 0:
          if (!
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19957; /* *pred_extract_firstrvvm8si */

        case 1:
          if (!
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19958; /* *pred_extract_firstrvvm4si */

        case 2:
          if (!
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19959; /* *pred_extract_firstrvvm2si */

        case 3:
          if (!
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19960; /* *pred_extract_firstrvvm1si */

        case 4:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 19970; /* *pred_extract_firstrvvmf2si */

        case 5:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 19996; /* *pred_extract_firstv1si */

        case 6:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 19997; /* *pred_extract_firstv2si */

        case 7:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 19998; /* *pred_extract_firstv4si */

        case 8:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 19999; /* *pred_extract_firstv8si */

        case 9:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20000; /* *pred_extract_firstv16si */

        case 10:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20001; /* *pred_extract_firstv32si */

        case 11:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20002; /* *pred_extract_firstv64si */

        case 12:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20003; /* *pred_extract_firstv128si */

        case 13:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20004; /* *pred_extract_firstv256si */

        case 14:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20005; /* *pred_extract_firstv512si */

        case 15:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20006; /* *pred_extract_firstv1024si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern447 (x2))
        {
        case 0:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19961; /* *pred_extract_firstrvvm8di */

        case 1:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19962; /* *pred_extract_firstrvvm4di */

        case 2:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19963; /* *pred_extract_firstrvvm2di */

        case 3:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19964; /* *pred_extract_firstrvvm1di */

        case 4:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20007; /* *pred_extract_firstv1di */

        case 5:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20008; /* *pred_extract_firstv2di */

        case 6:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20009; /* *pred_extract_firstv4di */

        case 7:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20010; /* *pred_extract_firstv8di */

        case 8:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20011; /* *pred_extract_firstv16di */

        case 9:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20012; /* *pred_extract_firstv32di */

        case 10:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20013; /* *pred_extract_firstv64di */

        case 11:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20014; /* *pred_extract_firstv128di */

        case 12:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20015; /* *pred_extract_firstv256di */

        case 13:
          if (!(
#line 8031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20016; /* *pred_extract_firstv512di */

        default:
          return -1;
        }

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x2) != E_HFmode
          || GET_MODE (x3) != E_HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_RVVM8HFmode:
          if (!register_operand (operands[1], E_RVVM8HFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20031; /* *pred_extract_firstrvvm8hf */

        case E_RVVM4HFmode:
          if (!register_operand (operands[1], E_RVVM4HFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20032; /* *pred_extract_firstrvvm4hf */

        case E_RVVM2HFmode:
          if (!register_operand (operands[1], E_RVVM2HFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20033; /* *pred_extract_firstrvvm2hf */

        case E_RVVM1HFmode:
          if (!register_operand (operands[1], E_RVVM1HFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20034; /* *pred_extract_firstrvvm1hf */

        case E_RVVMF2HFmode:
          if (!register_operand (operands[1], E_RVVMF2HFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20035; /* *pred_extract_firstrvvmf2hf */

        case E_RVVMF4HFmode:
          if (!register_operand (operands[1], E_RVVMF4HFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20036; /* *pred_extract_firstrvvmf4hf */

        case E_V1HFmode:
          if (!register_operand (operands[1], E_V1HFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 20046; /* *pred_extract_firstv1hf */

        case E_V2HFmode:
          if (!register_operand (operands[1], E_V2HFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 20047; /* *pred_extract_firstv2hf */

        case E_V4HFmode:
          if (!register_operand (operands[1], E_V4HFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 20048; /* *pred_extract_firstv4hf */

        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 20049; /* *pred_extract_firstv8hf */

        case E_V16HFmode:
          if (!register_operand (operands[1], E_V16HFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 20050; /* *pred_extract_firstv16hf */

        case E_V32HFmode:
          if (!register_operand (operands[1], E_V32HFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20051; /* *pred_extract_firstv32hf */

        case E_V64HFmode:
          if (!register_operand (operands[1], E_V64HFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20052; /* *pred_extract_firstv64hf */

        case E_V128HFmode:
          if (!register_operand (operands[1], E_V128HFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20053; /* *pred_extract_firstv128hf */

        case E_V256HFmode:
          if (!register_operand (operands[1], E_V256HFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20054; /* *pred_extract_firstv256hf */

        case E_V512HFmode:
          if (!register_operand (operands[1], E_V512HFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20055; /* *pred_extract_firstv512hf */

        case E_V1024HFmode:
          if (!register_operand (operands[1], E_V1024HFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20056; /* *pred_extract_firstv1024hf */

        case E_V2048HFmode:
          if (!register_operand (operands[1], E_V2048HFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20057; /* *pred_extract_firstv2048hf */

        default:
          return -1;
        }

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || GET_MODE (x3) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_RVVM8SFmode:
          if (!register_operand (operands[1], E_RVVM8SFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20037; /* *pred_extract_firstrvvm8sf */

        case E_RVVM4SFmode:
          if (!register_operand (operands[1], E_RVVM4SFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20038; /* *pred_extract_firstrvvm4sf */

        case E_RVVM2SFmode:
          if (!register_operand (operands[1], E_RVVM2SFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20039; /* *pred_extract_firstrvvm2sf */

        case E_RVVM1SFmode:
          if (!register_operand (operands[1], E_RVVM1SFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20040; /* *pred_extract_firstrvvm1sf */

        case E_RVVMF2SFmode:
          if (!register_operand (operands[1], E_RVVMF2SFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20041; /* *pred_extract_firstrvvmf2sf */

        case E_V1SFmode:
          if (!register_operand (operands[1], E_V1SFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20058; /* *pred_extract_firstv1sf */

        case E_V2SFmode:
          if (!register_operand (operands[1], E_V2SFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20059; /* *pred_extract_firstv2sf */

        case E_V4SFmode:
          if (!register_operand (operands[1], E_V4SFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20060; /* *pred_extract_firstv4sf */

        case E_V8SFmode:
          if (!register_operand (operands[1], E_V8SFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20061; /* *pred_extract_firstv8sf */

        case E_V16SFmode:
          if (!register_operand (operands[1], E_V16SFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20062; /* *pred_extract_firstv16sf */

        case E_V32SFmode:
          if (!register_operand (operands[1], E_V32SFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20063; /* *pred_extract_firstv32sf */

        case E_V64SFmode:
          if (!register_operand (operands[1], E_V64SFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20064; /* *pred_extract_firstv64sf */

        case E_V128SFmode:
          if (!register_operand (operands[1], E_V128SFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20065; /* *pred_extract_firstv128sf */

        case E_V256SFmode:
          if (!register_operand (operands[1], E_V256SFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20066; /* *pred_extract_firstv256sf */

        case E_V512SFmode:
          if (!register_operand (operands[1], E_V512SFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20067; /* *pred_extract_firstv512sf */

        case E_V1024SFmode:
          if (!register_operand (operands[1], E_V1024SFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20068; /* *pred_extract_firstv1024sf */

        default:
          return -1;
        }

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode
          || GET_MODE (x3) != E_DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_RVVM8DFmode:
          if (!register_operand (operands[1], E_RVVM8DFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20042; /* *pred_extract_firstrvvm8df */

        case E_RVVM4DFmode:
          if (!register_operand (operands[1], E_RVVM4DFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20043; /* *pred_extract_firstrvvm4df */

        case E_RVVM2DFmode:
          if (!register_operand (operands[1], E_RVVM2DFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20044; /* *pred_extract_firstrvvm2df */

        case E_RVVM1DFmode:
          if (!register_operand (operands[1], E_RVVM1DFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20045; /* *pred_extract_firstrvvm1df */

        case E_V1DFmode:
          if (!register_operand (operands[1], E_V1DFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20069; /* *pred_extract_firstv1df */

        case E_V2DFmode:
          if (!register_operand (operands[1], E_V2DFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20070; /* *pred_extract_firstv2df */

        case E_V4DFmode:
          if (!register_operand (operands[1], E_V4DFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20071; /* *pred_extract_firstv4df */

        case E_V8DFmode:
          if (!register_operand (operands[1], E_V8DFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20072; /* *pred_extract_firstv8df */

        case E_V16DFmode:
          if (!register_operand (operands[1], E_V16DFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20073; /* *pred_extract_firstv16df */

        case E_V32DFmode:
          if (!register_operand (operands[1], E_V32DFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20074; /* *pred_extract_firstv32df */

        case E_V64DFmode:
          if (!register_operand (operands[1], E_V64DFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20075; /* *pred_extract_firstv64df */

        case E_V128DFmode:
          if (!register_operand (operands[1], E_V128DFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20076; /* *pred_extract_firstv128df */

        case E_V256DFmode:
          if (!register_operand (operands[1], E_V256DFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20077; /* *pred_extract_firstv256df */

        case E_V512DFmode:
          if (!register_operand (operands[1], E_V512DFmode)
              || !(
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20078; /* *pred_extract_firstv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVMF8BImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_RVVMF8BImode
      || !register_operand (operands[3], E_RVVMF8BImode))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != E_RVVMF8BImode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x4))
    {
    case E_RVVM1QImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_RVVM1QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVM1QImode)
          || !
#line 3496 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8692; /* pred_madcrvvm1qi_scalar */

    case E_RVVM2HImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_RVVM2HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM2HImode)
          || !
#line 3496 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8698; /* pred_madcrvvm2hi_scalar */

    case E_RVVM4SImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_RVVM4SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM4SImode)
          || !
#line 3496 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8703; /* pred_madcrvvm4si_scalar */

    case E_RVVM8DImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_RVVM8DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM8DImode)
          || !(
#line 3567 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8797; /* *pred_madcrvvm8di_scalar */

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern589 (x2, 
E_V1024BImode) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_V1024QImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V1024QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V1024QImode)
          || !(
#line 3496 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8717; /* pred_madcv1024qi_scalar */

    case E_V1024HImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V1024HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V1024HImode)
          || !(
#line 3496 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8730; /* pred_madcv1024hi_scalar */

    case E_V1024SImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V1024SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V1024SImode)
          || !(
#line 3496 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8742; /* pred_madcv1024si_scalar */

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18127; /* pred_redmaxrvvm8qi */

        case 1:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18135; /* pred_redmaxrvvm4qi */

        case 2:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18143; /* pred_redmaxrvvm2qi */

        case 3:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18151; /* pred_redmaxrvvm1qi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18255; /* pred_redmaxrvvmf2qi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18263; /* pred_redmaxrvvmf4qi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18271; /* pred_redmaxrvvmf8qi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18303; /* pred_redmaxv1qi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18311; /* pred_redmaxv2qi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18319; /* pred_redmaxv4qi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18327; /* pred_redmaxv8qi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18335; /* pred_redmaxv16qi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18343; /* pred_redmaxv32qi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18351; /* pred_redmaxv64qi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18359; /* pred_redmaxv128qi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18367; /* pred_redmaxv256qi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18375; /* pred_redmaxv512qi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18383; /* pred_redmaxv1024qi */

        case 18:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18391; /* pred_redmaxv2048qi */

        case 19:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18399; /* pred_redmaxv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18159; /* pred_redmaxrvvm8hi */

        case 1:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18167; /* pred_redmaxrvvm4hi */

        case 2:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18175; /* pred_redmaxrvvm2hi */

        case 3:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18183; /* pred_redmaxrvvm1hi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18279; /* pred_redmaxrvvmf2hi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18287; /* pred_redmaxrvvmf4hi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18407; /* pred_redmaxv1hi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18415; /* pred_redmaxv2hi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18423; /* pred_redmaxv4hi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18431; /* pred_redmaxv8hi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18439; /* pred_redmaxv16hi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18447; /* pred_redmaxv32hi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18455; /* pred_redmaxv64hi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18463; /* pred_redmaxv128hi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18471; /* pred_redmaxv256hi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18479; /* pred_redmaxv512hi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18487; /* pred_redmaxv1024hi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18495; /* pred_redmaxv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18191; /* pred_redmaxrvvm8si */

        case 1:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18199; /* pred_redmaxrvvm4si */

        case 2:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18207; /* pred_redmaxrvvm2si */

        case 3:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18215; /* pred_redmaxrvvm1si */

        case 4:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18295; /* pred_redmaxrvvmf2si */

        case 5:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18503; /* pred_redmaxv1si */

        case 6:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18511; /* pred_redmaxv2si */

        case 7:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18519; /* pred_redmaxv4si */

        case 8:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18527; /* pred_redmaxv8si */

        case 9:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18535; /* pred_redmaxv16si */

        case 10:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18543; /* pred_redmaxv32si */

        case 11:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18551; /* pred_redmaxv64si */

        case 12:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18559; /* pred_redmaxv128si */

        case 13:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18567; /* pred_redmaxv256si */

        case 14:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18575; /* pred_redmaxv512si */

        case 15:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18583; /* pred_redmaxv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18223; /* pred_redmaxrvvm8di */

        case 1:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18231; /* pred_redmaxrvvm4di */

        case 2:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18239; /* pred_redmaxrvvm2di */

        case 3:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18247; /* pred_redmaxrvvm1di */

        case 4:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18591; /* pred_redmaxv1di */

        case 5:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18599; /* pred_redmaxv2di */

        case 6:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18607; /* pred_redmaxv4di */

        case 7:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18615; /* pred_redmaxv8di */

        case 8:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18623; /* pred_redmaxv16di */

        case 9:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18631; /* pred_redmaxv32di */

        case 10:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18639; /* pred_redmaxv64di */

        case 11:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18647; /* pred_redmaxv128di */

        case 12:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18655; /* pred_redmaxv256di */

        case 13:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18663; /* pred_redmaxv512di */

        default:
          return -1;
        }

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern681 (x2, 
E_RVVM1HFmode))
        {
        case 0:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19429; /* pred_redmaxrvvm8hf */

        case 1:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19431; /* pred_redmaxrvvm4hf */

        case 2:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19433; /* pred_redmaxrvvm2hf */

        case 3:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19435; /* pred_redmaxrvvm1hf */

        case 4:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19437; /* pred_redmaxrvvmf2hf */

        case 5:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19439; /* pred_redmaxrvvmf4hf */

        case 6:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 19459; /* pred_redmaxv1hf */

        case 7:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 19461; /* pred_redmaxv2hf */

        case 8:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 19463; /* pred_redmaxv4hf */

        case 9:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 19465; /* pred_redmaxv8hf */

        case 10:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 19467; /* pred_redmaxv16hf */

        case 11:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19469; /* pred_redmaxv32hf */

        case 12:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19471; /* pred_redmaxv64hf */

        case 13:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19473; /* pred_redmaxv128hf */

        case 14:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19475; /* pred_redmaxv256hf */

        case 15:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19477; /* pred_redmaxv512hf */

        case 16:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19479; /* pred_redmaxv1024hf */

        case 17:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19481; /* pred_redmaxv2048hf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern682 (x2, 
E_RVVM1SFmode))
        {
        case 0:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19441; /* pred_redmaxrvvm8sf */

        case 1:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19443; /* pred_redmaxrvvm4sf */

        case 2:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19445; /* pred_redmaxrvvm2sf */

        case 3:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19447; /* pred_redmaxrvvm1sf */

        case 4:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19449; /* pred_redmaxrvvmf2sf */

        case 5:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19483; /* pred_redmaxv1sf */

        case 6:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19485; /* pred_redmaxv2sf */

        case 7:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19487; /* pred_redmaxv4sf */

        case 8:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19489; /* pred_redmaxv8sf */

        case 9:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19491; /* pred_redmaxv16sf */

        case 10:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19493; /* pred_redmaxv32sf */

        case 11:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19495; /* pred_redmaxv64sf */

        case 12:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19497; /* pred_redmaxv128sf */

        case 13:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19499; /* pred_redmaxv256sf */

        case 14:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19501; /* pred_redmaxv512sf */

        case 15:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19503; /* pred_redmaxv1024sf */

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      switch (pattern683 (x2))
        {
        case 0:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19451; /* pred_redmaxrvvm8df */

        case 1:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19453; /* pred_redmaxrvvm4df */

        case 2:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19455; /* pred_redmaxrvvm2df */

        case 3:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19457; /* pred_redmaxrvvm1df */

        case 4:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19505; /* pred_redmaxv1df */

        case 5:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19507; /* pred_redmaxv2df */

        case 6:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19509; /* pred_redmaxv4df */

        case 7:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19511; /* pred_redmaxv8df */

        case 8:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19513; /* pred_redmaxv16df */

        case 9:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19515; /* pred_redmaxv32df */

        case 10:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19517; /* pred_redmaxv64df */

        case 11:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19519; /* pred_redmaxv128df */

        case 12:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19521; /* pred_redmaxv256df */

        case 13:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19523; /* pred_redmaxv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18128; /* pred_redminurvvm8qi */

        case 1:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18136; /* pred_redminurvvm4qi */

        case 2:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18144; /* pred_redminurvvm2qi */

        case 3:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18152; /* pred_redminurvvm1qi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18256; /* pred_redminurvvmf2qi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18264; /* pred_redminurvvmf4qi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18272; /* pred_redminurvvmf8qi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18304; /* pred_redminuv1qi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18312; /* pred_redminuv2qi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18320; /* pred_redminuv4qi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18328; /* pred_redminuv8qi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18336; /* pred_redminuv16qi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18344; /* pred_redminuv32qi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18352; /* pred_redminuv64qi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18360; /* pred_redminuv128qi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18368; /* pred_redminuv256qi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18376; /* pred_redminuv512qi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18384; /* pred_redminuv1024qi */

        case 18:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18392; /* pred_redminuv2048qi */

        case 19:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18400; /* pred_redminuv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18160; /* pred_redminurvvm8hi */

        case 1:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18168; /* pred_redminurvvm4hi */

        case 2:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18176; /* pred_redminurvvm2hi */

        case 3:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18184; /* pred_redminurvvm1hi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18280; /* pred_redminurvvmf2hi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18288; /* pred_redminurvvmf4hi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18408; /* pred_redminuv1hi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18416; /* pred_redminuv2hi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18424; /* pred_redminuv4hi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18432; /* pred_redminuv8hi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18440; /* pred_redminuv16hi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18448; /* pred_redminuv32hi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18456; /* pred_redminuv64hi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18464; /* pred_redminuv128hi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18472; /* pred_redminuv256hi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18480; /* pred_redminuv512hi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18488; /* pred_redminuv1024hi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18496; /* pred_redminuv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18192; /* pred_redminurvvm8si */

        case 1:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18200; /* pred_redminurvvm4si */

        case 2:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18208; /* pred_redminurvvm2si */

        case 3:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18216; /* pred_redminurvvm1si */

        case 4:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18296; /* pred_redminurvvmf2si */

        case 5:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18504; /* pred_redminuv1si */

        case 6:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18512; /* pred_redminuv2si */

        case 7:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18520; /* pred_redminuv4si */

        case 8:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18528; /* pred_redminuv8si */

        case 9:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18536; /* pred_redminuv16si */

        case 10:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18544; /* pred_redminuv32si */

        case 11:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18552; /* pred_redminuv64si */

        case 12:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18560; /* pred_redminuv128si */

        case 13:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18568; /* pred_redminuv256si */

        case 14:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18576; /* pred_redminuv512si */

        case 15:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18584; /* pred_redminuv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18224; /* pred_redminurvvm8di */

        case 1:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18232; /* pred_redminurvvm4di */

        case 2:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18240; /* pred_redminurvvm2di */

        case 3:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18248; /* pred_redminurvvm1di */

        case 4:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18592; /* pred_redminuv1di */

        case 5:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18600; /* pred_redminuv2di */

        case 6:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18608; /* pred_redminuv4di */

        case 7:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18616; /* pred_redminuv8di */

        case 8:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18624; /* pred_redminuv16di */

        case 9:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18632; /* pred_redminuv32di */

        case 10:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18640; /* pred_redminuv64di */

        case 11:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18648; /* pred_redminuv128di */

        case 12:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18656; /* pred_redminuv256di */

        case 13:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18664; /* pred_redminuv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (pattern361 (x3) != 0)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[5] = x5;
  if (!vector_length_operand (operands[5], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[6] = x6;
  if (!const_int_operand (operands[6], E_VOIDmode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[7] = x7;
  if (!const_int_operand (operands[7], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x2, 0, 1);
  switch (XINT (x8, 1))
    {
    case 143:
      return recog_78 (x1, insn, pnum_clobbers);

    case 149:
      return recog_77 (x1, insn, pnum_clobbers);

    case 150:
      return recog_66 (x1, insn, pnum_clobbers);

    case 151:
      return recog_76 (x1, insn, pnum_clobbers);

    case 152:
      return recog_65 (x1, insn, pnum_clobbers);

    case 153:
      return recog_75 (x1, insn, pnum_clobbers);

    case 154:
      return recog_74 (x1, insn, pnum_clobbers);

    case 155:
      return recog_73 (x1, insn, pnum_clobbers);

    case 144:
      return recog_72 (x1, insn, pnum_clobbers);

    case 156:
      return recog_71 (x1, insn, pnum_clobbers);

    case 157:
      return recog_64 (x1, insn, pnum_clobbers);

    case 158:
      return recog_70 (x1, insn, pnum_clobbers);

    case 159:
      return recog_63 (x1, insn, pnum_clobbers);

    case 160:
      return recog_69 (x1, insn, pnum_clobbers);

    case 161:
      return recog_68 (x1, insn, pnum_clobbers);

    case 162:
      return recog_67 (x1, insn, pnum_clobbers);

    case 163:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM1HImode:
          switch (pattern677 (x2, 
E_RVVM1HImode))
            {
            case 0:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19213; /* pred_wredsumrvvm8qi */

            case 1:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19215; /* pred_wredsumrvvm4qi */

            case 2:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19217; /* pred_wredsumrvvm2qi */

            case 3:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19219; /* pred_wredsumrvvm1qi */

            case 4:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19221; /* pred_wredsumrvvmf2qi */

            case 5:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19223; /* pred_wredsumrvvmf4qi */

            case 6:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 19225; /* pred_wredsumrvvmf8qi */

            case 7:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 19249; /* pred_wredsumv1qi */

            case 8:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 19251; /* pred_wredsumv2qi */

            case 9:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 19253; /* pred_wredsumv4qi */

            case 10:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 19255; /* pred_wredsumv8qi */

            case 11:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 19257; /* pred_wredsumv16qi */

            case 12:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 19259; /* pred_wredsumv32qi */

            case 13:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19261; /* pred_wredsumv64qi */

            case 14:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19263; /* pred_wredsumv128qi */

            case 15:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19265; /* pred_wredsumv256qi */

            case 16:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19267; /* pred_wredsumv512qi */

            case 17:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19269; /* pred_wredsumv1024qi */

            case 18:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19271; /* pred_wredsumv2048qi */

            case 19:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19273; /* pred_wredsumv4096qi */

            default:
              return -1;
            }

        case E_RVVM1SImode:
          switch (pattern678 (x2, 
E_RVVM1SImode))
            {
            case 0:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19227; /* pred_wredsumrvvm8hi */

            case 1:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19229; /* pred_wredsumrvvm4hi */

            case 2:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19231; /* pred_wredsumrvvm2hi */

            case 3:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19233; /* pred_wredsumrvvm1hi */

            case 4:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19235; /* pred_wredsumrvvmf2hi */

            case 5:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 19237; /* pred_wredsumrvvmf4hi */

            case 6:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 19275; /* pred_wredsumv1hi */

            case 7:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 19277; /* pred_wredsumv2hi */

            case 8:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 19279; /* pred_wredsumv4hi */

            case 9:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 19281; /* pred_wredsumv8hi */

            case 10:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 19283; /* pred_wredsumv16hi */

            case 11:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19285; /* pred_wredsumv32hi */

            case 12:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19287; /* pred_wredsumv64hi */

            case 13:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19289; /* pred_wredsumv128hi */

            case 14:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19291; /* pred_wredsumv256hi */

            case 15:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19293; /* pred_wredsumv512hi */

            case 16:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19295; /* pred_wredsumv1024hi */

            case 17:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19297; /* pred_wredsumv2048hi */

            default:
              return -1;
            }

        case E_RVVM1DImode:
          switch (pattern679 (x2, 
E_RVVM1DImode))
            {
            case 0:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19239; /* pred_wredsumrvvm8si */

            case 1:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19241; /* pred_wredsumrvvm4si */

            case 2:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19243; /* pred_wredsumrvvm2si */

            case 3:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19245; /* pred_wredsumrvvm1si */

            case 4:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 19247; /* pred_wredsumrvvmf2si */

            case 5:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 19299; /* pred_wredsumv1si */

            case 6:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 19301; /* pred_wredsumv2si */

            case 7:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 19303; /* pred_wredsumv4si */

            case 8:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 19305; /* pred_wredsumv8si */

            case 9:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19307; /* pred_wredsumv16si */

            case 10:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19309; /* pred_wredsumv32si */

            case 11:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19311; /* pred_wredsumv64si */

            case 12:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19313; /* pred_wredsumv128si */

            case 13:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19315; /* pred_wredsumv256si */

            case 14:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19317; /* pred_wredsumv512si */

            case 15:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19319; /* pred_wredsumv1024si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 164:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM1HImode:
          switch (pattern677 (x2, 
E_RVVM1HImode))
            {
            case 0:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19214; /* pred_wredsumurvvm8qi */

            case 1:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19216; /* pred_wredsumurvvm4qi */

            case 2:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19218; /* pred_wredsumurvvm2qi */

            case 3:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19220; /* pred_wredsumurvvm1qi */

            case 4:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19222; /* pred_wredsumurvvmf2qi */

            case 5:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19224; /* pred_wredsumurvvmf4qi */

            case 6:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 19226; /* pred_wredsumurvvmf8qi */

            case 7:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 19250; /* pred_wredsumuv1qi */

            case 8:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 19252; /* pred_wredsumuv2qi */

            case 9:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 19254; /* pred_wredsumuv4qi */

            case 10:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 19256; /* pred_wredsumuv8qi */

            case 11:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 19258; /* pred_wredsumuv16qi */

            case 12:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 19260; /* pred_wredsumuv32qi */

            case 13:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19262; /* pred_wredsumuv64qi */

            case 14:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19264; /* pred_wredsumuv128qi */

            case 15:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19266; /* pred_wredsumuv256qi */

            case 16:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19268; /* pred_wredsumuv512qi */

            case 17:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19270; /* pred_wredsumuv1024qi */

            case 18:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19272; /* pred_wredsumuv2048qi */

            case 19:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19274; /* pred_wredsumuv4096qi */

            default:
              return -1;
            }

        case E_RVVM1SImode:
          switch (pattern678 (x2, 
E_RVVM1SImode))
            {
            case 0:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19228; /* pred_wredsumurvvm8hi */

            case 1:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19230; /* pred_wredsumurvvm4hi */

            case 2:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19232; /* pred_wredsumurvvm2hi */

            case 3:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19234; /* pred_wredsumurvvm1hi */

            case 4:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19236; /* pred_wredsumurvvmf2hi */

            case 5:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 19238; /* pred_wredsumurvvmf4hi */

            case 6:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 19276; /* pred_wredsumuv1hi */

            case 7:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 19278; /* pred_wredsumuv2hi */

            case 8:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 19280; /* pred_wredsumuv4hi */

            case 9:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 19282; /* pred_wredsumuv8hi */

            case 10:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 19284; /* pred_wredsumuv16hi */

            case 11:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19286; /* pred_wredsumuv32hi */

            case 12:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19288; /* pred_wredsumuv64hi */

            case 13:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19290; /* pred_wredsumuv128hi */

            case 14:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19292; /* pred_wredsumuv256hi */

            case 15:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19294; /* pred_wredsumuv512hi */

            case 16:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19296; /* pred_wredsumuv1024hi */

            case 17:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19298; /* pred_wredsumuv2048hi */

            default:
              return -1;
            }

        case E_RVVM1DImode:
          switch (pattern679 (x2, 
E_RVVM1DImode))
            {
            case 0:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19240; /* pred_wredsumurvvm8si */

            case 1:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19242; /* pred_wredsumurvvm4si */

            case 2:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19244; /* pred_wredsumurvvm2si */

            case 3:
              if (!
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19246; /* pred_wredsumurvvm1si */

            case 4:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 19248; /* pred_wredsumurvvmf2si */

            case 5:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 19300; /* pred_wredsumuv1si */

            case 6:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 19302; /* pred_wredsumuv2si */

            case 7:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 19304; /* pred_wredsumuv4si */

            case 8:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 19306; /* pred_wredsumuv8si */

            case 9:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19308; /* pred_wredsumuv16si */

            case 10:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19310; /* pred_wredsumuv32si */

            case 11:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19312; /* pred_wredsumuv64si */

            case 12:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19314; /* pred_wredsumuv128si */

            case 13:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19316; /* pred_wredsumuv256si */

            case 14:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19318; /* pred_wredsumuv512si */

            case 15:
              if (!(
#line 7824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19320; /* pred_wredsumuv1024si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 165:
      return recog_79 (x1, insn, pnum_clobbers);

    case 166:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM1HImode:
          switch (pattern677 (x2, 
E_RVVM1HImode))
            {
            case 0:
              if (!
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19322; /* pred_wredsumu_vl0srvvm8qi */

            case 1:
              if (!
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19324; /* pred_wredsumu_vl0srvvm4qi */

            case 2:
              if (!
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19326; /* pred_wredsumu_vl0srvvm2qi */

            case 3:
              if (!
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19328; /* pred_wredsumu_vl0srvvm1qi */

            case 4:
              if (!
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19330; /* pred_wredsumu_vl0srvvmf2qi */

            case 5:
              if (!
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19332; /* pred_wredsumu_vl0srvvmf4qi */

            case 6:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 19334; /* pred_wredsumu_vl0srvvmf8qi */

            case 7:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 19358; /* pred_wredsumu_vl0sv1qi */

            case 8:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 19360; /* pred_wredsumu_vl0sv2qi */

            case 9:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 19362; /* pred_wredsumu_vl0sv4qi */

            case 10:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 19364; /* pred_wredsumu_vl0sv8qi */

            case 11:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 19366; /* pred_wredsumu_vl0sv16qi */

            case 12:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 19368; /* pred_wredsumu_vl0sv32qi */

            case 13:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19370; /* pred_wredsumu_vl0sv64qi */

            case 14:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19372; /* pred_wredsumu_vl0sv128qi */

            case 15:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19374; /* pred_wredsumu_vl0sv256qi */

            case 16:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19376; /* pred_wredsumu_vl0sv512qi */

            case 17:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19378; /* pred_wredsumu_vl0sv1024qi */

            case 18:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19380; /* pred_wredsumu_vl0sv2048qi */

            case 19:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19382; /* pred_wredsumu_vl0sv4096qi */

            default:
              return -1;
            }

        case E_RVVM1SImode:
          switch (pattern678 (x2, 
E_RVVM1SImode))
            {
            case 0:
              if (!
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19336; /* pred_wredsumu_vl0srvvm8hi */

            case 1:
              if (!
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19338; /* pred_wredsumu_vl0srvvm4hi */

            case 2:
              if (!
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19340; /* pred_wredsumu_vl0srvvm2hi */

            case 3:
              if (!
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19342; /* pred_wredsumu_vl0srvvm1hi */

            case 4:
              if (!
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19344; /* pred_wredsumu_vl0srvvmf2hi */

            case 5:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 19346; /* pred_wredsumu_vl0srvvmf4hi */

            case 6:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 19384; /* pred_wredsumu_vl0sv1hi */

            case 7:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 19386; /* pred_wredsumu_vl0sv2hi */

            case 8:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 19388; /* pred_wredsumu_vl0sv4hi */

            case 9:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 19390; /* pred_wredsumu_vl0sv8hi */

            case 10:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 19392; /* pred_wredsumu_vl0sv16hi */

            case 11:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19394; /* pred_wredsumu_vl0sv32hi */

            case 12:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19396; /* pred_wredsumu_vl0sv64hi */

            case 13:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19398; /* pred_wredsumu_vl0sv128hi */

            case 14:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19400; /* pred_wredsumu_vl0sv256hi */

            case 15:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19402; /* pred_wredsumu_vl0sv512hi */

            case 16:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19404; /* pred_wredsumu_vl0sv1024hi */

            case 17:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19406; /* pred_wredsumu_vl0sv2048hi */

            default:
              return -1;
            }

        case E_RVVM1DImode:
          switch (pattern679 (x2, 
E_RVVM1DImode))
            {
            case 0:
              if (!
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19348; /* pred_wredsumu_vl0srvvm8si */

            case 1:
              if (!
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19350; /* pred_wredsumu_vl0srvvm4si */

            case 2:
              if (!
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19352; /* pred_wredsumu_vl0srvvm2si */

            case 3:
              if (!
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19354; /* pred_wredsumu_vl0srvvm1si */

            case 4:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 19356; /* pred_wredsumu_vl0srvvmf2si */

            case 5:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 19408; /* pred_wredsumu_vl0sv1si */

            case 6:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 19410; /* pred_wredsumu_vl0sv2si */

            case 7:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 19412; /* pred_wredsumu_vl0sv4si */

            case 8:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 19414; /* pred_wredsumu_vl0sv8si */

            case 9:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19416; /* pred_wredsumu_vl0sv16si */

            case 10:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19418; /* pred_wredsumu_vl0sv32si */

            case 11:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19420; /* pred_wredsumu_vl0sv64si */

            case 12:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19422; /* pred_wredsumu_vl0sv128si */

            case 13:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19424; /* pred_wredsumu_vl0sv256si */

            case 14:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19426; /* pred_wredsumu_vl0sv512si */

            case 15:
              if (!(
#line 7846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19428; /* pred_wredsumu_vl0sv1024si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_101 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern195 (x1))
    {
    case 0:
      if (!
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20323; /* pred_slide1uprvvm8qi */

    case 1:
      if (!
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20325; /* pred_slide1uprvvm4qi */

    case 2:
      if (!
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20327; /* pred_slide1uprvvm2qi */

    case 3:
      if (!
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20329; /* pred_slide1uprvvm1qi */

    case 4:
      if (!
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20331; /* pred_slide1uprvvmf2qi */

    case 5:
      if (!
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20333; /* pred_slide1uprvvmf4qi */

    case 6:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20335; /* pred_slide1uprvvmf8qi */

    case 7:
      if (!
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20337; /* pred_slide1uprvvm8hi */

    case 8:
      if (!
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20339; /* pred_slide1uprvvm4hi */

    case 9:
      if (!
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20341; /* pred_slide1uprvvm2hi */

    case 10:
      if (!
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20343; /* pred_slide1uprvvm1hi */

    case 11:
      if (!
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20345; /* pred_slide1uprvvmf2hi */

    case 12:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20347; /* pred_slide1uprvvmf4hi */

    case 13:
      if (!
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20349; /* pred_slide1uprvvm8si */

    case 14:
      if (!
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20351; /* pred_slide1uprvvm4si */

    case 15:
      if (!
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20353; /* pred_slide1uprvvm2si */

    case 16:
      if (!
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20355; /* pred_slide1uprvvm1si */

    case 17:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20357; /* pred_slide1uprvvmf2si */

    case 18:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 20359; /* pred_slide1upv1qi */

    case 19:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 20361; /* pred_slide1upv2qi */

    case 20:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 20363; /* pred_slide1upv4qi */

    case 21:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 20365; /* pred_slide1upv8qi */

    case 22:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 20367; /* pred_slide1upv16qi */

    case 23:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 20369; /* pred_slide1upv32qi */

    case 24:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20371; /* pred_slide1upv64qi */

    case 25:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20373; /* pred_slide1upv128qi */

    case 26:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20375; /* pred_slide1upv256qi */

    case 27:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20377; /* pred_slide1upv512qi */

    case 28:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20379; /* pred_slide1upv1024qi */

    case 29:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20381; /* pred_slide1upv2048qi */

    case 30:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20383; /* pred_slide1upv4096qi */

    case 31:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 20385; /* pred_slide1upv1hi */

    case 32:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 20387; /* pred_slide1upv2hi */

    case 33:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 20389; /* pred_slide1upv4hi */

    case 34:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 20391; /* pred_slide1upv8hi */

    case 35:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 20393; /* pred_slide1upv16hi */

    case 36:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20395; /* pred_slide1upv32hi */

    case 37:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20397; /* pred_slide1upv64hi */

    case 38:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20399; /* pred_slide1upv128hi */

    case 39:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20401; /* pred_slide1upv256hi */

    case 40:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20403; /* pred_slide1upv512hi */

    case 41:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20405; /* pred_slide1upv1024hi */

    case 42:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20407; /* pred_slide1upv2048hi */

    case 43:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 20409; /* pred_slide1upv1si */

    case 44:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 20411; /* pred_slide1upv2si */

    case 45:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 20413; /* pred_slide1upv4si */

    case 46:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 20415; /* pred_slide1upv8si */

    case 47:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20417; /* pred_slide1upv16si */

    case 48:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20419; /* pred_slide1upv32si */

    case 49:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20421; /* pred_slide1upv64si */

    case 50:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20423; /* pred_slide1upv128si */

    case 51:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20425; /* pred_slide1upv256si */

    case 52:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20427; /* pred_slide1upv512si */

    case 53:
      if (!(
#line 8134 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20429; /* pred_slide1upv1024si */

    case 54:
      if (!(
#line 8178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20431; /* *pred_slide1uprvvm8di */

    case 55:
      if (!(
#line 8178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20433; /* *pred_slide1uprvvm4di */

    case 56:
      if (!(
#line 8178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20435; /* *pred_slide1uprvvm2di */

    case 57:
      if (!(
#line 8178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20437; /* *pred_slide1uprvvm1di */

    case 58:
      if (!(
#line 8178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20439; /* *pred_slide1upv1di */

    case 59:
      if (!(
#line 8178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20441; /* *pred_slide1upv2di */

    case 60:
      if (!(
#line 8178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20443; /* *pred_slide1upv4di */

    case 61:
      if (!(
#line 8178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20445; /* *pred_slide1upv8di */

    case 62:
      if (!(
#line 8178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20447; /* *pred_slide1upv16di */

    case 63:
      if (!(
#line 8178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20449; /* *pred_slide1upv32di */

    case 64:
      if (!(
#line 8178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20451; /* *pred_slide1upv64di */

    case 65:
      if (!(
#line 8178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20453; /* *pred_slide1upv128di */

    case 66:
      if (!(
#line 8178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20455; /* *pred_slide1upv256di */

    case 67:
      if (!(
#line 8178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20457; /* *pred_slide1upv512di */

    case 68:
      if (!(
#line 8198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20459; /* *pred_slide1uprvvm8di_extended */

    case 69:
      if (!(
#line 8198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20461; /* *pred_slide1uprvvm4di_extended */

    case 70:
      if (!(
#line 8198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20463; /* *pred_slide1uprvvm2di_extended */

    case 71:
      if (!(
#line 8198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20465; /* *pred_slide1uprvvm1di_extended */

    case 72:
      if (!(
#line 8198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20467; /* *pred_slide1upv1di_extended */

    case 73:
      if (!(
#line 8198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20469; /* *pred_slide1upv2di_extended */

    case 74:
      if (!(
#line 8198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20471; /* *pred_slide1upv4di_extended */

    case 75:
      if (!(
#line 8198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20473; /* *pred_slide1upv8di_extended */

    case 76:
      if (!(
#line 8198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20475; /* *pred_slide1upv16di_extended */

    case 77:
      if (!(
#line 8198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20477; /* *pred_slide1upv32di_extended */

    case 78:
      if (!(
#line 8198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20479; /* *pred_slide1upv64di_extended */

    case 79:
      if (!(
#line 8198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20481; /* *pred_slide1upv128di_extended */

    case 80:
      if (!(
#line 8198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20483; /* *pred_slide1upv256di_extended */

    case 81:
      if (!(
#line 8198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20485; /* *pred_slide1upv512di_extended */

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 36:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HFmode:
          switch (pattern334 (x2, 
E_HFmode))
            {
            case 0:
              if (!(
#line 2077 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!TARGET_ZFHMIN) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 142; /* *movhf_softfloat_boxing */

            case 1:
              if (!(
#line 2077 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!TARGET_ZFHMIN) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 144; /* *movhf_softfloat_boxing */

            default:
              return -1;
            }

        case E_BFmode:
          switch (pattern334 (x2, 
E_BFmode))
            {
            case 0:
              if (!(
#line 2077 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!TARGET_ZFHMIN) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 143; /* *movbf_softfloat_boxing */

            case 1:
              if (!(
#line 2077 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!TARGET_ZFHMIN) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 145; /* *movbf_softfloat_boxing */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 23:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern177 (x2, 
E_SImode))
            {
            case 0:
              if (!
#line 2176 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
                return -1;
              return 176; /* *lrintsfsi2 */

            case 1:
              if (!(
#line 2176 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 177; /* *lrintdfsi2 */

            case 2:
              if (!(
#line 2176 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 178; /* *lrinthfsi2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern177 (x2, 
E_DImode))
            {
            case 0:
              if (!(
#line 2196 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 182; /* lrintsfdi2 */

            case 1:
              if (!(
#line 2196 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 183; /* lrintdfdi2 */

            case 2:
              if (!(
#line 2196 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 184; /* lrinthfdi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 17:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 2225 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 185; /* *lroundsfsi2 */

        case 1:
          if (!(
#line 2225 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 191; /* *lrounddfsi2 */

        case 2:
          if (!(
#line 2225 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 197; /* *lroundhfsi2 */

        case 3:
          if (!(
#line 2245 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 221; /* lroundsfdi2 */

        case 4:
          if (!(
#line 2245 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 227; /* lrounddfdi2 */

        case 5:
          if (!(
#line 2245 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 233; /* lroundhfdi2 */

        case 6:
          if (!(
#line 2323 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 239; /* roundsf_zfa2 */

        case 7:
          if (!(
#line 2323 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 245; /* rounddf_zfa2 */

        case 8:
          if (!(
#line 2323 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 251; /* roundhf_zfa2 */

        default:
          return -1;
        }

    case 18:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 2225 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 186; /* *lfloorsfsi2 */

        case 1:
          if (!(
#line 2225 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 192; /* *lfloordfsi2 */

        case 2:
          if (!(
#line 2225 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 198; /* *lfloorhfsi2 */

        case 3:
          if (!(
#line 2245 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 222; /* lfloorsfdi2 */

        case 4:
          if (!(
#line 2245 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 228; /* lfloordfdi2 */

        case 5:
          if (!(
#line 2245 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 234; /* lfloorhfdi2 */

        case 6:
          if (!(
#line 2323 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 240; /* floorsf_zfa2 */

        case 7:
          if (!(
#line 2323 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 246; /* floordf_zfa2 */

        case 8:
          if (!(
#line 2323 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 252; /* floorhf_zfa2 */

        default:
          return -1;
        }

    case 19:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 2225 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 187; /* *lceilsfsi2 */

        case 1:
          if (!(
#line 2225 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 193; /* *lceildfsi2 */

        case 2:
          if (!(
#line 2225 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 199; /* *lceilhfsi2 */

        case 3:
          if (!(
#line 2245 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 223; /* lceilsfdi2 */

        case 4:
          if (!(
#line 2245 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 229; /* lceildfdi2 */

        case 5:
          if (!(
#line 2245 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 235; /* lceilhfdi2 */

        case 6:
          if (!(
#line 2323 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 241; /* ceilsf_zfa2 */

        case 7:
          if (!(
#line 2323 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 247; /* ceildf_zfa2 */

        case 8:
          if (!(
#line 2323 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 253; /* ceilhf_zfa2 */

        default:
          return -1;
        }

    case 20:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 2225 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 188; /* *lbtruncsfsi2 */

        case 1:
          if (!(
#line 2225 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 194; /* *lbtruncdfsi2 */

        case 2:
          if (!(
#line 2225 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 200; /* *lbtrunchfsi2 */

        case 3:
          if (!(
#line 2245 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 224; /* lbtruncsfdi2 */

        case 4:
          if (!(
#line 2245 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 230; /* lbtruncdfdi2 */

        case 5:
          if (!(
#line 2245 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 236; /* lbtrunchfdi2 */

        case 6:
          if (!(
#line 2323 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 242; /* btruncsf_zfa2 */

        case 7:
          if (!(
#line 2323 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 248; /* btruncdf_zfa2 */

        case 8:
          if (!(
#line 2323 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 254; /* btrunchf_zfa2 */

        default:
          return -1;
        }

    case 21:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 2225 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 189; /* *lroundevensfsi2 */

        case 1:
          if (!(
#line 2225 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 195; /* *lroundevendfsi2 */

        case 2:
          if (!(
#line 2225 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 201; /* *lroundevenhfsi2 */

        case 3:
          if (!(
#line 2245 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 225; /* lroundevensfdi2 */

        case 4:
          if (!(
#line 2245 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 231; /* lroundevendfdi2 */

        case 5:
          if (!(
#line 2245 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 237; /* lroundevenhfdi2 */

        case 6:
          if (!(
#line 2323 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 243; /* roundevensf_zfa2 */

        case 7:
          if (!(
#line 2323 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 249; /* roundevendf_zfa2 */

        case 8:
          if (!(
#line 2323 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 255; /* roundevenhf_zfa2 */

        default:
          return -1;
        }

    case 22:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 2225 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 190; /* *lnearbyintsfsi2 */

        case 1:
          if (!(
#line 2225 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 196; /* *lnearbyintdfsi2 */

        case 2:
          if (!(
#line 2225 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 202; /* *lnearbyinthfsi2 */

        case 3:
          if (!(
#line 2245 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 226; /* lnearbyintsfdi2 */

        case 4:
          if (!(
#line 2245 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 232; /* lnearbyintdfdi2 */

        case 5:
          if (!(
#line 2245 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 238; /* lnearbyinthfdi2 */

        case 6:
          if (!(
#line 2323 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 244; /* nearbyintsf_zfa2 */

        case 7:
          if (!(
#line 2323 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 250; /* nearbyintdf_zfa2 */

        case 8:
          if (!(
#line 2323 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 256; /* nearbyinthf_zfa2 */

        default:
          return -1;
        }

    case 16:
      return recog_53 (x1, insn, pnum_clobbers);

    case 4:
      switch (pattern179 (x1))
        {
        case 0:
          if (!
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))
            return -1;
          return 260; /* got_loadsi */

        case 1:
          if (!
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))
            return -1;
          return 261; /* got_loaddi */

        default:
          return -1;
        }

    case 8:
      switch (pattern179 (x1))
        {
        case 0:
          if (!
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))
            return -1;
          return 264; /* got_load_tls_gdsi */

        case 1:
          if (!
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))
            return -1;
          return 265; /* got_load_tls_gddi */

        default:
          return -1;
        }

    case 7:
      switch (pattern179 (x1))
        {
        case 0:
          if (!
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))
            return -1;
          return 266; /* got_load_tls_iesi */

        case 1:
          if (!
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))
            return -1;
          return 267; /* got_load_tls_iedi */

        default:
          return -1;
        }

    case 9:
      return recog_55 (x1, insn, pnum_clobbers);

    case 14:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 2699 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && !TARGET_64BIT && TARGET_ZFA))
        return -1;
      return 290; /* movsidf2_low_rv32 */

    case 15:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 2711 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && !TARGET_64BIT && TARGET_ZFA))
        return -1;
      return 291; /* movsidf2_high_rv32 */

    case 28:
      return recog_54 (x1, insn, pnum_clobbers);

    case 30:
      switch (pattern180 (x1))
        {
        case 0:
          if (
#line 467 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB))
            return 566; /* orcbsi2 */
          if (!(
#line 140 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 889; /* th_tstnbzsi2 */

        case 1:
          if ((
#line 467 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 567; /* orcbdi2 */
          if (!(
#line 140 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 890; /* th_tstnbzdi2 */

        default:
          return -1;
        }

    case 43:
      switch (pattern180 (x1))
        {
        case 0:
          if (!
#line 78 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZBKB))
            return -1;
          return 661; /* riscv_brev8_si */

        case 1:
          if (!(
#line 78 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZBKB) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 662; /* riscv_brev8_di */

        default:
          return -1;
        }

    case 44:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 86 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZBKB && !TARGET_64BIT))
        return -1;
      return 663; /* riscv_zip */

    case 45:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 94 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZBKB && !TARGET_64BIT))
        return -1;
      return 664; /* riscv_unzip */

    case 55:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZKND && TARGET_64BIT))
        return -1;
      return 687; /* riscv_aes64im */

    case 62:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 694; /* *riscv_sha256sig0_si */

    case 63:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 695; /* *riscv_sha256sig1_si */

    case 64:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 696; /* *riscv_sha256sum0_si */

    case 65:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 697; /* *riscv_sha256sum1_si */

    case 66:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 419 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
        return -1;
      return 708; /* riscv_sha512sig0 */

    case 69:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 427 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
        return -1;
      return 709; /* riscv_sha512sig1 */

    case 72:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 435 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
        return -1;
      return 710; /* riscv_sha512sum0 */

    case 74:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 443 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
        return -1;
      return 711; /* riscv_sha512sum1 */

    case 76:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 456 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZKSH && !TARGET_64BIT))
        return -1;
      return 712; /* *riscv_sm3p0_si */

    case 77:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 456 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZKSH && !TARGET_64BIT))
        return -1;
      return 713; /* *riscv_sm3p1_si */

    case 37:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(!TARGET_64BIT && TARGET_XTHEADFMV))
        return -1;
      return 897; /* th_fmv_x_w */

    case 38:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(!TARGET_64BIT && TARGET_XTHEADFMV))
        return -1;
      return 898; /* th_fmv_x_hw */

    case 92:
      x4 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 0
          || GET_MODE (x4) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      return recog_50 (x1, insn, pnum_clobbers);

    case 94:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !const_int_operand (operands[1], E_SImode)
              || !(
#line 1080 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
            return -1;
          return 2719; /* vlmax_avlsi */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !const_int_operand (operands[1], E_DImode)
              || !(
#line 1080 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
            return -1;
          return 2720; /* vlmax_avldi */

        default:
          return -1;
        }

    case 143:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      return recog_51 (x1, insn, pnum_clobbers);

    case 146:
      return recog_52 (x1, insn, pnum_clobbers);

    case 290:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 1555 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 34000; /* riscv_cv_simd_abs_h_si */

    case 291:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 1564 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 34001; /* riscv_cv_simd_abs_b_si */

    case 292:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 1573 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 34002; /* riscv_cv_simd_neg_h_si */

    case 293:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 1582 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 34003; /* riscv_cv_simd_neg_b_si */

    case 376:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 2597 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 34086; /* riscv_cv_simd_cplxconj_si */

    default:
      return -1;
    }
}

 int
recog_114 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      x2 = XEXP (x1, 1);
      switch (pattern295 (x2))
        {
        case 0:
          if (
#line 1878 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && !TARGET_ZBA && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX
   && !(REG_P (operands[1]) && VL_REG_P (REGNO (operands[1])))))
            return 121; /* *zero_extendsidi2_internal */
          if (!
#line 25 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA && !TARGET_XTHEADMEMIDX))
            return -1;
          return 508; /* *zero_extendsidi2_bitmanip */

        case 1:
          if ((
#line 1905 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 123; /* *zero_extendhidi2 */
          if (!(
#line 312 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 541; /* *zero_extendhidi2_bitmanip */

        case 2:
          if (!(
#line 1934 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 126; /* *zero_extendqidi2_internal */

        default:
          return -1;
        }

    case E_SImode:
      x2 = XEXP (x1, 1);
      switch (pattern286 (x2, 
E_SImode))
        {
        case 0:
          if (
#line 1905 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 122; /* *zero_extendhisi2 */
          if (!
#line 312 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 540; /* *zero_extendhisi2_bitmanip */

        case 1:
          if (!
#line 1934 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!TARGET_XTHEADMEMIDX))
            return -1;
          return 125; /* *zero_extendqisi2_internal */

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_HImode
          || !nonimmediate_operand (operands[1], E_QImode)
          || !
#line 1934 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!TARGET_XTHEADMEMIDX))
        return -1;
      return 124; /* *zero_extendqihi2_internal */

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM4QImode)
          || !
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26104; /* zero_extendrvvm4qirvvm8hi2 */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM2QImode)
          || !
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26106; /* zero_extendrvvm2qirvvm4hi2 */

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM1QImode)
          || !
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26108; /* zero_extendrvvm1qirvvm2hi2 */

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26110; /* zero_extendrvvmf2qirvvm1hi2 */

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26112; /* zero_extendrvvmf4qirvvmf2hi2 */

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26114; /* zero_extendrvvmf8qirvvmf4hi2 */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      switch (pattern296 (x2))
        {
        case 0:
          if (!
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26116; /* zero_extendrvvm4hirvvm8si2 */

        case 1:
          if (!
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26200; /* zero_extendrvvm2qirvvm8si2 */

        default:
          return -1;
        }

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      switch (pattern297 (x2))
        {
        case 0:
          if (!
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26118; /* zero_extendrvvm2hirvvm4si2 */

        case 1:
          if (!
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26202; /* zero_extendrvvm1qirvvm4si2 */

        default:
          return -1;
        }

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      switch (pattern298 (x2))
        {
        case 0:
          if (!
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26120; /* zero_extendrvvm1hirvvm2si2 */

        case 1:
          if (!
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26204; /* zero_extendrvvmf2qirvvm2si2 */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern299 (x2))
        {
        case 0:
          if (!
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26122; /* zero_extendrvvmf2hirvvm1si2 */

        case 1:
          if (!
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26206; /* zero_extendrvvmf4qirvvm1si2 */

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      switch (pattern300 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26124; /* zero_extendrvvmf4hirvvmf2si2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26208; /* zero_extendrvvmf8qirvvmf2si2 */

        default:
          return -1;
        }

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      switch (pattern301 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26126; /* zero_extendrvvm4sirvvm8di2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26210; /* zero_extendrvvm2hirvvm8di2 */

        case 2:
          if (!(
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26260; /* zero_extendrvvm1qirvvm8di2 */

        default:
          return -1;
        }

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      switch (pattern302 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26128; /* zero_extendrvvm2sirvvm4di2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26212; /* zero_extendrvvm1hirvvm4di2 */

        case 2:
          if (!(
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26262; /* zero_extendrvvmf2qirvvm4di2 */

        default:
          return -1;
        }

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      switch (pattern303 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26130; /* zero_extendrvvm1sirvvm2di2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26214; /* zero_extendrvvmf2hirvvm2di2 */

        case 2:
          if (!(
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26264; /* zero_extendrvvmf4qirvvm2di2 */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern304 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26132; /* zero_extendrvvmf2sirvvm1di2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26216; /* zero_extendrvvmf4hirvvm1di2 */

        case 2:
          if (!(
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26266; /* zero_extendrvvmf8qirvvm1di2 */

        default:
          return -1;
        }

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1HImode
          || !register_operand (operands[1], E_V1QImode)
          || !(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 26134; /* zero_extendv1qiv1hi2 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2HImode
          || !register_operand (operands[1], E_V2QImode)
          || !(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 26136; /* zero_extendv2qiv2hi2 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4QImode)
          || !(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 26138; /* zero_extendv4qiv4hi2 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8QImode)
          || !(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 26140; /* zero_extendv8qiv8hi2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HImode
          || !register_operand (operands[1], E_V16QImode)
          || !(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 26142; /* zero_extendv16qiv16hi2 */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HImode
          || !register_operand (operands[1], E_V32QImode)
          || !(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26144; /* zero_extendv32qiv32hi2 */

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64HImode
          || !register_operand (operands[1], E_V64QImode)
          || !(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26146; /* zero_extendv64qiv64hi2 */

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128HImode
          || !register_operand (operands[1], E_V128QImode)
          || !(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26148; /* zero_extendv128qiv128hi2 */

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256HImode
          || !register_operand (operands[1], E_V256QImode)
          || !(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26150; /* zero_extendv256qiv256hi2 */

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512HImode
          || !register_operand (operands[1], E_V512QImode)
          || !(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26152; /* zero_extendv512qiv512hi2 */

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024HImode
          || !register_operand (operands[1], E_V1024QImode)
          || !(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26154; /* zero_extendv1024qiv1024hi2 */

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048HImode
          || !register_operand (operands[1], E_V2048QImode)
          || !(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26156; /* zero_extendv2048qiv2048hi2 */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern305 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 26158; /* zero_extendv1hiv1si2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 26218; /* zero_extendv1qiv1si2 */

        default:
          return -1;
        }

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      switch (pattern306 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 26160; /* zero_extendv2hiv2si2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 26220; /* zero_extendv2qiv2si2 */

        default:
          return -1;
        }

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      switch (pattern307 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 26162; /* zero_extendv4hiv4si2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 26222; /* zero_extendv4qiv4si2 */

        default:
          return -1;
        }

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      switch (pattern308 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 26164; /* zero_extendv8hiv8si2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 26224; /* zero_extendv8qiv8si2 */

        default:
          return -1;
        }

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      switch (pattern309 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26166; /* zero_extendv16hiv16si2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26226; /* zero_extendv16qiv16si2 */

        default:
          return -1;
        }

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      switch (pattern310 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26168; /* zero_extendv32hiv32si2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26228; /* zero_extendv32qiv32si2 */

        default:
          return -1;
        }

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      switch (pattern311 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26170; /* zero_extendv64hiv64si2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26230; /* zero_extendv64qiv64si2 */

        default:
          return -1;
        }

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      switch (pattern312 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26172; /* zero_extendv128hiv128si2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1118 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26232; /* zero_extendv128qiv128si2 */

        default:
          return -1;
        }

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      switch (pattern313 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26174; /* zero_extendv256hiv256si2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1119 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26234; /* zero_extendv256qiv256si2 */

        default:
          return -1;
        }

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      switch (pattern314 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26176; /* zero_extendv512hiv512si2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1120 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26236; /* zero_extendv512qiv512si2 */

        default:
          return -1;
        }

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      switch (pattern315 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26178; /* zero_extendv1024hiv1024si2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1121 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26238; /* zero_extendv1024qiv1024si2 */

        default:
          return -1;
        }

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern316 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26180; /* zero_extendv1siv1di2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1122 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26240; /* zero_extendv1hiv1di2 */

        case 2:
          if (!(
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1154 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26268; /* zero_extendv1qiv1di2 */

        default:
          return -1;
        }

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      switch (pattern317 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26182; /* zero_extendv2siv2di2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1123 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26242; /* zero_extendv2hiv2di2 */

        case 2:
          if (!(
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26270; /* zero_extendv2qiv2di2 */

        default:
          return -1;
        }

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      switch (pattern318 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26184; /* zero_extendv4siv4di2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1124 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26244; /* zero_extendv4hiv4di2 */

        case 2:
          if (!(
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26272; /* zero_extendv4qiv4di2 */

        default:
          return -1;
        }

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      switch (pattern319 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26186; /* zero_extendv8siv8di2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1125 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26246; /* zero_extendv8hiv8di2 */

        case 2:
          if (!(
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26274; /* zero_extendv8qiv8di2 */

        default:
          return -1;
        }

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      switch (pattern320 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26188; /* zero_extendv16siv16di2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1126 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26248; /* zero_extendv16hiv16di2 */

        case 2:
          if (!(
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1158 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26276; /* zero_extendv16qiv16di2 */

        default:
          return -1;
        }

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      switch (pattern321 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26190; /* zero_extendv32siv32di2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1127 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26250; /* zero_extendv32hiv32di2 */

        case 2:
          if (!(
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26278; /* zero_extendv32qiv32di2 */

        default:
          return -1;
        }

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      switch (pattern322 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26192; /* zero_extendv64siv64di2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1128 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26252; /* zero_extendv64hiv64di2 */

        case 2:
          if (!(
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26280; /* zero_extendv64qiv64di2 */

        default:
          return -1;
        }

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      switch (pattern323 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26194; /* zero_extendv128siv128di2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26254; /* zero_extendv128hiv128di2 */

        case 2:
          if (!(
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26282; /* zero_extendv128qiv128di2 */

        default:
          return -1;
        }

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      switch (pattern324 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26196; /* zero_extendv256siv256di2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1130 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26256; /* zero_extendv256hiv256di2 */

        case 2:
          if (!(
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26284; /* zero_extendv256qiv256di2 */

        default:
          return -1;
        }

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      switch (pattern325 (x2))
        {
        case 0:
          if (!(
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26198; /* zero_extendv512siv512di2 */

        case 1:
          if (!(
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26258; /* zero_extendv512hiv512di2 */

        case 2:
          if (!(
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26286; /* zero_extendv512qiv512di2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_270 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2DImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3104; /* *movrvvm4x2di_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3105; /* *movrvvm4x2di_di */
}

 int
recog_281 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x8QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x8QImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3082; /* *movrvvmf2x8qi_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3083; /* *movrvvmf2x8qi_di */
}

 int
recog_289 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3DFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1272 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3066; /* *movrvvm2x3df_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1272 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3067; /* *movrvvm2x3df_di */
}

 int
recog_297 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2SFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3050; /* *movrvvm1x2sf_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3051; /* *movrvvm1x2sf_di */
}

 int
recog_305 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x8BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x8BFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3034; /* *movrvvmf2x8bf_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3035; /* *movrvvmf2x8bf_di */
}

 int
recog_313 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3DImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3018; /* *movrvvm2x3di_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3019; /* *movrvvm2x3di_di */
}

 int
recog_324 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x6HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x6HImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2996; /* *movrvvmf2x6hi_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2997; /* *movrvvmf2x6hi_di */
}

 int
recog_332 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x5QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x5QImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2980; /* *movrvvmf4x5qi_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2981; /* *movrvvmf4x5qi_di */
}

 int
recog_340 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x4DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x4DFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2964; /* *movrvvm1x4df_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2965; /* *movrvvm1x4df_di */
}

 int
recog_348 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x3SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x3SFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2948; /* *movrvvmf2x3sf_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2949; /* *movrvvmf2x3sf_di */
}

 int
recog_356 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x2HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x2HFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2932; /* *movrvvmf4x2hf_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2933; /* *movrvvmf4x2hf_di */
}

 int
recog_364 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x8DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x8DImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2916; /* *movrvvm1x8di_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2917; /* *movrvvm1x8di_di */
}

 int
recog_371 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x8SImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x8SImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1187 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2902; /* *movrvvmf2x8si_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1187 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2903; /* *movrvvmf2x8si_di */
}

 int
recog_379 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern328 (x2))
    {
    case 0:
      return 296; /* *ashlsi3 */

    case 1:
      if (!
#line 2914 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 299; /* ashldi3 */

    case 2:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25493; /* ashlrvvm8qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM8QImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25697; /* vashlrvvm8qi3 */

    case 3:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25496; /* ashlrvvm4qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM4QImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25700; /* vashlrvvm4qi3 */

    case 4:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25499; /* ashlrvvm2qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM2QImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25703; /* vashlrvvm2qi3 */

    case 5:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25502; /* ashlrvvm1qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM1QImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25706; /* vashlrvvm1qi3 */

    case 6:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25505; /* ashlrvvm8hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM8HImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25709; /* vashlrvvm8hi3 */

    case 7:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25508; /* ashlrvvm4hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM4HImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25712; /* vashlrvvm4hi3 */

    case 8:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25511; /* ashlrvvm2hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM2HImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25715; /* vashlrvvm2hi3 */

    case 9:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25514; /* ashlrvvm1hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM1HImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25718; /* vashlrvvm1hi3 */

    case 10:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25517; /* ashlrvvm8si3 */
      if (!vector_shift_operand (operands[2], E_RVVM8SImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25721; /* vashlrvvm8si3 */

    case 11:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25520; /* ashlrvvm4si3 */
      if (!vector_shift_operand (operands[2], E_RVVM4SImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25724; /* vashlrvvm4si3 */

    case 12:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25523; /* ashlrvvm2si3 */
      if (!vector_shift_operand (operands[2], E_RVVM2SImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25727; /* vashlrvvm2si3 */

    case 13:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25526; /* ashlrvvm1si3 */
      if (!vector_shift_operand (operands[2], E_RVVM1SImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25730; /* vashlrvvm1si3 */

    case 14:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25529; /* ashlrvvm8di3 */
      if (!vector_shift_operand (operands[2], E_RVVM8DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25733; /* vashlrvvm8di3 */

    case 15:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25532; /* ashlrvvm4di3 */
      if (!vector_shift_operand (operands[2], E_RVVM4DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25736; /* vashlrvvm4di3 */

    case 16:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25535; /* ashlrvvm2di3 */
      if (!vector_shift_operand (operands[2], E_RVVM2DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25739; /* vashlrvvm2di3 */

    case 17:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25538; /* ashlrvvm1di3 */
      if (!vector_shift_operand (operands[2], E_RVVM1DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25742; /* vashlrvvm1di3 */

    case 18:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 25541; /* ashlrvvmf2qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25745; /* vashlrvvmf2qi3 */

    case 19:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 25544; /* ashlrvvmf4qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF4QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25748; /* vashlrvvmf4qi3 */

    case 20:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 25547; /* ashlrvvmf8qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF8QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25751; /* vashlrvvmf8qi3 */

    case 21:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 25550; /* ashlrvvmf2hi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25754; /* vashlrvvmf2hi3 */

    case 22:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 25553; /* ashlrvvmf4hi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF4HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25757; /* vashlrvvmf4hi3 */

    case 23:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 25556; /* ashlrvvmf2si3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25760; /* vashlrvvmf2si3 */

    case 24:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 25559; /* ashlv1qi3 */
      if (!vector_shift_operand (operands[2], E_V1QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 25763; /* vashlv1qi3 */

    case 25:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 25562; /* ashlv2qi3 */
      if (!vector_shift_operand (operands[2], E_V2QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 25766; /* vashlv2qi3 */

    case 26:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 25565; /* ashlv4qi3 */
      if (!vector_shift_operand (operands[2], E_V4QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 25769; /* vashlv4qi3 */

    case 27:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 25568; /* ashlv8qi3 */
      if (!vector_shift_operand (operands[2], E_V8QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 25772; /* vashlv8qi3 */

    case 28:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 25571; /* ashlv16qi3 */
      if (!vector_shift_operand (operands[2], E_V16QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 25775; /* vashlv16qi3 */

    case 29:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 25574; /* ashlv32qi3 */
      if (!vector_shift_operand (operands[2], E_V32QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 25778; /* vashlv32qi3 */

    case 30:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 25577; /* ashlv64qi3 */
      if (!vector_shift_operand (operands[2], E_V64QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25781; /* vashlv64qi3 */

    case 31:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 25580; /* ashlv128qi3 */
      if (!vector_shift_operand (operands[2], E_V128QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25784; /* vashlv128qi3 */

    case 32:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 25583; /* ashlv256qi3 */
      if (!vector_shift_operand (operands[2], E_V256QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25787; /* vashlv256qi3 */

    case 33:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 25586; /* ashlv512qi3 */
      if (!vector_shift_operand (operands[2], E_V512QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25790; /* vashlv512qi3 */

    case 34:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 25589; /* ashlv1024qi3 */
      if (!vector_shift_operand (operands[2], E_V1024QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25793; /* vashlv1024qi3 */

    case 35:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 25592; /* ashlv2048qi3 */
      if (!vector_shift_operand (operands[2], E_V2048QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25796; /* vashlv2048qi3 */

    case 36:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 25595; /* ashlv4096qi3 */
      if (!vector_shift_operand (operands[2], E_V4096QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25799; /* vashlv4096qi3 */

    case 37:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 25598; /* ashlv1hi3 */
      if (!vector_shift_operand (operands[2], E_V1HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25802; /* vashlv1hi3 */

    case 38:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 25601; /* ashlv2hi3 */
      if (!vector_shift_operand (operands[2], E_V2HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25805; /* vashlv2hi3 */

    case 39:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 25604; /* ashlv4hi3 */
      if (!vector_shift_operand (operands[2], E_V4HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25808; /* vashlv4hi3 */

    case 40:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 25607; /* ashlv8hi3 */
      if (!vector_shift_operand (operands[2], E_V8HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25811; /* vashlv8hi3 */

    case 41:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 25610; /* ashlv16hi3 */
      if (!vector_shift_operand (operands[2], E_V16HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25814; /* vashlv16hi3 */

    case 42:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 25613; /* ashlv32hi3 */
      if (!vector_shift_operand (operands[2], E_V32HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25817; /* vashlv32hi3 */

    case 43:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 25616; /* ashlv64hi3 */
      if (!vector_shift_operand (operands[2], E_V64HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25820; /* vashlv64hi3 */

    case 44:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 25619; /* ashlv128hi3 */
      if (!vector_shift_operand (operands[2], E_V128HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25823; /* vashlv128hi3 */

    case 45:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 25622; /* ashlv256hi3 */
      if (!vector_shift_operand (operands[2], E_V256HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25826; /* vashlv256hi3 */

    case 46:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 25625; /* ashlv512hi3 */
      if (!vector_shift_operand (operands[2], E_V512HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25829; /* vashlv512hi3 */

    case 47:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 25628; /* ashlv1024hi3 */
      if (!vector_shift_operand (operands[2], E_V1024HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25832; /* vashlv1024hi3 */

    case 48:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 25631; /* ashlv2048hi3 */
      if (!vector_shift_operand (operands[2], E_V2048HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25835; /* vashlv2048hi3 */

    case 49:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 25634; /* ashlv1si3 */
      if (!vector_shift_operand (operands[2], E_V1SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25838; /* vashlv1si3 */

    case 50:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 25637; /* ashlv2si3 */
      if (!vector_shift_operand (operands[2], E_V2SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25841; /* vashlv2si3 */

    case 51:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 25640; /* ashlv4si3 */
      if (!vector_shift_operand (operands[2], E_V4SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25844; /* vashlv4si3 */

    case 52:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 25643; /* ashlv8si3 */
      if (!vector_shift_operand (operands[2], E_V8SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25847; /* vashlv8si3 */

    case 53:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 25646; /* ashlv16si3 */
      if (!vector_shift_operand (operands[2], E_V16SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25850; /* vashlv16si3 */

    case 54:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 25649; /* ashlv32si3 */
      if (!vector_shift_operand (operands[2], E_V32SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25853; /* vashlv32si3 */

    case 55:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 25652; /* ashlv64si3 */
      if (!vector_shift_operand (operands[2], E_V64SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25856; /* vashlv64si3 */

    case 56:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 25655; /* ashlv128si3 */
      if (!vector_shift_operand (operands[2], E_V128SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25859; /* vashlv128si3 */

    case 57:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 25658; /* ashlv256si3 */
      if (!vector_shift_operand (operands[2], E_V256SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25862; /* vashlv256si3 */

    case 58:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 25661; /* ashlv512si3 */
      if (!vector_shift_operand (operands[2], E_V512SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25865; /* vashlv512si3 */

    case 59:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 25664; /* ashlv1024si3 */
      if (!vector_shift_operand (operands[2], E_V1024SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25868; /* vashlv1024si3 */

    case 60:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 25667; /* ashlv1di3 */
      if (!vector_shift_operand (operands[2], E_V1DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25871; /* vashlv1di3 */

    case 61:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 25670; /* ashlv2di3 */
      if (!vector_shift_operand (operands[2], E_V2DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25874; /* vashlv2di3 */

    case 62:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 25673; /* ashlv4di3 */
      if (!vector_shift_operand (operands[2], E_V4DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25877; /* vashlv4di3 */

    case 63:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 25676; /* ashlv8di3 */
      if (!vector_shift_operand (operands[2], E_V8DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25880; /* vashlv8di3 */

    case 64:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 25679; /* ashlv16di3 */
      if (!vector_shift_operand (operands[2], E_V16DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25883; /* vashlv16di3 */

    case 65:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 25682; /* ashlv32di3 */
      if (!vector_shift_operand (operands[2], E_V32DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25886; /* vashlv32di3 */

    case 66:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 25685; /* ashlv64di3 */
      if (!vector_shift_operand (operands[2], E_V64DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25889; /* vashlv64di3 */

    case 67:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 25688; /* ashlv128di3 */
      if (!vector_shift_operand (operands[2], E_V128DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25892; /* vashlv128di3 */

    case 68:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 25691; /* ashlv256di3 */
      if (!vector_shift_operand (operands[2], E_V256DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25895; /* vashlv256di3 */

    case 69:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 25694; /* ashlv512di3 */
      if (!vector_shift_operand (operands[2], E_V512DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25898; /* vashlv512di3 */

    default:
      return -1;
    }
}

 int
recog_401 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 0);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 1);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 2);
  operands[7] = x8;
  x9 = XVECEXP (x3, 0, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  operands[1] = x10;
  x11 = XEXP (x4, 0);
  switch (GET_CODE (x11))
    {
    case REG:
    case SUBREG:
      operands[2] = x11;
      x12 = XEXP (x4, 1);
      operands[3] = x12;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          if (pattern685 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
              || !
#line 3192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8477; /* pred_adcrvvm8qi */

        case E_RVVM4QImode:
          if (pattern685 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
              || !
#line 3192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8478; /* pred_adcrvvm4qi */

        case E_RVVM2QImode:
          if (pattern685 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
              || !
#line 3192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8479; /* pred_adcrvvm2qi */

        case E_RVVM1QImode:
          if (pattern685 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
              || !
#line 3192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8480; /* pred_adcrvvm1qi */

        case E_RVVM8HImode:
          if (pattern685 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
              || !
#line 3192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8481; /* pred_adcrvvm8hi */

        case E_RVVM4HImode:
          if (pattern685 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
              || !
#line 3192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8482; /* pred_adcrvvm4hi */

        case E_RVVM2HImode:
          if (pattern685 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
              || !
#line 3192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8483; /* pred_adcrvvm2hi */

        case E_RVVM1HImode:
          if (pattern685 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
              || !
#line 3192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8484; /* pred_adcrvvm1hi */

        case E_RVVM8SImode:
          if (pattern685 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
              || !
#line 3192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8485; /* pred_adcrvvm8si */

        case E_RVVM4SImode:
          if (pattern685 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
              || !
#line 3192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8486; /* pred_adcrvvm4si */

        case E_RVVM2SImode:
          if (pattern685 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
              || !
#line 3192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8487; /* pred_adcrvvm2si */

        case E_RVVM1SImode:
          if (pattern685 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
              || !
#line 3192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8488; /* pred_adcrvvm1si */

        case E_RVVM8DImode:
          if (pattern685 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 3192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8489; /* pred_adcrvvm8di */

        case E_RVVM4DImode:
          if (pattern685 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 3192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8490; /* pred_adcrvvm4di */

        case E_RVVM2DImode:
          if (pattern685 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 3192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8491; /* pred_adcrvvm2di */

        case E_RVVM1DImode:
          if (pattern685 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 3192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8492; /* pred_adcrvvm1di */

        case E_RVVMF2QImode:
          if (pattern685 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
              || !(
#line 3192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 8493; /* pred_adcrvvmf2qi */

        case E_RVVMF4QImode:
          if (pattern685 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
              || !(
#line 3192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 8494; /* pred_adcrvvmf4qi */

        case E_RVVMF8QImode:
          if (pattern685 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
              || !(
#line 3192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 8495; /* pred_adcrvvmf8qi */

        case E_RVVMF2HImode:
          if (pattern685 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
              || !(
#line 3192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 8496; /* pred_adcrvvmf2hi */

        case E_RVVMF4HImode:
          if (pattern685 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
              || !(
#line 3192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 8497; /* pred_adcrvvmf4hi */

        case E_RVVMF2SImode:
          if (pattern685 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
              || !(
#line 3192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 8498; /* pred_adcrvvmf2si */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x12 = XEXP (x4, 1);
      operands[2] = x12;
      x13 = XEXP (x11, 0);
      switch (GET_CODE (x13))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[3] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8QImode:
              if (pattern697 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode) != 0
                  || !
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8521; /* pred_adcrvvm8qi_scalar */

            case E_RVVM4QImode:
              if (pattern697 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0
                  || !
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8522; /* pred_adcrvvm4qi_scalar */

            case E_RVVM2QImode:
              if (pattern697 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0
                  || !
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8523; /* pred_adcrvvm2qi_scalar */

            case E_RVVM1QImode:
              if (pattern697 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0
                  || !
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8524; /* pred_adcrvvm1qi_scalar */

            case E_RVVMF2QImode:
              if (pattern697 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0
                  || !
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8525; /* pred_adcrvvmf2qi_scalar */

            case E_RVVMF4QImode:
              if (pattern697 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0
                  || !
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8526; /* pred_adcrvvmf4qi_scalar */

            case E_RVVMF8QImode:
              if (pattern697 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8527; /* pred_adcrvvmf8qi_scalar */

            case E_RVVM8HImode:
              if (pattern697 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0
                  || !
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8528; /* pred_adcrvvm8hi_scalar */

            case E_RVVM4HImode:
              if (pattern697 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0
                  || !
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8529; /* pred_adcrvvm4hi_scalar */

            case E_RVVM2HImode:
              if (pattern697 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0
                  || !
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8530; /* pred_adcrvvm2hi_scalar */

            case E_RVVM1HImode:
              if (pattern697 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0
                  || !
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8531; /* pred_adcrvvm1hi_scalar */

            case E_RVVMF2HImode:
              if (pattern697 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0
                  || !
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8532; /* pred_adcrvvmf2hi_scalar */

            case E_RVVMF4HImode:
              if (pattern697 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8533; /* pred_adcrvvmf4hi_scalar */

            case E_RVVM8SImode:
              if (pattern697 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0
                  || !
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8534; /* pred_adcrvvm8si_scalar */

            case E_RVVM4SImode:
              if (pattern697 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0
                  || !
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8535; /* pred_adcrvvm4si_scalar */

            case E_RVVM2SImode:
              if (pattern697 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0
                  || !
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8536; /* pred_adcrvvm2si_scalar */

            case E_RVVM1SImode:
              if (pattern697 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0
                  || !
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8537; /* pred_adcrvvm1si_scalar */

            case E_RVVMF2SImode:
              if (pattern697 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8538; /* pred_adcrvvmf2si_scalar */

            case E_V1QImode:
              if (pattern697 (x2, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 8539; /* pred_adcv1qi_scalar */

            case E_V2QImode:
              if (pattern697 (x2, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 8540; /* pred_adcv2qi_scalar */

            case E_V4QImode:
              if (pattern697 (x2, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 8541; /* pred_adcv4qi_scalar */

            case E_V8QImode:
              if (pattern697 (x2, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 8542; /* pred_adcv8qi_scalar */

            case E_V16QImode:
              if (pattern697 (x2, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 8543; /* pred_adcv16qi_scalar */

            case E_V32QImode:
              if (pattern697 (x2, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 8544; /* pred_adcv32qi_scalar */

            case E_V64QImode:
              if (pattern697 (x2, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 8545; /* pred_adcv64qi_scalar */

            case E_V128QImode:
              if (pattern697 (x2, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 8546; /* pred_adcv128qi_scalar */

            case E_V256QImode:
              if (pattern697 (x2, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 8547; /* pred_adcv256qi_scalar */

            case E_V512QImode:
              if (pattern697 (x2, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 8548; /* pred_adcv512qi_scalar */

            case E_V1024QImode:
              if (pattern697 (x2, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 8549; /* pred_adcv1024qi_scalar */

            case E_V2048QImode:
              if (pattern697 (x2, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 8550; /* pred_adcv2048qi_scalar */

            case E_V4096QImode:
              if (pattern697 (x2, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 8551; /* pred_adcv4096qi_scalar */

            case E_V1HImode:
              if (pattern697 (x2, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 8552; /* pred_adcv1hi_scalar */

            case E_V2HImode:
              if (pattern697 (x2, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 8553; /* pred_adcv2hi_scalar */

            case E_V4HImode:
              if (pattern697 (x2, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 8554; /* pred_adcv4hi_scalar */

            case E_V8HImode:
              if (pattern697 (x2, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 8555; /* pred_adcv8hi_scalar */

            case E_V16HImode:
              if (pattern697 (x2, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 8556; /* pred_adcv16hi_scalar */

            case E_V32HImode:
              if (pattern697 (x2, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 8557; /* pred_adcv32hi_scalar */

            case E_V64HImode:
              if (pattern697 (x2, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 8558; /* pred_adcv64hi_scalar */

            case E_V128HImode:
              if (pattern697 (x2, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 8559; /* pred_adcv128hi_scalar */

            case E_V256HImode:
              if (pattern697 (x2, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 8560; /* pred_adcv256hi_scalar */

            case E_V512HImode:
              if (pattern697 (x2, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 8561; /* pred_adcv512hi_scalar */

            case E_V1024HImode:
              if (pattern697 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 8562; /* pred_adcv1024hi_scalar */

            case E_V2048HImode:
              if (pattern697 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 8563; /* pred_adcv2048hi_scalar */

            case E_V1SImode:
              if (pattern697 (x2, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 8564; /* pred_adcv1si_scalar */

            case E_V2SImode:
              if (pattern697 (x2, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 8565; /* pred_adcv2si_scalar */

            case E_V4SImode:
              if (pattern697 (x2, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 8566; /* pred_adcv4si_scalar */

            case E_V8SImode:
              if (pattern697 (x2, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 8567; /* pred_adcv8si_scalar */

            case E_V16SImode:
              if (pattern697 (x2, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 8568; /* pred_adcv16si_scalar */

            case E_V32SImode:
              if (pattern697 (x2, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 8569; /* pred_adcv32si_scalar */

            case E_V64SImode:
              if (pattern697 (x2, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 8570; /* pred_adcv64si_scalar */

            case E_V128SImode:
              if (pattern697 (x2, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 8571; /* pred_adcv128si_scalar */

            case E_V256SImode:
              if (pattern697 (x2, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 8572; /* pred_adcv256si_scalar */

            case E_V512SImode:
              if (pattern697 (x2, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 8573; /* pred_adcv512si_scalar */

            case E_V1024SImode:
              if (pattern697 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0
                  || !(
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 8574; /* pred_adcv1024si_scalar */

            case E_RVVM8DImode:
              if (pattern698 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
                  || !(
#line 3324 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8629; /* *pred_adcrvvm8di_scalar */

            case E_RVVM4DImode:
              if (pattern698 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
                  || !(
#line 3324 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8630; /* *pred_adcrvvm4di_scalar */

            case E_RVVM2DImode:
              if (pattern698 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
                  || !(
#line 3324 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8631; /* *pred_adcrvvm2di_scalar */

            case E_RVVM1DImode:
              if (pattern698 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 3324 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8632; /* *pred_adcrvvm1di_scalar */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x13) != E_DImode)
            return -1;
          x14 = XEXP (x13, 0);
          operands[3] = x14;
          if (!reg_or_0_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8DImode:
              if (pattern714 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
                  || !(
#line 3350 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8633; /* *pred_adcrvvm8di_extended_scalar */

            case E_RVVM4DImode:
              if (pattern714 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
                  || !(
#line 3350 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8634; /* *pred_adcrvvm4di_extended_scalar */

            case E_RVVM2DImode:
              if (pattern714 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
                  || !(
#line 3350 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8635; /* *pred_adcrvvm2di_extended_scalar */

            case E_RVVM1DImode:
              if (pattern714 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 3350 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8636; /* *pred_adcrvvm1di_extended_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_414 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode) != 0
          || !
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4047; /* *pred_broadcastrvvm8qi */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0
          || !
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4048; /* *pred_broadcastrvvm4qi */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0
          || !
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4049; /* *pred_broadcastrvvm2qi */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0
          || !
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4050; /* *pred_broadcastrvvm1qi */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0
          || !
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4051; /* *pred_broadcastrvvm8hi */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0
          || !
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4052; /* *pred_broadcastrvvm4hi */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0
          || !
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4053; /* *pred_broadcastrvvm2hi */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0
          || !
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4054; /* *pred_broadcastrvvm1hi */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0
          || !
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4055; /* *pred_broadcastrvvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0
          || !
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4056; /* *pred_broadcastrvvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0
          || !
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4057; /* *pred_broadcastrvvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0
          || !
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4058; /* *pred_broadcastrvvm1si */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4059; /* *pred_broadcastrvvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4060; /* *pred_broadcastrvvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4061; /* *pred_broadcastrvvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4062; /* *pred_broadcastrvvm1di */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 4063; /* *pred_broadcastrvvmf2qi */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 4064; /* *pred_broadcastrvvmf4qi */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 4065; /* *pred_broadcastrvvmf8qi */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 4066; /* *pred_broadcastrvvmf2hi */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 4067; /* *pred_broadcastrvvmf4hi */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 4068; /* *pred_broadcastrvvmf2si */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 4069; /* *pred_broadcastv1qi */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 4070; /* *pred_broadcastv2qi */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 4071; /* *pred_broadcastv4qi */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 4072; /* *pred_broadcastv8qi */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 4073; /* *pred_broadcastv16qi */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 4074; /* *pred_broadcastv32qi */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4075; /* *pred_broadcastv64qi */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4076; /* *pred_broadcastv128qi */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4077; /* *pred_broadcastv256qi */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4078; /* *pred_broadcastv512qi */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4079; /* *pred_broadcastv1024qi */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4080; /* *pred_broadcastv2048qi */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4081; /* *pred_broadcastv4096qi */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 4082; /* *pred_broadcastv1hi */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 4083; /* *pred_broadcastv2hi */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 4084; /* *pred_broadcastv4hi */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 4085; /* *pred_broadcastv8hi */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 4086; /* *pred_broadcastv16hi */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4087; /* *pred_broadcastv32hi */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4088; /* *pred_broadcastv64hi */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4089; /* *pred_broadcastv128hi */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4090; /* *pred_broadcastv256hi */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4091; /* *pred_broadcastv512hi */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4092; /* *pred_broadcastv1024hi */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4093; /* *pred_broadcastv2048hi */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 4094; /* *pred_broadcastv1si */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 4095; /* *pred_broadcastv2si */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 4096; /* *pred_broadcastv4si */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 4097; /* *pred_broadcastv8si */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4098; /* *pred_broadcastv16si */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4099; /* *pred_broadcastv32si */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4100; /* *pred_broadcastv64si */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4101; /* *pred_broadcastv128si */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4102; /* *pred_broadcastv256si */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4103; /* *pred_broadcastv512si */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4104; /* *pred_broadcastv1024si */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V1DImode, 
E_V1BImode, 
E_DImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4105; /* *pred_broadcastv1di */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V2DImode, 
E_V2BImode, 
E_DImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4106; /* *pred_broadcastv2di */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4107; /* *pred_broadcastv4di */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V8DImode, 
E_V8BImode, 
E_DImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4108; /* *pred_broadcastv8di */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4109; /* *pred_broadcastv16di */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4110; /* *pred_broadcastv32di */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4111; /* *pred_broadcastv64di */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V128DImode, 
E_V128BImode, 
E_DImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4112; /* *pred_broadcastv128di */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V256DImode, 
E_V256BImode, 
E_DImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4113; /* *pred_broadcastv256di */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0
          || !(
#line 2210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4114; /* *pred_broadcastv512di */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 4115; /* *pred_broadcastrvvm8hf_zvfh */
      if (!(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4169; /* *pred_broadcastrvvm8hf_zvfhmin */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 4116; /* *pred_broadcastrvvm4hf_zvfh */
      if (!(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4170; /* *pred_broadcastrvvm4hf_zvfhmin */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 4117; /* *pred_broadcastrvvm2hf_zvfh */
      if (!(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4171; /* *pred_broadcastrvvm2hf_zvfhmin */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 4118; /* *pred_broadcastrvvm1hf_zvfh */
      if (!(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4172; /* *pred_broadcastrvvm1hf_zvfhmin */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 4119; /* *pred_broadcastrvvmf2hf_zvfh */
      if (!(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4173; /* *pred_broadcastrvvmf2hf_zvfhmin */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return 4120; /* *pred_broadcastrvvmf4hf_zvfh */
      if (!(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4174; /* *pred_broadcastrvvmf4hf_zvfhmin */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode, 
E_SFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4121; /* *pred_broadcastrvvm8sf_zvfh */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4122; /* *pred_broadcastrvvm4sf_zvfh */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4123; /* *pred_broadcastrvvm2sf_zvfh */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4124; /* *pred_broadcastrvvm1sf_zvfh */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4125; /* *pred_broadcastrvvmf2sf_zvfh */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode, 
E_DFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4126; /* *pred_broadcastrvvm8df_zvfh */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode, 
E_DFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4127; /* *pred_broadcastrvvm4df_zvfh */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode, 
E_DFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4128; /* *pred_broadcastrvvm2df_zvfh */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode, 
E_DFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4129; /* *pred_broadcastrvvm1df_zvfh */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return 4130; /* *pred_broadcastv1hf_zvfh */
      if (!(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4184; /* *pred_broadcastv1hf_zvfhmin */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return 4131; /* *pred_broadcastv2hf_zvfh */
      if (!(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4185; /* *pred_broadcastv2hf_zvfhmin */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return 4132; /* *pred_broadcastv4hf_zvfh */
      if (!(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4186; /* *pred_broadcastv4hf_zvfhmin */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return 4133; /* *pred_broadcastv8hf_zvfh */
      if (!(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4187; /* *pred_broadcastv8hf_zvfhmin */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return 4134; /* *pred_broadcastv16hf_zvfh */
      if (!(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4188; /* *pred_broadcastv16hf_zvfhmin */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return 4135; /* *pred_broadcastv32hf_zvfh */
      if (!(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4189; /* *pred_broadcastv32hf_zvfhmin */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return 4136; /* *pred_broadcastv64hf_zvfh */
      if (!(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4190; /* *pred_broadcastv64hf_zvfhmin */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return 4137; /* *pred_broadcastv128hf_zvfh */
      if (!(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4191; /* *pred_broadcastv128hf_zvfhmin */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return 4138; /* *pred_broadcastv256hf_zvfh */
      if (!(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4192; /* *pred_broadcastv256hf_zvfhmin */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return 4139; /* *pred_broadcastv512hf_zvfh */
      if (!(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4193; /* *pred_broadcastv512hf_zvfhmin */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return 4140; /* *pred_broadcastv1024hf_zvfh */
      if (!(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4194; /* *pred_broadcastv1024hf_zvfhmin */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V2048HFmode, 
E_V2048BImode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return 4141; /* *pred_broadcastv2048hf_zvfh */
      if (!(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4195; /* *pred_broadcastv2048hf_zvfhmin */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4142; /* *pred_broadcastv1sf_zvfh */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4143; /* *pred_broadcastv2sf_zvfh */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4144; /* *pred_broadcastv4sf_zvfh */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4145; /* *pred_broadcastv8sf_zvfh */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4146; /* *pred_broadcastv16sf_zvfh */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4147; /* *pred_broadcastv32sf_zvfh */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4148; /* *pred_broadcastv64sf_zvfh */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4149; /* *pred_broadcastv128sf_zvfh */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4150; /* *pred_broadcastv256sf_zvfh */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4151; /* *pred_broadcastv512sf_zvfh */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V1024SFmode, 
E_V1024BImode, 
E_SFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4152; /* *pred_broadcastv1024sf_zvfh */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V1DFmode, 
E_V1BImode, 
E_DFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4153; /* *pred_broadcastv1df_zvfh */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V2DFmode, 
E_V2BImode, 
E_DFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4154; /* *pred_broadcastv2df_zvfh */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V4DFmode, 
E_V4BImode, 
E_DFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4155; /* *pred_broadcastv4df_zvfh */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V8DFmode, 
E_V8BImode, 
E_DFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4156; /* *pred_broadcastv8df_zvfh */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V16DFmode, 
E_V16BImode, 
E_DFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4157; /* *pred_broadcastv16df_zvfh */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V32DFmode, 
E_V32BImode, 
E_DFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4158; /* *pred_broadcastv32df_zvfh */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V64DFmode, 
E_V64BImode, 
E_DFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4159; /* *pred_broadcastv64df_zvfh */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V128DFmode, 
E_V128BImode, 
E_DFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4160; /* *pred_broadcastv128df_zvfh */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V256DFmode, 
E_V256BImode, 
E_DFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4161; /* *pred_broadcastv256df_zvfh */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_V512DFmode, 
E_V512BImode, 
E_DFmode) != 0
          || !(
#line 2271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4162; /* *pred_broadcastv512df_zvfh */

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode, 
E_BFmode) != 0
          || !(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4163; /* *pred_broadcastrvvm8bf_zvfhmin */

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode, 
E_BFmode) != 0
          || !(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 168 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4164; /* *pred_broadcastrvvm4bf_zvfhmin */

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode, 
E_BFmode) != 0
          || !(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4165; /* *pred_broadcastrvvm2bf_zvfhmin */

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode, 
E_BFmode) != 0
          || !(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4166; /* *pred_broadcastrvvm1bf_zvfhmin */

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode, 
E_BFmode) != 0
          || !(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 171 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4167; /* *pred_broadcastrvvmf2bf_zvfhmin */

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern601 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode, 
E_BFmode) != 0
          || !(
#line 2294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 172 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4168; /* *pred_broadcastrvvmf4bf_zvfhmin */

    default:
      return -1;
    }
}

 int
recog_600 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern558 (x2))
    {
    case 0:
      if (!
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8087; /* pred_mulhrvvm8qi */

    case 1:
      if (!
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8090; /* pred_mulhrvvm4qi */

    case 2:
      if (!
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8093; /* pred_mulhrvvm2qi */

    case 3:
      if (!
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8096; /* pred_mulhrvvm1qi */

    case 4:
      if (!
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8099; /* pred_mulhrvvmf2qi */

    case 5:
      if (!
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8102; /* pred_mulhrvvmf4qi */

    case 6:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8105; /* pred_mulhrvvmf8qi */

    case 7:
      if (!
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8108; /* pred_mulhrvvm8hi */

    case 8:
      if (!
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8111; /* pred_mulhrvvm4hi */

    case 9:
      if (!
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8114; /* pred_mulhrvvm2hi */

    case 10:
      if (!
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8117; /* pred_mulhrvvm1hi */

    case 11:
      if (!
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8120; /* pred_mulhrvvmf2hi */

    case 12:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 504 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8123; /* pred_mulhrvvmf4hi */

    case 13:
      if (!
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8126; /* pred_mulhrvvm8si */

    case 14:
      if (!
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8129; /* pred_mulhrvvm4si */

    case 15:
      if (!
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8132; /* pred_mulhrvvm2si */

    case 16:
      if (!
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8135; /* pred_mulhrvvm1si */

    case 17:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 506 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8138; /* pred_mulhrvvmf2si */

    case 18:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8141; /* pred_mulhrvvm8di */

    case 19:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8144; /* pred_mulhrvvm4di */

    case 20:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8147; /* pred_mulhrvvm2di */

    case 21:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8150; /* pred_mulhrvvm1di */

    case 22:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 8153; /* pred_mulhv1qi */

    case 23:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 8156; /* pred_mulhv2qi */

    case 24:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 8159; /* pred_mulhv4qi */

    case 25:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 513 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 8162; /* pred_mulhv8qi */

    case 26:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 514 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 8165; /* pred_mulhv16qi */

    case 27:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 515 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 8168; /* pred_mulhv32qi */

    case 28:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 516 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8171; /* pred_mulhv64qi */

    case 29:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 517 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8174; /* pred_mulhv128qi */

    case 30:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 518 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8177; /* pred_mulhv256qi */

    case 31:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 519 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8180; /* pred_mulhv512qi */

    case 32:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 520 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8183; /* pred_mulhv1024qi */

    case 33:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 521 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8186; /* pred_mulhv2048qi */

    case 34:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8189; /* pred_mulhv4096qi */

    case 35:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 523 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 8192; /* pred_mulhv1hi */

    case 36:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 8195; /* pred_mulhv2hi */

    case 37:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 525 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 8198; /* pred_mulhv4hi */

    case 38:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 526 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 8201; /* pred_mulhv8hi */

    case 39:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 8204; /* pred_mulhv16hi */

    case 40:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8207; /* pred_mulhv32hi */

    case 41:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8210; /* pred_mulhv64hi */

    case 42:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 530 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8213; /* pred_mulhv128hi */

    case 43:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 531 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8216; /* pred_mulhv256hi */

    case 44:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8219; /* pred_mulhv512hi */

    case 45:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8222; /* pred_mulhv1024hi */

    case 46:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 534 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8225; /* pred_mulhv2048hi */

    case 47:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 8228; /* pred_mulhv1si */

    case 48:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 8231; /* pred_mulhv2si */

    case 49:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 537 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 8234; /* pred_mulhv4si */

    case 50:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 538 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 8237; /* pred_mulhv8si */

    case 51:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 539 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8240; /* pred_mulhv16si */

    case 52:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 540 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8243; /* pred_mulhv32si */

    case 53:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 541 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8246; /* pred_mulhv64si */

    case 54:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 542 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8249; /* pred_mulhv128si */

    case 55:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 543 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8252; /* pred_mulhv256si */

    case 56:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8255; /* pred_mulhv512si */

    case 57:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 545 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8258; /* pred_mulhv1024si */

    case 58:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)))
        return -1;
      return 8261; /* pred_mulhv1di */

    case 59:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 547 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)))
        return -1;
      return 8264; /* pred_mulhv2di */

    case 60:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 548 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)))
        return -1;
      return 8267; /* pred_mulhv4di */

    case 61:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 549 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8270; /* pred_mulhv8di */

    case 62:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8273; /* pred_mulhv16di */

    case 63:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 551 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8276; /* pred_mulhv32di */

    case 64:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 552 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8279; /* pred_mulhv64di */

    case 65:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8282; /* pred_mulhv128di */

    case 66:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 554 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8285; /* pred_mulhv256di */

    case 67:
      if (!(
#line 3074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 555 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8288; /* pred_mulhv512di */

    case 68:
      if (!
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8291; /* pred_mulhrvvm8qi_scalar */

    case 69:
      if (!
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8294; /* pred_mulhrvvm4qi_scalar */

    case 70:
      if (!
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8297; /* pred_mulhrvvm2qi_scalar */

    case 71:
      if (!
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8300; /* pred_mulhrvvm1qi_scalar */

    case 72:
      if (!
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8303; /* pred_mulhrvvmf2qi_scalar */

    case 73:
      if (!
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8306; /* pred_mulhrvvmf4qi_scalar */

    case 74:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8309; /* pred_mulhrvvmf8qi_scalar */

    case 75:
      if (!
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8312; /* pred_mulhrvvm8hi_scalar */

    case 76:
      if (!
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8315; /* pred_mulhrvvm4hi_scalar */

    case 77:
      if (!
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8318; /* pred_mulhrvvm2hi_scalar */

    case 78:
      if (!
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8321; /* pred_mulhrvvm1hi_scalar */

    case 79:
      if (!
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8324; /* pred_mulhrvvmf2hi_scalar */

    case 80:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8327; /* pred_mulhrvvmf4hi_scalar */

    case 81:
      if (!
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8330; /* pred_mulhrvvm8si_scalar */

    case 82:
      if (!
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8333; /* pred_mulhrvvm4si_scalar */

    case 83:
      if (!
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8336; /* pred_mulhrvvm2si_scalar */

    case 84:
      if (!
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8339; /* pred_mulhrvvm1si_scalar */

    case 85:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8342; /* pred_mulhrvvmf2si_scalar */

    case 86:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 8345; /* pred_mulhv1qi_scalar */

    case 87:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 8348; /* pred_mulhv2qi_scalar */

    case 88:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 8351; /* pred_mulhv4qi_scalar */

    case 89:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 8354; /* pred_mulhv8qi_scalar */

    case 90:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 8357; /* pred_mulhv16qi_scalar */

    case 91:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 8360; /* pred_mulhv32qi_scalar */

    case 92:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8363; /* pred_mulhv64qi_scalar */

    case 93:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8366; /* pred_mulhv128qi_scalar */

    case 94:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8369; /* pred_mulhv256qi_scalar */

    case 95:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8372; /* pred_mulhv512qi_scalar */

    case 96:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8375; /* pred_mulhv1024qi_scalar */

    case 97:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8378; /* pred_mulhv2048qi_scalar */

    case 98:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8381; /* pred_mulhv4096qi_scalar */

    case 99:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 8384; /* pred_mulhv1hi_scalar */

    case 100:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 8387; /* pred_mulhv2hi_scalar */

    case 101:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 8390; /* pred_mulhv4hi_scalar */

    case 102:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 8393; /* pred_mulhv8hi_scalar */

    case 103:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 8396; /* pred_mulhv16hi_scalar */

    case 104:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8399; /* pred_mulhv32hi_scalar */

    case 105:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8402; /* pred_mulhv64hi_scalar */

    case 106:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8405; /* pred_mulhv128hi_scalar */

    case 107:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8408; /* pred_mulhv256hi_scalar */

    case 108:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8411; /* pred_mulhv512hi_scalar */

    case 109:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8414; /* pred_mulhv1024hi_scalar */

    case 110:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8417; /* pred_mulhv2048hi_scalar */

    case 111:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 8420; /* pred_mulhv1si_scalar */

    case 112:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 8423; /* pred_mulhv2si_scalar */

    case 113:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 8426; /* pred_mulhv4si_scalar */

    case 114:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 8429; /* pred_mulhv8si_scalar */

    case 115:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8432; /* pred_mulhv16si_scalar */

    case 116:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8435; /* pred_mulhv32si_scalar */

    case 117:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8438; /* pred_mulhv64si_scalar */

    case 118:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8441; /* pred_mulhv128si_scalar */

    case 119:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8444; /* pred_mulhv256si_scalar */

    case 120:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8447; /* pred_mulhv512si_scalar */

    case 121:
      if (!(
#line 3095 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8450; /* pred_mulhv1024si_scalar */

    case 122:
      if (!(
#line 3149 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 790 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8453; /* *pred_mulhrvvm8di_scalar */

    case 123:
      if (!(
#line 3149 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 790 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8456; /* *pred_mulhrvvm4di_scalar */

    case 124:
      if (!(
#line 3149 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 791 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8459; /* *pred_mulhrvvm2di_scalar */

    case 125:
      if (!(
#line 3149 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 791 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8462; /* *pred_mulhrvvm1di_scalar */

    case 126:
      if (!(
#line 3171 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 790 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8465; /* *pred_mulhrvvm8di_extended_scalar */

    case 127:
      if (!(
#line 3171 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 790 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8468; /* *pred_mulhrvvm4di_extended_scalar */

    case 128:
      if (!(
#line 3171 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 791 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8471; /* *pred_mulhrvvm2di_extended_scalar */

    case 129:
      if (!(
#line 3171 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 791 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8474; /* *pred_mulhrvvm1di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_607 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[6] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[7] = x7;
  x8 = XEXP (x2, 1);
  switch (XINT (x8, 1))
    {
    case 119:
      x9 = XVECEXP (x8, 0, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          if (pattern670 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
              || !
#line 6152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14408; /* pred_iotarvvm8qi */

        case E_RVVM4QImode:
          if (pattern670 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
              || !
#line 6152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14409; /* pred_iotarvvm4qi */

        case E_RVVM2QImode:
          if (pattern670 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
              || !
#line 6152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14410; /* pred_iotarvvm2qi */

        case E_RVVM1QImode:
          if (pattern670 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
              || !
#line 6152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14411; /* pred_iotarvvm1qi */

        case E_RVVM8HImode:
          if (pattern670 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
              || !
#line 6152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14412; /* pred_iotarvvm8hi */

        case E_RVVM4HImode:
          if (pattern670 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
              || !
#line 6152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14413; /* pred_iotarvvm4hi */

        case E_RVVM2HImode:
          if (pattern670 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
              || !
#line 6152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14414; /* pred_iotarvvm2hi */

        case E_RVVM1HImode:
          if (pattern670 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
              || !
#line 6152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14415; /* pred_iotarvvm1hi */

        case E_RVVM8SImode:
          if (pattern670 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
              || !
#line 6152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14416; /* pred_iotarvvm8si */

        case E_RVVM4SImode:
          if (pattern670 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
              || !
#line 6152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14417; /* pred_iotarvvm4si */

        case E_RVVM2SImode:
          if (pattern670 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
              || !
#line 6152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14418; /* pred_iotarvvm2si */

        case E_RVVM1SImode:
          if (pattern670 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
              || !
#line 6152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14419; /* pred_iotarvvm1si */

        case E_RVVM8DImode:
          if (pattern670 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 6152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14420; /* pred_iotarvvm8di */

        case E_RVVM4DImode:
          if (pattern670 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 6152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14421; /* pred_iotarvvm4di */

        case E_RVVM2DImode:
          if (pattern670 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 6152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14422; /* pred_iotarvvm2di */

        case E_RVVM1DImode:
          if (pattern670 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 6152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14423; /* pred_iotarvvm1di */

        case E_RVVMF2QImode:
          if (pattern670 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
              || !(
#line 6152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 14424; /* pred_iotarvvmf2qi */

        case E_RVVMF4QImode:
          if (pattern670 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
              || !(
#line 6152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 14425; /* pred_iotarvvmf4qi */

        case E_RVVMF8QImode:
          if (pattern670 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
              || !(
#line 6152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 14426; /* pred_iotarvvmf8qi */

        case E_RVVMF2HImode:
          if (pattern670 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
              || !(
#line 6152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 14427; /* pred_iotarvvmf2hi */

        case E_RVVMF4HImode:
          if (pattern670 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
              || !(
#line 6152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 14428; /* pred_iotarvvmf4hi */

        case E_RVVMF2SImode:
          if (pattern670 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
              || !(
#line 6152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 14429; /* pred_iotarvvmf2si */

        default:
          return -1;
        }

    case 120:
      x9 = XVECEXP (x8, 0, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern603 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
              || !(
#line 6963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16358; /* pred_rsqrt7rvvm8hf */

        case E_RVVM4HFmode:
          if (pattern603 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
              || !(
#line 6963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16359; /* pred_rsqrt7rvvm4hf */

        case E_RVVM2HFmode:
          if (pattern603 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 6963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16360; /* pred_rsqrt7rvvm2hf */

        case E_RVVM1HFmode:
          if (pattern603 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 6963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16361; /* pred_rsqrt7rvvm1hf */

        case E_RVVMF2HFmode:
          if (pattern603 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 6963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16362; /* pred_rsqrt7rvvmf2hf */

        case E_RVVMF4HFmode:
          if (pattern603 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 6963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 16363; /* pred_rsqrt7rvvmf4hf */

        case E_RVVM8SFmode:
          if (pattern603 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
              || !(
#line 6963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16364; /* pred_rsqrt7rvvm8sf */

        case E_RVVM4SFmode:
          if (pattern603 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 6963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16365; /* pred_rsqrt7rvvm4sf */

        case E_RVVM2SFmode:
          if (pattern603 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 6963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16366; /* pred_rsqrt7rvvm2sf */

        case E_RVVM1SFmode:
          if (pattern603 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 6963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16367; /* pred_rsqrt7rvvm1sf */

        case E_RVVMF2SFmode:
          if (pattern603 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 6963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 16368; /* pred_rsqrt7rvvmf2sf */

        case E_RVVM8DFmode:
          if (pattern603 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 6963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16369; /* pred_rsqrt7rvvm8df */

        case E_RVVM4DFmode:
          if (pattern603 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 6963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16370; /* pred_rsqrt7rvvm4df */

        case E_RVVM2DFmode:
          if (pattern603 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 6963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16371; /* pred_rsqrt7rvvm2df */

        case E_RVVM1DFmode:
          if (pattern603 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 6963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16372; /* pred_rsqrt7rvvm1df */

        default:
          return -1;
        }

    case 122:
      x9 = XVECEXP (x8, 0, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern671 (x2, 
E_RVVM8HImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
              || !(
#line 7005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16388; /* pred_classrvvm8hf */

        case E_RVVM4HImode:
          if (pattern671 (x2, 
E_RVVM4HImode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
              || !(
#line 7005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16389; /* pred_classrvvm4hf */

        case E_RVVM2HImode:
          if (pattern671 (x2, 
E_RVVM2HImode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 7005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16390; /* pred_classrvvm2hf */

        case E_RVVM1HImode:
          if (pattern671 (x2, 
E_RVVM1HImode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 7005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16391; /* pred_classrvvm1hf */

        case E_RVVMF2HImode:
          if (pattern671 (x2, 
E_RVVMF2HImode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 7005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16392; /* pred_classrvvmf2hf */

        case E_RVVMF4HImode:
          if (pattern671 (x2, 
E_RVVMF4HImode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 7005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 16393; /* pred_classrvvmf4hf */

        case E_RVVM8SImode:
          if (pattern671 (x2, 
E_RVVM8SImode, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
              || !(
#line 7005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16394; /* pred_classrvvm8sf */

        case E_RVVM4SImode:
          if (pattern671 (x2, 
E_RVVM4SImode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 7005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16395; /* pred_classrvvm4sf */

        case E_RVVM2SImode:
          if (pattern671 (x2, 
E_RVVM2SImode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 7005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16396; /* pred_classrvvm2sf */

        case E_RVVM1SImode:
          if (pattern671 (x2, 
E_RVVM1SImode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 7005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16397; /* pred_classrvvm1sf */

        case E_RVVMF2SImode:
          if (pattern671 (x2, 
E_RVVMF2SImode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 7005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 16398; /* pred_classrvvmf2sf */

        case E_RVVM8DImode:
          if (pattern671 (x2, 
E_RVVM8DImode, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 7005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16399; /* pred_classrvvm8df */

        case E_RVVM4DImode:
          if (pattern671 (x2, 
E_RVVM4DImode, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 7005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16400; /* pred_classrvvm4df */

        case E_RVVM2DImode:
          if (pattern671 (x2, 
E_RVVM2DImode, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 7005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16401; /* pred_classrvvm2df */

        case E_RVVM1DImode:
          if (pattern671 (x2, 
E_RVVM1DImode, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 7005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16402; /* pred_classrvvm1df */

        default:
          return -1;
        }

    case 127:
      x9 = XVECEXP (x8, 0, 0);
      if (GET_CODE (x9) != FLOAT_TRUNCATE)
        return -1;
      x10 = XEXP (x9, 0);
      operands[3] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4HFmode:
          if (pattern689 (x2, 
E_RVVM4HFmode, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 990 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18095; /* pred_rod_truncrvvm8sf */

        case E_RVVM2HFmode:
          if (pattern689 (x2, 
E_RVVM2HFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 991 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18096; /* pred_rod_truncrvvm4sf */

        case E_RVVM1HFmode:
          if (pattern689 (x2, 
E_RVVM1HFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 992 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18097; /* pred_rod_truncrvvm2sf */

        case E_RVVMF2HFmode:
          if (pattern689 (x2, 
E_RVVMF2HFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 993 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18098; /* pred_rod_truncrvvm1sf */

        case E_RVVMF4HFmode:
          if (pattern689 (x2, 
E_RVVMF4HFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 994 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18099; /* pred_rod_truncrvvmf2sf */

        case E_RVVM4SFmode:
          if (pattern689 (x2, 
E_RVVM4SFmode, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 996 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18100; /* pred_rod_truncrvvm8df */

        case E_RVVM2SFmode:
          if (pattern689 (x2, 
E_RVVM2SFmode, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 996 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18101; /* pred_rod_truncrvvm4df */

        case E_RVVM1SFmode:
          if (pattern689 (x2, 
E_RVVM1SFmode, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 997 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18102; /* pred_rod_truncrvvm2df */

        case E_RVVMF2SFmode:
          if (pattern689 (x2, 
E_RVVMF2SFmode, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 997 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18103; /* pred_rod_truncrvvm1df */

        case E_V1HFmode:
          if (pattern689 (x2, 
E_V1HFmode, 
E_V1SFmode, 
E_V1BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 999 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18104; /* pred_rod_truncv1sf */

        case E_V2HFmode:
          if (pattern689 (x2, 
E_V2HFmode, 
E_V2SFmode, 
E_V2BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1000 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18105; /* pred_rod_truncv2sf */

        case E_V4HFmode:
          if (pattern689 (x2, 
E_V4HFmode, 
E_V4SFmode, 
E_V4BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1001 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18106; /* pred_rod_truncv4sf */

        case E_V8HFmode:
          if (pattern689 (x2, 
E_V8HFmode, 
E_V8SFmode, 
E_V8BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1002 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18107; /* pred_rod_truncv8sf */

        case E_V16HFmode:
          if (pattern689 (x2, 
E_V16HFmode, 
E_V16SFmode, 
E_V16BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1003 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18108; /* pred_rod_truncv16sf */

        case E_V32HFmode:
          if (pattern689 (x2, 
E_V32HFmode, 
E_V32SFmode, 
E_V32BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1004 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18109; /* pred_rod_truncv32sf */

        case E_V64HFmode:
          if (pattern689 (x2, 
E_V64HFmode, 
E_V64SFmode, 
E_V64BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18110; /* pred_rod_truncv64sf */

        case E_V128HFmode:
          if (pattern689 (x2, 
E_V128HFmode, 
E_V128SFmode, 
E_V128BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1006 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18111; /* pred_rod_truncv128sf */

        case E_V256HFmode:
          if (pattern689 (x2, 
E_V256HFmode, 
E_V256SFmode, 
E_V256BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1007 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18112; /* pred_rod_truncv256sf */

        case E_V512HFmode:
          if (pattern689 (x2, 
E_V512HFmode, 
E_V512SFmode, 
E_V512BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1008 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18113; /* pred_rod_truncv512sf */

        case E_V1024HFmode:
          if (pattern689 (x2, 
E_V1024HFmode, 
E_V1024SFmode, 
E_V1024BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1009 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18114; /* pred_rod_truncv1024sf */

        case E_V1SFmode:
          if (pattern689 (x2, 
E_V1SFmode, 
E_V1DFmode, 
E_V1BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1010 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18115; /* pred_rod_truncv1df */

        case E_V2SFmode:
          if (pattern689 (x2, 
E_V2SFmode, 
E_V2DFmode, 
E_V2BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1011 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18116; /* pred_rod_truncv2df */

        case E_V4SFmode:
          if (pattern689 (x2, 
E_V4SFmode, 
E_V4DFmode, 
E_V4BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1012 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18117; /* pred_rod_truncv4df */

        case E_V8SFmode:
          if (pattern689 (x2, 
E_V8SFmode, 
E_V8DFmode, 
E_V8BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1013 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18118; /* pred_rod_truncv8df */

        case E_V16SFmode:
          if (pattern689 (x2, 
E_V16SFmode, 
E_V16DFmode, 
E_V16BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1014 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18119; /* pred_rod_truncv16df */

        case E_V32SFmode:
          if (pattern689 (x2, 
E_V32SFmode, 
E_V32DFmode, 
E_V32BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1015 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18120; /* pred_rod_truncv32df */

        case E_V64SFmode:
          if (pattern689 (x2, 
E_V64SFmode, 
E_V64DFmode, 
E_V64BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1016 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18121; /* pred_rod_truncv64df */

        case E_V128SFmode:
          if (pattern689 (x2, 
E_V128SFmode, 
E_V128DFmode, 
E_V128BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1017 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18122; /* pred_rod_truncv128df */

        case E_V256SFmode:
          if (pattern689 (x2, 
E_V256SFmode, 
E_V256DFmode, 
E_V256BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1018 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18123; /* pred_rod_truncv256df */

        case E_V512SFmode:
          if (pattern689 (x2, 
E_V512SFmode, 
E_V512DFmode, 
E_V512BImode) != 0
              || !(
#line 7745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1019 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18124; /* pred_rod_truncv512df */

        default:
          return -1;
        }

    case 196:
      return recog_605 (x1, insn, pnum_clobbers);

    case 197:
      return recog_604 (x1, insn, pnum_clobbers);

    case 198:
      return recog_603 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_689 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V256SImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_664 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V256SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return 13204; /* *pred_maddv256si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13272; /* *pred_maccv256si */
}

 int
recog_696 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V2SImode, 
E_V2BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_657 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V2SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 13197; /* *pred_maddv2si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 13265; /* *pred_maccv2si */
}

 int
recog_703 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V64HImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_650 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V64HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return 13190; /* *pred_maddv64hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13258; /* *pred_maccv64hi */
}

 int
recog_710 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_643 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V4096QImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4096QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
    return 13183; /* *pred_maddv4096qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13251; /* *pred_maccv4096qi */
}

 int
recog_717 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 13352; /* *pred_maddv512di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13420; /* *pred_maccv512di_scalar */
}

 int
recog_724 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 13345; /* *pred_maddv4di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13413; /* *pred_maccv4di_scalar */
}

 int
recog_731 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 13338; /* *pred_maddv64si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13406; /* *pred_maccv64si_scalar */
}

 int
recog_738 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return 13331; /* *pred_maddv2048hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13399; /* *pred_maccv2048hi_scalar */
}

 int
recog_745 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return 13324; /* *pred_maddv16hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return -1;
  return 13392; /* *pred_maccv16hi_scalar */
}

 int
recog_752 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      return recog_748 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          return recog_746 (x1, insn, pnum_clobbers);

        case SIGN_EXTEND:
          if (GET_MODE (x13) != E_DImode)
            return -1;
          x14 = XEXP (x13, 0);
          operands[2] = x14;
          if (!reg_or_0_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8DImode:
              if (pattern720 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return 13421; /* *pred_maddrvvm8di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13435; /* *pred_maccrvvm8di_extended_scalar */

            case E_RVVM4DImode:
              if (pattern720 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return 13422; /* *pred_maddrvvm4di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13436; /* *pred_maccrvvm4di_extended_scalar */

            case E_RVVM2DImode:
              if (pattern720 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return 13423; /* *pred_maddrvvm2di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13437; /* *pred_maccrvvm2di_extended_scalar */

            case E_RVVM1DImode:
              if (pattern720 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return 13424; /* *pred_maddrvvm1di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13438; /* *pred_maccrvvm1di_extended_scalar */

            case E_V1DImode:
              if (pattern720 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return 13425; /* *pred_maddv1di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13439; /* *pred_maccv1di_extended_scalar */

            case E_V2DImode:
              if (pattern720 (x2, 
E_V2DImode, 
E_V2BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return 13426; /* *pred_maddv2di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13440; /* *pred_maccv2di_extended_scalar */

            case E_V4DImode:
              if (pattern720 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return 13427; /* *pred_maddv4di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13441; /* *pred_maccv4di_extended_scalar */

            case E_V8DImode:
              if (pattern720 (x2, 
E_V8DImode, 
E_V8BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return 13428; /* *pred_maddv8di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 13442; /* *pred_maccv8di_extended_scalar */

            case E_V16DImode:
              if (pattern720 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return 13429; /* *pred_maddv16di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 13443; /* *pred_maccv16di_extended_scalar */

            case E_V32DImode:
              if (pattern720 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return 13430; /* *pred_maddv32di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 13444; /* *pred_maccv32di_extended_scalar */

            case E_V64DImode:
              if (pattern720 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return 13431; /* *pred_maddv64di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 13445; /* *pred_maccv64di_extended_scalar */

            case E_V128DImode:
              if (pattern720 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return 13432; /* *pred_maddv128di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 13446; /* *pred_maccv128di_extended_scalar */

            case E_V256DImode:
              if (pattern720 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return 13433; /* *pred_maddv256di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 13447; /* *pred_maccv256di_extended_scalar */

            case E_V512DImode:
              if (pattern720 (x2, 
E_V512DImode, 
E_V512BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return 13434; /* *pred_maddv512di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 13448; /* *pred_maccv512di_extended_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x12 = XEXP (x3, 1);
      operands[2] = x12;
      x15 = XEXP (x2, 2);
      if (!rtx_equal_p (x15, operands[2]))
        return -1;
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case REG:
        case SUBREG:
          return recog_747 (x1, insn, pnum_clobbers);

        case VEC_DUPLICATE:
          x14 = XEXP (x13, 0);
          operands[3] = x14;
          x11 = XEXP (x4, 1);
          switch (GET_CODE (x11))
            {
            case SIGN_EXTEND:
              switch (pattern705 (x2))
                {
                case 0:
                  if (!
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13913; /* pred_widen_mul_plussrvvm8hi_scalar */

                case 1:
                  if (!
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13915; /* pred_widen_mul_plussrvvm4hi_scalar */

                case 2:
                  if (!
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13917; /* pred_widen_mul_plussrvvm2hi_scalar */

                case 3:
                  if (!
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13919; /* pred_widen_mul_plussrvvm1hi_scalar */

                case 4:
                  if (!
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13921; /* pred_widen_mul_plussrvvmf2hi_scalar */

                case 5:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13923; /* pred_widen_mul_plussrvvmf4hi_scalar */

                case 6:
                  if (!
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13925; /* pred_widen_mul_plussrvvm8si_scalar */

                case 7:
                  if (!
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13927; /* pred_widen_mul_plussrvvm4si_scalar */

                case 8:
                  if (!
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13929; /* pred_widen_mul_plussrvvm2si_scalar */

                case 9:
                  if (!
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13931; /* pred_widen_mul_plussrvvm1si_scalar */

                case 10:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13933; /* pred_widen_mul_plussrvvmf2si_scalar */

                case 11:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13935; /* pred_widen_mul_plussrvvm8di_scalar */

                case 12:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13937; /* pred_widen_mul_plussrvvm4di_scalar */

                case 13:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13939; /* pred_widen_mul_plussrvvm2di_scalar */

                case 14:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13941; /* pred_widen_mul_plussrvvm1di_scalar */

                case 15:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                    return -1;
                  return 13943; /* pred_widen_mul_plussv1hi_scalar */

                case 16:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                    return -1;
                  return 13945; /* pred_widen_mul_plussv2hi_scalar */

                case 17:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                    return -1;
                  return 13947; /* pred_widen_mul_plussv4hi_scalar */

                case 18:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                    return -1;
                  return 13949; /* pred_widen_mul_plussv8hi_scalar */

                case 19:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                    return -1;
                  return 13951; /* pred_widen_mul_plussv16hi_scalar */

                case 20:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 13953; /* pred_widen_mul_plussv32hi_scalar */

                case 21:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 13955; /* pred_widen_mul_plussv64hi_scalar */

                case 22:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 13957; /* pred_widen_mul_plussv128hi_scalar */

                case 23:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 13959; /* pred_widen_mul_plussv256hi_scalar */

                case 24:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 13961; /* pred_widen_mul_plussv512hi_scalar */

                case 25:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 13963; /* pred_widen_mul_plussv1024hi_scalar */

                case 26:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 13965; /* pred_widen_mul_plussv2048hi_scalar */

                case 27:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                    return -1;
                  return 13967; /* pred_widen_mul_plussv1si_scalar */

                case 28:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                    return -1;
                  return 13969; /* pred_widen_mul_plussv2si_scalar */

                case 29:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                    return -1;
                  return 13971; /* pred_widen_mul_plussv4si_scalar */

                case 30:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                    return -1;
                  return 13973; /* pred_widen_mul_plussv8si_scalar */

                case 31:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 13975; /* pred_widen_mul_plussv16si_scalar */

                case 32:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 13977; /* pred_widen_mul_plussv32si_scalar */

                case 33:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 13979; /* pred_widen_mul_plussv64si_scalar */

                case 34:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 13981; /* pred_widen_mul_plussv128si_scalar */

                case 35:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 13983; /* pred_widen_mul_plussv256si_scalar */

                case 36:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 13985; /* pred_widen_mul_plussv512si_scalar */

                case 37:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 13987; /* pred_widen_mul_plussv1024si_scalar */

                case 38:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13989; /* pred_widen_mul_plussv1di_scalar */

                case 39:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13991; /* pred_widen_mul_plussv2di_scalar */

                case 40:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13993; /* pred_widen_mul_plussv4di_scalar */

                case 41:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 13995; /* pred_widen_mul_plussv8di_scalar */

                case 42:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 13997; /* pred_widen_mul_plussv16di_scalar */

                case 43:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 13999; /* pred_widen_mul_plussv32di_scalar */

                case 44:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 14001; /* pred_widen_mul_plussv64di_scalar */

                case 45:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 14003; /* pred_widen_mul_plussv128di_scalar */

                case 46:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 14005; /* pred_widen_mul_plussv256di_scalar */

                case 47:
                  if (!(
#line 5909 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 14007; /* pred_widen_mul_plussv512di_scalar */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern705 (x2))
                {
                case 0:
                  if (!
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14057; /* pred_widen_mul_plussurvvm8hi_scalar */

                case 1:
                  if (!
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14058; /* pred_widen_mul_plussurvvm4hi_scalar */

                case 2:
                  if (!
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14059; /* pred_widen_mul_plussurvvm2hi_scalar */

                case 3:
                  if (!
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14060; /* pred_widen_mul_plussurvvm1hi_scalar */

                case 4:
                  if (!
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14061; /* pred_widen_mul_plussurvvmf2hi_scalar */

                case 5:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14062; /* pred_widen_mul_plussurvvmf4hi_scalar */

                case 6:
                  if (!
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14063; /* pred_widen_mul_plussurvvm8si_scalar */

                case 7:
                  if (!
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14064; /* pred_widen_mul_plussurvvm4si_scalar */

                case 8:
                  if (!
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14065; /* pred_widen_mul_plussurvvm2si_scalar */

                case 9:
                  if (!
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14066; /* pred_widen_mul_plussurvvm1si_scalar */

                case 10:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14067; /* pred_widen_mul_plussurvvmf2si_scalar */

                case 11:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14068; /* pred_widen_mul_plussurvvm8di_scalar */

                case 12:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14069; /* pred_widen_mul_plussurvvm4di_scalar */

                case 13:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14070; /* pred_widen_mul_plussurvvm2di_scalar */

                case 14:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14071; /* pred_widen_mul_plussurvvm1di_scalar */

                case 15:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                    return -1;
                  return 14072; /* pred_widen_mul_plussuv1hi_scalar */

                case 16:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                    return -1;
                  return 14073; /* pred_widen_mul_plussuv2hi_scalar */

                case 17:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                    return -1;
                  return 14074; /* pred_widen_mul_plussuv4hi_scalar */

                case 18:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                    return -1;
                  return 14075; /* pred_widen_mul_plussuv8hi_scalar */

                case 19:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                    return -1;
                  return 14076; /* pred_widen_mul_plussuv16hi_scalar */

                case 20:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 14077; /* pred_widen_mul_plussuv32hi_scalar */

                case 21:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 14078; /* pred_widen_mul_plussuv64hi_scalar */

                case 22:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 14079; /* pred_widen_mul_plussuv128hi_scalar */

                case 23:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 14080; /* pred_widen_mul_plussuv256hi_scalar */

                case 24:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 14081; /* pred_widen_mul_plussuv512hi_scalar */

                case 25:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 14082; /* pred_widen_mul_plussuv1024hi_scalar */

                case 26:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 14083; /* pred_widen_mul_plussuv2048hi_scalar */

                case 27:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                    return -1;
                  return 14084; /* pred_widen_mul_plussuv1si_scalar */

                case 28:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                    return -1;
                  return 14085; /* pred_widen_mul_plussuv2si_scalar */

                case 29:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                    return -1;
                  return 14086; /* pred_widen_mul_plussuv4si_scalar */

                case 30:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                    return -1;
                  return 14087; /* pred_widen_mul_plussuv8si_scalar */

                case 31:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 14088; /* pred_widen_mul_plussuv16si_scalar */

                case 32:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 14089; /* pred_widen_mul_plussuv32si_scalar */

                case 33:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 14090; /* pred_widen_mul_plussuv64si_scalar */

                case 34:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 14091; /* pred_widen_mul_plussuv128si_scalar */

                case 35:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 14092; /* pred_widen_mul_plussuv256si_scalar */

                case 36:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 14093; /* pred_widen_mul_plussuv512si_scalar */

                case 37:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 14094; /* pred_widen_mul_plussuv1024si_scalar */

                case 38:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14095; /* pred_widen_mul_plussuv1di_scalar */

                case 39:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14096; /* pred_widen_mul_plussuv2di_scalar */

                case 40:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14097; /* pred_widen_mul_plussuv4di_scalar */

                case 41:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 14098; /* pred_widen_mul_plussuv8di_scalar */

                case 42:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 14099; /* pred_widen_mul_plussuv16di_scalar */

                case 43:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 14100; /* pred_widen_mul_plussuv32di_scalar */

                case 44:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 14101; /* pred_widen_mul_plussuv64di_scalar */

                case 45:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 14102; /* pred_widen_mul_plussuv128di_scalar */

                case 46:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 14103; /* pred_widen_mul_plussuv256di_scalar */

                case 47:
                  if (!(
#line 5958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 14104; /* pred_widen_mul_plussuv512di_scalar */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      return recog_749 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_769 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V64SImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V64SImode) == 0
      && (
#line 5613 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 13502; /* *pred_minus_mulv64si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V64SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V64SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 13570; /* *pred_nmsubv64si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13638; /* *pred_nmsacv64si */
}

 int
recog_772 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V8SImode, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V8SImode) == 0
      && (
#line 5613 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return 13499; /* *pred_minus_mulv8si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V8SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V8SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return 13567; /* *pred_nmsubv8si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return -1;
  return 13635; /* *pred_nmsacv8si */
}

 int
recog_775 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V1SImode, 
E_V1BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V1SImode) == 0
      && (
#line 5613 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return 13496; /* *pred_minus_mulv1si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V1SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V1SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return 13564; /* *pred_nmsubv1si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return -1;
  return 13632; /* *pred_nmsacv1si */
}

 int
recog_780 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V128HImode, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V128HImode) == 0
      && (
#line 5613 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return 13491; /* *pred_minus_mulv128hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V128HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V128HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return 13559; /* *pred_nmsubv128hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13627; /* *pred_nmsacv128hi */
}

 int
recog_786 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V2HImode, 
E_V2BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V2HImode) == 0
      && (
#line 5613 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return 13485; /* *pred_minus_mulv2hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V2HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return 13553; /* *pred_nmsubv2hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return -1;
  return 13621; /* *pred_nmsacv2hi */
}

 int
recog_792 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V256QImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V256QImode) == 0
      && (
#line 5613 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return 13479; /* *pred_minus_mulv256qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V256QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V256QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return 13547; /* *pred_nmsubv256qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13615; /* *pred_nmsacv256qi */
}

 int
recog_800 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V1QImode, 
E_V1BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V1QImode) == 0
      && (
#line 5613 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return 13471; /* *pred_minus_mulv1qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V1QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V1QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return 13539; /* *pred_nmsubv1qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return -1;
  return 13607; /* *pred_nmsacv1qi */
}

 int
recog_808 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 13716; /* *pred_nmsubv32di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13784; /* *pred_nmsacv32di_scalar */
}

 int
recog_815 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 13709; /* *pred_nmsubv512si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13777; /* *pred_nmsacv512si_scalar */
}

 int
recog_823 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 13701; /* *pred_nmsubv2si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 13769; /* *pred_nmsacv2si_scalar */
}

 int
recog_831 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return 13693; /* *pred_nmsubv32hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13761; /* *pred_nmsacv32hi_scalar */
}

 int
recog_840 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[4] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          if (pattern707 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode) != 0
              || !
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32657; /* pred_vandnrvvm8qi_scalar */

        case E_RVVM4QImode:
          if (pattern707 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0
              || !
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32658; /* pred_vandnrvvm4qi_scalar */

        case E_RVVM2QImode:
          if (pattern707 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0
              || !
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32659; /* pred_vandnrvvm2qi_scalar */

        case E_RVVM1QImode:
          if (pattern707 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0
              || !
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32660; /* pred_vandnrvvm1qi_scalar */

        case E_RVVMF2QImode:
          if (pattern707 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0
              || !
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32661; /* pred_vandnrvvmf2qi_scalar */

        case E_RVVMF4QImode:
          if (pattern707 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0
              || !
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32662; /* pred_vandnrvvmf4qi_scalar */

        case E_RVVMF8QImode:
          if (pattern707 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 724 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32663; /* pred_vandnrvvmf8qi_scalar */

        case E_RVVM8HImode:
          if (pattern707 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0
              || !
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32664; /* pred_vandnrvvm8hi_scalar */

        case E_RVVM4HImode:
          if (pattern707 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0
              || !
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32665; /* pred_vandnrvvm4hi_scalar */

        case E_RVVM2HImode:
          if (pattern707 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0
              || !
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32666; /* pred_vandnrvvm2hi_scalar */

        case E_RVVM1HImode:
          if (pattern707 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0
              || !
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32667; /* pred_vandnrvvm1hi_scalar */

        case E_RVVMF2HImode:
          if (pattern707 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0
              || !
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32668; /* pred_vandnrvvmf2hi_scalar */

        case E_RVVMF4HImode:
          if (pattern707 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 726 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32669; /* pred_vandnrvvmf4hi_scalar */

        case E_RVVM8SImode:
          if (pattern707 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0
              || !
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32670; /* pred_vandnrvvm8si_scalar */

        case E_RVVM4SImode:
          if (pattern707 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0
              || !
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32671; /* pred_vandnrvvm4si_scalar */

        case E_RVVM2SImode:
          if (pattern707 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0
              || !
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32672; /* pred_vandnrvvm2si_scalar */

        case E_RVVM1SImode:
          if (pattern707 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0
              || !
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32673; /* pred_vandnrvvm1si_scalar */

        case E_RVVMF2SImode:
          if (pattern707 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 728 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32674; /* pred_vandnrvvmf2si_scalar */

        case E_V1QImode:
          if (pattern707 (x2, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 730 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 32675; /* pred_vandnv1qi_scalar */

        case E_V2QImode:
          if (pattern707 (x2, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 731 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 32676; /* pred_vandnv2qi_scalar */

        case E_V4QImode:
          if (pattern707 (x2, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 732 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 32677; /* pred_vandnv4qi_scalar */

        case E_V8QImode:
          if (pattern707 (x2, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 733 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 32678; /* pred_vandnv8qi_scalar */

        case E_V16QImode:
          if (pattern707 (x2, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 734 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 32679; /* pred_vandnv16qi_scalar */

        case E_V32QImode:
          if (pattern707 (x2, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 735 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 32680; /* pred_vandnv32qi_scalar */

        case E_V64QImode:
          if (pattern707 (x2, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 736 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32681; /* pred_vandnv64qi_scalar */

        case E_V128QImode:
          if (pattern707 (x2, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 737 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32682; /* pred_vandnv128qi_scalar */

        case E_V256QImode:
          if (pattern707 (x2, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 738 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32683; /* pred_vandnv256qi_scalar */

        case E_V512QImode:
          if (pattern707 (x2, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 739 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32684; /* pred_vandnv512qi_scalar */

        case E_V1024QImode:
          if (pattern707 (x2, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 740 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32685; /* pred_vandnv1024qi_scalar */

        case E_V2048QImode:
          if (pattern707 (x2, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 741 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32686; /* pred_vandnv2048qi_scalar */

        case E_V4096QImode:
          if (pattern707 (x2, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 742 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32687; /* pred_vandnv4096qi_scalar */

        case E_V1HImode:
          if (pattern707 (x2, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 743 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 32688; /* pred_vandnv1hi_scalar */

        case E_V2HImode:
          if (pattern707 (x2, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 744 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 32689; /* pred_vandnv2hi_scalar */

        case E_V4HImode:
          if (pattern707 (x2, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 32690; /* pred_vandnv4hi_scalar */

        case E_V8HImode:
          if (pattern707 (x2, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 32691; /* pred_vandnv8hi_scalar */

        case E_V16HImode:
          if (pattern707 (x2, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 747 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 32692; /* pred_vandnv16hi_scalar */

        case E_V32HImode:
          if (pattern707 (x2, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32693; /* pred_vandnv32hi_scalar */

        case E_V64HImode:
          if (pattern707 (x2, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 749 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32694; /* pred_vandnv64hi_scalar */

        case E_V128HImode:
          if (pattern707 (x2, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 750 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32695; /* pred_vandnv128hi_scalar */

        case E_V256HImode:
          if (pattern707 (x2, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 751 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32696; /* pred_vandnv256hi_scalar */

        case E_V512HImode:
          if (pattern707 (x2, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 752 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32697; /* pred_vandnv512hi_scalar */

        case E_V1024HImode:
          if (pattern707 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 753 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32698; /* pred_vandnv1024hi_scalar */

        case E_V2048HImode:
          if (pattern707 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 754 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32699; /* pred_vandnv2048hi_scalar */

        case E_V1SImode:
          if (pattern707 (x2, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 755 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 32700; /* pred_vandnv1si_scalar */

        case E_V2SImode:
          if (pattern707 (x2, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 756 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 32701; /* pred_vandnv2si_scalar */

        case E_V4SImode:
          if (pattern707 (x2, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 32702; /* pred_vandnv4si_scalar */

        case E_V8SImode:
          if (pattern707 (x2, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 32703; /* pred_vandnv8si_scalar */

        case E_V16SImode:
          if (pattern707 (x2, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 759 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32704; /* pred_vandnv16si_scalar */

        case E_V32SImode:
          if (pattern707 (x2, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32705; /* pred_vandnv32si_scalar */

        case E_V64SImode:
          if (pattern707 (x2, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 761 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32706; /* pred_vandnv64si_scalar */

        case E_V128SImode:
          if (pattern707 (x2, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32707; /* pred_vandnv128si_scalar */

        case E_V256SImode:
          if (pattern707 (x2, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 763 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32708; /* pred_vandnv256si_scalar */

        case E_V512SImode:
          if (pattern707 (x2, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32709; /* pred_vandnv512si_scalar */

        case E_V1024SImode:
          if (pattern707 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 765 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32710; /* pred_vandnv1024si_scalar */

        case E_RVVM8DImode:
          if (pattern708 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32711; /* *pred_vandnrvvm8di_scalar */

        case E_RVVM4DImode:
          if (pattern708 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32712; /* *pred_vandnrvvm4di_scalar */

        case E_RVVM2DImode:
          if (pattern708 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32713; /* *pred_vandnrvvm2di_scalar */

        case E_RVVM1DImode:
          if (pattern708 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32714; /* *pred_vandnrvvm1di_scalar */

        case E_V1DImode:
          if (pattern708 (x2, 
E_V1DImode, 
E_V1BImode) != 0
              || !(
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32715; /* *pred_vandnv1di_scalar */

        case E_V2DImode:
          if (pattern708 (x2, 
E_V2DImode, 
E_V2BImode) != 0
              || !(
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 778 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32716; /* *pred_vandnv2di_scalar */

        case E_V4DImode:
          if (pattern708 (x2, 
E_V4DImode, 
E_V4BImode) != 0
              || !(
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32717; /* *pred_vandnv4di_scalar */

        case E_V8DImode:
          if (pattern708 (x2, 
E_V8DImode, 
E_V8BImode) != 0
              || !(
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32718; /* *pred_vandnv8di_scalar */

        case E_V16DImode:
          if (pattern708 (x2, 
E_V16DImode, 
E_V16BImode) != 0
              || !(
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32719; /* *pred_vandnv16di_scalar */

        case E_V32DImode:
          if (pattern708 (x2, 
E_V32DImode, 
E_V32BImode) != 0
              || !(
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 782 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32720; /* *pred_vandnv32di_scalar */

        case E_V64DImode:
          if (pattern708 (x2, 
E_V64DImode, 
E_V64BImode) != 0
              || !(
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 783 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32721; /* *pred_vandnv64di_scalar */

        case E_V128DImode:
          if (pattern708 (x2, 
E_V128DImode, 
E_V128BImode) != 0
              || !(
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 784 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32722; /* *pred_vandnv128di_scalar */

        case E_V256DImode:
          if (pattern708 (x2, 
E_V256DImode, 
E_V256BImode) != 0
              || !(
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 785 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32723; /* *pred_vandnv256di_scalar */

        case E_V512DImode:
          if (pattern708 (x2, 
E_V512DImode, 
E_V512BImode) != 0
              || !(
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 786 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32724; /* *pred_vandnv512di_scalar */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      if (!reg_or_0_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8DImode:
          if (pattern721 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32725; /* *pred_vandnrvvm8di_extended_scalar */

        case E_RVVM4DImode:
          if (pattern721 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32726; /* *pred_vandnrvvm4di_extended_scalar */

        case E_RVVM2DImode:
          if (pattern721 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32727; /* *pred_vandnrvvm2di_extended_scalar */

        case E_RVVM1DImode:
          if (pattern721 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32728; /* *pred_vandnrvvm1di_extended_scalar */

        case E_V1DImode:
          if (pattern721 (x2, 
E_V1DImode, 
E_V1BImode) != 0
              || !(
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32729; /* *pred_vandnv1di_extended_scalar */

        case E_V2DImode:
          if (pattern721 (x2, 
E_V2DImode, 
E_V2BImode) != 0
              || !(
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 778 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32730; /* *pred_vandnv2di_extended_scalar */

        case E_V4DImode:
          if (pattern721 (x2, 
E_V4DImode, 
E_V4BImode) != 0
              || !(
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32731; /* *pred_vandnv4di_extended_scalar */

        case E_V8DImode:
          if (pattern721 (x2, 
E_V8DImode, 
E_V8BImode) != 0
              || !(
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32732; /* *pred_vandnv8di_extended_scalar */

        case E_V16DImode:
          if (pattern721 (x2, 
E_V16DImode, 
E_V16BImode) != 0
              || !(
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32733; /* *pred_vandnv16di_extended_scalar */

        case E_V32DImode:
          if (pattern721 (x2, 
E_V32DImode, 
E_V32BImode) != 0
              || !(
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 782 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32734; /* *pred_vandnv32di_extended_scalar */

        case E_V64DImode:
          if (pattern721 (x2, 
E_V64DImode, 
E_V64BImode) != 0
              || !(
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 783 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32735; /* *pred_vandnv64di_extended_scalar */

        case E_V128DImode:
          if (pattern721 (x2, 
E_V128DImode, 
E_V128BImode) != 0
              || !(
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 784 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32736; /* *pred_vandnv128di_extended_scalar */

        case E_V256DImode:
          if (pattern721 (x2, 
E_V256DImode, 
E_V256BImode) != 0
              || !(
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 785 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32737; /* *pred_vandnv256di_extended_scalar */

        case E_V512DImode:
          if (pattern721 (x2, 
E_V512DImode, 
E_V512BImode) != 0
              || !(
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 786 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32738; /* *pred_vandnv512di_extended_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_861 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern493 (x2, 
E_V2SImode, 
E_V2BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V2SImode)
      && (
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 6318; /* pred_ashlv2si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 6797; /* pred_ashlv2si_scalar */
}

 int
recog_866 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern493 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V256HImode)
      && (
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 6233; /* pred_ashlv256hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 6782; /* pred_ashlv256hi_scalar */
}

 int
recog_871 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern672 (x2, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V512SImode)
      && (
#line 301 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 32896; /* pred_vwsllv512di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 322 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 32944; /* pred_vwsllv512di_scalar */
}

 int
recog_876 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern672 (x2, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V16SImode)
      && (
#line 301 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 32891; /* pred_vwsllv16di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 322 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 32939; /* pred_vwsllv16di_scalar */
}

 int
recog_881 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  x6 = XEXP (x3, 1);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTEND:
      switch (pattern534 (x2))
        {
        case 0:
          if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9305; /* pred_dual_widen_mulsrvvm8hi */

        case 1:
          if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9311; /* pred_dual_widen_mulsrvvm4hi */

        case 2:
          if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9317; /* pred_dual_widen_mulsrvvm2hi */

        case 3:
          if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9323; /* pred_dual_widen_mulsrvvm1hi */

        case 4:
          if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9329; /* pred_dual_widen_mulsrvvmf2hi */

        case 5:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9335; /* pred_dual_widen_mulsrvvmf4hi */

        case 6:
          if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9341; /* pred_dual_widen_mulsrvvm8si */

        case 7:
          if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9347; /* pred_dual_widen_mulsrvvm4si */

        case 8:
          if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9353; /* pred_dual_widen_mulsrvvm2si */

        case 9:
          if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9359; /* pred_dual_widen_mulsrvvm1si */

        case 10:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9365; /* pred_dual_widen_mulsrvvmf2si */

        case 11:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9371; /* pred_dual_widen_mulsrvvm8di */

        case 12:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9377; /* pred_dual_widen_mulsrvvm4di */

        case 13:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9383; /* pred_dual_widen_mulsrvvm2di */

        case 14:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9389; /* pred_dual_widen_mulsrvvm1di */

        case 15:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9395; /* pred_dual_widen_mulsv1hi */

        case 16:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9401; /* pred_dual_widen_mulsv2hi */

        case 17:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9407; /* pred_dual_widen_mulsv4hi */

        case 18:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9413; /* pred_dual_widen_mulsv8hi */

        case 19:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9419; /* pred_dual_widen_mulsv16hi */

        case 20:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9425; /* pred_dual_widen_mulsv32hi */

        case 21:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9431; /* pred_dual_widen_mulsv64hi */

        case 22:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9437; /* pred_dual_widen_mulsv128hi */

        case 23:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9443; /* pred_dual_widen_mulsv256hi */

        case 24:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9449; /* pred_dual_widen_mulsv512hi */

        case 25:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9455; /* pred_dual_widen_mulsv1024hi */

        case 26:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9461; /* pred_dual_widen_mulsv2048hi */

        case 27:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9467; /* pred_dual_widen_mulsv1si */

        case 28:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9473; /* pred_dual_widen_mulsv2si */

        case 29:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9479; /* pred_dual_widen_mulsv4si */

        case 30:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9485; /* pred_dual_widen_mulsv8si */

        case 31:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9491; /* pred_dual_widen_mulsv16si */

        case 32:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9497; /* pred_dual_widen_mulsv32si */

        case 33:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9503; /* pred_dual_widen_mulsv64si */

        case 34:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9509; /* pred_dual_widen_mulsv128si */

        case 35:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9515; /* pred_dual_widen_mulsv256si */

        case 36:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9521; /* pred_dual_widen_mulsv512si */

        case 37:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9527; /* pred_dual_widen_mulsv1024si */

        case 38:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9533; /* pred_dual_widen_mulsv1di */

        case 39:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9539; /* pred_dual_widen_mulsv2di */

        case 40:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9545; /* pred_dual_widen_mulsv4di */

        case 41:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9551; /* pred_dual_widen_mulsv8di */

        case 42:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9557; /* pred_dual_widen_mulsv16di */

        case 43:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9563; /* pred_dual_widen_mulsv32di */

        case 44:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9569; /* pred_dual_widen_mulsv64di */

        case 45:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9575; /* pred_dual_widen_mulsv128di */

        case 46:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9581; /* pred_dual_widen_mulsv256di */

        case 47:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9587; /* pred_dual_widen_mulsv512di */

        case 48:
          if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9593; /* pred_dual_widen_mulsrvvm8hi_scalar */

        case 49:
          if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9599; /* pred_dual_widen_mulsrvvm4hi_scalar */

        case 50:
          if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9605; /* pred_dual_widen_mulsrvvm2hi_scalar */

        case 51:
          if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9611; /* pred_dual_widen_mulsrvvm1hi_scalar */

        case 52:
          if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9617; /* pred_dual_widen_mulsrvvmf2hi_scalar */

        case 53:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9623; /* pred_dual_widen_mulsrvvmf4hi_scalar */

        case 54:
          if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9629; /* pred_dual_widen_mulsrvvm8si_scalar */

        case 55:
          if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9635; /* pred_dual_widen_mulsrvvm4si_scalar */

        case 56:
          if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9641; /* pred_dual_widen_mulsrvvm2si_scalar */

        case 57:
          if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9647; /* pred_dual_widen_mulsrvvm1si_scalar */

        case 58:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9653; /* pred_dual_widen_mulsrvvmf2si_scalar */

        case 59:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9659; /* pred_dual_widen_mulsrvvm8di_scalar */

        case 60:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9665; /* pred_dual_widen_mulsrvvm4di_scalar */

        case 61:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9671; /* pred_dual_widen_mulsrvvm2di_scalar */

        case 62:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9677; /* pred_dual_widen_mulsrvvm1di_scalar */

        case 63:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9683; /* pred_dual_widen_mulsv1hi_scalar */

        case 64:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9689; /* pred_dual_widen_mulsv2hi_scalar */

        case 65:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9695; /* pred_dual_widen_mulsv4hi_scalar */

        case 66:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9701; /* pred_dual_widen_mulsv8hi_scalar */

        case 67:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9707; /* pred_dual_widen_mulsv16hi_scalar */

        case 68:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9713; /* pred_dual_widen_mulsv32hi_scalar */

        case 69:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9719; /* pred_dual_widen_mulsv64hi_scalar */

        case 70:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9725; /* pred_dual_widen_mulsv128hi_scalar */

        case 71:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9731; /* pred_dual_widen_mulsv256hi_scalar */

        case 72:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9737; /* pred_dual_widen_mulsv512hi_scalar */

        case 73:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9743; /* pred_dual_widen_mulsv1024hi_scalar */

        case 74:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9749; /* pred_dual_widen_mulsv2048hi_scalar */

        case 75:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9755; /* pred_dual_widen_mulsv1si_scalar */

        case 76:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9761; /* pred_dual_widen_mulsv2si_scalar */

        case 77:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9767; /* pred_dual_widen_mulsv4si_scalar */

        case 78:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9773; /* pred_dual_widen_mulsv8si_scalar */

        case 79:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9779; /* pred_dual_widen_mulsv16si_scalar */

        case 80:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9785; /* pred_dual_widen_mulsv32si_scalar */

        case 81:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9791; /* pred_dual_widen_mulsv64si_scalar */

        case 82:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9797; /* pred_dual_widen_mulsv128si_scalar */

        case 83:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9803; /* pred_dual_widen_mulsv256si_scalar */

        case 84:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9809; /* pred_dual_widen_mulsv512si_scalar */

        case 85:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9815; /* pred_dual_widen_mulsv1024si_scalar */

        case 86:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9821; /* pred_dual_widen_mulsv1di_scalar */

        case 87:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9827; /* pred_dual_widen_mulsv2di_scalar */

        case 88:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9833; /* pred_dual_widen_mulsv4di_scalar */

        case 89:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9839; /* pred_dual_widen_mulsv8di_scalar */

        case 90:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9845; /* pred_dual_widen_mulsv16di_scalar */

        case 91:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9851; /* pred_dual_widen_mulsv32di_scalar */

        case 92:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9857; /* pred_dual_widen_mulsv64di_scalar */

        case 93:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9863; /* pred_dual_widen_mulsv128di_scalar */

        case 94:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9869; /* pred_dual_widen_mulsv256di_scalar */

        case 95:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9875; /* pred_dual_widen_mulsv512di_scalar */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern534 (x2))
        {
        case 0:
          if (!
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10453; /* pred_widen_mulsurvvm8hi */

        case 1:
          if (!
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10454; /* pred_widen_mulsurvvm4hi */

        case 2:
          if (!
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10455; /* pred_widen_mulsurvvm2hi */

        case 3:
          if (!
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10456; /* pred_widen_mulsurvvm1hi */

        case 4:
          if (!
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10457; /* pred_widen_mulsurvvmf2hi */

        case 5:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10458; /* pred_widen_mulsurvvmf4hi */

        case 6:
          if (!
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10459; /* pred_widen_mulsurvvm8si */

        case 7:
          if (!
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10460; /* pred_widen_mulsurvvm4si */

        case 8:
          if (!
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10461; /* pred_widen_mulsurvvm2si */

        case 9:
          if (!
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10462; /* pred_widen_mulsurvvm1si */

        case 10:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10463; /* pred_widen_mulsurvvmf2si */

        case 11:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10464; /* pred_widen_mulsurvvm8di */

        case 12:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10465; /* pred_widen_mulsurvvm4di */

        case 13:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10466; /* pred_widen_mulsurvvm2di */

        case 14:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10467; /* pred_widen_mulsurvvm1di */

        case 15:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10468; /* pred_widen_mulsuv1hi */

        case 16:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10469; /* pred_widen_mulsuv2hi */

        case 17:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10470; /* pred_widen_mulsuv4hi */

        case 18:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10471; /* pred_widen_mulsuv8hi */

        case 19:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10472; /* pred_widen_mulsuv16hi */

        case 20:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10473; /* pred_widen_mulsuv32hi */

        case 21:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10474; /* pred_widen_mulsuv64hi */

        case 22:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10475; /* pred_widen_mulsuv128hi */

        case 23:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10476; /* pred_widen_mulsuv256hi */

        case 24:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10477; /* pred_widen_mulsuv512hi */

        case 25:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10478; /* pred_widen_mulsuv1024hi */

        case 26:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10479; /* pred_widen_mulsuv2048hi */

        case 27:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10480; /* pred_widen_mulsuv1si */

        case 28:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10481; /* pred_widen_mulsuv2si */

        case 29:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10482; /* pred_widen_mulsuv4si */

        case 30:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10483; /* pred_widen_mulsuv8si */

        case 31:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10484; /* pred_widen_mulsuv16si */

        case 32:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10485; /* pred_widen_mulsuv32si */

        case 33:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10486; /* pred_widen_mulsuv64si */

        case 34:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10487; /* pred_widen_mulsuv128si */

        case 35:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10488; /* pred_widen_mulsuv256si */

        case 36:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10489; /* pred_widen_mulsuv512si */

        case 37:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10490; /* pred_widen_mulsuv1024si */

        case 38:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10491; /* pred_widen_mulsuv1di */

        case 39:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10492; /* pred_widen_mulsuv2di */

        case 40:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10493; /* pred_widen_mulsuv4di */

        case 41:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10494; /* pred_widen_mulsuv8di */

        case 42:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10495; /* pred_widen_mulsuv16di */

        case 43:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10496; /* pred_widen_mulsuv32di */

        case 44:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10497; /* pred_widen_mulsuv64di */

        case 45:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10498; /* pred_widen_mulsuv128di */

        case 46:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10499; /* pred_widen_mulsuv256di */

        case 47:
          if (!(
#line 4160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10500; /* pred_widen_mulsuv512di */

        case 48:
          if (!
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10501; /* pred_widen_mulsurvvm8hi_scalar */

        case 49:
          if (!
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10502; /* pred_widen_mulsurvvm4hi_scalar */

        case 50:
          if (!
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10503; /* pred_widen_mulsurvvm2hi_scalar */

        case 51:
          if (!
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10504; /* pred_widen_mulsurvvm1hi_scalar */

        case 52:
          if (!
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10505; /* pred_widen_mulsurvvmf2hi_scalar */

        case 53:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10506; /* pred_widen_mulsurvvmf4hi_scalar */

        case 54:
          if (!
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10507; /* pred_widen_mulsurvvm8si_scalar */

        case 55:
          if (!
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10508; /* pred_widen_mulsurvvm4si_scalar */

        case 56:
          if (!
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10509; /* pred_widen_mulsurvvm2si_scalar */

        case 57:
          if (!
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10510; /* pred_widen_mulsurvvm1si_scalar */

        case 58:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10511; /* pred_widen_mulsurvvmf2si_scalar */

        case 59:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10512; /* pred_widen_mulsurvvm8di_scalar */

        case 60:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10513; /* pred_widen_mulsurvvm4di_scalar */

        case 61:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10514; /* pred_widen_mulsurvvm2di_scalar */

        case 62:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10515; /* pred_widen_mulsurvvm1di_scalar */

        case 63:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10516; /* pred_widen_mulsuv1hi_scalar */

        case 64:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10517; /* pred_widen_mulsuv2hi_scalar */

        case 65:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10518; /* pred_widen_mulsuv4hi_scalar */

        case 66:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10519; /* pred_widen_mulsuv8hi_scalar */

        case 67:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10520; /* pred_widen_mulsuv16hi_scalar */

        case 68:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10521; /* pred_widen_mulsuv32hi_scalar */

        case 69:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10522; /* pred_widen_mulsuv64hi_scalar */

        case 70:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10523; /* pred_widen_mulsuv128hi_scalar */

        case 71:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10524; /* pred_widen_mulsuv256hi_scalar */

        case 72:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10525; /* pred_widen_mulsuv512hi_scalar */

        case 73:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10526; /* pred_widen_mulsuv1024hi_scalar */

        case 74:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10527; /* pred_widen_mulsuv2048hi_scalar */

        case 75:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10528; /* pred_widen_mulsuv1si_scalar */

        case 76:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10529; /* pred_widen_mulsuv2si_scalar */

        case 77:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10530; /* pred_widen_mulsuv4si_scalar */

        case 78:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10531; /* pred_widen_mulsuv8si_scalar */

        case 79:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10532; /* pred_widen_mulsuv16si_scalar */

        case 80:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10533; /* pred_widen_mulsuv32si_scalar */

        case 81:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10534; /* pred_widen_mulsuv64si_scalar */

        case 82:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10535; /* pred_widen_mulsuv128si_scalar */

        case 83:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10536; /* pred_widen_mulsuv256si_scalar */

        case 84:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10537; /* pred_widen_mulsuv512si_scalar */

        case 85:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10538; /* pred_widen_mulsuv1024si_scalar */

        case 86:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10539; /* pred_widen_mulsuv1di_scalar */

        case 87:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10540; /* pred_widen_mulsuv2di_scalar */

        case 88:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10541; /* pred_widen_mulsuv4di_scalar */

        case 89:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10542; /* pred_widen_mulsuv8di_scalar */

        case 90:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10543; /* pred_widen_mulsuv16di_scalar */

        case 91:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10544; /* pred_widen_mulsuv32di_scalar */

        case 92:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10545; /* pred_widen_mulsuv64di_scalar */

        case 93:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10546; /* pred_widen_mulsuv128di_scalar */

        case 94:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10547; /* pred_widen_mulsuv256di_scalar */

        case 95:
          if (!(
#line 4183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10548; /* pred_widen_mulsuv512di_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_895 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return recog_753 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      operands[3] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      x12 = XEXP (x4, 0);
      switch (GET_CODE (x12))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          switch (pattern489 (x2))
            {
            case 0:
              if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6857; /* pred_addrvvm8qi_scalar */

            case 1:
              if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6866; /* pred_addrvvm4qi_scalar */

            case 2:
              if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6875; /* pred_addrvvm2qi_scalar */

            case 3:
              if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6884; /* pred_addrvvm1qi_scalar */

            case 4:
              if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6893; /* pred_addrvvmf2qi_scalar */

            case 5:
              if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6902; /* pred_addrvvmf4qi_scalar */

            case 6:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 6911; /* pred_addrvvmf8qi_scalar */

            case 7:
              if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6920; /* pred_addrvvm8hi_scalar */

            case 8:
              if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6929; /* pred_addrvvm4hi_scalar */

            case 9:
              if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6938; /* pred_addrvvm2hi_scalar */

            case 10:
              if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6947; /* pred_addrvvm1hi_scalar */

            case 11:
              if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6956; /* pred_addrvvmf2hi_scalar */

            case 12:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 6965; /* pred_addrvvmf4hi_scalar */

            case 13:
              if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6974; /* pred_addrvvm8si_scalar */

            case 14:
              if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6983; /* pred_addrvvm4si_scalar */

            case 15:
              if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6992; /* pred_addrvvm2si_scalar */

            case 16:
              if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7001; /* pred_addrvvm1si_scalar */

            case 17:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7010; /* pred_addrvvmf2si_scalar */

            case 18:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 7019; /* pred_addv1qi_scalar */

            case 19:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 7028; /* pred_addv2qi_scalar */

            case 20:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 7037; /* pred_addv4qi_scalar */

            case 21:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 7046; /* pred_addv8qi_scalar */

            case 22:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 7055; /* pred_addv16qi_scalar */

            case 23:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 7064; /* pred_addv32qi_scalar */

            case 24:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7073; /* pred_addv64qi_scalar */

            case 25:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7082; /* pred_addv128qi_scalar */

            case 26:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7091; /* pred_addv256qi_scalar */

            case 27:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7100; /* pred_addv512qi_scalar */

            case 28:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7109; /* pred_addv1024qi_scalar */

            case 29:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7118; /* pred_addv2048qi_scalar */

            case 30:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7127; /* pred_addv4096qi_scalar */

            case 31:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 7136; /* pred_addv1hi_scalar */

            case 32:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 7145; /* pred_addv2hi_scalar */

            case 33:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 7154; /* pred_addv4hi_scalar */

            case 34:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 7163; /* pred_addv8hi_scalar */

            case 35:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 7172; /* pred_addv16hi_scalar */

            case 36:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7181; /* pred_addv32hi_scalar */

            case 37:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7190; /* pred_addv64hi_scalar */

            case 38:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7199; /* pred_addv128hi_scalar */

            case 39:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7208; /* pred_addv256hi_scalar */

            case 40:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7217; /* pred_addv512hi_scalar */

            case 41:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7226; /* pred_addv1024hi_scalar */

            case 42:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7235; /* pred_addv2048hi_scalar */

            case 43:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 7244; /* pred_addv1si_scalar */

            case 44:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 7253; /* pred_addv2si_scalar */

            case 45:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 7262; /* pred_addv4si_scalar */

            case 46:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 7271; /* pred_addv8si_scalar */

            case 47:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7280; /* pred_addv16si_scalar */

            case 48:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7289; /* pred_addv32si_scalar */

            case 49:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7298; /* pred_addv64si_scalar */

            case 50:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7307; /* pred_addv128si_scalar */

            case 51:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7316; /* pred_addv256si_scalar */

            case 52:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7325; /* pred_addv512si_scalar */

            case 53:
              if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7334; /* pred_addv1024si_scalar */

            case 54:
              if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7667; /* *pred_addrvvm8di_scalar */

            case 55:
              if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7676; /* *pred_addrvvm4di_scalar */

            case 56:
              if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7685; /* *pred_addrvvm2di_scalar */

            case 57:
              if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7694; /* *pred_addrvvm1di_scalar */

            case 58:
              if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7703; /* *pred_addv1di_scalar */

            case 59:
              if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7712; /* *pred_addv2di_scalar */

            case 60:
              if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7721; /* *pred_addv4di_scalar */

            case 61:
              if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7730; /* *pred_addv8di_scalar */

            case 62:
              if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7739; /* *pred_addv16di_scalar */

            case 63:
              if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7748; /* *pred_addv32di_scalar */

            case 64:
              if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7757; /* *pred_addv64di_scalar */

            case 65:
              if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7766; /* *pred_addv128di_scalar */

            case 66:
              if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7775; /* *pred_addv256di_scalar */

            case 67:
              if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7784; /* *pred_addv512di_scalar */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          return recog_608 (x1, insn, pnum_clobbers);

        case ZERO_EXTEND:
          x13 = XEXP (x12, 0);
          operands[4] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8HImode:
              if (pattern690 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10262; /* pred_single_widen_addurvvm8hi_extended_scalar */

            case E_RVVM4HImode:
              if (pattern690 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10264; /* pred_single_widen_addurvvm4hi_extended_scalar */

            case E_RVVM2HImode:
              if (pattern690 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10266; /* pred_single_widen_addurvvm2hi_extended_scalar */

            case E_RVVM1HImode:
              if (pattern690 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10268; /* pred_single_widen_addurvvm1hi_extended_scalar */

            case E_RVVMF2HImode:
              if (pattern690 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10270; /* pred_single_widen_addurvvmf2hi_extended_scalar */

            case E_RVVMF4HImode:
              if (pattern690 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10272; /* pred_single_widen_addurvvmf4hi_extended_scalar */

            case E_RVVM8SImode:
              if (pattern690 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10274; /* pred_single_widen_addurvvm8si_extended_scalar */

            case E_RVVM4SImode:
              if (pattern690 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10276; /* pred_single_widen_addurvvm4si_extended_scalar */

            case E_RVVM2SImode:
              if (pattern690 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10278; /* pred_single_widen_addurvvm2si_extended_scalar */

            case E_RVVM1SImode:
              if (pattern690 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10280; /* pred_single_widen_addurvvm1si_extended_scalar */

            case E_RVVMF2SImode:
              if (pattern690 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10282; /* pred_single_widen_addurvvmf2si_extended_scalar */

            case E_RVVM8DImode:
              if (pattern690 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10284; /* pred_single_widen_addurvvm8di_extended_scalar */

            case E_RVVM4DImode:
              if (pattern690 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10286; /* pred_single_widen_addurvvm4di_extended_scalar */

            case E_RVVM2DImode:
              if (pattern690 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10288; /* pred_single_widen_addurvvm2di_extended_scalar */

            case E_RVVM1DImode:
              if (pattern690 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10290; /* pred_single_widen_addurvvm1di_extended_scalar */

            case E_V1HImode:
              if (pattern690 (x2, 
E_V1HImode, 
E_V1BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 10292; /* pred_single_widen_adduv1hi_extended_scalar */

            case E_V2HImode:
              if (pattern690 (x2, 
E_V2HImode, 
E_V2BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 10294; /* pred_single_widen_adduv2hi_extended_scalar */

            case E_V4HImode:
              if (pattern690 (x2, 
E_V4HImode, 
E_V4BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 10296; /* pred_single_widen_adduv4hi_extended_scalar */

            case E_V8HImode:
              if (pattern690 (x2, 
E_V8HImode, 
E_V8BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 10298; /* pred_single_widen_adduv8hi_extended_scalar */

            case E_V16HImode:
              if (pattern690 (x2, 
E_V16HImode, 
E_V16BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 10300; /* pred_single_widen_adduv16hi_extended_scalar */

            case E_V32HImode:
              if (pattern690 (x2, 
E_V32HImode, 
E_V32BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 10302; /* pred_single_widen_adduv32hi_extended_scalar */

            case E_V64HImode:
              if (pattern690 (x2, 
E_V64HImode, 
E_V64BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 10304; /* pred_single_widen_adduv64hi_extended_scalar */

            case E_V128HImode:
              if (pattern690 (x2, 
E_V128HImode, 
E_V128BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 10306; /* pred_single_widen_adduv128hi_extended_scalar */

            case E_V256HImode:
              if (pattern690 (x2, 
E_V256HImode, 
E_V256BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 10308; /* pred_single_widen_adduv256hi_extended_scalar */

            case E_V512HImode:
              if (pattern690 (x2, 
E_V512HImode, 
E_V512BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 10310; /* pred_single_widen_adduv512hi_extended_scalar */

            case E_V1024HImode:
              if (pattern690 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 10312; /* pred_single_widen_adduv1024hi_extended_scalar */

            case E_V2048HImode:
              if (pattern690 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 10314; /* pred_single_widen_adduv2048hi_extended_scalar */

            case E_V1SImode:
              if (pattern690 (x2, 
E_V1SImode, 
E_V1BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 10316; /* pred_single_widen_adduv1si_extended_scalar */

            case E_V2SImode:
              if (pattern690 (x2, 
E_V2SImode, 
E_V2BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 10318; /* pred_single_widen_adduv2si_extended_scalar */

            case E_V4SImode:
              if (pattern690 (x2, 
E_V4SImode, 
E_V4BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 10320; /* pred_single_widen_adduv4si_extended_scalar */

            case E_V8SImode:
              if (pattern690 (x2, 
E_V8SImode, 
E_V8BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 10322; /* pred_single_widen_adduv8si_extended_scalar */

            case E_V16SImode:
              if (pattern690 (x2, 
E_V16SImode, 
E_V16BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 10324; /* pred_single_widen_adduv16si_extended_scalar */

            case E_V32SImode:
              if (pattern690 (x2, 
E_V32SImode, 
E_V32BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 10326; /* pred_single_widen_adduv32si_extended_scalar */

            case E_V64SImode:
              if (pattern690 (x2, 
E_V64SImode, 
E_V64BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 10328; /* pred_single_widen_adduv64si_extended_scalar */

            case E_V128SImode:
              if (pattern690 (x2, 
E_V128SImode, 
E_V128BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 10330; /* pred_single_widen_adduv128si_extended_scalar */

            case E_V256SImode:
              if (pattern690 (x2, 
E_V256SImode, 
E_V256BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 10332; /* pred_single_widen_adduv256si_extended_scalar */

            case E_V512SImode:
              if (pattern690 (x2, 
E_V512SImode, 
E_V512BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 10334; /* pred_single_widen_adduv512si_extended_scalar */

            case E_V1024SImode:
              if (pattern690 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 10336; /* pred_single_widen_adduv1024si_extended_scalar */

            case E_V1DImode:
              if (pattern690 (x2, 
E_V1DImode, 
E_V1BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10338; /* pred_single_widen_adduv1di_extended_scalar */

            case E_V2DImode:
              if (pattern690 (x2, 
E_V2DImode, 
E_V2BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10340; /* pred_single_widen_adduv2di_extended_scalar */

            case E_V4DImode:
              if (pattern690 (x2, 
E_V4DImode, 
E_V4BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10342; /* pred_single_widen_adduv4di_extended_scalar */

            case E_V8DImode:
              if (pattern690 (x2, 
E_V8DImode, 
E_V8BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 10344; /* pred_single_widen_adduv8di_extended_scalar */

            case E_V16DImode:
              if (pattern690 (x2, 
E_V16DImode, 
E_V16BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 10346; /* pred_single_widen_adduv16di_extended_scalar */

            case E_V32DImode:
              if (pattern690 (x2, 
E_V32DImode, 
E_V32BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 10348; /* pred_single_widen_adduv32di_extended_scalar */

            case E_V64DImode:
              if (pattern690 (x2, 
E_V64DImode, 
E_V64BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 10350; /* pred_single_widen_adduv64di_extended_scalar */

            case E_V128DImode:
              if (pattern690 (x2, 
E_V128DImode, 
E_V128BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 10352; /* pred_single_widen_adduv128di_extended_scalar */

            case E_V256DImode:
              if (pattern690 (x2, 
E_V256DImode, 
E_V256BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 10354; /* pred_single_widen_adduv256di_extended_scalar */

            case E_V512DImode:
              if (pattern690 (x2, 
E_V512DImode, 
E_V512BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 10356; /* pred_single_widen_adduv512di_extended_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_751 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_750 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_752 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_904 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern499 (x2))
    {
    case 0:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5506; /* pred_umaxrvvm8qi */

    case 1:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5523; /* pred_umaxrvvm4qi */

    case 2:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5540; /* pred_umaxrvvm2qi */

    case 3:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5557; /* pred_umaxrvvm1qi */

    case 4:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5574; /* pred_umaxrvvm8hi */

    case 5:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5591; /* pred_umaxrvvm4hi */

    case 6:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5608; /* pred_umaxrvvm2hi */

    case 7:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5625; /* pred_umaxrvvm1hi */

    case 8:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5642; /* pred_umaxrvvm8si */

    case 9:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5659; /* pred_umaxrvvm4si */

    case 10:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5676; /* pred_umaxrvvm2si */

    case 11:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5693; /* pred_umaxrvvm1si */

    case 12:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5710; /* pred_umaxrvvm8di */

    case 13:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5727; /* pred_umaxrvvm4di */

    case 14:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5744; /* pred_umaxrvvm2di */

    case 15:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5761; /* pred_umaxrvvm1di */

    case 16:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5778; /* pred_umaxrvvmf2qi */

    case 17:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5795; /* pred_umaxrvvmf4qi */

    case 18:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5812; /* pred_umaxrvvmf8qi */

    case 19:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5829; /* pred_umaxrvvmf2hi */

    case 20:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5846; /* pred_umaxrvvmf4hi */

    case 21:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5863; /* pred_umaxrvvmf2si */

    case 22:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5880; /* pred_umaxv1qi */

    case 23:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5897; /* pred_umaxv2qi */

    case 24:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5914; /* pred_umaxv4qi */

    case 25:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5931; /* pred_umaxv8qi */

    case 26:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5948; /* pred_umaxv16qi */

    case 27:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5965; /* pred_umaxv32qi */

    case 28:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5982; /* pred_umaxv64qi */

    case 29:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 5999; /* pred_umaxv128qi */

    case 30:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6016; /* pred_umaxv256qi */

    case 31:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6033; /* pred_umaxv512qi */

    case 32:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6050; /* pred_umaxv1024qi */

    case 33:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6067; /* pred_umaxv2048qi */

    case 34:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6084; /* pred_umaxv4096qi */

    case 35:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6101; /* pred_umaxv1hi */

    case 36:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6118; /* pred_umaxv2hi */

    case 37:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6135; /* pred_umaxv4hi */

    case 38:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6152; /* pred_umaxv8hi */

    case 39:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6169; /* pred_umaxv16hi */

    case 40:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6186; /* pred_umaxv32hi */

    case 41:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6203; /* pred_umaxv64hi */

    case 42:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6220; /* pred_umaxv128hi */

    case 43:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6237; /* pred_umaxv256hi */

    case 44:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6254; /* pred_umaxv512hi */

    case 45:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6271; /* pred_umaxv1024hi */

    case 46:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6288; /* pred_umaxv2048hi */

    case 47:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6305; /* pred_umaxv1si */

    case 48:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6322; /* pred_umaxv2si */

    case 49:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6339; /* pred_umaxv4si */

    case 50:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6356; /* pred_umaxv8si */

    case 51:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6373; /* pred_umaxv16si */

    case 52:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6390; /* pred_umaxv32si */

    case 53:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6407; /* pred_umaxv64si */

    case 54:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6424; /* pred_umaxv128si */

    case 55:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6441; /* pred_umaxv256si */

    case 56:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6458; /* pred_umaxv512si */

    case 57:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6475; /* pred_umaxv1024si */

    case 58:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6492; /* pred_umaxv1di */

    case 59:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6509; /* pred_umaxv2di */

    case 60:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6526; /* pred_umaxv4di */

    case 61:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6543; /* pred_umaxv8di */

    case 62:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6560; /* pred_umaxv16di */

    case 63:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6577; /* pred_umaxv32di */

    case 64:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6594; /* pred_umaxv64di */

    case 65:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6611; /* pred_umaxv128di */

    case 66:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6628; /* pred_umaxv256di */

    case 67:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6645; /* pred_umaxv512di */

    case 68:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6862; /* pred_umaxrvvm8qi_scalar */

    case 69:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6871; /* pred_umaxrvvm4qi_scalar */

    case 70:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6880; /* pred_umaxrvvm2qi_scalar */

    case 71:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6889; /* pred_umaxrvvm1qi_scalar */

    case 72:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6898; /* pred_umaxrvvmf2qi_scalar */

    case 73:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6907; /* pred_umaxrvvmf4qi_scalar */

    case 74:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6916; /* pred_umaxrvvmf8qi_scalar */

    case 75:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6925; /* pred_umaxrvvm8hi_scalar */

    case 76:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6934; /* pred_umaxrvvm4hi_scalar */

    case 77:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6943; /* pred_umaxrvvm2hi_scalar */

    case 78:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6952; /* pred_umaxrvvm1hi_scalar */

    case 79:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6961; /* pred_umaxrvvmf2hi_scalar */

    case 80:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6970; /* pred_umaxrvvmf4hi_scalar */

    case 81:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6979; /* pred_umaxrvvm8si_scalar */

    case 82:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6988; /* pred_umaxrvvm4si_scalar */

    case 83:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6997; /* pred_umaxrvvm2si_scalar */

    case 84:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7006; /* pred_umaxrvvm1si_scalar */

    case 85:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7015; /* pred_umaxrvvmf2si_scalar */

    case 86:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7024; /* pred_umaxv1qi_scalar */

    case 87:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7033; /* pred_umaxv2qi_scalar */

    case 88:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7042; /* pred_umaxv4qi_scalar */

    case 89:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7051; /* pred_umaxv8qi_scalar */

    case 90:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7060; /* pred_umaxv16qi_scalar */

    case 91:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7069; /* pred_umaxv32qi_scalar */

    case 92:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7078; /* pred_umaxv64qi_scalar */

    case 93:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7087; /* pred_umaxv128qi_scalar */

    case 94:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7096; /* pred_umaxv256qi_scalar */

    case 95:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7105; /* pred_umaxv512qi_scalar */

    case 96:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7114; /* pred_umaxv1024qi_scalar */

    case 97:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7123; /* pred_umaxv2048qi_scalar */

    case 98:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7132; /* pred_umaxv4096qi_scalar */

    case 99:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7141; /* pred_umaxv1hi_scalar */

    case 100:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7150; /* pred_umaxv2hi_scalar */

    case 101:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7159; /* pred_umaxv4hi_scalar */

    case 102:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7168; /* pred_umaxv8hi_scalar */

    case 103:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7177; /* pred_umaxv16hi_scalar */

    case 104:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7186; /* pred_umaxv32hi_scalar */

    case 105:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7195; /* pred_umaxv64hi_scalar */

    case 106:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7204; /* pred_umaxv128hi_scalar */

    case 107:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7213; /* pred_umaxv256hi_scalar */

    case 108:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7222; /* pred_umaxv512hi_scalar */

    case 109:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7231; /* pred_umaxv1024hi_scalar */

    case 110:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7240; /* pred_umaxv2048hi_scalar */

    case 111:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7249; /* pred_umaxv1si_scalar */

    case 112:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7258; /* pred_umaxv2si_scalar */

    case 113:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7267; /* pred_umaxv4si_scalar */

    case 114:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7276; /* pred_umaxv8si_scalar */

    case 115:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7285; /* pred_umaxv16si_scalar */

    case 116:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7294; /* pred_umaxv32si_scalar */

    case 117:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7303; /* pred_umaxv64si_scalar */

    case 118:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7312; /* pred_umaxv128si_scalar */

    case 119:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7321; /* pred_umaxv256si_scalar */

    case 120:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7330; /* pred_umaxv512si_scalar */

    case 121:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7339; /* pred_umaxv1024si_scalar */

    case 122:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7672; /* *pred_umaxrvvm8di_scalar */

    case 123:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7681; /* *pred_umaxrvvm4di_scalar */

    case 124:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7690; /* *pred_umaxrvvm2di_scalar */

    case 125:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7699; /* *pred_umaxrvvm1di_scalar */

    case 126:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7708; /* *pred_umaxv1di_scalar */

    case 127:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7717; /* *pred_umaxv2di_scalar */

    case 128:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7726; /* *pred_umaxv4di_scalar */

    case 129:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7735; /* *pred_umaxv8di_scalar */

    case 130:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7744; /* *pred_umaxv16di_scalar */

    case 131:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7753; /* *pred_umaxv32di_scalar */

    case 132:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7762; /* *pred_umaxv64di_scalar */

    case 133:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7771; /* *pred_umaxv128di_scalar */

    case 134:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7780; /* *pred_umaxv256di_scalar */

    case 135:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7789; /* *pred_umaxv512di_scalar */

    case 136:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7798; /* *pred_umaxrvvm8di_extended_scalar */

    case 137:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7807; /* *pred_umaxrvvm4di_extended_scalar */

    case 138:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7816; /* *pred_umaxrvvm2di_extended_scalar */

    case 139:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7825; /* *pred_umaxrvvm1di_extended_scalar */

    case 140:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7834; /* *pred_umaxv1di_extended_scalar */

    case 141:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7843; /* *pred_umaxv2di_extended_scalar */

    case 142:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7852; /* *pred_umaxv4di_extended_scalar */

    case 143:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7861; /* *pred_umaxv8di_extended_scalar */

    case 144:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7870; /* *pred_umaxv16di_extended_scalar */

    case 145:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7879; /* *pred_umaxv32di_extended_scalar */

    case 146:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7888; /* *pred_umaxv64di_extended_scalar */

    case 147:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7897; /* *pred_umaxv128di_extended_scalar */

    case 148:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7906; /* *pred_umaxv256di_extended_scalar */

    case 149:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7915; /* *pred_umaxv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_915 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ASHIFTRT:
      return recog_885 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_884 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
      operands[3] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[4] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[5] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[6] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[7] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4QImode:
          if (pattern504 (x2, 
E_RVVM4QImode, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
              || !
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10837; /* pred_truncrvvm8hi */

        case E_RVVM2QImode:
          if (pattern504 (x2, 
E_RVVM2QImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
              || !
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10838; /* pred_truncrvvm4hi */

        case E_RVVM1QImode:
          if (pattern504 (x2, 
E_RVVM1QImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
              || !
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10839; /* pred_truncrvvm2hi */

        case E_RVVMF2QImode:
          if (pattern504 (x2, 
E_RVVMF2QImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
              || !
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10840; /* pred_truncrvvm1hi */

        case E_RVVMF4QImode:
          if (pattern504 (x2, 
E_RVVMF4QImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
              || !
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10841; /* pred_truncrvvmf2hi */

        case E_RVVMF8QImode:
          if (pattern504 (x2, 
E_RVVMF8QImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10842; /* pred_truncrvvmf4hi */

        case E_RVVM4HImode:
          if (pattern504 (x2, 
E_RVVM4HImode, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
              || !
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10843; /* pred_truncrvvm8si */

        case E_RVVM2HImode:
          if (pattern504 (x2, 
E_RVVM2HImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
              || !
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10844; /* pred_truncrvvm4si */

        case E_RVVM1HImode:
          if (pattern504 (x2, 
E_RVVM1HImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
              || !
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10845; /* pred_truncrvvm2si */

        case E_RVVMF2HImode:
          if (pattern504 (x2, 
E_RVVMF2HImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
              || !
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10846; /* pred_truncrvvm1si */

        case E_RVVMF4HImode:
          if (pattern504 (x2, 
E_RVVMF4HImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10847; /* pred_truncrvvmf2si */

        case E_RVVM4SImode:
          if (pattern504 (x2, 
E_RVVM4SImode, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10848; /* pred_truncrvvm8di */

        case E_RVVM2SImode:
          if (pattern504 (x2, 
E_RVVM2SImode, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10849; /* pred_truncrvvm4di */

        case E_RVVM1SImode:
          if (pattern504 (x2, 
E_RVVM1SImode, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10850; /* pred_truncrvvm2di */

        case E_RVVMF2SImode:
          if (pattern504 (x2, 
E_RVVMF2SImode, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10851; /* pred_truncrvvm1di */

        case E_V1QImode:
          if (pattern504 (x2, 
E_V1QImode, 
E_V1HImode, 
E_V1BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10852; /* pred_truncv1hi */

        case E_V2QImode:
          if (pattern504 (x2, 
E_V2QImode, 
E_V2HImode, 
E_V2BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10853; /* pred_truncv2hi */

        case E_V4QImode:
          if (pattern504 (x2, 
E_V4QImode, 
E_V4HImode, 
E_V4BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10854; /* pred_truncv4hi */

        case E_V8QImode:
          if (pattern504 (x2, 
E_V8QImode, 
E_V8HImode, 
E_V8BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10855; /* pred_truncv8hi */

        case E_V16QImode:
          if (pattern504 (x2, 
E_V16QImode, 
E_V16HImode, 
E_V16BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10856; /* pred_truncv16hi */

        case E_V32QImode:
          if (pattern504 (x2, 
E_V32QImode, 
E_V32HImode, 
E_V32BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10857; /* pred_truncv32hi */

        case E_V64QImode:
          if (pattern504 (x2, 
E_V64QImode, 
E_V64HImode, 
E_V64BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10858; /* pred_truncv64hi */

        case E_V128QImode:
          if (pattern504 (x2, 
E_V128QImode, 
E_V128HImode, 
E_V128BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10859; /* pred_truncv128hi */

        case E_V256QImode:
          if (pattern504 (x2, 
E_V256QImode, 
E_V256HImode, 
E_V256BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10860; /* pred_truncv256hi */

        case E_V512QImode:
          if (pattern504 (x2, 
E_V512QImode, 
E_V512HImode, 
E_V512BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10861; /* pred_truncv512hi */

        case E_V1024QImode:
          if (pattern504 (x2, 
E_V1024QImode, 
E_V1024HImode, 
E_V1024BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10862; /* pred_truncv1024hi */

        case E_V2048QImode:
          if (pattern504 (x2, 
E_V2048QImode, 
E_V2048HImode, 
E_V2048BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10863; /* pred_truncv2048hi */

        case E_V1HImode:
          if (pattern504 (x2, 
E_V1HImode, 
E_V1SImode, 
E_V1BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10864; /* pred_truncv1si */

        case E_V2HImode:
          if (pattern504 (x2, 
E_V2HImode, 
E_V2SImode, 
E_V2BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10865; /* pred_truncv2si */

        case E_V4HImode:
          if (pattern504 (x2, 
E_V4HImode, 
E_V4SImode, 
E_V4BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10866; /* pred_truncv4si */

        case E_V8HImode:
          if (pattern504 (x2, 
E_V8HImode, 
E_V8SImode, 
E_V8BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10867; /* pred_truncv8si */

        case E_V16HImode:
          if (pattern504 (x2, 
E_V16HImode, 
E_V16SImode, 
E_V16BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10868; /* pred_truncv16si */

        case E_V32HImode:
          if (pattern504 (x2, 
E_V32HImode, 
E_V32SImode, 
E_V32BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10869; /* pred_truncv32si */

        case E_V64HImode:
          if (pattern504 (x2, 
E_V64HImode, 
E_V64SImode, 
E_V64BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10870; /* pred_truncv64si */

        case E_V128HImode:
          if (pattern504 (x2, 
E_V128HImode, 
E_V128SImode, 
E_V128BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10871; /* pred_truncv128si */

        case E_V256HImode:
          if (pattern504 (x2, 
E_V256HImode, 
E_V256SImode, 
E_V256BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10872; /* pred_truncv256si */

        case E_V512HImode:
          if (pattern504 (x2, 
E_V512HImode, 
E_V512SImode, 
E_V512BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10873; /* pred_truncv512si */

        case E_V1024HImode:
          if (pattern504 (x2, 
E_V1024HImode, 
E_V1024SImode, 
E_V1024BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10874; /* pred_truncv1024si */

        case E_V1SImode:
          if (pattern504 (x2, 
E_V1SImode, 
E_V1DImode, 
E_V1BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10875; /* pred_truncv1di */

        case E_V2SImode:
          if (pattern504 (x2, 
E_V2SImode, 
E_V2DImode, 
E_V2BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10876; /* pred_truncv2di */

        case E_V4SImode:
          if (pattern504 (x2, 
E_V4SImode, 
E_V4DImode, 
E_V4BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10877; /* pred_truncv4di */

        case E_V8SImode:
          if (pattern504 (x2, 
E_V8SImode, 
E_V8DImode, 
E_V8BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10878; /* pred_truncv8di */

        case E_V16SImode:
          if (pattern504 (x2, 
E_V16SImode, 
E_V16DImode, 
E_V16BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10879; /* pred_truncv16di */

        case E_V32SImode:
          if (pattern504 (x2, 
E_V32SImode, 
E_V32DImode, 
E_V32BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10880; /* pred_truncv32di */

        case E_V64SImode:
          if (pattern504 (x2, 
E_V64SImode, 
E_V64DImode, 
E_V64BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10881; /* pred_truncv64di */

        case E_V128SImode:
          if (pattern504 (x2, 
E_V128SImode, 
E_V128DImode, 
E_V128BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10882; /* pred_truncv128di */

        case E_V256SImode:
          if (pattern504 (x2, 
E_V256SImode, 
E_V256DImode, 
E_V256BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10883; /* pred_truncv256di */

        case E_V512SImode:
          if (pattern504 (x2, 
E_V512SImode, 
E_V512DImode, 
E_V512BImode) != 0
              || !(
#line 4290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10884; /* pred_truncv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_922 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern474 (x2))
    {
    case 0:
      if (!
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))))
        return -1;
      return 1256; /* *pred_mov_widthwurvvm8qi */

    case 1:
      if (!
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))))
        return -1;
      return 1262; /* *pred_mov_widthwurvvm4qi */

    case 2:
      if (!
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))))
        return -1;
      return 1268; /* *pred_mov_widthwurvvm2qi */

    case 3:
      if (!
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))))
        return -1;
      return 1274; /* *pred_mov_widthwurvvm1qi */

    case 4:
      if (!
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))))
        return -1;
      return 1280; /* *pred_mov_widthwurvvm8hi */

    case 5:
      if (!
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))))
        return -1;
      return 1286; /* *pred_mov_widthwurvvm4hi */

    case 6:
      if (!
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))))
        return -1;
      return 1292; /* *pred_mov_widthwurvvm2hi */

    case 7:
      if (!
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))))
        return -1;
      return 1298; /* *pred_mov_widthwurvvm1hi */

    case 8:
      if (!
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))))
        return -1;
      return 1304; /* *pred_mov_widthwurvvm8si */

    case 9:
      if (!
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))))
        return -1;
      return 1310; /* *pred_mov_widthwurvvm4si */

    case 10:
      if (!
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))))
        return -1;
      return 1316; /* *pred_mov_widthwurvvm2si */

    case 11:
      if (!
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))))
        return -1;
      return 1322; /* *pred_mov_widthwurvvm1si */

    case 12:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1328; /* *pred_mov_widthwurvvm8di */

    case 13:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1334; /* *pred_mov_widthwurvvm4di */

    case 14:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1340; /* *pred_mov_widthwurvvm2di */

    case 15:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1346; /* *pred_mov_widthwurvvm1di */

    case 16:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1352; /* *pred_mov_widthwurvvmf2qi */

    case 17:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1358; /* *pred_mov_widthwurvvmf4qi */

    case 18:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1364; /* *pred_mov_widthwurvvmf8qi */

    case 19:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1370; /* *pred_mov_widthwurvvmf2hi */

    case 20:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1376; /* *pred_mov_widthwurvvmf4hi */

    case 21:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1382; /* *pred_mov_widthwurvvmf2si */

    case 22:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1388; /* *pred_mov_widthwurvvm8bf */

    case 23:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1394; /* *pred_mov_widthwurvvm4bf */

    case 24:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1400; /* *pred_mov_widthwurvvm2bf */

    case 25:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1406; /* *pred_mov_widthwurvvm1bf */

    case 26:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1412; /* *pred_mov_widthwurvvmf2bf */

    case 27:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1418; /* *pred_mov_widthwurvvmf4bf */

    case 28:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1424; /* *pred_mov_widthwurvvm8hf */

    case 29:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1430; /* *pred_mov_widthwurvvm4hf */

    case 30:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1436; /* *pred_mov_widthwurvvm2hf */

    case 31:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1442; /* *pred_mov_widthwurvvm1hf */

    case 32:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1448; /* *pred_mov_widthwurvvmf2hf */

    case 33:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1454; /* *pred_mov_widthwurvvmf4hf */

    case 34:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1460; /* *pred_mov_widthwurvvm8sf */

    case 35:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1466; /* *pred_mov_widthwurvvm4sf */

    case 36:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1472; /* *pred_mov_widthwurvvm2sf */

    case 37:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1478; /* *pred_mov_widthwurvvm1sf */

    case 38:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1484; /* *pred_mov_widthwurvvmf2sf */

    case 39:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1490; /* *pred_mov_widthwurvvm8df */

    case 40:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1496; /* *pred_mov_widthwurvvm4df */

    case 41:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1502; /* *pred_mov_widthwurvvm2df */

    case 42:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1508; /* *pred_mov_widthwurvvm1df */

    case 43:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 1514; /* *pred_mov_widthwuv1qi */

    case 44:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 1520; /* *pred_mov_widthwuv2qi */

    case 45:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 1526; /* *pred_mov_widthwuv4qi */

    case 46:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 1532; /* *pred_mov_widthwuv8qi */

    case 47:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 1538; /* *pred_mov_widthwuv16qi */

    case 48:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 1544; /* *pred_mov_widthwuv32qi */

    case 49:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1550; /* *pred_mov_widthwuv64qi */

    case 50:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1556; /* *pred_mov_widthwuv128qi */

    case 51:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1562; /* *pred_mov_widthwuv256qi */

    case 52:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1568; /* *pred_mov_widthwuv512qi */

    case 53:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1574; /* *pred_mov_widthwuv1024qi */

    case 54:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1580; /* *pred_mov_widthwuv2048qi */

    case 55:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1586; /* *pred_mov_widthwuv4096qi */

    case 56:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 1592; /* *pred_mov_widthwuv1hi */

    case 57:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 1598; /* *pred_mov_widthwuv2hi */

    case 58:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 1604; /* *pred_mov_widthwuv4hi */

    case 59:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 1610; /* *pred_mov_widthwuv8hi */

    case 60:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 1616; /* *pred_mov_widthwuv16hi */

    case 61:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1622; /* *pred_mov_widthwuv32hi */

    case 62:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1628; /* *pred_mov_widthwuv64hi */

    case 63:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1634; /* *pred_mov_widthwuv128hi */

    case 64:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1640; /* *pred_mov_widthwuv256hi */

    case 65:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1646; /* *pred_mov_widthwuv512hi */

    case 66:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1652; /* *pred_mov_widthwuv1024hi */

    case 67:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1658; /* *pred_mov_widthwuv2048hi */

    case 68:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 1664; /* *pred_mov_widthwuv1si */

    case 69:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 1670; /* *pred_mov_widthwuv2si */

    case 70:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 1676; /* *pred_mov_widthwuv4si */

    case 71:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 1682; /* *pred_mov_widthwuv8si */

    case 72:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1688; /* *pred_mov_widthwuv16si */

    case 73:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1694; /* *pred_mov_widthwuv32si */

    case 74:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1700; /* *pred_mov_widthwuv64si */

    case 75:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1706; /* *pred_mov_widthwuv128si */

    case 76:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1712; /* *pred_mov_widthwuv256si */

    case 77:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1718; /* *pred_mov_widthwuv512si */

    case 78:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1724; /* *pred_mov_widthwuv1024si */

    case 79:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1730; /* *pred_mov_widthwuv1di */

    case 80:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1736; /* *pred_mov_widthwuv2di */

    case 81:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1742; /* *pred_mov_widthwuv4di */

    case 82:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1748; /* *pred_mov_widthwuv8di */

    case 83:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1754; /* *pred_mov_widthwuv16di */

    case 84:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1760; /* *pred_mov_widthwuv32di */

    case 85:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1766; /* *pred_mov_widthwuv64di */

    case 86:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1772; /* *pred_mov_widthwuv128di */

    case 87:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1778; /* *pred_mov_widthwuv256di */

    case 88:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1784; /* *pred_mov_widthwuv512di */

    case 89:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1790; /* *pred_mov_widthwuv1hf */

    case 90:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1796; /* *pred_mov_widthwuv2hf */

    case 91:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1802; /* *pred_mov_widthwuv4hf */

    case 92:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1808; /* *pred_mov_widthwuv8hf */

    case 93:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1814; /* *pred_mov_widthwuv16hf */

    case 94:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1820; /* *pred_mov_widthwuv32hf */

    case 95:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1826; /* *pred_mov_widthwuv64hf */

    case 96:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1832; /* *pred_mov_widthwuv128hf */

    case 97:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1838; /* *pred_mov_widthwuv256hf */

    case 98:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1844; /* *pred_mov_widthwuv512hf */

    case 99:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1850; /* *pred_mov_widthwuv1024hf */

    case 100:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1856; /* *pred_mov_widthwuv2048hf */

    case 101:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1862; /* *pred_mov_widthwuv1sf */

    case 102:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1868; /* *pred_mov_widthwuv2sf */

    case 103:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1874; /* *pred_mov_widthwuv4sf */

    case 104:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1880; /* *pred_mov_widthwuv8sf */

    case 105:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1886; /* *pred_mov_widthwuv16sf */

    case 106:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1892; /* *pred_mov_widthwuv32sf */

    case 107:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1898; /* *pred_mov_widthwuv64sf */

    case 108:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1904; /* *pred_mov_widthwuv128sf */

    case 109:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1910; /* *pred_mov_widthwuv256sf */

    case 110:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1916; /* *pred_mov_widthwuv512sf */

    case 111:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1922; /* *pred_mov_widthwuv1024sf */

    case 112:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1928; /* *pred_mov_widthwuv1df */

    case 113:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1934; /* *pred_mov_widthwuv2df */

    case 114:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1940; /* *pred_mov_widthwuv4df */

    case 115:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1946; /* *pred_mov_widthwuv8df */

    case 116:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1952; /* *pred_mov_widthwuv16df */

    case 117:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1958; /* *pred_mov_widthwuv32df */

    case 118:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1964; /* *pred_mov_widthwuv64df */

    case 119:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1970; /* *pred_mov_widthwuv128df */

    case 120:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1976; /* *pred_mov_widthwuv256df */

    case 121:
      if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1982; /* *pred_mov_widthwuv512df */

    default:
      return -1;
    }
}

 int
recog_934 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern722 (x2))
    {
    case 0:
      if (register_operand (operands[4], E_RVVM8QImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11406; /* pred_aaddrvvm8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11882; /* pred_aaddrvvm8qi_scalar */

    case 1:
      if (register_operand (operands[4], E_RVVM4QImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11413; /* pred_aaddrvvm4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11887; /* pred_aaddrvvm4qi_scalar */

    case 2:
      if (register_operand (operands[4], E_RVVM2QImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11420; /* pred_aaddrvvm2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11892; /* pred_aaddrvvm2qi_scalar */

    case 3:
      if (register_operand (operands[4], E_RVVM1QImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11427; /* pred_aaddrvvm1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11897; /* pred_aaddrvvm1qi_scalar */

    case 4:
      if (register_operand (operands[4], E_RVVM8HImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11434; /* pred_aaddrvvm8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11917; /* pred_aaddrvvm8hi_scalar */

    case 5:
      if (register_operand (operands[4], E_RVVM4HImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11441; /* pred_aaddrvvm4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11922; /* pred_aaddrvvm4hi_scalar */

    case 6:
      if (register_operand (operands[4], E_RVVM2HImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11448; /* pred_aaddrvvm2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11927; /* pred_aaddrvvm2hi_scalar */

    case 7:
      if (register_operand (operands[4], E_RVVM1HImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11455; /* pred_aaddrvvm1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11932; /* pred_aaddrvvm1hi_scalar */

    case 8:
      if (register_operand (operands[4], E_RVVM8SImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11462; /* pred_aaddrvvm8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11947; /* pred_aaddrvvm8si_scalar */

    case 9:
      if (register_operand (operands[4], E_RVVM4SImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11469; /* pred_aaddrvvm4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11952; /* pred_aaddrvvm4si_scalar */

    case 10:
      if (register_operand (operands[4], E_RVVM2SImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11476; /* pred_aaddrvvm2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11957; /* pred_aaddrvvm2si_scalar */

    case 11:
      if (register_operand (operands[4], E_RVVM1SImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11483; /* pred_aaddrvvm1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11962; /* pred_aaddrvvm1si_scalar */

    case 12:
      if (register_operand (operands[4], E_RVVM8DImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11490; /* pred_aaddrvvm8di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12196; /* *pred_aaddrvvm8di_scalar */

    case 13:
      if (register_operand (operands[4], E_RVVM4DImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11497; /* pred_aaddrvvm4di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12201; /* *pred_aaddrvvm4di_scalar */

    case 14:
      if (register_operand (operands[4], E_RVVM2DImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11504; /* pred_aaddrvvm2di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12206; /* *pred_aaddrvvm2di_scalar */

    case 15:
      if (register_operand (operands[4], E_RVVM1DImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11511; /* pred_aaddrvvm1di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12211; /* *pred_aaddrvvm1di_scalar */

    case 16:
      if (register_operand (operands[4], E_RVVMF2QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11518; /* pred_aaddrvvmf2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11902; /* pred_aaddrvvmf2qi_scalar */

    case 17:
      if (register_operand (operands[4], E_RVVMF4QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11525; /* pred_aaddrvvmf4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11907; /* pred_aaddrvvmf4qi_scalar */

    case 18:
      if (register_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11532; /* pred_aaddrvvmf8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11912; /* pred_aaddrvvmf8qi_scalar */

    case 19:
      if (register_operand (operands[4], E_RVVMF2HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11539; /* pred_aaddrvvmf2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11937; /* pred_aaddrvvmf2hi_scalar */

    case 20:
      if (register_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11546; /* pred_aaddrvvmf4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11942; /* pred_aaddrvvmf4hi_scalar */

    case 21:
      if (register_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11553; /* pred_aaddrvvmf2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11967; /* pred_aaddrvvmf2si_scalar */

    case 22:
      if (register_operand (operands[4], E_V1QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 11560; /* pred_aaddv1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 11972; /* pred_aaddv1qi_scalar */

    case 23:
      if (register_operand (operands[4], E_V2QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 11567; /* pred_aaddv2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 11977; /* pred_aaddv2qi_scalar */

    case 24:
      if (register_operand (operands[4], E_V4QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 11574; /* pred_aaddv4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 11982; /* pred_aaddv4qi_scalar */

    case 25:
      if (register_operand (operands[4], E_V8QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 11581; /* pred_aaddv8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 11987; /* pred_aaddv8qi_scalar */

    case 26:
      if (register_operand (operands[4], E_V16QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 11588; /* pred_aaddv16qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 11992; /* pred_aaddv16qi_scalar */

    case 27:
      if (register_operand (operands[4], E_V32QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 11595; /* pred_aaddv32qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 11997; /* pred_aaddv32qi_scalar */

    case 28:
      if (register_operand (operands[4], E_V64QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 11602; /* pred_aaddv64qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12002; /* pred_aaddv64qi_scalar */

    case 29:
      if (register_operand (operands[4], E_V128QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 11609; /* pred_aaddv128qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12007; /* pred_aaddv128qi_scalar */

    case 30:
      if (register_operand (operands[4], E_V256QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 11616; /* pred_aaddv256qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12012; /* pred_aaddv256qi_scalar */

    case 31:
      if (register_operand (operands[4], E_V512QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 11623; /* pred_aaddv512qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12017; /* pred_aaddv512qi_scalar */

    case 32:
      if (register_operand (operands[4], E_V1024QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 11630; /* pred_aaddv1024qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12022; /* pred_aaddv1024qi_scalar */

    case 33:
      if (register_operand (operands[4], E_V2048QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 11637; /* pred_aaddv2048qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12027; /* pred_aaddv2048qi_scalar */

    case 34:
      if (register_operand (operands[4], E_V4096QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 11644; /* pred_aaddv4096qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12032; /* pred_aaddv4096qi_scalar */

    case 35:
      if (register_operand (operands[4], E_V1HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 11651; /* pred_aaddv1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 12037; /* pred_aaddv1hi_scalar */

    case 36:
      if (register_operand (operands[4], E_V2HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 11658; /* pred_aaddv2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12042; /* pred_aaddv2hi_scalar */

    case 37:
      if (register_operand (operands[4], E_V4HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 11665; /* pred_aaddv4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12047; /* pred_aaddv4hi_scalar */

    case 38:
      if (register_operand (operands[4], E_V8HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 11672; /* pred_aaddv8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12052; /* pred_aaddv8hi_scalar */

    case 39:
      if (register_operand (operands[4], E_V16HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 11679; /* pred_aaddv16hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12057; /* pred_aaddv16hi_scalar */

    case 40:
      if (register_operand (operands[4], E_V32HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 11686; /* pred_aaddv32hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12062; /* pred_aaddv32hi_scalar */

    case 41:
      if (register_operand (operands[4], E_V64HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 11693; /* pred_aaddv64hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12067; /* pred_aaddv64hi_scalar */

    case 42:
      if (register_operand (operands[4], E_V128HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 11700; /* pred_aaddv128hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12072; /* pred_aaddv128hi_scalar */

    case 43:
      if (register_operand (operands[4], E_V256HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 11707; /* pred_aaddv256hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12077; /* pred_aaddv256hi_scalar */

    case 44:
      if (register_operand (operands[4], E_V512HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 11714; /* pred_aaddv512hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12082; /* pred_aaddv512hi_scalar */

    case 45:
      if (register_operand (operands[4], E_V1024HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 11721; /* pred_aaddv1024hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12087; /* pred_aaddv1024hi_scalar */

    case 46:
      if (register_operand (operands[4], E_V2048HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 11728; /* pred_aaddv2048hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12092; /* pred_aaddv2048hi_scalar */

    case 47:
      if (register_operand (operands[4], E_V1SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 11735; /* pred_aaddv1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 12097; /* pred_aaddv1si_scalar */

    case 48:
      if (register_operand (operands[4], E_V2SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 11742; /* pred_aaddv2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12102; /* pred_aaddv2si_scalar */

    case 49:
      if (register_operand (operands[4], E_V4SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 11749; /* pred_aaddv4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12107; /* pred_aaddv4si_scalar */

    case 50:
      if (register_operand (operands[4], E_V8SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 11756; /* pred_aaddv8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12112; /* pred_aaddv8si_scalar */

    case 51:
      if (register_operand (operands[4], E_V16SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 11763; /* pred_aaddv16si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12117; /* pred_aaddv16si_scalar */

    case 52:
      if (register_operand (operands[4], E_V32SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 11770; /* pred_aaddv32si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12122; /* pred_aaddv32si_scalar */

    case 53:
      if (register_operand (operands[4], E_V64SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 11777; /* pred_aaddv64si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12127; /* pred_aaddv64si_scalar */

    case 54:
      if (register_operand (operands[4], E_V128SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 11784; /* pred_aaddv128si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12132; /* pred_aaddv128si_scalar */

    case 55:
      if (register_operand (operands[4], E_V256SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 11791; /* pred_aaddv256si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12137; /* pred_aaddv256si_scalar */

    case 56:
      if (register_operand (operands[4], E_V512SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 11798; /* pred_aaddv512si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12142; /* pred_aaddv512si_scalar */

    case 57:
      if (register_operand (operands[4], E_V1024SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 11805; /* pred_aaddv1024si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12147; /* pred_aaddv1024si_scalar */

    case 58:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11812; /* pred_aaddv1di */

    case 59:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11819; /* pred_aaddv2di */

    case 60:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11826; /* pred_aaddv4di */

    case 61:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11833; /* pred_aaddv8di */

    case 62:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11840; /* pred_aaddv16di */

    case 63:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11847; /* pred_aaddv32di */

    case 64:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11854; /* pred_aaddv64di */

    case 65:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11861; /* pred_aaddv128di */

    case 66:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11868; /* pred_aaddv256di */

    case 67:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11875; /* pred_aaddv512di */

    case 68:
      if (!(
#line 4679 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12216; /* *pred_aaddrvvm8di_extended_scalar */

    case 69:
      if (!(
#line 4679 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12221; /* *pred_aaddrvvm4di_extended_scalar */

    case 70:
      if (!(
#line 4679 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12226; /* *pred_aaddrvvm2di_extended_scalar */

    case 71:
      if (!(
#line 4679 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12231; /* *pred_aaddrvvm1di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_1072 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1SFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15788; /* *pred_mul_neg_addv1sf_undef */
}

 int
recog_1081 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V512SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V512SFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15806; /* *pred_mul_neg_addv512sf_undef */
}

 int
recog_1090 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V128DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V128DFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15824; /* *pred_mul_neg_addv128df_undef */
}

 int
recog_1100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1085 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V4DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V4DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15910; /* *pred_nmsubv4df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 16006; /* *pred_nmsacv4df */
}

 int
recog_1109 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1076 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V16SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return 15892; /* *pred_nmsubv16sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15988; /* *pred_nmsacv16sf */
}

 int
recog_1122 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1063 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V8HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V8HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return 15866; /* *pred_nmsubv8hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return -1;
  return 15962; /* *pred_nmsacv8hf */
}

 int
recog_1129 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1056 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM8DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM8DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15852; /* *pred_nmsubrvvm8df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15948; /* *pred_nmsacrvvm8df */
}

 int
recog_1139 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1046 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM4HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15832; /* *pred_nmsubrvvm4hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15928; /* *pred_nmsacrvvm4hf */
}

 int
recog_1149 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVMF4HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVMF4HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVMF4HFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 15265; /* *pred_mul_subrvvmf4hf_undef */
}

 int
recog_1156 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM4DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM4DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM4DFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15279; /* *pred_mul_subrvvm4df_undef */
}

 int
recog_1163 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V16HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V16HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V16HFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return -1;
  return 15293; /* *pred_mul_subv16hf_undef */
}

 int
recog_1170 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2048HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2048HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2048HFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15307; /* *pred_mul_subv2048hf_undef */
}

 int
recog_1177 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V64SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V64SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V64SFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15321; /* *pred_mul_subv64sf_undef */
}

 int
recog_1184 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V4DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V4DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V4DFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15335; /* *pred_mul_subv4df_undef */
}

 int
recog_1191 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V512DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V512DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V512DFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15349; /* *pred_mul_subv512df_undef */
}

 int
recog_1198 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1185 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return 15433; /* *pred_msubv8df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15529; /* *pred_msacv8df */
}

 int
recog_1205 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1178 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V128SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return 15419; /* *pred_msubv128sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15515; /* *pred_msacv128sf */
}

 int
recog_1212 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1171 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V1SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15405; /* *pred_msubv1sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15501; /* *pred_msacv1sf */
}

 int
recog_1219 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1164 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V32HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V32HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
    return 15391; /* *pred_msubv32hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15487; /* *pred_msacv32hf */
}

 int
recog_1226 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1157 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM2DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15377; /* *pred_msubrvvm2df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15473; /* *pred_msacrvvm2df */
}

 int
recog_1233 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1150 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM8SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15363; /* *pred_msubrvvm8sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15459; /* *pred_msacrvvm8sf */
}

 int
recog_1240 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM8HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM8HFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15735; /* *pred_mul_neg_subrvvm8hf_undef */
}

 int
recog_1245 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVMF4HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVMF4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVMF4HFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 15745; /* *pred_mul_neg_subrvvmf4hf_undef */
}

 int
recog_1252 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM4DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM4DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM4DFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15759; /* *pred_mul_neg_subrvvm4df_undef */
}

 int
recog_1259 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V16HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V16HFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return -1;
  return 15773; /* *pred_mul_neg_subv16hf_undef */
}

 int
recog_1266 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2048HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V2048HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V2048HFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15787; /* *pred_mul_neg_subv2048hf_undef */
}

 int
recog_1273 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V64SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V64SFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15801; /* *pred_mul_neg_subv64sf_undef */
}

 int
recog_1280 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V4DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V4DFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15815; /* *pred_mul_neg_subv4df_undef */
}

 int
recog_1287 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V512DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V512DFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15829; /* *pred_mul_neg_subv512df_undef */
}

 int
recog_1294 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1281 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V8DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return 15913; /* *pred_nmaddv8df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 16009; /* *pred_nmaccv8df */
}

 int
recog_1301 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1274 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V128SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V128SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return 15899; /* *pred_nmaddv128sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15995; /* *pred_nmaccv128sf */
}

 int
recog_1308 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1267 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15885; /* *pred_nmaddv1sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15981; /* *pred_nmaccv1sf */
}

 int
recog_1315 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1260 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V32HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V32HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
    return 15871; /* *pred_nmaddv32hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15967; /* *pred_nmaccv32hf */
}

 int
recog_1322 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1253 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM2DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM2DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15857; /* *pred_nmaddrvvm2df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15953; /* *pred_nmaccrvvm2df */
}

 int
recog_1330 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1245 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVMF4HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVMF4HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
    return 15841; /* *pred_nmaddrvvmf4hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 15937; /* *pred_nmaccrvvmf4hf */
}

 int
recog_1338 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XVECEXP (x5, 0, 5);
  operands[9] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  x12 = XEXP (x3, 1);
  switch (GET_CODE (x12))
    {
    case REG:
    case SUBREG:
      switch (pattern713 (x2))
        {
        case 0:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14500; /* pred_subrvvm8hf */

        case 1:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14504; /* pred_subrvvm4hf */

        case 2:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14508; /* pred_subrvvm2hf */

        case 3:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14512; /* pred_subrvvm1hf */

        case 4:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14516; /* pred_subrvvmf2hf */

        case 5:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14520; /* pred_subrvvmf4hf */

        case 6:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14524; /* pred_subrvvm8sf */

        case 7:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14528; /* pred_subrvvm4sf */

        case 8:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14532; /* pred_subrvvm2sf */

        case 9:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14536; /* pred_subrvvm1sf */

        case 10:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14540; /* pred_subrvvmf2sf */

        case 11:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14544; /* pred_subrvvm8df */

        case 12:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14548; /* pred_subrvvm4df */

        case 13:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14552; /* pred_subrvvm2df */

        case 14:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14556; /* pred_subrvvm1df */

        case 15:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 14560; /* pred_subv1hf */

        case 16:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 14564; /* pred_subv2hf */

        case 17:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 14568; /* pred_subv4hf */

        case 18:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 14572; /* pred_subv8hf */

        case 19:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 14576; /* pred_subv16hf */

        case 20:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14580; /* pred_subv32hf */

        case 21:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14584; /* pred_subv64hf */

        case 22:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14588; /* pred_subv128hf */

        case 23:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14592; /* pred_subv256hf */

        case 24:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14596; /* pred_subv512hf */

        case 25:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14600; /* pred_subv1024hf */

        case 26:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14604; /* pred_subv2048hf */

        case 27:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14608; /* pred_subv1sf */

        case 28:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14612; /* pred_subv2sf */

        case 29:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14616; /* pred_subv4sf */

        case 30:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14620; /* pred_subv8sf */

        case 31:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14624; /* pred_subv16sf */

        case 32:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14628; /* pred_subv32sf */

        case 33:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14632; /* pred_subv64sf */

        case 34:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14636; /* pred_subv128sf */

        case 35:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14640; /* pred_subv256sf */

        case 36:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14644; /* pred_subv512sf */

        case 37:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14648; /* pred_subv1024sf */

        case 38:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14652; /* pred_subv1df */

        case 39:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14656; /* pred_subv2df */

        case 40:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14660; /* pred_subv4df */

        case 41:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14664; /* pred_subv8df */

        case 42:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14668; /* pred_subv16df */

        case 43:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14672; /* pred_subv32df */

        case 44:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14676; /* pred_subv64df */

        case 45:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14680; /* pred_subv128df */

        case 46:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14684; /* pred_subv256df */

        case 47:
          if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14688; /* pred_subv512df */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern728 (x2))
        {
        case 0:
          if (!(
#line 6336 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14972; /* pred_subrvvm8hf_scalar */

        case 1:
          if (!(
#line 6336 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14974; /* pred_subrvvm4hf_scalar */

        case 2:
          if (!(
#line 6336 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14976; /* pred_subrvvm2hf_scalar */

        case 3:
          if (!(
#line 6336 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14978; /* pred_subrvvm1hf_scalar */

        case 4:
          if (!(
#line 6336 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14980; /* pred_subrvvmf2hf_scalar */

        case 5:
          if (!(
#line 6336 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14982; /* pred_subrvvmf4hf_scalar */

        case 6:
          if (!(
#line 6336 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14984; /* pred_subrvvm8sf_scalar */

        case 7:
          if (!(
#line 6336 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14986; /* pred_subrvvm4sf_scalar */

        case 8:
          if (!(
#line 6336 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14988; /* pred_subrvvm2sf_scalar */

        case 9:
          if (!(
#line 6336 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14990; /* pred_subrvvm1sf_scalar */

        case 10:
          if (!(
#line 6336 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14992; /* pred_subrvvmf2sf_scalar */

        case 11:
          if (!(
#line 6336 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14994; /* pred_subrvvm8df_scalar */

        case 12:
          if (!(
#line 6336 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14996; /* pred_subrvvm4df_scalar */

        case 13:
          if (!(
#line 6336 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14998; /* pred_subrvvm2df_scalar */

        case 14:
          if (!(
#line 6336 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 15000; /* pred_subrvvm1df_scalar */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x13 = XEXP (x12, 0);
      switch (GET_CODE (x13))
        {
        case REG:
        case SUBREG:
          operands[4] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern542 (x2, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16613; /* pred_single_widen_subrvvm8sf */

            case E_RVVM4SFmode:
              if (pattern542 (x2, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16614; /* pred_single_widen_subrvvm4sf */

            case E_RVVM2SFmode:
              if (pattern542 (x2, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16615; /* pred_single_widen_subrvvm2sf */

            case E_RVVM1SFmode:
              if (pattern542 (x2, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16616; /* pred_single_widen_subrvvm1sf */

            case E_RVVMF2SFmode:
              if (pattern542 (x2, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 16617; /* pred_single_widen_subrvvmf2sf */

            case E_RVVM8DFmode:
              if (pattern542 (x2, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16618; /* pred_single_widen_subrvvm8df */

            case E_RVVM4DFmode:
              if (pattern542 (x2, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16619; /* pred_single_widen_subrvvm4df */

            case E_RVVM2DFmode:
              if (pattern542 (x2, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16620; /* pred_single_widen_subrvvm2df */

            case E_RVVM1DFmode:
              if (pattern542 (x2, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16621; /* pred_single_widen_subrvvm1df */

            case E_V1SFmode:
              if (pattern542 (x2, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16622; /* pred_single_widen_subv1sf */

            case E_V2SFmode:
              if (pattern542 (x2, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16623; /* pred_single_widen_subv2sf */

            case E_V4SFmode:
              if (pattern542 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16624; /* pred_single_widen_subv4sf */

            case E_V8SFmode:
              if (pattern542 (x2, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16625; /* pred_single_widen_subv8sf */

            case E_V16SFmode:
              if (pattern542 (x2, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16626; /* pred_single_widen_subv16sf */

            case E_V32SFmode:
              if (pattern542 (x2, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16627; /* pred_single_widen_subv32sf */

            case E_V64SFmode:
              if (pattern542 (x2, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16628; /* pred_single_widen_subv64sf */

            case E_V128SFmode:
              if (pattern542 (x2, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16629; /* pred_single_widen_subv128sf */

            case E_V256SFmode:
              if (pattern542 (x2, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16630; /* pred_single_widen_subv256sf */

            case E_V512SFmode:
              if (pattern542 (x2, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16631; /* pred_single_widen_subv512sf */

            case E_V1024SFmode:
              if (pattern542 (x2, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16632; /* pred_single_widen_subv1024sf */

            case E_V1DFmode:
              if (pattern542 (x2, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16633; /* pred_single_widen_subv1df */

            case E_V2DFmode:
              if (pattern542 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16634; /* pred_single_widen_subv2df */

            case E_V4DFmode:
              if (pattern542 (x2, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16635; /* pred_single_widen_subv4df */

            case E_V8DFmode:
              if (pattern542 (x2, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16636; /* pred_single_widen_subv8df */

            case E_V16DFmode:
              if (pattern542 (x2, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16637; /* pred_single_widen_subv16df */

            case E_V32DFmode:
              if (pattern542 (x2, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16638; /* pred_single_widen_subv32df */

            case E_V64DFmode:
              if (pattern542 (x2, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16639; /* pred_single_widen_subv64df */

            case E_V128DFmode:
              if (pattern542 (x2, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16640; /* pred_single_widen_subv128df */

            case E_V256DFmode:
              if (pattern542 (x2, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16641; /* pred_single_widen_subv256df */

            case E_V512DFmode:
              if (pattern542 (x2, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0
                  || !(
#line 7115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16642; /* pred_single_widen_subv512df */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          switch (pattern734 (x2))
            {
            case 0:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16644; /* pred_single_widen_subrvvm8sf_scalar */

            case 1:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16646; /* pred_single_widen_subrvvm4sf_scalar */

            case 2:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16648; /* pred_single_widen_subrvvm2sf_scalar */

            case 3:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16650; /* pred_single_widen_subrvvm1sf_scalar */

            case 4:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 16652; /* pred_single_widen_subrvvmf2sf_scalar */

            case 5:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16654; /* pred_single_widen_subrvvm8df_scalar */

            case 6:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16656; /* pred_single_widen_subrvvm4df_scalar */

            case 7:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16658; /* pred_single_widen_subrvvm2df_scalar */

            case 8:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16660; /* pred_single_widen_subrvvm1df_scalar */

            case 9:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16662; /* pred_single_widen_subv1sf_scalar */

            case 10:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16664; /* pred_single_widen_subv2sf_scalar */

            case 11:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16666; /* pred_single_widen_subv4sf_scalar */

            case 12:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16668; /* pred_single_widen_subv8sf_scalar */

            case 13:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16670; /* pred_single_widen_subv16sf_scalar */

            case 14:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16672; /* pred_single_widen_subv32sf_scalar */

            case 15:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16674; /* pred_single_widen_subv64sf_scalar */

            case 16:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16676; /* pred_single_widen_subv128sf_scalar */

            case 17:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16678; /* pred_single_widen_subv256sf_scalar */

            case 18:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16680; /* pred_single_widen_subv512sf_scalar */

            case 19:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16682; /* pred_single_widen_subv1024sf_scalar */

            case 20:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16684; /* pred_single_widen_subv1df_scalar */

            case 21:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16686; /* pred_single_widen_subv2df_scalar */

            case 22:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16688; /* pred_single_widen_subv4df_scalar */

            case 23:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16690; /* pred_single_widen_subv8df_scalar */

            case 24:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16692; /* pred_single_widen_subv16df_scalar */

            case 25:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16694; /* pred_single_widen_subv32df_scalar */

            case 26:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16696; /* pred_single_widen_subv64df_scalar */

            case 27:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16698; /* pred_single_widen_subv128df_scalar */

            case 28:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16700; /* pred_single_widen_subv256df_scalar */

            case 29:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16702; /* pred_single_widen_subv512df_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1361 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V256QImode:
      if (!register_operand (operands[3], E_V256QImode)
          || !vector_arith_operand (operands[4], E_V256QImode)
          || !(
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12457; /* *pred_cmpv256qi_merge_tie_mask */

    case E_V256HImode:
      if (!register_operand (operands[3], E_V256HImode)
          || !vector_arith_operand (operands[4], E_V256HImode)
          || !(
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12470; /* *pred_cmpv256hi_merge_tie_mask */

    case E_V256SImode:
      if (!register_operand (operands[3], E_V256SImode)
          || !vector_arith_operand (operands[4], E_V256SImode)
          || !(
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12482; /* *pred_cmpv256si_merge_tie_mask */

    case E_V256DImode:
      if (!register_operand (operands[3], E_V256DImode)
          || !vector_arith_operand (operands[4], E_V256DImode)
          || !(
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12493; /* *pred_cmpv256di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1367 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern536 (x2, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V128BImode))
    {
      res = recog_1360 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V128BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V128BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V128QImode:
      if (!register_operand (operands[4], E_V128QImode)
          || !vector_arith_operand (operands[5], E_V128QImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128QImode)) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 12524; /* *pred_cmpv128qi */
      if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128QImode)) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12592; /* *pred_cmpv128qi_narrow */

    case E_V128HImode:
      if (!register_operand (operands[4], E_V128HImode)
          || !vector_arith_operand (operands[5], E_V128HImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128HImode)) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 12537; /* *pred_cmpv128hi */
      if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128HImode)) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12605; /* *pred_cmpv128hi_narrow */

    case E_V128SImode:
      if (!register_operand (operands[4], E_V128SImode)
          || !vector_arith_operand (operands[5], E_V128SImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128SImode)) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 12549; /* *pred_cmpv128si */
      if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128SImode)) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12617; /* *pred_cmpv128si_narrow */

    case E_V128DImode:
      if (!register_operand (operands[4], E_V128DImode)
          || !vector_arith_operand (operands[5], E_V128DImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128DImode)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 12560; /* *pred_cmpv128di */
      if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128DImode)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12628; /* *pred_cmpv128di_narrow */

    default:
      return -1;
    }
}

 int
recog_1374 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM4QImode:
      if (!register_operand (operands[3], E_RVVM4QImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM4QImode)
          || !
#line 4851 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12632; /* *pred_ltgervvm4qi_merge_tie_mask */

    case E_RVVM8HImode:
      if (!register_operand (operands[3], E_RVVM8HImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM8HImode)
          || !
#line 4851 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12635; /* *pred_ltgervvm8hi_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1379 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1DImode:
      if (!register_operand (operands[3], E_RVVM1DImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM1DImode)
          || !(
#line 4851 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12646; /* *pred_ltgervvm1di_merge_tie_mask */

    case E_RVVMF8QImode:
      if (!register_operand (operands[3], E_RVVMF8QImode)
          || !vector_neg_arith_operand (operands[4], E_RVVMF8QImode)
          || !(
#line 4851 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12649; /* *pred_ltgervvmf8qi_merge_tie_mask */

    case E_RVVMF4HImode:
      if (!register_operand (operands[3], E_RVVMF4HImode)
          || !vector_neg_arith_operand (operands[4], E_RVVMF4HImode)
          || !(
#line 4851 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12651; /* *pred_ltgervvmf4hi_merge_tie_mask */

    case E_RVVMF2SImode:
      if (!register_operand (operands[3], E_RVVMF2SImode)
          || !vector_neg_arith_operand (operands[4], E_RVVMF2SImode)
          || !(
#line 4851 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12652; /* *pred_ltgervvmf2si_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1385 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V32QImode:
      if (!register_operand (operands[3], E_V32QImode)
          || !vector_neg_arith_operand (operands[4], E_V32QImode)
          || !(
#line 4851 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 12658; /* *pred_ltgev32qi_merge_tie_mask */

    case E_V32HImode:
      if (!register_operand (operands[3], E_V32HImode)
          || !vector_neg_arith_operand (operands[4], E_V32HImode)
          || !(
#line 4851 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12671; /* *pred_ltgev32hi_merge_tie_mask */

    case E_V32SImode:
      if (!register_operand (operands[3], E_V32SImode)
          || !vector_neg_arith_operand (operands[4], E_V32SImode)
          || !(
#line 4851 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12683; /* *pred_ltgev32si_merge_tie_mask */

    case E_V32DImode:
      if (!register_operand (operands[3], E_V32DImode)
          || !vector_neg_arith_operand (operands[4], E_V32DImode)
          || !(
#line 4851 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12694; /* *pred_ltgev32di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1392 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern537 (x2, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V512BImode))
    {
      res = recog_1389 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V512BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V512BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V512QImode:
      if (!register_operand (operands[4], E_V512QImode)
          || !vector_neg_arith_operand (operands[5], E_V512QImode))
        return -1;
      if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512QImode)) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 12730; /* *pred_ltgev512qi */
      if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512QImode)) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12798; /* *pred_ltgev512qi_narrow */

    case E_V512HImode:
      if (!register_operand (operands[4], E_V512HImode)
          || !vector_neg_arith_operand (operands[5], E_V512HImode))
        return -1;
      if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512HImode)) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 12743; /* *pred_ltgev512hi */
      if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512HImode)) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12811; /* *pred_ltgev512hi_narrow */

    case E_V512SImode:
      if (!register_operand (operands[4], E_V512SImode)
          || !vector_neg_arith_operand (operands[5], E_V512SImode))
        return -1;
      if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512SImode)) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 12755; /* *pred_ltgev512si */
      if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512SImode)) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12823; /* *pred_ltgev512si_narrow */

    case E_V512DImode:
      if (!register_operand (operands[4], E_V512DImode)
          || !vector_neg_arith_operand (operands[5], E_V512DImode))
        return -1;
      if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512DImode)) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 12766; /* *pred_ltgev512di */
      if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512DImode)) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12834; /* *pred_ltgev512di_narrow */

    default:
      return -1;
    }
}

 int
recog_1400 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1BImode:
      x2 = XEXP (x1, 1);
      if (pattern537 (x2, 
E_RVVM1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern593 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) == 0
          && 
#line 4851 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12631; /* *pred_ltgervvm8qi_merge_tie_mask */
      operands[3] = x3;
      if (pattern594 (x2, 
E_RVVM1BImode, 
E_RVVM8QImode) != 0)
        return -1;
      if (
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8QImode)))
        return 12699; /* *pred_ltgervvm8qi */
      if (!
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8QImode)))
        return -1;
      return 12767; /* *pred_ltgervvm8qi_narrow */

    case E_RVVMF2BImode:
      x2 = XEXP (x1, 1);
      if (pattern537 (x2, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF2BImode))
        {
          res = recog_1374 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF2BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF2BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM4QImode:
          if (!register_operand (operands[4], E_RVVM4QImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM4QImode))
            return -1;
          if (
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4QImode)))
            return 12700; /* *pred_ltgervvm4qi */
          if (!
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4QImode)))
            return -1;
          return 12768; /* *pred_ltgervvm4qi_narrow */

        case E_RVVM8HImode:
          if (!register_operand (operands[4], E_RVVM8HImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM8HImode))
            return -1;
          if (
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8HImode)))
            return 12703; /* *pred_ltgervvm8hi */
          if (!
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8HImode)))
            return -1;
          return 12771; /* *pred_ltgervvm8hi_narrow */

        default:
          return -1;
        }

    case E_RVVMF4BImode:
      x2 = XEXP (x1, 1);
      if (pattern537 (x2, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF4BImode))
        {
          res = recog_1375 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF4BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM2QImode:
          if (!register_operand (operands[4], E_RVVM2QImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM2QImode))
            return -1;
          if (
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2QImode)))
            return 12701; /* *pred_ltgervvm2qi */
          if (!
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2QImode)))
            return -1;
          return 12769; /* *pred_ltgervvm2qi_narrow */

        case E_RVVM4HImode:
          if (!register_operand (operands[4], E_RVVM4HImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM4HImode))
            return -1;
          if (
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4HImode)))
            return 12704; /* *pred_ltgervvm4hi */
          if (!
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4HImode)))
            return -1;
          return 12772; /* *pred_ltgervvm4hi_narrow */

        case E_RVVM8SImode:
          if (!register_operand (operands[4], E_RVVM8SImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM8SImode))
            return -1;
          if (
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8SImode)))
            return 12707; /* *pred_ltgervvm8si */
          if (!
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8SImode)))
            return -1;
          return 12775; /* *pred_ltgervvm8si_narrow */

        default:
          return -1;
        }

    case E_RVVMF8BImode:
      x2 = XEXP (x1, 1);
      if (pattern537 (x2, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF8BImode))
        {
          res = recog_1376 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF8BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1QImode:
          if (!register_operand (operands[4], E_RVVM1QImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM1QImode))
            return -1;
          if (
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1QImode)))
            return 12702; /* *pred_ltgervvm1qi */
          if (!
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1QImode)))
            return -1;
          return 12770; /* *pred_ltgervvm1qi_narrow */

        case E_RVVM2HImode:
          if (!register_operand (operands[4], E_RVVM2HImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM2HImode))
            return -1;
          if (
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2HImode)))
            return 12705; /* *pred_ltgervvm2hi */
          if (!
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2HImode)))
            return -1;
          return 12773; /* *pred_ltgervvm2hi_narrow */

        case E_RVVM4SImode:
          if (!register_operand (operands[4], E_RVVM4SImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM4SImode))
            return -1;
          if (
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4SImode)))
            return 12708; /* *pred_ltgervvm4si */
          if (!
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4SImode)))
            return -1;
          return 12776; /* *pred_ltgervvm4si_narrow */

        case E_RVVM8DImode:
          if (!register_operand (operands[4], E_RVVM8DImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM8DImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8DImode)) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12711; /* *pred_ltgervvm8di */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8DImode)) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12779; /* *pred_ltgervvm8di_narrow */

        default:
          return -1;
        }

    case E_RVVMF16BImode:
      x2 = XEXP (x1, 1);
      if (pattern537 (x2, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF16BImode))
        {
          res = recog_1377 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF16BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[4], E_RVVM1HImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM1HImode))
            return -1;
          if (
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1HImode)))
            return 12706; /* *pred_ltgervvm1hi */
          if (!
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1HImode)))
            return -1;
          return 12774; /* *pred_ltgervvm1hi_narrow */

        case E_RVVM2SImode:
          if (!register_operand (operands[4], E_RVVM2SImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM2SImode))
            return -1;
          if (
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2SImode)))
            return 12709; /* *pred_ltgervvm2si */
          if (!
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2SImode)))
            return -1;
          return 12777; /* *pred_ltgervvm2si_narrow */

        case E_RVVM4DImode:
          if (!register_operand (operands[4], E_RVVM4DImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM4DImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4DImode)) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12712; /* *pred_ltgervvm4di */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4DImode)) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12780; /* *pred_ltgervvm4di_narrow */

        case E_RVVMF2QImode:
          if (!register_operand (operands[4], E_RVVMF2QImode)
              || !vector_neg_arith_operand (operands[5], E_RVVMF2QImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2QImode)) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 12715; /* *pred_ltgervvmf2qi */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2QImode)) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 12783; /* *pred_ltgervvmf2qi_narrow */

        default:
          return -1;
        }

    case E_RVVMF32BImode:
      x2 = XEXP (x1, 1);
      if (pattern537 (x2, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF32BImode))
        {
          res = recog_1378 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF32BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1SImode:
          if (!register_operand (operands[4], E_RVVM1SImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM1SImode))
            return -1;
          if (
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1SImode)))
            return 12710; /* *pred_ltgervvm1si */
          if (!
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1SImode)))
            return -1;
          return 12778; /* *pred_ltgervvm1si_narrow */

        case E_RVVM2DImode:
          if (!register_operand (operands[4], E_RVVM2DImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM2DImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2DImode)) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12713; /* *pred_ltgervvm2di */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2DImode)) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12781; /* *pred_ltgervvm2di_narrow */

        case E_RVVMF4QImode:
          if (!register_operand (operands[4], E_RVVMF4QImode)
              || !vector_neg_arith_operand (operands[5], E_RVVMF4QImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4QImode)) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 12716; /* *pred_ltgervvmf4qi */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4QImode)) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 12784; /* *pred_ltgervvmf4qi_narrow */

        case E_RVVMF2HImode:
          if (!register_operand (operands[4], E_RVVMF2HImode)
              || !vector_neg_arith_operand (operands[5], E_RVVMF2HImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2HImode)) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 12718; /* *pred_ltgervvmf2hi */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2HImode)) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 12786; /* *pred_ltgervvmf2hi_narrow */

        default:
          return -1;
        }

    case E_RVVMF64BImode:
      x2 = XEXP (x1, 1);
      if (pattern537 (x2, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF64BImode))
        {
          res = recog_1379 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF64BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1DImode:
          if (!register_operand (operands[4], E_RVVM1DImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM1DImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1DImode)) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12714; /* *pred_ltgervvm1di */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1DImode)) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12782; /* *pred_ltgervvm1di_narrow */

        case E_RVVMF8QImode:
          if (!register_operand (operands[4], E_RVVMF8QImode)
              || !vector_neg_arith_operand (operands[5], E_RVVMF8QImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF8QImode)) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 12717; /* *pred_ltgervvmf8qi */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF8QImode)) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 12785; /* *pred_ltgervvmf8qi_narrow */

        case E_RVVMF4HImode:
          if (!register_operand (operands[4], E_RVVMF4HImode)
              || !vector_neg_arith_operand (operands[5], E_RVVMF4HImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4HImode)) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 12719; /* *pred_ltgervvmf4hi */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4HImode)) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 12787; /* *pred_ltgervvmf4hi_narrow */

        case E_RVVMF2SImode:
          if (!register_operand (operands[4], E_RVVMF2SImode)
              || !vector_neg_arith_operand (operands[5], E_RVVMF2SImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2SImode)) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 12720; /* *pred_ltgervvmf2si */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2SImode)) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 12788; /* *pred_ltgervvmf2si_narrow */

        default:
          return -1;
        }

    case E_V1BImode:
      x2 = XEXP (x1, 1);
      if (pattern537 (x2, 
E_V1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1BImode))
        {
          res = recog_1380 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V1BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1QImode:
          if (!register_operand (operands[4], E_V1QImode)
              || !vector_neg_arith_operand (operands[5], E_V1QImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1QImode)) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return 12721; /* *pred_ltgev1qi */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1QImode)) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 12789; /* *pred_ltgev1qi_narrow */

        case E_V1HImode:
          if (!register_operand (operands[4], E_V1HImode)
              || !vector_neg_arith_operand (operands[5], E_V1HImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1HImode)) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return 12734; /* *pred_ltgev1hi */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1HImode)) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 12802; /* *pred_ltgev1hi_narrow */

        case E_V1SImode:
          if (!register_operand (operands[4], E_V1SImode)
              || !vector_neg_arith_operand (operands[5], E_V1SImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1SImode)) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return 12746; /* *pred_ltgev1si */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1SImode)) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 12814; /* *pred_ltgev1si_narrow */

        case E_V1DImode:
          if (!register_operand (operands[4], E_V1DImode)
              || !vector_neg_arith_operand (operands[5], E_V1DImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1DImode)) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return 12757; /* *pred_ltgev1di */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1DImode)) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12825; /* *pred_ltgev1di_narrow */

        default:
          return -1;
        }

    case E_V2BImode:
      x2 = XEXP (x1, 1);
      if (pattern537 (x2, 
E_V2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V2BImode))
        {
          res = recog_1381 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V2BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V2BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V2QImode:
          if (!register_operand (operands[4], E_V2QImode)
              || !vector_neg_arith_operand (operands[5], E_V2QImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2QImode)) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return 12722; /* *pred_ltgev2qi */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2QImode)) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 12790; /* *pred_ltgev2qi_narrow */

        case E_V2HImode:
          if (!register_operand (operands[4], E_V2HImode)
              || !vector_neg_arith_operand (operands[5], E_V2HImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2HImode)) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return 12735; /* *pred_ltgev2hi */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2HImode)) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 12803; /* *pred_ltgev2hi_narrow */

        case E_V2SImode:
          if (!register_operand (operands[4], E_V2SImode)
              || !vector_neg_arith_operand (operands[5], E_V2SImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2SImode)) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return 12747; /* *pred_ltgev2si */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2SImode)) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 12815; /* *pred_ltgev2si_narrow */

        case E_V2DImode:
          if (!register_operand (operands[4], E_V2DImode)
              || !vector_neg_arith_operand (operands[5], E_V2DImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2DImode)) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return 12758; /* *pred_ltgev2di */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2DImode)) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12826; /* *pred_ltgev2di_narrow */

        default:
          return -1;
        }

    case E_V4BImode:
      return recog_1399 (x1, insn, pnum_clobbers);

    case E_V8BImode:
      return recog_1398 (x1, insn, pnum_clobbers);

    case E_V16BImode:
      return recog_1397 (x1, insn, pnum_clobbers);

    case E_V32BImode:
      return recog_1396 (x1, insn, pnum_clobbers);

    case E_V64BImode:
      return recog_1395 (x1, insn, pnum_clobbers);

    case E_V128BImode:
      return recog_1394 (x1, insn, pnum_clobbers);

    case E_V256BImode:
      return recog_1393 (x1, insn, pnum_clobbers);

    case E_V512BImode:
      return recog_1392 (x1, insn, pnum_clobbers);

    case E_V1024BImode:
      x2 = XEXP (x1, 1);
      if (pattern537 (x2, 
E_V1024BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1024BImode))
        {
          res = recog_1390 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1024BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V1024BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1024QImode:
          if (!register_operand (operands[4], E_V1024QImode)
              || !vector_neg_arith_operand (operands[5], E_V1024QImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024QImode)) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return 12731; /* *pred_ltgev1024qi */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024QImode)) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 12799; /* *pred_ltgev1024qi_narrow */

        case E_V1024HImode:
          if (!register_operand (operands[4], E_V1024HImode)
              || !vector_neg_arith_operand (operands[5], E_V1024HImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024HImode)) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return 12744; /* *pred_ltgev1024hi */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024HImode)) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 12812; /* *pred_ltgev1024hi_narrow */

        case E_V1024SImode:
          if (!register_operand (operands[4], E_V1024SImode)
              || !vector_neg_arith_operand (operands[5], E_V1024SImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024SImode)) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return 12756; /* *pred_ltgev1024si */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024SImode)) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 12824; /* *pred_ltgev1024si_narrow */

        default:
          return -1;
        }

    case E_V2048BImode:
      x2 = XEXP (x1, 1);
      if (pattern537 (x2, 
E_V2048BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V2048BImode))
        {
          res = recog_1391 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V2048BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V2048BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V2048QImode:
          if (!register_operand (operands[4], E_V2048QImode)
              || !vector_neg_arith_operand (operands[5], E_V2048QImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048QImode)) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return 12732; /* *pred_ltgev2048qi */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048QImode)) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 12800; /* *pred_ltgev2048qi_narrow */

        case E_V2048HImode:
          if (!register_operand (operands[4], E_V2048HImode)
              || !vector_neg_arith_operand (operands[5], E_V2048HImode))
            return -1;
          if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048HImode)) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return 12745; /* *pred_ltgev2048hi */
          if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048HImode)) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 12813; /* *pred_ltgev2048hi_narrow */

        default:
          return -1;
        }

    case E_V4096BImode:
      x2 = XEXP (x1, 1);
      if (pattern537 (x2, 
E_V4096BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern593 (x2, 
E_V4096QImode, 
E_V4096BImode) == 0
          && (
#line 4851 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 12665; /* *pred_ltgev4096qi_merge_tie_mask */
      operands[3] = x3;
      if (pattern594 (x2, 
E_V4096BImode, 
E_V4096QImode) != 0)
        return -1;
      if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4096QImode)) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 12733; /* *pred_ltgev4096qi */
      if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4096QImode)) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12801; /* *pred_ltgev4096qi_narrow */

    default:
      return -1;
    }
}

 int
recog_1478 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          if (register_operand (operands[1], E_SImode))
            {
              x6 = XEXP (x4, 1);
              operands[2] = x6;
              if (arith_operand (operands[2], E_SImode)
                  && 
#line 858 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                return 8; /* addsi3_extended */
            }
          if (pnum_clobbers == NULL
              || GET_CODE (x5) != SUBREG
              || maybe_ne (SUBREG_BYTE (x5), 0)
              || GET_MODE (x5) != E_SImode)
            return -1;
          x7 = XEXP (x5, 0);
          if (pattern420 (x7) != 0
              || !const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x8 = XEXP (x7, 1);
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[4] = x6;
          if (!register_operand (operands[4], E_SImode)
              || !
#line 4563 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT
   && (INTVAL (operands[3]) | ((1 << INTVAL (operands[2])) - 1)) == 0xffffffff))
            return -1;
          *pnum_clobbers = 1;
          return 491; /* *riscv.md:4553 */

        case ASHIFT:
          if (pnum_clobbers == NULL
              || GET_MODE (x5) != E_SImode)
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x5, 1);
          operands[2] = x9;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          if (!const_int_operand (operands[3], E_VOIDmode)
              || !
#line 4722 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((TARGET_64BIT && riscv_const_insns (operands[3], false) == 1)))
            return -1;
          *pnum_clobbers = 1;
          return 493; /* *riscv.md:4715 */

        case MULT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x7 = XEXP (x5, 0);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[1] = x7;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (!register_operand (operands[2], E_SImode)
                  || !
#line 301 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC && TARGET_64BIT))
                return -1;
              return 903; /* *th_mulawsi */

            case SIGN_EXTEND:
              if (GET_MODE (x7) != E_SImode)
                return -1;
              x9 = XEXP (x5, 1);
              if (GET_CODE (x9) != SIGN_EXTEND
                  || GET_MODE (x9) != E_SImode)
                return -1;
              x10 = XEXP (x7, 0);
              operands[1] = x10;
              if (!register_operand (operands[1], E_HImode))
                return -1;
              x11 = XEXP (x9, 0);
              operands[2] = x11;
              if (!register_operand (operands[2], E_HImode)
                  || !
#line 339 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC && TARGET_64BIT))
                return -1;
              return 906; /* *th_sextw_maddhisi4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
    case TRUNCATE:
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case TRUNCATE:
          res = recog_14 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case MEM:
          if (GET_MODE (x4) == E_SImode)
            {
              x5 = XEXP (x4, 0);
              operands[1] = x5;
              if (absolute_symbolic_operand (operands[1], E_VOIDmode))
                {
                  switch (GET_MODE (operands[0]))
                    {
                    case E_HImode:
                      if (register_operand (operands[0], E_HImode)
                          && GET_MODE (x3) == E_HImode
                          && (
#line 36 "../../gcc-15.1.1-20250425/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 63 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                        return 815; /* *local_pic_load_ssi */
                      break;

                    case E_SImode:
                      if (register_operand (operands[0], E_SImode)
                          && GET_MODE (x3) == E_SImode
                          && (
#line 36 "../../gcc-15.1.1-20250425/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 63 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                        return 816; /* *local_pic_load_ssi */
                      break;

                    default:
                      break;
                    }
                }
            }
          break;

        default:
          break;
        }
      operands[1] = x4;
      res = recog_11 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x4) == MEM)
        {
          res = recog_12 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x4;
      res = recog_13 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x4) != SUBREG
          || pattern237 (x3) != 0)
        return -1;
      if (vector_length_operand (operands[1], E_SImode)
          && (
#line 1828 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && TARGET_64BIT) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return 3649; /* *vsetvldi_no_side_effects_si_extend */
      if (!vector_length_operand (operands[1], E_DImode)
          || !(
#line 1828 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && TARGET_64BIT) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 3650; /* *vsetvldi_no_side_effects_si_extend */

    case MINUS:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!reg_or_0_operand (operands[1], E_SImode)
              || !
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 17; /* subsi3_extended */

        case MULT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x5 = XEXP (x4, 0);
          operands[3] = x5;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x12 = XEXP (x6, 0);
          switch (GET_CODE (x12))
            {
            case REG:
            case SUBREG:
              operands[1] = x12;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x13 = XEXP (x6, 1);
              operands[2] = x13;
              if (!register_operand (operands[2], E_SImode)
                  || !
#line 362 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC && TARGET_64BIT))
                return -1;
              return 909; /* *th_mulswsi */

            case SIGN_EXTEND:
              if (GET_MODE (x12) != E_SImode)
                return -1;
              x13 = XEXP (x6, 1);
              if (GET_CODE (x13) != SIGN_EXTEND
                  || GET_MODE (x13) != E_SImode)
                return -1;
              x14 = XEXP (x12, 0);
              operands[1] = x14;
              if (!register_operand (operands[1], E_HImode))
                return -1;
              x15 = XEXP (x13, 0);
              operands[2] = x15;
              if (!register_operand (operands[2], E_HImode)
                  || !
#line 397 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC && TARGET_64BIT))
                return -1;
              return 912; /* *th_sextw_msubhisi4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      if (pattern132 (x3) != 0
          || !
#line 1092 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 21; /* negsi2_extended */

    case MULT:
      if (pattern133 (x3) != 0
          || !
#line 1256 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && TARGET_64BIT))
        return -1;
      return 28; /* mulsi3_extended */

    case DIV:
      if (pattern133 (x3) != 0
          || !
#line 1469 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 44; /* divsi3_extended */

    case UDIV:
      if (pattern133 (x3) != 0
          || !
#line 1469 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 45; /* udivsi3_extended */

    case MOD:
      if (pattern133 (x3) != 0
          || !
#line 1469 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 46; /* modsi3_extended */

    case UMOD:
      if (pattern133 (x3) != 0
          || !
#line 1469 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 47; /* umodsi3_extended */

    case FIX:
      switch (pattern134 (x3))
        {
        case 0:
          if (!(
#line 2120 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 152; /* fix_truncsfsi2_sext */

        case 1:
          if (!(
#line 2120 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 154; /* fix_truncdfsi2_sext */

        case 2:
          if (!(
#line 2120 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 156; /* fix_trunchfsi2_sext */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern134 (x3))
        {
        case 0:
          if (!(
#line 2120 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 153; /* fixuns_truncsfsi2_sext */

        case 1:
          if (!(
#line 2120 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 155; /* fixuns_truncdfsi2_sext */

        case 2:
          if (!(
#line 2120 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 157; /* fixuns_trunchfsi2_sext */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_16 (x1, insn, pnum_clobbers);

    case ASHIFT:
      switch (pattern135 (x3))
        {
        case 0:
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (arith_operand (operands[2], E_QImode)
              && 
#line 2948 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return 314; /* ashlsi3_extend */
          if (!subreg_lowpart_operator (x6, E_VOIDmode))
            return -1;
          switch (pattern401 (x6))
            {
            case 0:
              if (!
#line 2967 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                return -1;
              return 317; /* *ashlsi3_extend_mask */

            case 1:
              if (!
#line 2967 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                return -1;
              return 320; /* *ashlsi3_extend_mask */

            default:
              return -1;
            }

        case 1:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != SUBREG)
            return -1;
          switch (pattern392 (x6, pnum_clobbers))
            {
            case 0:
              if ((
#line 638 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 589; /* *bitmanip.md:630 */
                }
              if (!(
#line 638 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 591; /* *bitmanip.md:630 */

            case 1:
              if (!
#line 661 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f))
                return -1;
              return 593; /* *bitmanip.md:654 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pattern132 (x3) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (arith_operand (operands[2], E_QImode)
          && 
#line 2948 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return 315; /* ashrsi3_extend */
      if (!subreg_lowpart_operator (x6, E_VOIDmode))
        return -1;
      switch (pattern401 (x6))
        {
        case 0:
          if (!
#line 2967 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 318; /* *ashrsi3_extend_mask */

        case 1:
          if (!
#line 2967 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 321; /* *ashrsi3_extend_mask */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (pattern132 (x3) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (arith_operand (operands[2], E_QImode)
          && 
#line 2948 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return 316; /* lshrsi3_extend */
      if (!subreg_lowpart_operator (x6, E_VOIDmode))
        return -1;
      switch (pattern401 (x6))
        {
        case 0:
          if (!
#line 2967 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 319; /* *lshrsi3_extend_mask */

        case 1:
          if (!
#line 2967 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 322; /* *lshrsi3_extend_mask */

        default:
          return -1;
        }

    case CLZ:
      if (pattern132 (x3) != 0
          || !
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB))
        return -1;
      return 528; /* *clzdisi2 */

    case CTZ:
      if (pattern132 (x3) != 0
          || !
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB))
        return -1;
      return 529; /* *ctzdisi2 */

    case POPCOUNT:
      if (pattern132 (x3) != 0
          || !
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB))
        return -1;
      return 530; /* *popcountdisi2 */

    case ROTATERT:
      if (pattern132 (x3) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (arith_operand (operands[2], E_QImode)
          && 
#line 380 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)))
        return 550; /* rotrsi3_sext */
      if (!subreg_lowpart_operator (x6, E_VOIDmode))
        return -1;
      switch (pattern401 (x6))
        {
        case 0:
          if (!
#line 452 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)))
            return -1;
          return 563; /* *rotrsi3_sext_mask */

        case 1:
          if (!(
#line 452 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 565; /* *rotrsi3_sext_mask */

        default:
          return -1;
        }

    case ROTATE:
      if (pattern132 (x3) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (register_operand (operands[2], E_QImode)
          && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)))
        return 553; /* rotlsi3_sext */
      if (!subreg_lowpart_operator (x6, E_VOIDmode))
        return -1;
      switch (pattern401 (x6))
        {
        case 0:
          if (!
#line 452 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)))
            return -1;
          return 562; /* *rotlsi3_sext_mask */

        case 1:
          if (!(
#line 452 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 564; /* *rotlsi3_sext_mask */

        default:
          return -1;
        }

    case IOR:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != ASHIFT
          || GET_MODE (x5) != E_SImode)
        return -1;
      x9 = XEXP (x5, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != ZERO_EXTEND
          || GET_MODE (x6) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x6, 0);
      operands[2] = x12;
      if (!register_operand (operands[2], E_HImode)
          || !
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZBKB && TARGET_64BIT))
        return -1;
      return 678; /* *riscv_packw_2 */

    default:
      return -1;
    }
}

 int
recog_1480 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern101 (x1))
    {
    case 0:
      if (reg_or_0_operand (operands[1], E_SImode)
          && 
#line 2138 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
        return 164; /* floatsisf2 */
      if (!reg_or_0_operand (operands[1], E_DImode)
          || !(
#line 2138 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
        return -1;
      return 165; /* floatdisf2 */

    case 1:
      if (reg_or_0_operand (operands[1], E_SImode)
          && (
#line 2138 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return 166; /* floatsidf2 */
      if (!reg_or_0_operand (operands[1], E_DImode)
          || !(
#line 2138 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
        return -1;
      return 167; /* floatdidf2 */

    case 2:
      if (reg_or_0_operand (operands[1], E_SImode)
          && (
#line 2138 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return 168; /* floatsihf2 */
      if (!reg_or_0_operand (operands[1], E_DImode)
          || !(
#line 2138 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
        return -1;
      return 169; /* floatdihf2 */

    case 3:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26491; /* floatrvvm8hirvvm8hf2 */

    case 4:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26647; /* floatrvvm4qirvvm8hf2 */

    case 5:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26493; /* floatrvvm4hirvvm4hf2 */

    case 6:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26649; /* floatrvvm2qirvvm4hf2 */

    case 7:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26839; /* floatrvvm8sirvvm4hf2 */

    case 8:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26495; /* floatrvvm2hirvvm2hf2 */

    case 9:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26651; /* floatrvvm1qirvvm2hf2 */

    case 10:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26841; /* floatrvvm4sirvvm2hf2 */

    case 11:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26497; /* floatrvvm1hirvvm1hf2 */

    case 12:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26653; /* floatrvvmf2qirvvm1hf2 */

    case 13:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26843; /* floatrvvm2sirvvm1hf2 */

    case 14:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26499; /* floatrvvmf2hirvvmf2hf2 */

    case 15:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26655; /* floatrvvmf4qirvvmf2hf2 */

    case 16:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26845; /* floatrvvm1sirvvmf2hf2 */

    case 17:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26501; /* floatrvvmf4hirvvmf4hf2 */

    case 18:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26657; /* floatrvvmf8qirvvmf4hf2 */

    case 19:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26847; /* floatrvvmf2sirvvmf4hf2 */

    case 20:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26503; /* floatrvvm8sirvvm8sf2 */

    case 21:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26659; /* floatrvvm4hirvvm8sf2 */

    case 22:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26505; /* floatrvvm4sirvvm4sf2 */

    case 23:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26661; /* floatrvvm2hirvvm4sf2 */

    case 24:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26849; /* floatrvvm8dirvvm4sf2 */

    case 25:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26507; /* floatrvvm2sirvvm2sf2 */

    case 26:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26663; /* floatrvvm1hirvvm2sf2 */

    case 27:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26851; /* floatrvvm4dirvvm2sf2 */

    case 28:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26509; /* floatrvvm1sirvvm1sf2 */

    case 29:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26665; /* floatrvvmf2hirvvm1sf2 */

    case 30:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26853; /* floatrvvm2dirvvm1sf2 */

    case 31:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26511; /* floatrvvmf2sirvvmf2sf2 */

    case 32:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26667; /* floatrvvmf4hirvvmf2sf2 */

    case 33:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26855; /* floatrvvm1dirvvmf2sf2 */

    case 34:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26513; /* floatrvvm8dirvvm8df2 */

    case 35:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26669; /* floatrvvm4sirvvm8df2 */

    case 36:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26515; /* floatrvvm4dirvvm4df2 */

    case 37:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26671; /* floatrvvm2sirvvm4df2 */

    case 38:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26517; /* floatrvvm2dirvvm2df2 */

    case 39:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26673; /* floatrvvm1sirvvm2df2 */

    case 40:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26519; /* floatrvvm1dirvvm1df2 */

    case 41:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26675; /* floatrvvmf2sirvvm1df2 */

    case 42:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 26521; /* floatv1hiv1hf2 */

    case 43:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 26677; /* floatv1qiv1hf2 */

    case 44:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 26857; /* floatv1siv1hf2 */

    case 45:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 26523; /* floatv2hiv2hf2 */

    case 46:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 26679; /* floatv2qiv2hf2 */

    case 47:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 26859; /* floatv2siv2hf2 */

    case 48:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 26525; /* floatv4hiv4hf2 */

    case 49:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 26681; /* floatv4qiv4hf2 */

    case 50:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 26861; /* floatv4siv4hf2 */

    case 51:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 26527; /* floatv8hiv8hf2 */

    case 52:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 26683; /* floatv8qiv8hf2 */

    case 53:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 26863; /* floatv8siv8hf2 */

    case 54:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 26529; /* floatv16hiv16hf2 */

    case 55:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 26685; /* floatv16qiv16hf2 */

    case 56:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26865; /* floatv16siv16hf2 */

    case 57:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26531; /* floatv32hiv32hf2 */

    case 58:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26687; /* floatv32qiv32hf2 */

    case 59:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26867; /* floatv32siv32hf2 */

    case 60:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26533; /* floatv64hiv64hf2 */

    case 61:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26689; /* floatv64qiv64hf2 */

    case 62:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26869; /* floatv64siv64hf2 */

    case 63:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26535; /* floatv128hiv128hf2 */

    case 64:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26691; /* floatv128qiv128hf2 */

    case 65:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26871; /* floatv128siv128hf2 */

    case 66:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26537; /* floatv256hiv256hf2 */

    case 67:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26693; /* floatv256qiv256hf2 */

    case 68:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26873; /* floatv256siv256hf2 */

    case 69:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26539; /* floatv512hiv512hf2 */

    case 70:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26695; /* floatv512qiv512hf2 */

    case 71:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26875; /* floatv512siv512hf2 */

    case 72:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26541; /* floatv1024hiv1024hf2 */

    case 73:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26697; /* floatv1024qiv1024hf2 */

    case 74:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26877; /* floatv1024siv1024hf2 */

    case 75:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26543; /* floatv2048hiv2048hf2 */

    case 76:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26699; /* floatv2048qiv2048hf2 */

    case 77:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26545; /* floatv1siv1sf2 */

    case 78:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26701; /* floatv1hiv1sf2 */

    case 79:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26879; /* floatv1div1sf2 */

    case 80:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26547; /* floatv2siv2sf2 */

    case 81:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26703; /* floatv2hiv2sf2 */

    case 82:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26881; /* floatv2div2sf2 */

    case 83:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26549; /* floatv4siv4sf2 */

    case 84:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26705; /* floatv4hiv4sf2 */

    case 85:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26883; /* floatv4div4sf2 */

    case 86:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26551; /* floatv8siv8sf2 */

    case 87:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26707; /* floatv8hiv8sf2 */

    case 88:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26885; /* floatv8div8sf2 */

    case 89:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26553; /* floatv16siv16sf2 */

    case 90:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26709; /* floatv16hiv16sf2 */

    case 91:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26887; /* floatv16div16sf2 */

    case 92:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26555; /* floatv32siv32sf2 */

    case 93:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26711; /* floatv32hiv32sf2 */

    case 94:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26889; /* floatv32div32sf2 */

    case 95:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26557; /* floatv64siv64sf2 */

    case 96:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26713; /* floatv64hiv64sf2 */

    case 97:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26891; /* floatv64div64sf2 */

    case 98:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26559; /* floatv128siv128sf2 */

    case 99:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26715; /* floatv128hiv128sf2 */

    case 100:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26893; /* floatv128div128sf2 */

    case 101:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26561; /* floatv256siv256sf2 */

    case 102:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26717; /* floatv256hiv256sf2 */

    case 103:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26895; /* floatv256div256sf2 */

    case 104:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26563; /* floatv512siv512sf2 */

    case 105:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26719; /* floatv512hiv512sf2 */

    case 106:
      if (!(
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26897; /* floatv512div512sf2 */

    case 107:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26565; /* floatv1024siv1024sf2 */

    case 108:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26721; /* floatv1024hiv1024sf2 */

    case 109:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26567; /* floatv1div1df2 */

    case 110:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26723; /* floatv1siv1df2 */

    case 111:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26569; /* floatv2div2df2 */

    case 112:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26725; /* floatv2siv2df2 */

    case 113:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26571; /* floatv4div4df2 */

    case 114:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26727; /* floatv4siv4df2 */

    case 115:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26573; /* floatv8div8df2 */

    case 116:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26729; /* floatv8siv8df2 */

    case 117:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26575; /* floatv16div16df2 */

    case 118:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26731; /* floatv16siv16df2 */

    case 119:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26577; /* floatv32div32df2 */

    case 120:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26733; /* floatv32siv32df2 */

    case 121:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26579; /* floatv64div64df2 */

    case 122:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26735; /* floatv64siv64df2 */

    case 123:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26581; /* floatv128div128df2 */

    case 124:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26737; /* floatv128siv128df2 */

    case 125:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26583; /* floatv256div256df2 */

    case 126:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26739; /* floatv256siv256df2 */

    case 127:
      if (!(
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26585; /* floatv512div512df2 */

    case 128:
      if (!(
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26741; /* floatv512siv512df2 */

    default:
      return -1;
    }
}

 int
recog_1490 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      return recog_21 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_20 (x1, insn, pnum_clobbers);

    case NEG:
      switch (pattern144 (x3))
        {
        case 0:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 27459; /* fnmsrvvm8hf4 */

        case 1:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 27460; /* fnmsrvvm4hf4 */

        case 2:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 27461; /* fnmsrvvm2hf4 */

        case 3:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 27462; /* fnmsrvvm1hf4 */

        case 4:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 27463; /* fnmsrvvmf2hf4 */

        case 5:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27464; /* fnmsrvvmf4hf4 */

        case 6:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27465; /* fnmsrvvm8sf4 */

        case 7:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27466; /* fnmsrvvm4sf4 */

        case 8:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27467; /* fnmsrvvm2sf4 */

        case 9:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27468; /* fnmsrvvm1sf4 */

        case 10:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27469; /* fnmsrvvmf2sf4 */

        case 11:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 27470; /* fnmsrvvm8df4 */

        case 12:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 27471; /* fnmsrvvm4df4 */

        case 13:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 27472; /* fnmsrvvm2df4 */

        case 14:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 27473; /* fnmsrvvm1df4 */

        case 15:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 27474; /* fnmsv1hf4 */

        case 16:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 27475; /* fnmsv2hf4 */

        case 17:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 27476; /* fnmsv4hf4 */

        case 18:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 27477; /* fnmsv8hf4 */

        case 19:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 27478; /* fnmsv16hf4 */

        case 20:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 27479; /* fnmsv32hf4 */

        case 21:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 27480; /* fnmsv64hf4 */

        case 22:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 27481; /* fnmsv128hf4 */

        case 23:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 27482; /* fnmsv256hf4 */

        case 24:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 27483; /* fnmsv512hf4 */

        case 25:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 27484; /* fnmsv1024hf4 */

        case 26:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 27485; /* fnmsv2048hf4 */

        case 27:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27486; /* fnmsv1sf4 */

        case 28:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27487; /* fnmsv2sf4 */

        case 29:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27488; /* fnmsv4sf4 */

        case 30:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27489; /* fnmsv8sf4 */

        case 31:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 27490; /* fnmsv16sf4 */

        case 32:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 27491; /* fnmsv32sf4 */

        case 33:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 27492; /* fnmsv64sf4 */

        case 34:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 27493; /* fnmsv128sf4 */

        case 35:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 27494; /* fnmsv256sf4 */

        case 36:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 27495; /* fnmsv512sf4 */

        case 37:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 27496; /* fnmsv1024sf4 */

        case 38:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 27497; /* fnmsv1df4 */

        case 39:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 27498; /* fnmsv2df4 */

        case 40:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 27499; /* fnmsv4df4 */

        case 41:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 27500; /* fnmsv8df4 */

        case 42:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 27501; /* fnmsv16df4 */

        case 43:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 27502; /* fnmsv32df4 */

        case 44:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 27503; /* fnmsv64df4 */

        case 45:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 27504; /* fnmsv128df4 */

        case 46:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 27505; /* fnmsv256df4 */

        case 47:
          if (!(
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 27506; /* fnmsv512df4 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_23 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_22 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      switch (pattern150 (x3))
        {
        case 0:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30915; /* *dual_widen_subrvvm8sf */

        case 1:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30918; /* *dual_widen_subrvvm4sf */

        case 2:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30921; /* *dual_widen_subrvvm2sf */

        case 3:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30924; /* *dual_widen_subrvvm1sf */

        case 4:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30927; /* *dual_widen_subrvvmf2sf */

        case 5:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30930; /* *dual_widen_subrvvm8df */

        case 6:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30933; /* *dual_widen_subrvvm4df */

        case 7:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30936; /* *dual_widen_subrvvm2df */

        case 8:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30939; /* *dual_widen_subrvvm1df */

        case 9:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30942; /* *dual_widen_subv1sf */

        case 10:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30945; /* *dual_widen_subv2sf */

        case 11:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30948; /* *dual_widen_subv4sf */

        case 12:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30951; /* *dual_widen_subv8sf */

        case 13:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30954; /* *dual_widen_subv16sf */

        case 14:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30957; /* *dual_widen_subv32sf */

        case 15:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30960; /* *dual_widen_subv64sf */

        case 16:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30963; /* *dual_widen_subv128sf */

        case 17:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30966; /* *dual_widen_subv256sf */

        case 18:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30969; /* *dual_widen_subv512sf */

        case 19:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30972; /* *dual_widen_subv1024sf */

        case 20:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30975; /* *dual_widen_subv1df */

        case 21:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30978; /* *dual_widen_subv2df */

        case 22:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30981; /* *dual_widen_subv4df */

        case 23:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30984; /* *dual_widen_subv8df */

        case 24:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30987; /* *dual_widen_subv16df */

        case 25:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30990; /* *dual_widen_subv32df */

        case 26:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30993; /* *dual_widen_subv64df */

        case 27:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30996; /* *dual_widen_subv128df */

        case 28:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30999; /* *dual_widen_subv256df */

        case 29:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31002; /* *dual_widen_subv512df */

        case 30:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31064; /* *single_widen_first_subrvvm8sf */

        case 31:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31065; /* *single_widen_first_subrvvm4sf */

        case 32:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31066; /* *single_widen_first_subrvvm2sf */

        case 33:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31067; /* *single_widen_first_subrvvm1sf */

        case 34:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31068; /* *single_widen_first_subrvvmf2sf */

        case 35:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31069; /* *single_widen_first_subrvvm8df */

        case 36:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31070; /* *single_widen_first_subrvvm4df */

        case 37:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31071; /* *single_widen_first_subrvvm2df */

        case 38:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31072; /* *single_widen_first_subrvvm1df */

        case 39:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31073; /* *single_widen_first_subv1sf */

        case 40:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31074; /* *single_widen_first_subv2sf */

        case 41:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31075; /* *single_widen_first_subv4sf */

        case 42:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31076; /* *single_widen_first_subv8sf */

        case 43:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31077; /* *single_widen_first_subv16sf */

        case 44:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31078; /* *single_widen_first_subv32sf */

        case 45:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31079; /* *single_widen_first_subv64sf */

        case 46:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31080; /* *single_widen_first_subv128sf */

        case 47:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31081; /* *single_widen_first_subv256sf */

        case 48:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31082; /* *single_widen_first_subv512sf */

        case 49:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31083; /* *single_widen_first_subv1024sf */

        case 50:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31084; /* *single_widen_first_subv1df */

        case 51:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31085; /* *single_widen_first_subv2df */

        case 52:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31086; /* *single_widen_first_subv4df */

        case 53:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31087; /* *single_widen_first_subv8df */

        case 54:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31088; /* *single_widen_first_subv16df */

        case 55:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31089; /* *single_widen_first_subv32df */

        case 56:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31090; /* *single_widen_first_subv64df */

        case 57:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31091; /* *single_widen_first_subv128df */

        case 58:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31092; /* *single_widen_first_subv256df */

        case 59:
          if (!(
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31093; /* *single_widen_first_subv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1505 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      return recog_25 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_26 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_27 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      switch (pattern131 (x3))
        {
        case 0:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30916; /* *dual_widen_mulrvvm8sf */

        case 1:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30919; /* *dual_widen_mulrvvm4sf */

        case 2:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30922; /* *dual_widen_mulrvvm2sf */

        case 3:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30925; /* *dual_widen_mulrvvm1sf */

        case 4:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30928; /* *dual_widen_mulrvvmf2sf */

        case 5:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30931; /* *dual_widen_mulrvvm8df */

        case 6:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30934; /* *dual_widen_mulrvvm4df */

        case 7:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30937; /* *dual_widen_mulrvvm2df */

        case 8:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30940; /* *dual_widen_mulrvvm1df */

        case 9:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30943; /* *dual_widen_mulv1sf */

        case 10:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30946; /* *dual_widen_mulv2sf */

        case 11:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30949; /* *dual_widen_mulv4sf */

        case 12:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30952; /* *dual_widen_mulv8sf */

        case 13:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30955; /* *dual_widen_mulv16sf */

        case 14:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30958; /* *dual_widen_mulv32sf */

        case 15:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30961; /* *dual_widen_mulv64sf */

        case 16:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30964; /* *dual_widen_mulv128sf */

        case 17:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30967; /* *dual_widen_mulv256sf */

        case 18:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30970; /* *dual_widen_mulv512sf */

        case 19:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30973; /* *dual_widen_mulv1024sf */

        case 20:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30976; /* *dual_widen_mulv1df */

        case 21:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30979; /* *dual_widen_mulv2df */

        case 22:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30982; /* *dual_widen_mulv4df */

        case 23:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30985; /* *dual_widen_mulv8df */

        case 24:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30988; /* *dual_widen_mulv16df */

        case 25:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30991; /* *dual_widen_mulv32df */

        case 26:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30994; /* *dual_widen_mulv64df */

        case 27:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30997; /* *dual_widen_mulv128df */

        case 28:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31000; /* *dual_widen_mulv256df */

        case 29:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31003; /* *dual_widen_mulv512df */

        case 30:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31094; /* *single_widen_mulrvvm8sf */

        case 31:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31095; /* *single_widen_mulrvvm4sf */

        case 32:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31096; /* *single_widen_mulrvvm2sf */

        case 33:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31097; /* *single_widen_mulrvvm1sf */

        case 34:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31098; /* *single_widen_mulrvvmf2sf */

        case 35:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31099; /* *single_widen_mulrvvm8df */

        case 36:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31100; /* *single_widen_mulrvvm4df */

        case 37:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31101; /* *single_widen_mulrvvm2df */

        case 38:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31102; /* *single_widen_mulrvvm1df */

        case 39:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31103; /* *single_widen_mulv1sf */

        case 40:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31104; /* *single_widen_mulv2sf */

        case 41:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31105; /* *single_widen_mulv4sf */

        case 42:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31106; /* *single_widen_mulv8sf */

        case 43:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31107; /* *single_widen_mulv16sf */

        case 44:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31108; /* *single_widen_mulv32sf */

        case 45:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31109; /* *single_widen_mulv64sf */

        case 46:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31110; /* *single_widen_mulv128sf */

        case 47:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31111; /* *single_widen_mulv256sf */

        case 48:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31112; /* *single_widen_mulv512sf */

        case 49:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31113; /* *single_widen_mulv1024sf */

        case 50:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31114; /* *single_widen_mulv1df */

        case 51:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31115; /* *single_widen_mulv2df */

        case 52:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31116; /* *single_widen_mulv4df */

        case 53:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31117; /* *single_widen_mulv8df */

        case 54:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31118; /* *single_widen_mulv16df */

        case 55:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31119; /* *single_widen_mulv32df */

        case 56:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31120; /* *single_widen_mulv64df */

        case 57:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31121; /* *single_widen_mulv128df */

        case 58:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31122; /* *single_widen_mulv256df */

        case 59:
          if (!(
#line 838 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31123; /* *single_widen_mulv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1523 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != LABEL_REF)
        return -1;
      x6 = XEXP (x3, 2);
      if (GET_CODE (x6) != PC)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      x9 = XEXP (x8, 0);
      operands[4] = x9;
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
          res = recog_1512 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (!fp_native_comparison (x4, E_VOIDmode))
        return -1;
      switch (pattern411 (x3))
        {
        case 0:
          if (!(
#line 3376 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
            return -1;
          return 371; /* *cbranchsf4 */

        case 1:
          if (!(
#line 3376 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
            return -1;
          return 372; /* *cbranchsf4 */

        case 2:
          if (!(
#line 3376 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
            return -1;
          return 373; /* *cbranchdf4 */

        case 3:
          if (!(
#line 3376 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
            return -1;
          return 374; /* *cbranchdf4 */

        case 4:
          if (!(
#line 3376 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
            return -1;
          return 375; /* *cbranchhf4 */

        case 5:
          if (!(
#line 3376 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
            return -1;
          return 376; /* *cbranchhf4 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 7
          || XINT (x4, 1) != 93)
        return -1;
      x10 = XVECEXP (x4, 0, 5);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 66
          || GET_MODE (x10) != E_SImode)
        return -1;
      x11 = XVECEXP (x4, 0, 6);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 67
          || GET_MODE (x11) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != UNSPEC
          || XINT (x5, 1) != 137)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x12 = XEXP (x8, 1);
      if (pattern375 (x12, 
138, 
1, 
UNSPEC) != 0)
        return -1;
      x13 = XVECEXP (x12, 0, 0);
      if (GET_CODE (x13) != IF_THEN_ELSE)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != UNSPEC
          || XVECLEN (x14, 0) != 7
          || XINT (x14, 1) != 93)
        return -1;
      x15 = XVECEXP (x14, 0, 5);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 66
          || GET_MODE (x15) != E_SImode)
        return -1;
      x16 = XVECEXP (x14, 0, 6);
      if (GET_CODE (x16) != REG
          || REGNO (x16) != 67
          || GET_MODE (x16) != E_SImode)
        return -1;
      x17 = XEXP (x13, 1);
      if (GET_CODE (x17) != UNSPEC
          || XINT (x17, 1) != 137)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 66
          || GET_MODE (x9) != E_SImode)
        return -1;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x18 = XVECEXP (x4, 0, 0);
      operands[1] = x18;
      x19 = XVECEXP (x4, 0, 1);
      operands[4] = x19;
      if (!vector_length_operand (operands[4], E_VOIDmode))
        return -1;
      x20 = XVECEXP (x4, 0, 2);
      operands[5] = x20;
      if (!const_int_operand (operands[5], E_VOIDmode))
        return -1;
      x21 = XVECEXP (x4, 0, 3);
      operands[6] = x21;
      if (!const_int_operand (operands[6], E_VOIDmode))
        return -1;
      x22 = XVECEXP (x4, 0, 4);
      operands[7] = x22;
      if (!const_int_operand (operands[7], E_VOIDmode))
        return -1;
      x6 = XEXP (x3, 2);
      operands[2] = x6;
      x23 = XVECEXP (x14, 0, 0);
      if (!rtx_equal_p (x23, operands[1]))
        return -1;
      x24 = XVECEXP (x14, 0, 1);
      if (!rtx_equal_p (x24, operands[4]))
        return -1;
      x25 = XVECEXP (x14, 0, 2);
      if (!rtx_equal_p (x25, operands[5]))
        return -1;
      x26 = XVECEXP (x14, 0, 3);
      if (!rtx_equal_p (x26, operands[6]))
        return -1;
      x27 = XVECEXP (x14, 0, 4);
      if (!rtx_equal_p (x27, operands[7]))
        return -1;
      x28 = XEXP (x13, 2);
      if (!rtx_equal_p (x28, operands[2]))
        return -1;
      switch (XVECLEN (x5, 0))
        {
        case 1:
          if (XVECLEN (x17, 0) != 1)
            return -1;
          x29 = XVECEXP (x5, 0, 0);
          operands[3] = x29;
          x30 = XVECEXP (x17, 0, 0);
          if (!rtx_equal_p (x30, operands[3]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8QImode:
              if (pattern751 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
                  || !
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21065; /* pred_fault_loadrvvm8qi */

            case E_RVVM4QImode:
              if (pattern751 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
                  || !
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21066; /* pred_fault_loadrvvm4qi */

            case E_RVVM2QImode:
              if (pattern751 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
                  || !
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21067; /* pred_fault_loadrvvm2qi */

            case E_RVVM1QImode:
              if (pattern751 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
                  || !
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21068; /* pred_fault_loadrvvm1qi */

            case E_RVVM8HImode:
              if (pattern751 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
                  || !
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21069; /* pred_fault_loadrvvm8hi */

            case E_RVVM4HImode:
              if (pattern751 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
                  || !
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21070; /* pred_fault_loadrvvm4hi */

            case E_RVVM2HImode:
              if (pattern751 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
                  || !
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21071; /* pred_fault_loadrvvm2hi */

            case E_RVVM1HImode:
              if (pattern751 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
                  || !
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21072; /* pred_fault_loadrvvm1hi */

            case E_RVVM8SImode:
              if (pattern751 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
                  || !
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21073; /* pred_fault_loadrvvm8si */

            case E_RVVM4SImode:
              if (pattern751 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
                  || !
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21074; /* pred_fault_loadrvvm4si */

            case E_RVVM2SImode:
              if (pattern751 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
                  || !
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21075; /* pred_fault_loadrvvm2si */

            case E_RVVM1SImode:
              if (pattern751 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
                  || !
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21076; /* pred_fault_loadrvvm1si */

            case E_RVVM8DImode:
              if (pattern751 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 21077; /* pred_fault_loadrvvm8di */

            case E_RVVM4DImode:
              if (pattern751 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 21078; /* pred_fault_loadrvvm4di */

            case E_RVVM2DImode:
              if (pattern751 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 21079; /* pred_fault_loadrvvm2di */

            case E_RVVM1DImode:
              if (pattern751 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 21080; /* pred_fault_loadrvvm1di */

            case E_RVVMF2QImode:
              if (pattern751 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return -1;
              return 21081; /* pred_fault_loadrvvmf2qi */

            case E_RVVMF4QImode:
              if (pattern751 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return -1;
              return 21082; /* pred_fault_loadrvvmf4qi */

            case E_RVVMF8QImode:
              if (pattern751 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 21083; /* pred_fault_loadrvvmf8qi */

            case E_RVVMF2HImode:
              if (pattern751 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return -1;
              return 21084; /* pred_fault_loadrvvmf2hi */

            case E_RVVMF4HImode:
              if (pattern751 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 21085; /* pred_fault_loadrvvmf4hi */

            case E_RVVMF2SImode:
              if (pattern751 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 21086; /* pred_fault_loadrvvmf2si */

            case E_RVVM8BFmode:
              if (pattern751 (x1, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
                return -1;
              return 21087; /* pred_fault_loadrvvm8bf */

            case E_RVVM4BFmode:
              if (pattern751 (x1, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 168 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
                return -1;
              return 21088; /* pred_fault_loadrvvm4bf */

            case E_RVVM2BFmode:
              if (pattern751 (x1, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
                return -1;
              return 21089; /* pred_fault_loadrvvm2bf */

            case E_RVVM1BFmode:
              if (pattern751 (x1, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
                return -1;
              return 21090; /* pred_fault_loadrvvm1bf */

            case E_RVVMF2BFmode:
              if (pattern751 (x1, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 171 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
                return -1;
              return 21091; /* pred_fault_loadrvvmf2bf */

            case E_RVVMF4BFmode:
              if (pattern751 (x1, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 172 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 21092; /* pred_fault_loadrvvmf4bf */

            case E_RVVM8HFmode:
              if (pattern751 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
                return -1;
              return 21093; /* pred_fault_loadrvvm8hf */

            case E_RVVM4HFmode:
              if (pattern751 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
                return -1;
              return 21094; /* pred_fault_loadrvvm4hf */

            case E_RVVM2HFmode:
              if (pattern751 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
                return -1;
              return 21095; /* pred_fault_loadrvvm2hf */

            case E_RVVM1HFmode:
              if (pattern751 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
                return -1;
              return 21096; /* pred_fault_loadrvvm1hf */

            case E_RVVMF2HFmode:
              if (pattern751 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
                return -1;
              return 21097; /* pred_fault_loadrvvmf2hf */

            case E_RVVMF4HFmode:
              if (pattern751 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 21098; /* pred_fault_loadrvvmf4hf */

            case E_RVVM8SFmode:
              if (pattern751 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 21099; /* pred_fault_loadrvvm8sf */

            case E_RVVM4SFmode:
              if (pattern751 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 21100; /* pred_fault_loadrvvm4sf */

            case E_RVVM2SFmode:
              if (pattern751 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 21101; /* pred_fault_loadrvvm2sf */

            case E_RVVM1SFmode:
              if (pattern751 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 21102; /* pred_fault_loadrvvm1sf */

            case E_RVVMF2SFmode:
              if (pattern751 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 21103; /* pred_fault_loadrvvmf2sf */

            case E_RVVM8DFmode:
              if (pattern751 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 21104; /* pred_fault_loadrvvm8df */

            case E_RVVM4DFmode:
              if (pattern751 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 21105; /* pred_fault_loadrvvm4df */

            case E_RVVM2DFmode:
              if (pattern751 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 21106; /* pred_fault_loadrvvm2df */

            case E_RVVM1DFmode:
              if (pattern751 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 21107; /* pred_fault_loadrvvm1df */

            default:
              return -1;
            }

        case 2:
          x31 = XVECEXP (x5, 0, 1);
          if (GET_CODE (x31) != MEM
              || GET_MODE (x31) != E_BLKmode)
            return -1;
          x32 = XEXP (x31, 0);
          if (GET_CODE (x32) != SCRATCH
              || XVECLEN (x17, 0) != 2)
            return -1;
          x33 = XVECEXP (x17, 0, 1);
          if (GET_CODE (x33) != MEM
              || GET_MODE (x33) != E_BLKmode)
            return -1;
          x34 = XEXP (x33, 0);
          if (GET_CODE (x34) != SCRATCH)
            return -1;
          x29 = XVECEXP (x5, 0, 0);
          operands[3] = x29;
          if (!pmode_reg_or_0_operand (operands[3], E_VOIDmode))
            return -1;
          x30 = XVECEXP (x17, 0, 0);
          if (!rtx_equal_p (x30, operands[3]))
            return -1;
          return recog_1513 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1536 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  if (pattern113 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (pattern376 (x1) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 4);
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != MEM)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != PLUS)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 2)
        return -1;
      x9 = XEXP (x7, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XEXP (x5, 0);
      if (GET_CODE (x10) != REG)
        return -1;
      x11 = XEXP (x2, 0);
      if (GET_CODE (x11) != REG)
        return -1;
      switch (pattern730 (x1))
        {
        case 0:
          if (XWINT (x9, 0) != -16L)
            return -1;
          switch (pattern742 (x1, 
E_SImode, 
-32, 
-28, 
-24, 
-20))
            {
            case 0:
              if (!(
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33819; /* gpr_multi_pop_up_to_s6_si */

            case 1:
              if (!(
#line 473 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33839; /* gpr_multi_popret_up_to_s4_si */

            case 2:
              if (!(
#line 789 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33859; /* gpr_multi_popretz_up_to_s2_si */

            default:
              return -1;
            }

        case 1:
          if (XWINT (x9, 0) != -32L)
            return -1;
          switch (pattern742 (x1, 
E_DImode, 
-64, 
-56, 
-48, 
-40))
            {
            case 0:
              if (!(
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33820; /* gpr_multi_pop_up_to_s6_di */

            case 1:
              if (!(
#line 473 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33840; /* gpr_multi_popret_up_to_s4_di */

            case 2:
              if (!(
#line 789 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33860; /* gpr_multi_popretz_up_to_s2_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      if (REGNO (x4) != 22)
        return -1;
      x12 = XEXP (x3, 0);
      if (GET_CODE (x12) != MEM)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != PLUS)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 2)
        return -1;
      x15 = XEXP (x13, 1);
      if (GET_CODE (x15) != CONST_INT)
        return -1;
      x16 = XVECEXP (x1, 0, 1);
      if (pattern418 (x16, 
21) != 0)
        return -1;
      x17 = XVECEXP (x1, 0, 2);
      x18 = XEXP (x17, 1);
      if (GET_CODE (x18) != REG
          || REGNO (x18) != 20)
        return -1;
      x19 = XEXP (x17, 0);
      if (GET_CODE (x19) != MEM)
        return -1;
      x20 = XEXP (x19, 0);
      if (GET_CODE (x20) != PLUS)
        return -1;
      x21 = XEXP (x20, 0);
      if (GET_CODE (x21) != REG
          || REGNO (x21) != 2)
        return -1;
      x22 = XEXP (x20, 1);
      if (GET_CODE (x22) != CONST_INT)
        return -1;
      x23 = XVECEXP (x1, 0, 3);
      if (pattern675 (x23, 
19) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 4);
      if (pattern735 (x5, 
18) != 0
          || pattern741 (x1, 
9) != 0
          || pattern747 (x1, 
8) != 0)
        return -1;
      x24 = XVECEXP (x1, 0, 7);
      if (pattern752 (x24, 
1) != 0)
        return -1;
      x25 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x25) != SET)
        return -1;
      x26 = XEXP (x25, 1);
      if (GET_CODE (x26) != PLUS)
        return -1;
      x27 = XEXP (x26, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 2)
        return -1;
      x28 = XEXP (x25, 0);
      if (GET_CODE (x28) != REG
          || REGNO (x28) != 2)
        return -1;
      x29 = XEXP (x26, 1);
      operands[0] = x29;
      if (!stack_push_up_to_s6_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern760 (x1))
        {
        case 0:
          x30 = XEXP (x24, 0);
          x31 = XEXP (x30, 0);
          x32 = XEXP (x31, 1);
          if (XWINT (x32, 0) != -32L
              || pattern769 (x1, 
E_SImode) != 0
              || !(
#line 1272 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33891; /* gpr_multi_push_up_to_s6_si */

        case 1:
          x30 = XEXP (x24, 0);
          x31 = XEXP (x30, 0);
          x32 = XEXP (x31, 1);
          if (XWINT (x32, 0) != -64L
              || pattern769 (x1, 
E_DImode) != 0
              || !(
#line 1272 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33892; /* gpr_multi_push_up_to_s6_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1539 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  if (pattern115 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      if (pattern432 (x1) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 8);
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG)
        return -1;
      switch (pattern756 (x1))
        {
        case 0:
          switch (pattern764 (x1, 
E_SImode))
            {
            case 0:
              if (pattern780 (x1, 
18, 
19, 
20, 
21, 
22) != 0
                  || pattern788 (x1, 
E_SImode) != 0)
                return -1;
              x6 = XVECEXP (x1, 0, 10);
              x7 = XEXP (x6, 1);
              x8 = XEXP (x7, 0);
              x9 = XEXP (x8, 1);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + -40])
                return -1;
              x10 = XEXP (x6, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 8
                  || GET_MODE (x10) != E_SImode)
                return -1;
              x11 = XVECEXP (x1, 0, 11);
              if (pattern794 (x11) != 0)
                return -1;
              x12 = XEXP (x11, 0);
              if (pattern799 (x12, 
E_SImode) != 0
                  || !(
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33825; /* gpr_multi_pop_up_to_s9_si */

            case 1:
              if (pattern780 (x1, 
8, 
9, 
18, 
19, 
20) != 0
                  || pattern789 (x1, 
E_SImode) != 0
                  || !(
#line 575 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33845; /* gpr_multi_popret_up_to_s7_si */

            case 2:
              if (!(
#line 882 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33865; /* gpr_multi_popretz_up_to_s5_si */

            default:
              return -1;
            }

        case 1:
          switch (pattern764 (x1, 
E_DImode))
            {
            case 0:
              if (pattern782 (x1, 
18, 
19, 
20, 
21, 
22) != 0
                  || pattern788 (x1, 
E_DImode) != 0)
                return -1;
              x6 = XVECEXP (x1, 0, 10);
              x7 = XEXP (x6, 1);
              x8 = XEXP (x7, 0);
              x9 = XEXP (x8, 1);
              if (GET_CODE (x9) != CONST_INT
                  || XWINT (x9, 0) != -80L)
                return -1;
              x10 = XEXP (x6, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 8
                  || GET_MODE (x10) != E_DImode)
                return -1;
              x11 = XVECEXP (x1, 0, 11);
              if (pattern796 (x11) != 0)
                return -1;
              x12 = XEXP (x11, 0);
              if (pattern799 (x12, 
E_DImode) != 0
                  || !(
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33826; /* gpr_multi_pop_up_to_s9_di */

            case 1:
              if (pattern782 (x1, 
8, 
9, 
18, 
19, 
20) != 0
                  || pattern789 (x1, 
E_DImode) != 0
                  || !(
#line 575 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33846; /* gpr_multi_popret_up_to_s7_di */

            case 2:
              if (!(
#line 882 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33866; /* gpr_multi_popretz_up_to_s5_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      if (pattern395 (x1, 
24, 
25) != 0
          || pattern541 (x1, 
19, 
20, 
21, 
22, 
23) != 0)
        return -1;
      x13 = XVECEXP (x1, 0, 7);
      if (pattern752 (x13, 
18) != 0
          || pattern763 (x1, 
8, 
9) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x6) != SET
          || pattern771 (x6, 
1) != 0)
        return -1;
      x11 = XVECEXP (x1, 0, 11);
      if (GET_CODE (x11) != SET)
        return -1;
      x14 = XEXP (x11, 1);
      if (GET_CODE (x14) != PLUS)
        return -1;
      x15 = XEXP (x14, 0);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 2)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != REG
          || REGNO (x12) != 2)
        return -1;
      x16 = XEXP (x14, 1);
      operands[0] = x16;
      if (!stack_push_up_to_s9_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern776 (x1))
        {
        case 0:
          if (pattern785 (x1, 
E_SImode) != 0
              || !(
#line 1386 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33897; /* gpr_multi_push_up_to_s9_si */

        case 1:
          if (pattern785 (x1, 
E_DImode) != 0
              || !(
#line 1386 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33898; /* gpr_multi_push_up_to_s9_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1542 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  if (pattern116 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 9);
  if (pattern759 (x2) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XEXP (x3, 0);
  if (GET_CODE (x8) != REG)
    return -1;
  x9 = XVECEXP (x1, 0, 11);
  if (pattern767 (x9) != 0)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG)
    return -1;
  x11 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x11) != SET)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != REG)
    return -1;
  x13 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x13) != RETURN)
    return -1;
  x14 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x14) != USE)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 1
      || GET_MODE (x15) != E_SImode)
    return -1;
  x16 = XVECEXP (x1, 0, 0);
  x17 = XEXP (x16, 1);
  x18 = XEXP (x17, 1);
  operands[0] = x18;
  switch (pattern775 (x1))
    {
    case 0:
      switch (pattern784 (x1, 
E_SImode))
        {
        case 0:
          x19 = XEXP (x11, 1);
          if (pattern802 (x19) != 0
              || REGNO (x12) != 8)
            return -1;
          x20 = XVECEXP (x1, 0, 13);
          if (pattern805 (x20) != 0
              || !(
#line 707 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33851; /* gpr_multi_popret_up_to_s11_si */

        case 1:
          if (!(
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33873; /* gpr_multi_popretz_up_to_s9_si */

        default:
          return -1;
        }

    case 1:
      switch (pattern784 (x1, 
E_DImode))
        {
        case 0:
          x19 = XEXP (x11, 1);
          if (pattern803 (x19) != 0
              || REGNO (x12) != 8)
            return -1;
          x20 = XVECEXP (x1, 0, 13);
          if (pattern806 (x20) != 0
              || !(
#line 707 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33852; /* gpr_multi_popret_up_to_s11_di */

        case 1:
          if (!(
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33874; /* gpr_multi_popretz_up_to_s9_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM8QImode) != 0
          || !(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2587 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM4QImode) != 0
          || !(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2601 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM2QImode) != 0
          || !(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2615 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM1QImode) != 0
          || !(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2629 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM8HImode) != 0
          || !(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2643 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM4HImode) != 0
          || !(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2657 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM2HImode) != 0
          || !(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2671 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM1HImode) != 0
          || !(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2685 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM8SImode) != 0
          || !(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2699 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM4SImode) != 0
          || !(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2713 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM2SImode) != 0
          || !(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2727 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM1SImode) != 0
          || !(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2741 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM8DImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2755 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM4DImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2769 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM2DImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2783 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM1DImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2797 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVMF2QImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2811 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVMF4QImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2825 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVMF8QImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2839 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVMF2HImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2853 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVMF4HImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2867 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVMF2SImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2881 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V1QImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2895 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V2QImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2909 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V4QImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2923 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V8QImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2937 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V16QImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2951 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V32QImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2965 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V64QImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2979 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V128QImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2993 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V256QImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3007 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V512QImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3021 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V1024QImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3035 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V2048QImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3049 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V4096QImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3063 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V1HImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3077 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V2HImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3091 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V4HImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3105 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V8HImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3119 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V16HImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3133 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V32HImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3147 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V64HImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3161 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V128HImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3175 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V256HImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3189 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V512HImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3203 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V1024HImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3217 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V2048HImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3231 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V1SImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3245 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V2SImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3259 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V4SImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3273 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V8SImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3287 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V16SImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3301 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V32SImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3315 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V64SImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3329 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V128SImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3343 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V256SImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3357 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V512SImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3371 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V1024SImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3385 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V1DImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3399 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V2DImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3413 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V4DImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3427 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V8DImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3441 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V16DImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3455 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V32DImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3469 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V64DImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3483 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V128DImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3497 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V256DImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3511 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V512DImode) != 0
          || !((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3525 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5553 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5557 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5561 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5565 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5569 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5573 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5577 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5581 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5585 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5589 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5593 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5597 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5601 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5605 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5609 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5613 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5617 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5621 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5625 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5629 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5633 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5637 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5641 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5645 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5649 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5653 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5657 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5661 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5665 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5669 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5673 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5677 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5681 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5685 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5689 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5693 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5697 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5701 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5705 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5709 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5713 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5717 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5721 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5725 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5729 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5733 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5737 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DFmode) != 0
          || !((
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5741 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_13 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2DFmode)
      && reg_or_mem_operand (operands[1], E_V2DFmode))
    {
      if ((
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return gen_split_314 (insn, operands);
      if (((
#line 1434 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2DFmode)
       || register_operand (operands[1], V2DFmode))) && 
#line 4335 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1441 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V2DFmode)
       || !register_operand (operands[1], V2DFmode)))))
        return gen_split_1978 (insn, operands);
    }
  if (!register_operand (operands[0], E_V2DFmode)
      || !register_operand (operands[1], E_V2DFmode)
      || !((
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2161 (insn, operands);
}

 rtx_insn *
split_16 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8SFmode)
      && reg_or_mem_operand (operands[1], E_V8SFmode))
    {
      if ((
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 287 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return gen_split_305 (insn, operands);
      if (((
#line 1434 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8SFmode)
       || register_operand (operands[1], V8SFmode))) && 
#line 4332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1441 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V8SFmode)
       || !register_operand (operands[1], V8SFmode)))))
        return gen_split_1975 (insn, operands);
    }
  if (!register_operand (operands[0], E_V8SFmode)
      || !register_operand (operands[1], E_V8SFmode)
      || !((
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2152 (insn, operands);
}

 rtx_insn *
split_20 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16HFmode)
      && reg_or_mem_operand (operands[1], E_V16HFmode))
    {
      if ((
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 276 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return gen_split_294 (insn, operands);
      if (((
#line 1434 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16HFmode)
       || register_operand (operands[1], V16HFmode))) && 
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1441 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16HFmode)
       || !register_operand (operands[1], V16HFmode)))))
        return gen_split_1971 (insn, operands);
    }
  if (!register_operand (operands[0], E_V16HFmode)
      || !register_operand (operands[1], E_V16HFmode)
      || !((
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2141 (insn, operands);
}

 rtx_insn *
split_24 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1HFmode)
      && reg_or_mem_operand (operands[1], E_V1HFmode))
    {
      if ((
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 272 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return gen_split_290 (insn, operands);
      if (((
#line 1434 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1HFmode)
       || register_operand (operands[1], V1HFmode))) && 
#line 4324 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1441 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1HFmode)
       || !register_operand (operands[1], V1HFmode)))))
        return gen_split_1967 (insn, operands);
    }
  if (!register_operand (operands[0], E_V1HFmode)
      || !register_operand (operands[1], E_V1HFmode)
      || !((
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2137 (insn, operands);
}

 rtx_insn *
split_28 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2DImode)
      && reg_or_mem_operand (operands[1], E_V2DImode))
    {
      if ((
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return gen_split_281 (insn, operands);
      if (((
#line 1434 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2DImode)
       || register_operand (operands[1], V2DImode))) && 
#line 4320 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1441 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V2DImode)
       || !register_operand (operands[1], V2DImode)))))
        return gen_split_1963 (insn, operands);
    }
  if (!register_operand (operands[0], E_V2DImode)
      || !register_operand (operands[1], E_V2DImode)
      || !((
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2128 (insn, operands);
}

 rtx_insn *
split_32 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4SImode)
      && reg_or_mem_operand (operands[1], E_V4SImode))
    {
      if ((
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return gen_split_271 (insn, operands);
      if (((
#line 1434 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[1], V4SImode))) && 
#line 4316 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1441 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4SImode)
       || !register_operand (operands[1], V4SImode)))))
        return gen_split_1959 (insn, operands);
    }
  if (!register_operand (operands[0], E_V4SImode)
      || !register_operand (operands[1], E_V4SImode)
      || !((
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2118 (insn, operands);
}

 rtx_insn *
split_37 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4HImode)
      && reg_or_mem_operand (operands[1], E_V4HImode))
    {
      if ((
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return gen_split_259 (insn, operands);
      if (((
#line 1434 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4HImode)
       || register_operand (operands[1], V4HImode))) && 
#line 4311 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1441 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4HImode)
       || !register_operand (operands[1], V4HImode)))))
        return gen_split_1954 (insn, operands);
    }
  if (!register_operand (operands[0], E_V4HImode)
      || !register_operand (operands[1], E_V4HImode)
      || !((
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2106 (insn, operands);
}

 rtx_insn *
split_43 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2QImode)
      && reg_or_mem_operand (operands[1], E_V2QImode))
    {
      if ((
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return gen_split_245 (insn, operands);
      if (((
#line 1434 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2QImode)
       || register_operand (operands[1], V2QImode))) && 
#line 4305 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1441 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V2QImode)
       || !register_operand (operands[1], V2QImode)))))
        return gen_split_1948 (insn, operands);
    }
  if (!register_operand (operands[0], E_V2QImode)
      || !register_operand (operands[1], E_V2QImode)
      || !((
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2092 (insn, operands);
}

 rtx_insn *
split_49 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1BImode)
      && reg_or_mem_operand (operands[1], E_V1BImode)
      && ((
#line 1434 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1BImode)
       || register_operand (operands[1], V1BImode))) && 
#line 4340 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1441 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1BImode)
       || !register_operand (operands[1], V1BImode)))))
    return gen_split_1982 (insn, operands);
  if (!register_operand (operands[0], E_V1BImode)
      || !register_operand (operands[1], E_V1BImode)
      || !((
#line 1530 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2170 (insn, operands);
}

 rtx_insn *
split_58 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128SFmode)
      && reg_or_mem_operand (operands[1], E_V128SFmode)
      && (
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 291 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return gen_split_309 (insn, operands);
  if (!register_operand (operands[0], E_V128SFmode)
      || !register_operand (operands[1], E_V128SFmode)
      || !((
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 291 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2156 (insn, operands);
}

 rtx_insn *
split_64 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256HFmode)
      && reg_or_mem_operand (operands[1], E_V256HFmode)
      && (
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 280 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
    return gen_split_298 (insn, operands);
  if (!register_operand (operands[0], E_V256HFmode)
      || !register_operand (operands[1], E_V256HFmode)
      || !((
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 1511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2145 (insn, operands);
}

 rtx_insn *
split_70 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128DImode)
      && reg_or_mem_operand (operands[1], E_V128DImode)
      && (
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return gen_split_287 (insn, operands);
  if (!register_operand (operands[0], E_V128DImode)
      || !register_operand (operands[1], E_V128DImode)
      || !((
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2134 (insn, operands);
}

 rtx_insn *
split_76 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128SImode)
      && reg_or_mem_operand (operands[1], E_V128SImode)
      && (
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return gen_split_276 (insn, operands);
  if (!register_operand (operands[0], E_V128SImode)
      || !register_operand (operands[1], E_V128SImode)
      || !((
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2123 (insn, operands);
}

 rtx_insn *
split_83 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128HImode)
      && reg_or_mem_operand (operands[1], E_V128HImode)
      && (
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return gen_split_264 (insn, operands);
  if (!register_operand (operands[0], E_V128HImode)
      || !register_operand (operands[1], E_V128HImode)
      || !((
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2111 (insn, operands);
}

 rtx_insn *
split_90 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256QImode)
      && reg_or_mem_operand (operands[1], E_V256QImode)
      && (
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return gen_split_252 (insn, operands);
  if (!register_operand (operands[0], E_V256QImode)
      || !register_operand (operands[1], E_V256QImode)
      || !((
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2099 (insn, operands);
}

 rtx_insn *
split_97 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF8BImode)
      && reg_or_mem_operand (operands[1], E_RVVMF8BImode)
      && 
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return gen_split_240 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF8BImode)
      || !register_operand (operands[1], E_RVVMF8BImode)
      || !(
#line 1294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1577 (insn, operands);
}

 rtx_insn *
split_104 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF4BFmode)
      && reg_or_mem_operand (operands[1], E_RVVMF4BFmode)
      && (
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 172 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
    return gen_split_221 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF4BFmode)
      || !register_operand (operands[1], E_RVVMF4BFmode)
      || !((
#line 1257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)) && 
#line 1259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1569 (insn, operands);
}

 rtx_insn *
split_111 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern276 (x2))
    {
    case 0:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3539 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3743 (insn, operands);

    case 1:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3542 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3746 (insn, operands);

    case 2:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3545 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3749 (insn, operands);

    case 3:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3548 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3752 (insn, operands);

    case 4:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3551 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3755 (insn, operands);

    case 5:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3554 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3758 (insn, operands);

    case 6:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3557 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3761 (insn, operands);

    case 7:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3560 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3764 (insn, operands);

    case 8:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3563 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3767 (insn, operands);

    case 9:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3566 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3770 (insn, operands);

    case 10:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3569 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3773 (insn, operands);

    case 11:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3572 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3776 (insn, operands);

    case 12:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3575 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8DImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3779 (insn, operands);

    case 13:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3578 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4DImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3782 (insn, operands);

    case 14:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3581 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2DImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3785 (insn, operands);

    case 15:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3584 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1DImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3788 (insn, operands);

    case 16:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3587 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF2QImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3791 (insn, operands);

    case 17:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3590 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF4QImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3794 (insn, operands);

    case 18:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3593 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF8QImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3797 (insn, operands);

    case 19:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3596 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF2HImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3800 (insn, operands);

    case 20:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3599 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF4HImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3803 (insn, operands);

    case 21:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3602 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF2SImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3806 (insn, operands);

    case 22:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3605 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1QImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3809 (insn, operands);

    case 23:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3608 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2QImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3812 (insn, operands);

    case 24:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3611 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4QImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3815 (insn, operands);

    case 25:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3614 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8QImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3818 (insn, operands);

    case 26:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3617 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16QImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3821 (insn, operands);

    case 27:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3620 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32QImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3824 (insn, operands);

    case 28:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3623 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64QImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3827 (insn, operands);

    case 29:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3626 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128QImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3830 (insn, operands);

    case 30:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3629 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256QImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3833 (insn, operands);

    case 31:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3632 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512QImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3836 (insn, operands);

    case 32:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3635 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1024QImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3839 (insn, operands);

    case 33:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3638 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2048QImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3842 (insn, operands);

    case 34:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3641 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4096QImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3845 (insn, operands);

    case 35:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3644 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1HImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3848 (insn, operands);

    case 36:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3647 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2HImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3851 (insn, operands);

    case 37:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3650 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4HImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3854 (insn, operands);

    case 38:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3653 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8HImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3857 (insn, operands);

    case 39:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3656 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16HImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3860 (insn, operands);

    case 40:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3659 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32HImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3863 (insn, operands);

    case 41:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3662 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64HImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3866 (insn, operands);

    case 42:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3665 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128HImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3869 (insn, operands);

    case 43:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3668 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256HImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3872 (insn, operands);

    case 44:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3671 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512HImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3875 (insn, operands);

    case 45:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3674 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1024HImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3878 (insn, operands);

    case 46:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3677 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2048HImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3881 (insn, operands);

    case 47:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3680 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1SImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3884 (insn, operands);

    case 48:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3683 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2SImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3887 (insn, operands);

    case 49:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3686 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4SImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3890 (insn, operands);

    case 50:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3689 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8SImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3893 (insn, operands);

    case 51:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3692 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16SImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3896 (insn, operands);

    case 52:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3695 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32SImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3899 (insn, operands);

    case 53:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3698 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64SImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3902 (insn, operands);

    case 54:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3701 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128SImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3905 (insn, operands);

    case 55:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3704 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256SImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3908 (insn, operands);

    case 56:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3707 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512SImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3911 (insn, operands);

    case 57:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3710 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1024SImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3914 (insn, operands);

    case 58:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3713 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1DImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3917 (insn, operands);

    case 59:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3716 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2DImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3920 (insn, operands);

    case 60:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3719 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4DImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3923 (insn, operands);

    case 61:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3722 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8DImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3926 (insn, operands);

    case 62:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3725 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16DImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3929 (insn, operands);

    case 63:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3728 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32DImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3932 (insn, operands);

    case 64:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3731 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64DImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3935 (insn, operands);

    case 65:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3734 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128DImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3938 (insn, operands);

    case 66:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3737 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256DImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3941 (insn, operands);

    case 67:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3740 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512DImode)
          || !((
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3944 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_120 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern250 (x2))
    {
    case 0:
      if (!(
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6121 (insn, operands);

    case 1:
      if (!(
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6122 (insn, operands);

    case 2:
      if (!(
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6123 (insn, operands);

    case 3:
      if (!(
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6124 (insn, operands);

    case 4:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6137 (insn, operands);

    case 5:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6138 (insn, operands);

    case 6:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6139 (insn, operands);

    case 7:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6143 (insn, operands);

    case 8:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6144 (insn, operands);

    case 9:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6145 (insn, operands);

    case 10:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6146 (insn, operands);

    case 11:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6147 (insn, operands);

    case 12:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6148 (insn, operands);

    case 13:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6149 (insn, operands);

    case 14:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6150 (insn, operands);

    case 15:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6151 (insn, operands);

    case 16:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6152 (insn, operands);

    case 17:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6153 (insn, operands);

    case 18:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6154 (insn, operands);

    case 19:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6155 (insn, operands);

    case 20:
      if (!(
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6125 (insn, operands);

    case 21:
      if (!(
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6126 (insn, operands);

    case 22:
      if (!(
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6127 (insn, operands);

    case 23:
      if (!(
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6128 (insn, operands);

    case 24:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6140 (insn, operands);

    case 25:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6141 (insn, operands);

    case 26:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6156 (insn, operands);

    case 27:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6157 (insn, operands);

    case 28:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6158 (insn, operands);

    case 29:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6159 (insn, operands);

    case 30:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6160 (insn, operands);

    case 31:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6161 (insn, operands);

    case 32:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6162 (insn, operands);

    case 33:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6163 (insn, operands);

    case 34:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6164 (insn, operands);

    case 35:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6165 (insn, operands);

    case 36:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6166 (insn, operands);

    case 37:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6167 (insn, operands);

    case 38:
      if (!(
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6129 (insn, operands);

    case 39:
      if (!(
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6130 (insn, operands);

    case 40:
      if (!(
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6131 (insn, operands);

    case 41:
      if (!(
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6132 (insn, operands);

    case 42:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6142 (insn, operands);

    case 43:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6168 (insn, operands);

    case 44:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6169 (insn, operands);

    case 45:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6170 (insn, operands);

    case 46:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6171 (insn, operands);

    case 47:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6172 (insn, operands);

    case 48:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6173 (insn, operands);

    case 49:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6174 (insn, operands);

    case 50:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6175 (insn, operands);

    case 51:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6176 (insn, operands);

    case 52:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6177 (insn, operands);

    case 53:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6178 (insn, operands);

    case 54:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6133 (insn, operands);

    case 55:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6134 (insn, operands);

    case 56:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6135 (insn, operands);

    case 57:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6136 (insn, operands);

    case 58:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6179 (insn, operands);

    case 59:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6180 (insn, operands);

    case 60:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6181 (insn, operands);

    case 61:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6182 (insn, operands);

    case 62:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6183 (insn, operands);

    case 63:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6184 (insn, operands);

    case 64:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6185 (insn, operands);

    case 65:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6186 (insn, operands);

    case 66:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6187 (insn, operands);

    case 67:
      if (!((
#line 2203 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 2205 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6188 (insn, operands);

    case 68:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9110 (insn, operands);

    case 69:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9112 (insn, operands);

    case 70:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9114 (insn, operands);

    case 71:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9116 (insn, operands);

    case 72:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9118 (insn, operands);

    case 73:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9120 (insn, operands);

    case 74:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 616 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9140 (insn, operands);

    case 75:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 617 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9142 (insn, operands);

    case 76:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 618 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9144 (insn, operands);

    case 77:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 619 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9146 (insn, operands);

    case 78:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 620 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9148 (insn, operands);

    case 79:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 621 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9150 (insn, operands);

    case 80:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9152 (insn, operands);

    case 81:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 623 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9154 (insn, operands);

    case 82:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 624 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9156 (insn, operands);

    case 83:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 625 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9158 (insn, operands);

    case 84:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9160 (insn, operands);

    case 85:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 627 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9162 (insn, operands);

    case 86:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9122 (insn, operands);

    case 87:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9124 (insn, operands);

    case 88:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9126 (insn, operands);

    case 89:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9128 (insn, operands);

    case 90:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9130 (insn, operands);

    case 91:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 628 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9164 (insn, operands);

    case 92:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9186 (insn, operands);

    case 93:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9166 (insn, operands);

    case 94:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 640 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9188 (insn, operands);

    case 95:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 630 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9168 (insn, operands);

    case 96:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 641 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9190 (insn, operands);

    case 97:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9170 (insn, operands);

    case 98:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 642 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9192 (insn, operands);

    case 99:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 632 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9172 (insn, operands);

    case 100:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9194 (insn, operands);

    case 101:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 633 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9174 (insn, operands);

    case 102:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 644 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9196 (insn, operands);

    case 103:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 634 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9176 (insn, operands);

    case 104:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 645 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9198 (insn, operands);

    case 105:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 635 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9178 (insn, operands);

    case 106:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 646 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9200 (insn, operands);

    case 107:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 636 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9180 (insn, operands);

    case 108:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 647 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9202 (insn, operands);

    case 109:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 637 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9182 (insn, operands);

    case 110:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 648 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9204 (insn, operands);

    case 111:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 638 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9184 (insn, operands);

    case 112:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9132 (insn, operands);

    case 113:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9134 (insn, operands);

    case 114:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9136 (insn, operands);

    case 115:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 614 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9138 (insn, operands);

    case 116:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9111 (insn, operands);

    case 117:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9113 (insn, operands);

    case 118:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9115 (insn, operands);

    case 119:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9117 (insn, operands);

    case 120:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9119 (insn, operands);

    case 121:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9121 (insn, operands);

    case 122:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 616 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9141 (insn, operands);

    case 123:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 617 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9143 (insn, operands);

    case 124:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 618 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9145 (insn, operands);

    case 125:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 619 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9147 (insn, operands);

    case 126:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 620 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9149 (insn, operands);

    case 127:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 621 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9151 (insn, operands);

    case 128:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9153 (insn, operands);

    case 129:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 623 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9155 (insn, operands);

    case 130:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 624 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9157 (insn, operands);

    case 131:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 625 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9159 (insn, operands);

    case 132:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9161 (insn, operands);

    case 133:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 627 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9163 (insn, operands);

    case 134:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9123 (insn, operands);

    case 135:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9125 (insn, operands);

    case 136:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9127 (insn, operands);

    case 137:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9129 (insn, operands);

    case 138:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9131 (insn, operands);

    case 139:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 628 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9165 (insn, operands);

    case 140:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9187 (insn, operands);

    case 141:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9167 (insn, operands);

    case 142:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 640 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9189 (insn, operands);

    case 143:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 630 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9169 (insn, operands);

    case 144:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 641 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9191 (insn, operands);

    case 145:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9171 (insn, operands);

    case 146:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 642 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9193 (insn, operands);

    case 147:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 632 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9173 (insn, operands);

    case 148:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9195 (insn, operands);

    case 149:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 633 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9175 (insn, operands);

    case 150:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 644 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9197 (insn, operands);

    case 151:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 634 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9177 (insn, operands);

    case 152:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 645 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9199 (insn, operands);

    case 153:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 635 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9179 (insn, operands);

    case 154:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 646 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9201 (insn, operands);

    case 155:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 636 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9181 (insn, operands);

    case 156:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 647 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9203 (insn, operands);

    case 157:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 637 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9183 (insn, operands);

    case 158:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 648 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9205 (insn, operands);

    case 159:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 638 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9185 (insn, operands);

    case 160:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9133 (insn, operands);

    case 161:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9135 (insn, operands);

    case 162:
      if (!(
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9137 (insn, operands);

    case 163:
      if (!((
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 614 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 864 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9139 (insn, operands);

    case 164:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9824 (insn, operands);

    case 165:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9826 (insn, operands);

    case 166:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9828 (insn, operands);

    case 167:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9830 (insn, operands);

    case 168:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9832 (insn, operands);

    case 169:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9834 (insn, operands);

    case 170:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 616 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9854 (insn, operands);

    case 171:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 617 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9856 (insn, operands);

    case 172:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 618 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9858 (insn, operands);

    case 173:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 619 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9860 (insn, operands);

    case 174:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 620 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9862 (insn, operands);

    case 175:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 621 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9864 (insn, operands);

    case 176:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9866 (insn, operands);

    case 177:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 623 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9868 (insn, operands);

    case 178:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 624 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9870 (insn, operands);

    case 179:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 625 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9872 (insn, operands);

    case 180:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9874 (insn, operands);

    case 181:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 627 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9876 (insn, operands);

    case 182:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9836 (insn, operands);

    case 183:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9838 (insn, operands);

    case 184:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9840 (insn, operands);

    case 185:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9842 (insn, operands);

    case 186:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9844 (insn, operands);

    case 187:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 628 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9878 (insn, operands);

    case 188:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9900 (insn, operands);

    case 189:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9880 (insn, operands);

    case 190:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 640 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9902 (insn, operands);

    case 191:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 630 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9882 (insn, operands);

    case 192:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 641 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9904 (insn, operands);

    case 193:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9884 (insn, operands);

    case 194:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 642 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9906 (insn, operands);

    case 195:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 632 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9886 (insn, operands);

    case 196:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9908 (insn, operands);

    case 197:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 633 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9888 (insn, operands);

    case 198:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 644 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9910 (insn, operands);

    case 199:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 634 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9890 (insn, operands);

    case 200:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 645 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9912 (insn, operands);

    case 201:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 635 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9892 (insn, operands);

    case 202:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 646 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9914 (insn, operands);

    case 203:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 636 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9894 (insn, operands);

    case 204:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 647 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9916 (insn, operands);

    case 205:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 637 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9896 (insn, operands);

    case 206:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 648 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9918 (insn, operands);

    case 207:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 638 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9898 (insn, operands);

    case 208:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9846 (insn, operands);

    case 209:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9848 (insn, operands);

    case 210:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9850 (insn, operands);

    case 211:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 614 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9852 (insn, operands);

    case 212:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9825 (insn, operands);

    case 213:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9827 (insn, operands);

    case 214:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9829 (insn, operands);

    case 215:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9831 (insn, operands);

    case 216:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9833 (insn, operands);

    case 217:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9835 (insn, operands);

    case 218:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 616 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9855 (insn, operands);

    case 219:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 617 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9857 (insn, operands);

    case 220:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 618 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9859 (insn, operands);

    case 221:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 619 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9861 (insn, operands);

    case 222:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 620 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9863 (insn, operands);

    case 223:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 621 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9865 (insn, operands);

    case 224:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9867 (insn, operands);

    case 225:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 623 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9869 (insn, operands);

    case 226:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 624 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9871 (insn, operands);

    case 227:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 625 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9873 (insn, operands);

    case 228:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9875 (insn, operands);

    case 229:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 627 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9877 (insn, operands);

    case 230:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9837 (insn, operands);

    case 231:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9839 (insn, operands);

    case 232:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9841 (insn, operands);

    case 233:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9843 (insn, operands);

    case 234:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9845 (insn, operands);

    case 235:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 628 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9879 (insn, operands);

    case 236:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9901 (insn, operands);

    case 237:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9881 (insn, operands);

    case 238:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 640 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9903 (insn, operands);

    case 239:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 630 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9883 (insn, operands);

    case 240:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 641 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9905 (insn, operands);

    case 241:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9885 (insn, operands);

    case 242:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 642 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9907 (insn, operands);

    case 243:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 632 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9887 (insn, operands);

    case 244:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9909 (insn, operands);

    case 245:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 633 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9889 (insn, operands);

    case 246:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 644 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9911 (insn, operands);

    case 247:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 634 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9891 (insn, operands);

    case 248:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 645 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9913 (insn, operands);

    case 249:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 635 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9893 (insn, operands);

    case 250:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 646 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9915 (insn, operands);

    case 251:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 636 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9895 (insn, operands);

    case 252:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 647 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9917 (insn, operands);

    case 253:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 637 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9897 (insn, operands);

    case 254:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 648 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9919 (insn, operands);

    case 255:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 638 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9899 (insn, operands);

    case 256:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9847 (insn, operands);

    case 257:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9849 (insn, operands);

    case 258:
      if (!(
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9851 (insn, operands);

    case 259:
      if (!((
#line 1280 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 614 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1282 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9853 (insn, operands);

    case 260:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9920 (insn, operands);

    case 261:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9922 (insn, operands);

    case 262:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9924 (insn, operands);

    case 263:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9926 (insn, operands);

    case 264:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9928 (insn, operands);

    case 265:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9930 (insn, operands);

    case 266:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 616 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9950 (insn, operands);

    case 267:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 617 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9952 (insn, operands);

    case 268:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 618 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9954 (insn, operands);

    case 269:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 619 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9956 (insn, operands);

    case 270:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 620 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9958 (insn, operands);

    case 271:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 621 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9960 (insn, operands);

    case 272:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9962 (insn, operands);

    case 273:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 623 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9964 (insn, operands);

    case 274:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 624 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9966 (insn, operands);

    case 275:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 625 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9968 (insn, operands);

    case 276:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9970 (insn, operands);

    case 277:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 627 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9972 (insn, operands);

    case 278:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9932 (insn, operands);

    case 279:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9934 (insn, operands);

    case 280:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9936 (insn, operands);

    case 281:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9938 (insn, operands);

    case 282:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9940 (insn, operands);

    case 283:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 628 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9974 (insn, operands);

    case 284:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9996 (insn, operands);

    case 285:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9976 (insn, operands);

    case 286:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 640 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9998 (insn, operands);

    case 287:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 630 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9978 (insn, operands);

    case 288:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 641 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10000 (insn, operands);

    case 289:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9980 (insn, operands);

    case 290:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 642 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10002 (insn, operands);

    case 291:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 632 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9982 (insn, operands);

    case 292:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10004 (insn, operands);

    case 293:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 633 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9984 (insn, operands);

    case 294:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 644 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10006 (insn, operands);

    case 295:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 634 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9986 (insn, operands);

    case 296:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 645 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10008 (insn, operands);

    case 297:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 635 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9988 (insn, operands);

    case 298:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 646 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10010 (insn, operands);

    case 299:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 636 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9990 (insn, operands);

    case 300:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 647 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10012 (insn, operands);

    case 301:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 637 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9992 (insn, operands);

    case 302:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 648 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10014 (insn, operands);

    case 303:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 638 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9994 (insn, operands);

    case 304:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9942 (insn, operands);

    case 305:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9944 (insn, operands);

    case 306:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9946 (insn, operands);

    case 307:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 614 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9948 (insn, operands);

    case 308:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9921 (insn, operands);

    case 309:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9923 (insn, operands);

    case 310:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9925 (insn, operands);

    case 311:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9927 (insn, operands);

    case 312:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9929 (insn, operands);

    case 313:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9931 (insn, operands);

    case 314:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 616 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9951 (insn, operands);

    case 315:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 617 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9953 (insn, operands);

    case 316:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 618 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9955 (insn, operands);

    case 317:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 619 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9957 (insn, operands);

    case 318:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 620 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9959 (insn, operands);

    case 319:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 621 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9961 (insn, operands);

    case 320:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9963 (insn, operands);

    case 321:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 623 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9965 (insn, operands);

    case 322:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 624 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9967 (insn, operands);

    case 323:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 625 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9969 (insn, operands);

    case 324:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9971 (insn, operands);

    case 325:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 627 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9973 (insn, operands);

    case 326:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9933 (insn, operands);

    case 327:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9935 (insn, operands);

    case 328:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9937 (insn, operands);

    case 329:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9939 (insn, operands);

    case 330:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9941 (insn, operands);

    case 331:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 628 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9975 (insn, operands);

    case 332:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9997 (insn, operands);

    case 333:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9977 (insn, operands);

    case 334:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 640 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9999 (insn, operands);

    case 335:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 630 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9979 (insn, operands);

    case 336:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 641 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10001 (insn, operands);

    case 337:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9981 (insn, operands);

    case 338:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 642 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10003 (insn, operands);

    case 339:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 632 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9983 (insn, operands);

    case 340:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10005 (insn, operands);

    case 341:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 633 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9985 (insn, operands);

    case 342:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 644 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10007 (insn, operands);

    case 343:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 634 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9987 (insn, operands);

    case 344:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 645 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10009 (insn, operands);

    case 345:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 635 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9989 (insn, operands);

    case 346:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 646 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10011 (insn, operands);

    case 347:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 636 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9991 (insn, operands);

    case 348:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 647 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10013 (insn, operands);

    case 349:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 637 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9993 (insn, operands);

    case 350:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 648 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10015 (insn, operands);

    case 351:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 638 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9995 (insn, operands);

    case 352:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9943 (insn, operands);

    case 353:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9945 (insn, operands);

    case 354:
      if (!(
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9947 (insn, operands);

    case 355:
      if (!((
#line 1337 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 614 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1339 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9949 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_138 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern149 (x2))
    {
    case 0:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8135 (insn, operands);

    case 1:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8141 (insn, operands);

    case 2:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8147 (insn, operands);

    case 3:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8153 (insn, operands);

    case 4:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8159 (insn, operands);

    case 5:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8165 (insn, operands);

    case 6:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8171 (insn, operands);

    case 7:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8177 (insn, operands);

    case 8:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8183 (insn, operands);

    case 9:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8189 (insn, operands);

    case 10:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8195 (insn, operands);

    case 11:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8201 (insn, operands);

    case 12:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8207 (insn, operands);

    case 13:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8213 (insn, operands);

    case 14:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8219 (insn, operands);

    case 15:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8225 (insn, operands);

    case 16:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8231 (insn, operands);

    case 17:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8237 (insn, operands);

    case 18:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8243 (insn, operands);

    case 19:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8249 (insn, operands);

    case 20:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8255 (insn, operands);

    case 21:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8261 (insn, operands);

    case 22:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8267 (insn, operands);

    case 23:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8273 (insn, operands);

    case 24:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8279 (insn, operands);

    case 25:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8285 (insn, operands);

    case 26:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8291 (insn, operands);

    case 27:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8297 (insn, operands);

    case 28:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8303 (insn, operands);

    case 29:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8309 (insn, operands);

    case 30:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8315 (insn, operands);

    case 31:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8321 (insn, operands);

    case 32:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8327 (insn, operands);

    case 33:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8333 (insn, operands);

    case 34:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8339 (insn, operands);

    case 35:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8345 (insn, operands);

    case 36:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8351 (insn, operands);

    case 37:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8357 (insn, operands);

    case 38:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8363 (insn, operands);

    case 39:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8369 (insn, operands);

    case 40:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8375 (insn, operands);

    case 41:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8381 (insn, operands);

    case 42:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8387 (insn, operands);

    case 43:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8393 (insn, operands);

    case 44:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8399 (insn, operands);

    case 45:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8405 (insn, operands);

    case 46:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8411 (insn, operands);

    case 47:
      if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8417 (insn, operands);

    case 48:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8517 (insn, operands);

    case 49:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8519 (insn, operands);

    case 50:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8521 (insn, operands);

    case 51:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8523 (insn, operands);

    case 52:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8525 (insn, operands);

    case 53:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8527 (insn, operands);

    case 54:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8529 (insn, operands);

    case 55:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8531 (insn, operands);

    case 56:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8533 (insn, operands);

    case 57:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8535 (insn, operands);

    case 58:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8537 (insn, operands);

    case 59:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8539 (insn, operands);

    case 60:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8541 (insn, operands);

    case 61:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8543 (insn, operands);

    case 62:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8545 (insn, operands);

    case 63:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8547 (insn, operands);

    case 64:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8549 (insn, operands);

    case 65:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8551 (insn, operands);

    case 66:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8553 (insn, operands);

    case 67:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8555 (insn, operands);

    case 68:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8557 (insn, operands);

    case 69:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8559 (insn, operands);

    case 70:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8561 (insn, operands);

    case 71:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8563 (insn, operands);

    case 72:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8565 (insn, operands);

    case 73:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8567 (insn, operands);

    case 74:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8569 (insn, operands);

    case 75:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8571 (insn, operands);

    case 76:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8573 (insn, operands);

    case 77:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8575 (insn, operands);

    case 78:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8577 (insn, operands);

    case 79:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8579 (insn, operands);

    case 80:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8581 (insn, operands);

    case 81:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8583 (insn, operands);

    case 82:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8585 (insn, operands);

    case 83:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8587 (insn, operands);

    case 84:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8589 (insn, operands);

    case 85:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8591 (insn, operands);

    case 86:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8593 (insn, operands);

    case 87:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8595 (insn, operands);

    case 88:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8597 (insn, operands);

    case 89:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8599 (insn, operands);

    case 90:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8601 (insn, operands);

    case 91:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8603 (insn, operands);

    case 92:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8605 (insn, operands);

    case 93:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8607 (insn, operands);

    case 94:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8609 (insn, operands);

    case 95:
      if (!((
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8611 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_145 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      switch (pattern156 (x2))
        {
        case 0:
          if (!(
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4333 (insn, operands);

        case 1:
          if (!(
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4334 (insn, operands);

        case 2:
          if (!(
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4335 (insn, operands);

        case 3:
          if (!(
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4336 (insn, operands);

        case 4:
          if (!(
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4337 (insn, operands);

        case 5:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4338 (insn, operands);

        case 6:
          if (!(
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4339 (insn, operands);

        case 7:
          if (!(
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4340 (insn, operands);

        case 8:
          if (!(
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4341 (insn, operands);

        case 9:
          if (!(
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4342 (insn, operands);

        case 10:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4343 (insn, operands);

        case 11:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4344 (insn, operands);

        case 12:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4345 (insn, operands);

        case 13:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4346 (insn, operands);

        case 14:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4347 (insn, operands);

        case 15:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4348 (insn, operands);

        case 16:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4349 (insn, operands);

        case 17:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4350 (insn, operands);

        case 18:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4351 (insn, operands);

        case 19:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4352 (insn, operands);

        case 20:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4353 (insn, operands);

        case 21:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4354 (insn, operands);

        case 22:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4355 (insn, operands);

        case 23:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4356 (insn, operands);

        case 24:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4357 (insn, operands);

        case 25:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4358 (insn, operands);

        case 26:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4359 (insn, operands);

        case 27:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4360 (insn, operands);

        case 28:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4361 (insn, operands);

        case 29:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4362 (insn, operands);

        case 30:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4363 (insn, operands);

        case 31:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4364 (insn, operands);

        case 32:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4365 (insn, operands);

        case 33:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4366 (insn, operands);

        case 34:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4367 (insn, operands);

        case 35:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4368 (insn, operands);

        case 36:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4369 (insn, operands);

        case 37:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4370 (insn, operands);

        case 38:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4371 (insn, operands);

        case 39:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4372 (insn, operands);

        case 40:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4373 (insn, operands);

        case 41:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4374 (insn, operands);

        case 42:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4375 (insn, operands);

        case 43:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4376 (insn, operands);

        case 44:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4377 (insn, operands);

        case 45:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4378 (insn, operands);

        case 46:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4379 (insn, operands);

        case 47:
          if (!((
#line 797 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 799 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4380 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      switch (pattern160 (x2))
        {
        case 0:
          if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7844 (insn, operands);

        case 1:
          if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7848 (insn, operands);

        case 2:
          if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7852 (insn, operands);

        case 3:
          if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7856 (insn, operands);

        case 4:
          if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7860 (insn, operands);

        case 5:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7864 (insn, operands);

        case 6:
          if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7868 (insn, operands);

        case 7:
          if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7872 (insn, operands);

        case 8:
          if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7876 (insn, operands);

        case 9:
          if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7880 (insn, operands);

        case 10:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7884 (insn, operands);

        case 11:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7888 (insn, operands);

        case 12:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7892 (insn, operands);

        case 13:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7896 (insn, operands);

        case 14:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7900 (insn, operands);

        case 15:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7904 (insn, operands);

        case 16:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7908 (insn, operands);

        case 17:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7912 (insn, operands);

        case 18:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7916 (insn, operands);

        case 19:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7920 (insn, operands);

        case 20:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7924 (insn, operands);

        case 21:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7928 (insn, operands);

        case 22:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7932 (insn, operands);

        case 23:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7936 (insn, operands);

        case 24:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7940 (insn, operands);

        case 25:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7944 (insn, operands);

        case 26:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7948 (insn, operands);

        case 27:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7952 (insn, operands);

        case 28:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7956 (insn, operands);

        case 29:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7960 (insn, operands);

        case 30:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7964 (insn, operands);

        case 31:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7968 (insn, operands);

        case 32:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7972 (insn, operands);

        case 33:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7976 (insn, operands);

        case 34:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7980 (insn, operands);

        case 35:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7984 (insn, operands);

        case 36:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7988 (insn, operands);

        case 37:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7992 (insn, operands);

        case 38:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7996 (insn, operands);

        case 39:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8000 (insn, operands);

        case 40:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8004 (insn, operands);

        case 41:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8008 (insn, operands);

        case 42:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8012 (insn, operands);

        case 43:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8016 (insn, operands);

        case 44:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8020 (insn, operands);

        case 45:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8024 (insn, operands);

        case 46:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8028 (insn, operands);

        case 47:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8032 (insn, operands);

        case 48:
          if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7846 (insn, operands);

        case 49:
          if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7850 (insn, operands);

        case 50:
          if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7854 (insn, operands);

        case 51:
          if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7858 (insn, operands);

        case 52:
          if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7862 (insn, operands);

        case 53:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7866 (insn, operands);

        case 54:
          if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7870 (insn, operands);

        case 55:
          if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7874 (insn, operands);

        case 56:
          if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7878 (insn, operands);

        case 57:
          if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7882 (insn, operands);

        case 58:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7886 (insn, operands);

        case 59:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7890 (insn, operands);

        case 60:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7894 (insn, operands);

        case 61:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7898 (insn, operands);

        case 62:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7902 (insn, operands);

        case 63:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7906 (insn, operands);

        case 64:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7910 (insn, operands);

        case 65:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7914 (insn, operands);

        case 66:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7918 (insn, operands);

        case 67:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7922 (insn, operands);

        case 68:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7926 (insn, operands);

        case 69:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7930 (insn, operands);

        case 70:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7934 (insn, operands);

        case 71:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7938 (insn, operands);

        case 72:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7942 (insn, operands);

        case 73:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7946 (insn, operands);

        case 74:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7950 (insn, operands);

        case 75:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7954 (insn, operands);

        case 76:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7958 (insn, operands);

        case 77:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7962 (insn, operands);

        case 78:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7966 (insn, operands);

        case 79:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7970 (insn, operands);

        case 80:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7974 (insn, operands);

        case 81:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7978 (insn, operands);

        case 82:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7982 (insn, operands);

        case 83:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7986 (insn, operands);

        case 84:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7990 (insn, operands);

        case 85:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7994 (insn, operands);

        case 86:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7998 (insn, operands);

        case 87:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8002 (insn, operands);

        case 88:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8006 (insn, operands);

        case 89:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8010 (insn, operands);

        case 90:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8014 (insn, operands);

        case 91:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8018 (insn, operands);

        case 92:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8022 (insn, operands);

        case 93:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8026 (insn, operands);

        case 94:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8030 (insn, operands);

        case 95:
          if (!((
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8034 (insn, operands);

        case 96:
          if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8036 (insn, operands);

        case 97:
          if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8038 (insn, operands);

        case 98:
          if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8040 (insn, operands);

        case 99:
          if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8042 (insn, operands);

        case 100:
          if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8044 (insn, operands);

        case 101:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8046 (insn, operands);

        case 102:
          if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8048 (insn, operands);

        case 103:
          if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8050 (insn, operands);

        case 104:
          if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8052 (insn, operands);

        case 105:
          if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8054 (insn, operands);

        case 106:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8056 (insn, operands);

        case 107:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8058 (insn, operands);

        case 108:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8060 (insn, operands);

        case 109:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8062 (insn, operands);

        case 110:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8064 (insn, operands);

        case 111:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8066 (insn, operands);

        case 112:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8068 (insn, operands);

        case 113:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8070 (insn, operands);

        case 114:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8072 (insn, operands);

        case 115:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8074 (insn, operands);

        case 116:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8076 (insn, operands);

        case 117:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8078 (insn, operands);

        case 118:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8080 (insn, operands);

        case 119:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8082 (insn, operands);

        case 120:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8084 (insn, operands);

        case 121:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8086 (insn, operands);

        case 122:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8088 (insn, operands);

        case 123:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8090 (insn, operands);

        case 124:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8092 (insn, operands);

        case 125:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8094 (insn, operands);

        case 126:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8096 (insn, operands);

        case 127:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8098 (insn, operands);

        case 128:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8100 (insn, operands);

        case 129:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8102 (insn, operands);

        case 130:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8104 (insn, operands);

        case 131:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8106 (insn, operands);

        case 132:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8108 (insn, operands);

        case 133:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8110 (insn, operands);

        case 134:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8112 (insn, operands);

        case 135:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8114 (insn, operands);

        case 136:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8116 (insn, operands);

        case 137:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8118 (insn, operands);

        case 138:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8120 (insn, operands);

        case 139:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8122 (insn, operands);

        case 140:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8124 (insn, operands);

        case 141:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8126 (insn, operands);

        case 142:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8128 (insn, operands);

        case 143:
          if (!((
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8130 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      return split_144 (x1, insn);

    case ASHIFT:
      return split_143 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
split_156 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode)
          || GET_MODE (x2) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVM4HFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4381 (insn, operands);

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x2) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM2HFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4382 (insn, operands);

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x2) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM1HFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4383 (insn, operands);

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x2) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVMF2HFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4384 (insn, operands);

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x2) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF4HFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4385 (insn, operands);

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode)
          || GET_MODE (x2) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVM4SFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4386 (insn, operands);

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode)
          || GET_MODE (x2) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVM2SFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4387 (insn, operands);

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode)
          || GET_MODE (x2) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVM1SFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4388 (insn, operands);

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode)
          || GET_MODE (x2) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVMF2SFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4389 (insn, operands);

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x2) != E_V1SFmode
          || !register_operand (operands[1], E_V1HFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4390 (insn, operands);

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V2HFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4391 (insn, operands);

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4HFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4392 (insn, operands);

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !register_operand (operands[1], E_V8HFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4393 (insn, operands);

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x2) != E_V16SFmode
          || !register_operand (operands[1], E_V16HFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4394 (insn, operands);

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x2) != E_V32SFmode
          || !register_operand (operands[1], E_V32HFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4395 (insn, operands);

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x2) != E_V64SFmode
          || !register_operand (operands[1], E_V64HFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4396 (insn, operands);

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x2) != E_V128SFmode
          || !register_operand (operands[1], E_V128HFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1006 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4397 (insn, operands);

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x2) != E_V256SFmode
          || !register_operand (operands[1], E_V256HFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4398 (insn, operands);

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x2) != E_V512SFmode
          || !register_operand (operands[1], E_V512HFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1008 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4399 (insn, operands);

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode)
          || GET_MODE (x2) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024HFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4400 (insn, operands);

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x2) != E_V1DFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4401 (insn, operands);

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4402 (insn, operands);

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x2) != E_V4DFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4403 (insn, operands);

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x2) != E_V8DFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4404 (insn, operands);

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x2) != E_V16DFmode
          || !register_operand (operands[1], E_V16SFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1014 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4405 (insn, operands);

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x2) != E_V32DFmode
          || !register_operand (operands[1], E_V32SFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4406 (insn, operands);

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x2) != E_V64DFmode
          || !register_operand (operands[1], E_V64SFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4407 (insn, operands);

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode)
          || GET_MODE (x2) != E_V128DFmode
          || !register_operand (operands[1], E_V128SFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1017 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4408 (insn, operands);

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode)
          || GET_MODE (x2) != E_V256DFmode
          || !register_operand (operands[1], E_V256SFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4409 (insn, operands);

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode)
          || GET_MODE (x2) != E_V512DFmode
          || !register_operand (operands[1], E_V512SFmode)
          || !((
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 852 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4410 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_163 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern118 (x2))
    {
    case 0:
      if (!(
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5986 (insn, operands);

    case 1:
      if (!(
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5988 (insn, operands);

    case 2:
      if (!(
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5990 (insn, operands);

    case 3:
      if (!(
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5992 (insn, operands);

    case 4:
      if (!(
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5994 (insn, operands);

    case 5:
      if (!(
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5996 (insn, operands);

    case 6:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5998 (insn, operands);

    case 7:
      if (!(
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6000 (insn, operands);

    case 8:
      if (!(
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6002 (insn, operands);

    case 9:
      if (!(
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6004 (insn, operands);

    case 10:
      if (!(
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6006 (insn, operands);

    case 11:
      if (!(
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6008 (insn, operands);

    case 12:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 504 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6010 (insn, operands);

    case 13:
      if (!(
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6012 (insn, operands);

    case 14:
      if (!(
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6014 (insn, operands);

    case 15:
      if (!(
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6016 (insn, operands);

    case 16:
      if (!(
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6018 (insn, operands);

    case 17:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 506 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6020 (insn, operands);

    case 18:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6022 (insn, operands);

    case 19:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6024 (insn, operands);

    case 20:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6026 (insn, operands);

    case 21:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6028 (insn, operands);

    case 22:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6030 (insn, operands);

    case 23:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6032 (insn, operands);

    case 24:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6034 (insn, operands);

    case 25:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 513 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6036 (insn, operands);

    case 26:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 514 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6038 (insn, operands);

    case 27:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6040 (insn, operands);

    case 28:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 516 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6042 (insn, operands);

    case 29:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 517 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6044 (insn, operands);

    case 30:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 518 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6046 (insn, operands);

    case 31:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 519 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6048 (insn, operands);

    case 32:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 520 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6050 (insn, operands);

    case 33:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 521 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6052 (insn, operands);

    case 34:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6054 (insn, operands);

    case 35:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 523 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6056 (insn, operands);

    case 36:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6058 (insn, operands);

    case 37:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 525 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6060 (insn, operands);

    case 38:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 526 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6062 (insn, operands);

    case 39:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6064 (insn, operands);

    case 40:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6066 (insn, operands);

    case 41:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6068 (insn, operands);

    case 42:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 530 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6070 (insn, operands);

    case 43:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 531 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6072 (insn, operands);

    case 44:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6074 (insn, operands);

    case 45:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6076 (insn, operands);

    case 46:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 534 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6078 (insn, operands);

    case 47:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6080 (insn, operands);

    case 48:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6082 (insn, operands);

    case 49:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 537 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6084 (insn, operands);

    case 50:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 538 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6086 (insn, operands);

    case 51:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 539 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6088 (insn, operands);

    case 52:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6090 (insn, operands);

    case 53:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 541 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6092 (insn, operands);

    case 54:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 542 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6094 (insn, operands);

    case 55:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 543 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6096 (insn, operands);

    case 56:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6098 (insn, operands);

    case 57:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 545 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6100 (insn, operands);

    case 58:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6102 (insn, operands);

    case 59:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 547 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6104 (insn, operands);

    case 60:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 548 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6106 (insn, operands);

    case 61:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 549 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6108 (insn, operands);

    case 62:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6110 (insn, operands);

    case 63:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 551 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6112 (insn, operands);

    case 64:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 552 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6114 (insn, operands);

    case 65:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6116 (insn, operands);

    case 66:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 554 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6118 (insn, operands);

    case 67:
      if (!((
#line 1704 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 555 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)) && 
#line 1706 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6120 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_167 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern124 (x2))
    {
    case 0:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2598 (insn, operands);

    case 1:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2612 (insn, operands);

    case 2:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2626 (insn, operands);

    case 3:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2640 (insn, operands);

    case 4:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2654 (insn, operands);

    case 5:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2668 (insn, operands);

    case 6:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2682 (insn, operands);

    case 7:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2696 (insn, operands);

    case 8:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2710 (insn, operands);

    case 9:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2724 (insn, operands);

    case 10:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2738 (insn, operands);

    case 11:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2752 (insn, operands);

    case 12:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2766 (insn, operands);

    case 13:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2780 (insn, operands);

    case 14:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2794 (insn, operands);

    case 15:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2808 (insn, operands);

    case 16:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2822 (insn, operands);

    case 17:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2836 (insn, operands);

    case 18:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2850 (insn, operands);

    case 19:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2864 (insn, operands);

    case 20:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2878 (insn, operands);

    case 21:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2892 (insn, operands);

    case 22:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2906 (insn, operands);

    case 23:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2920 (insn, operands);

    case 24:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2934 (insn, operands);

    case 25:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2948 (insn, operands);

    case 26:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2962 (insn, operands);

    case 27:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2976 (insn, operands);

    case 28:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2990 (insn, operands);

    case 29:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3004 (insn, operands);

    case 30:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3018 (insn, operands);

    case 31:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3032 (insn, operands);

    case 32:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3046 (insn, operands);

    case 33:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3060 (insn, operands);

    case 34:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3074 (insn, operands);

    case 35:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3088 (insn, operands);

    case 36:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3102 (insn, operands);

    case 37:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3116 (insn, operands);

    case 38:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3130 (insn, operands);

    case 39:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3144 (insn, operands);

    case 40:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3158 (insn, operands);

    case 41:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3172 (insn, operands);

    case 42:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3186 (insn, operands);

    case 43:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3200 (insn, operands);

    case 44:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3214 (insn, operands);

    case 45:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3228 (insn, operands);

    case 46:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3242 (insn, operands);

    case 47:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3256 (insn, operands);

    case 48:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3270 (insn, operands);

    case 49:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3284 (insn, operands);

    case 50:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3298 (insn, operands);

    case 51:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3312 (insn, operands);

    case 52:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3326 (insn, operands);

    case 53:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3340 (insn, operands);

    case 54:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3354 (insn, operands);

    case 55:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3368 (insn, operands);

    case 56:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3382 (insn, operands);

    case 57:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3396 (insn, operands);

    case 58:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3410 (insn, operands);

    case 59:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3424 (insn, operands);

    case 60:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3438 (insn, operands);

    case 61:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3452 (insn, operands);

    case 62:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3466 (insn, operands);

    case 63:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3480 (insn, operands);

    case 64:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3494 (insn, operands);

    case 65:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3508 (insn, operands);

    case 66:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3522 (insn, operands);

    case 67:
      if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3536 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_178 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  switch (pattern347 (x6))
    {
    case 0:
      if (!((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1581 (insn, operands);

    case 1:
      if (!((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1592 (insn, operands);

    case 2:
      if (!((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1582 (insn, operands);

    case 3:
      if (!((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1593 (insn, operands);

    case 4:
      if (!((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 932 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1583 (insn, operands);

    case 5:
      if (!((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 932 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1594 (insn, operands);

    case 6:
      if (!((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1584 (insn, operands);

    case 7:
      if (!((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1595 (insn, operands);

    case 8:
      if (!((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 934 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1585 (insn, operands);

    case 9:
      if (!((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 934 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1596 (insn, operands);

    case 10:
      if (!((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 936 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1586 (insn, operands);

    case 11:
      if (!((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 936 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1597 (insn, operands);

    case 12:
      if (!((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 936 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1587 (insn, operands);

    case 13:
      if (!((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 936 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1598 (insn, operands);

    case 14:
      if (!((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 938 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1588 (insn, operands);

    case 15:
      if (!((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 938 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1599 (insn, operands);

    case 16:
      if (!((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 938 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1589 (insn, operands);

    case 17:
      if (!((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 938 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1600 (insn, operands);

    case 18:
      if (!((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1590 (insn, operands);

    case 19:
      if (!((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1601 (insn, operands);

    case 20:
      if (!((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1591 (insn, operands);

    case 21:
      if (!((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1602 (insn, operands);

    case 22:
      if (!((
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 1533 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1356 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1603 (insn, operands);

    case 23:
      if (!((
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 1533 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1356 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1604 (insn, operands);

    case 24:
      if (!((
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1356 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1605 (insn, operands);

    case 25:
      if (!((
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1356 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1606 (insn, operands);

    case 26:
      if (!((
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1356 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1607 (insn, operands);

    case 27:
      if (!((
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1356 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1608 (insn, operands);

    case 28:
      if (!((
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1356 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1609 (insn, operands);

    case 29:
      if (!((
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1356 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1610 (insn, operands);

    case 30:
      if (!((
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1356 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1611 (insn, operands);

    case 31:
      if (!((
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1356 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1612 (insn, operands);

    case 32:
      if (!((
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1356 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1613 (insn, operands);

    case 33:
      if (!((
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1356 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1614 (insn, operands);

    case 34:
      if (!((
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1356 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1615 (insn, operands);

    case 35:
      if (!((
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1356 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1616 (insn, operands);

    case 36:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32QImode)
       || register_operand (operands[1], V32QImode))) && (
#line 4348 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1987 (insn, operands);

    case 37:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32QImode)
       || register_operand (operands[1], V32QImode))) && (
#line 4348 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1988 (insn, operands);

    case 38:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))) && (
#line 4349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1989 (insn, operands);

    case 39:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))) && (
#line 4349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1990 (insn, operands);

    case 40:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128QImode)
       || register_operand (operands[1], V128QImode))) && (
#line 4350 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1991 (insn, operands);

    case 41:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128QImode)
       || register_operand (operands[1], V128QImode))) && (
#line 4350 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1992 (insn, operands);

    case 42:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256QImode)
       || register_operand (operands[1], V256QImode))) && (
#line 4351 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1993 (insn, operands);

    case 43:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256QImode)
       || register_operand (operands[1], V256QImode))) && (
#line 4351 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1994 (insn, operands);

    case 44:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512QImode)
       || register_operand (operands[1], V512QImode))) && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1995 (insn, operands);

    case 45:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512QImode)
       || register_operand (operands[1], V512QImode))) && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1996 (insn, operands);

    case 46:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024QImode)
       || register_operand (operands[1], V1024QImode))) && (
#line 4353 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1997 (insn, operands);

    case 47:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024QImode)
       || register_operand (operands[1], V1024QImode))) && (
#line 4353 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1998 (insn, operands);

    case 48:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048QImode)
       || register_operand (operands[1], V2048QImode))) && (
#line 4354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1999 (insn, operands);

    case 49:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048QImode)
       || register_operand (operands[1], V2048QImode))) && (
#line 4354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2000 (insn, operands);

    case 50:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096QImode)
       || register_operand (operands[1], V4096QImode))) && (
#line 4355 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2001 (insn, operands);

    case 51:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096QImode)
       || register_operand (operands[1], V4096QImode))) && (
#line 4355 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2002 (insn, operands);

    case 52:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HImode)
       || register_operand (operands[1], V32HImode))) && (
#line 4356 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2003 (insn, operands);

    case 53:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HImode)
       || register_operand (operands[1], V32HImode))) && (
#line 4356 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2004 (insn, operands);

    case 54:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HImode)
       || register_operand (operands[1], V64HImode))) && (
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2005 (insn, operands);

    case 55:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HImode)
       || register_operand (operands[1], V64HImode))) && (
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2006 (insn, operands);

    case 56:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HImode)
       || register_operand (operands[1], V128HImode))) && (
#line 4358 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2007 (insn, operands);

    case 57:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HImode)
       || register_operand (operands[1], V128HImode))) && (
#line 4358 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2008 (insn, operands);

    case 58:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HImode)
       || register_operand (operands[1], V256HImode))) && (
#line 4359 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2009 (insn, operands);

    case 59:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HImode)
       || register_operand (operands[1], V256HImode))) && (
#line 4359 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2010 (insn, operands);

    case 60:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HImode)
       || register_operand (operands[1], V512HImode))) && (
#line 4360 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2011 (insn, operands);

    case 61:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HImode)
       || register_operand (operands[1], V512HImode))) && (
#line 4360 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2012 (insn, operands);

    case 62:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HImode)
       || register_operand (operands[1], V1024HImode))) && (
#line 4361 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2013 (insn, operands);

    case 63:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HImode)
       || register_operand (operands[1], V1024HImode))) && (
#line 4361 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2014 (insn, operands);

    case 64:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HImode)
       || register_operand (operands[1], V2048HImode))) && (
#line 4362 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2015 (insn, operands);

    case 65:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HImode)
       || register_operand (operands[1], V2048HImode))) && (
#line 4362 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2016 (insn, operands);

    case 66:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SImode)
       || register_operand (operands[1], V32SImode))) && (
#line 4363 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2017 (insn, operands);

    case 67:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SImode)
       || register_operand (operands[1], V32SImode))) && (
#line 4363 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2018 (insn, operands);

    case 68:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SImode)
       || register_operand (operands[1], V64SImode))) && (
#line 4364 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2019 (insn, operands);

    case 69:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SImode)
       || register_operand (operands[1], V64SImode))) && (
#line 4364 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2020 (insn, operands);

    case 70:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128SImode)
       || register_operand (operands[1], V128SImode))) && (
#line 4365 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2021 (insn, operands);

    case 71:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128SImode)
       || register_operand (operands[1], V128SImode))) && (
#line 4365 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2022 (insn, operands);

    case 72:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SImode)
       || register_operand (operands[1], V256SImode))) && (
#line 4366 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2023 (insn, operands);

    case 73:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SImode)
       || register_operand (operands[1], V256SImode))) && (
#line 4366 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2024 (insn, operands);

    case 74:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SImode)
       || register_operand (operands[1], V512SImode))) && (
#line 4367 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2025 (insn, operands);

    case 75:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SImode)
       || register_operand (operands[1], V512SImode))) && (
#line 4367 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2026 (insn, operands);

    case 76:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SImode)
       || register_operand (operands[1], V1024SImode))) && (
#line 4368 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2027 (insn, operands);

    case 77:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SImode)
       || register_operand (operands[1], V1024SImode))) && (
#line 4368 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2028 (insn, operands);

    case 78:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DImode)
       || register_operand (operands[1], V32DImode))) && (
#line 4369 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2029 (insn, operands);

    case 79:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DImode)
       || register_operand (operands[1], V32DImode))) && (
#line 4369 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2030 (insn, operands);

    case 80:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DImode)
       || register_operand (operands[1], V64DImode))) && (
#line 4370 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2031 (insn, operands);

    case 81:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DImode)
       || register_operand (operands[1], V64DImode))) && (
#line 4370 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2032 (insn, operands);

    case 82:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DImode)
       || register_operand (operands[1], V128DImode))) && (
#line 4371 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2033 (insn, operands);

    case 83:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DImode)
       || register_operand (operands[1], V128DImode))) && (
#line 4371 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2034 (insn, operands);

    case 84:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DImode)
       || register_operand (operands[1], V256DImode))) && (
#line 4372 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2035 (insn, operands);

    case 85:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DImode)
       || register_operand (operands[1], V256DImode))) && (
#line 4372 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2036 (insn, operands);

    case 86:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DImode)
       || register_operand (operands[1], V512DImode))) && (
#line 4373 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2037 (insn, operands);

    case 87:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DImode)
       || register_operand (operands[1], V512DImode))) && (
#line 4373 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2038 (insn, operands);

    case 88:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HFmode)
       || register_operand (operands[1], V32HFmode))) && (
#line 4374 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2039 (insn, operands);

    case 89:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HFmode)
       || register_operand (operands[1], V32HFmode))) && (
#line 4374 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2040 (insn, operands);

    case 90:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HFmode)
       || register_operand (operands[1], V64HFmode))) && (
#line 4375 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2041 (insn, operands);

    case 91:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HFmode)
       || register_operand (operands[1], V64HFmode))) && (
#line 4375 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2042 (insn, operands);

    case 92:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HFmode)
       || register_operand (operands[1], V128HFmode))) && (
#line 4376 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2043 (insn, operands);

    case 93:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HFmode)
       || register_operand (operands[1], V128HFmode))) && (
#line 4376 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2044 (insn, operands);

    case 94:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HFmode)
       || register_operand (operands[1], V256HFmode))) && (
#line 4377 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2045 (insn, operands);

    case 95:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HFmode)
       || register_operand (operands[1], V256HFmode))) && (
#line 4377 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2046 (insn, operands);

    case 96:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HFmode)
       || register_operand (operands[1], V512HFmode))) && (
#line 4378 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2047 (insn, operands);

    case 97:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HFmode)
       || register_operand (operands[1], V512HFmode))) && (
#line 4378 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2048 (insn, operands);

    case 98:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HFmode)
       || register_operand (operands[1], V1024HFmode))) && (
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2049 (insn, operands);

    case 99:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HFmode)
       || register_operand (operands[1], V1024HFmode))) && (
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2050 (insn, operands);

    case 100:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HFmode)
       || register_operand (operands[1], V2048HFmode))) && (
#line 4380 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2051 (insn, operands);

    case 101:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HFmode)
       || register_operand (operands[1], V2048HFmode))) && (
#line 4380 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2052 (insn, operands);

    case 102:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SFmode)
       || register_operand (operands[1], V32SFmode))) && (
#line 4381 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2053 (insn, operands);

    case 103:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SFmode)
       || register_operand (operands[1], V32SFmode))) && (
#line 4381 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2054 (insn, operands);

    case 104:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SFmode)
       || register_operand (operands[1], V64SFmode))) && (
#line 4382 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2055 (insn, operands);

    case 105:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SFmode)
       || register_operand (operands[1], V64SFmode))) && (
#line 4382 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2056 (insn, operands);

    case 106:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128SFmode)
       || register_operand (operands[1], V128SFmode))) && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2057 (insn, operands);

    case 107:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128SFmode)
       || register_operand (operands[1], V128SFmode))) && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2058 (insn, operands);

    case 108:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SFmode)
       || register_operand (operands[1], V256SFmode))) && (
#line 4384 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2059 (insn, operands);

    case 109:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SFmode)
       || register_operand (operands[1], V256SFmode))) && (
#line 4384 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2060 (insn, operands);

    case 110:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SFmode)
       || register_operand (operands[1], V512SFmode))) && (
#line 4385 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2061 (insn, operands);

    case 111:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SFmode)
       || register_operand (operands[1], V512SFmode))) && (
#line 4385 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2062 (insn, operands);

    case 112:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SFmode)
       || register_operand (operands[1], V1024SFmode))) && (
#line 4386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2063 (insn, operands);

    case 113:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SFmode)
       || register_operand (operands[1], V1024SFmode))) && (
#line 4386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2064 (insn, operands);

    case 114:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DFmode)
       || register_operand (operands[1], V32DFmode))) && (
#line 4387 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2065 (insn, operands);

    case 115:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DFmode)
       || register_operand (operands[1], V32DFmode))) && (
#line 4387 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2066 (insn, operands);

    case 116:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DFmode)
       || register_operand (operands[1], V64DFmode))) && (
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2067 (insn, operands);

    case 117:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DFmode)
       || register_operand (operands[1], V64DFmode))) && (
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2068 (insn, operands);

    case 118:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DFmode)
       || register_operand (operands[1], V128DFmode))) && (
#line 4389 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2069 (insn, operands);

    case 119:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DFmode)
       || register_operand (operands[1], V128DFmode))) && (
#line 4389 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2070 (insn, operands);

    case 120:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DFmode)
       || register_operand (operands[1], V256DFmode))) && (
#line 4390 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2071 (insn, operands);

    case 121:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DFmode)
       || register_operand (operands[1], V256DFmode))) && (
#line 4390 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2072 (insn, operands);

    case 122:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DFmode)
       || register_operand (operands[1], V512DFmode))) && (
#line 4391 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2073 (insn, operands);

    case 123:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DFmode)
       || register_operand (operands[1], V512DFmode))) && (
#line 4391 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2074 (insn, operands);

    case 124:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32BImode)
       || register_operand (operands[1], V32BImode))) && (
#line 4393 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2075 (insn, operands);

    case 125:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32BImode)
       || register_operand (operands[1], V32BImode))) && (
#line 4393 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2076 (insn, operands);

    case 126:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64BImode)
       || register_operand (operands[1], V64BImode))) && (
#line 4394 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2077 (insn, operands);

    case 127:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64BImode)
       || register_operand (operands[1], V64BImode))) && (
#line 4394 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2078 (insn, operands);

    case 128:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128BImode)
       || register_operand (operands[1], V128BImode))) && (
#line 4395 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2079 (insn, operands);

    case 129:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128BImode)
       || register_operand (operands[1], V128BImode))) && (
#line 4395 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2080 (insn, operands);

    case 130:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256BImode)
       || register_operand (operands[1], V256BImode))) && (
#line 4396 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2081 (insn, operands);

    case 131:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256BImode)
       || register_operand (operands[1], V256BImode))) && (
#line 4396 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2082 (insn, operands);

    case 132:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512BImode)
       || register_operand (operands[1], V512BImode))) && (
#line 4397 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2083 (insn, operands);

    case 133:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512BImode)
       || register_operand (operands[1], V512BImode))) && (
#line 4397 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2084 (insn, operands);

    case 134:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024BImode)
       || register_operand (operands[1], V1024BImode))) && (
#line 4398 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2085 (insn, operands);

    case 135:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024BImode)
       || register_operand (operands[1], V1024BImode))) && (
#line 4398 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2086 (insn, operands);

    case 136:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048BImode)
       || register_operand (operands[1], V2048BImode))) && (
#line 4399 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2087 (insn, operands);

    case 137:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048BImode)
       || register_operand (operands[1], V2048BImode))) && (
#line 4399 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2088 (insn, operands);

    case 138:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096BImode)
       || register_operand (operands[1], V4096BImode))) && (
#line 4400 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2089 (insn, operands);

    case 139:
      if (!((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096BImode)
       || register_operand (operands[1], V4096BImode))) && (
#line 4400 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2090 (insn, operands);

    default:
      return NULL;
    }
}
